program BonsFMmini;

uses
  Vcl.Forms,
  Main in 'Main.pas' {FormMain},
  Archive in 'Archive.pas',
  ArchiveSetting in 'ArchiveSetting.pas' {FormArchiveSetting},
  Attribute in 'Attribute.pas' {FormAttribute},
  Browse in 'Browse.pas' {FormBrowse},
  CopyEx in 'CopyEx.pas' {FormCopyEx},
  DeleteEx in 'DeleteEx.pas' {FormDeleteEx},
  Drive in 'Drive.pas' {FormDrive},
  Drop in 'Drop.pas' {FormDrop},
  DropFile in 'DropFile.pas' {FormDropFile},
  Execute in 'Execute.pas' {FormExecute},
  Extract in 'Extract.pas' {FormExtract},
  InputFilename in 'InputFilename.pas' {FormInputFilename},
  MakeFolder in 'MakeFolder.pas' {FormMakeFolder},
  MoveEx in 'MoveEx.pas' {FormMoveEx},
  MyUtility in 'MyUtility.pas',
  Pack in 'Pack.pas' {FormPack},
  Password in 'Password.pas' {FormPassword},
  PasswordPack in 'PasswordPack.pas' {FormPasswordPack},
  Rename in 'Rename.pas' {FormRename},
  Setting in 'Setting.pas' {FormSetting},
  Sort in 'Sort.pas' {FormSort},
  TimeStamp in 'TimeStamp.pas' {FormTimeStamp},
  Version in 'Version.pas' {FormVersion},
  RunProgram in 'RunProgram.pas' {FormRunProgram},
  Launcher in 'Launcher.pas' {FormLauncher},
  InputFolder in 'InputFolder.pas' {FormInputFolder},
  InputLauncher in 'InputLauncher.pas' {FormInputLauncher},
  JumpFolder in 'JumpFolder.pas' {FormJumpFolder},
  JumpFolderEx in 'JumpFolderEx.pas' {FormJumpFolderEx},
  WildCard in 'WildCard.pas' {FormWildCard},
  FileMask in 'FileMask.pas' {FormFileMask},
  KeyBoard in 'KeyBoard.pas' {FormKeyBoard},
  KeyMap in 'KeyMap.pas' {FormKeyMap},
  InputExtract in 'InputExtract.pas' {FormInputExtract},
  InputPack in 'InputPack.pas' {FormInputPack},
  Recover in 'Recover.pas' {FormRecover},
  Help in 'Help.pas' {FormHelp},
  Search in 'Search.pas' {FormSearch},
  Tree in 'Tree.pas' {FormTree},
  Network in 'Network.pas' {FormNetwork},
  InputNetwork in 'InputNetwork.pas' {FormInputNetwork},
  FileName in 'FileName.pas' {FormFileName},
  RunMacro in 'RunMacro.pas' {FormRunMacro},
  MyMacro in 'MyMacro.pas',
  Extention in 'Extention.pas' {FormExtention},
  Remove in 'Remove.pas' {FormRemove},
  ImageTimeStamp in 'ImageTimeStamp.pas' {FormImageTimeStamp},
  ExifData in 'ExifData.pas',
  DisplayOff in 'DisplayOff.pas' {FormDisplayOff},
  SelectCopy in 'SelectCopy.pas' {FormSelectCopy},
  SelectMove in 'SelectMove.pas' {FormSelectMove},
  JumpFile in 'JumpFile.pas' {FormJumpFile},
  InputFile in 'InputFile.pas' {FormInputFile},
  FileTime in 'FileTime.pas' {FormFileTime},
  Mirror in 'Mirror.pas' {FormMirror},
  FtpTree in 'FtpTree.pas' {FormFtpTree},
  FtpFiler in 'FtpFiler.pas' {FormFtpFiler},
  FtpMirror in 'FtpMirror.pas' {FormFtpMirror},
  FtpFileTime in 'FtpFileTime.pas' {FormFtpFileTime},
  FtpMakeFolder in 'FtpMakeFolder.pas' {FormFtpMakeFolder},
  FtpCopy in 'FtpCopy.pas' {FormFtpCopy},
  FtpDelete in 'FtpDelete.pas' {FormFtpDelete},
  FtpSort in 'FtpSort.pas' {FormFtpSort},
  FtpRename in 'FtpRename.pas' {FormFtpRename},
  CopyFtp in 'CopyFtp.pas' {FormCopyFtp},
  FtpSelectCopy in 'FtpSelectCopy.pas' {FormFtpSelectCopy},
  ImageGrid in 'ImageGrid.pas' {FormImageGrid},
  ThumbNail in 'ThumbNail.pas' {FormThumbNail},
  View in 'View.pas' {FormView},
  ToolPanel in 'ToolPanel.pas' {FormToolPanel},
  System.SysUtils,
  IniFiles,
  Vcl.Themes,
  Vcl.Styles,
  Url in 'Url.pas' {FormUrl},
  FolderSize in 'FolderSize.pas' {FormFolderSize},
  InputNewFilename in 'InputNewFilename.pas' {FormInputNewFilename},
  RenameAll in 'RenameAll.pas' {FormRenameAll},
  NumberJump in 'NumberJump.pas' {FormNumberJump},
  TenKeyBoard in 'TenKeyBoard.pas' {FormTenKeyBoard},
  MyThread in 'MyThread.pas',
  ViewDiary in 'ViewDiary.pas' {FormViewDiary},
  ViewGrid in 'ViewGrid.pas' {FormViewGrid},
  InputDateTime in 'InputDateTime.pas' {FormInputDateTime};

{$R *.res}

function SetVCLStyle: Boolean;
var
  IniFile: TIniFile;
  sStr1: String;
begin
  Result := TRUE;

  //m
  IniFile := TIniFile.Create (System.SysUtils.ChangeFileExt(ParamStr(0), '.ini'));
  //X^C
  sStr1 := IniFile.ReadString   ('VclStyle',    'Text',   'Windows');
  //j
  IniFile.Free;

  //
  if      sStr1 = 'Windows' then
  begin
    ;
  end
  else if sStr1 = 'Carbon' then
  begin
    TStyleManager.TrySetStyle('Carbon');
  end
  else if sStr1 = 'Charcoal Dark Slate' then
  begin
    TStyleManager.TrySetStyle('Charcoal Dark Slate');
  end
  else if sStr1 = 'Windows10 Dark' then
  begin
    TStyleManager.TrySetStyle('Windows10 Dark');
  end
  else
  begin
    ;
  end;
end;

begin
  //VCLX^Cݒ
  SetVCLStyle;
  //ʏ폈
  Application.Initialize;
  Application.MainFormOnTaskbar := True;
  Application.CreateForm(TFormMain, FormMain);
  Application.Run;
end.
