unit DateTimeEdit;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN COMBINING_SIGNED_UNSIGNED OFF} //W1024
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDateTimeType = (Year, Month, Date, Hour, Minute, Second);
  TDateTimeEdit = class(TEdit)
  private
    FAlignment: TAlignment;
    FDateTimeType: TDateTimeType;
    procedure SetDateTimeType(Value: TDateTimeType);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure KeyPress(var Key: Char); Override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Alignment: TAlignment  read FAlignment  write SetAlignment  default taLeftJustify;
    property DateTimeType: TDateTimeType  read FdateTimeType  write SetdateTimeType  default Year;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TDateTimeEdit]);
end;

procedure TDateTimeEdit.KeyPress(var Key: Char);
begin
//  VK_BACK   =  8;
//  VK_TAB    =  9;
//  VK_LEFT   = 37;
//  VK_UP     = 38;
//  VK_RIGHT  = 39;
//  VK_DOWN   = 40;
//  VK_DELETE = 46;

  if FDateTimeType = Year then
  begin
    if not SysUtils.CharInSet(key, ['0'..'9']) then
    begin
      //ݒ
      Key := #0 ;
    end
    else
    begin
      //
      if Length(Text) <> 4 then
      begin
        Text := '    ';
      end;
      //ݒ
      Text := Copy(Text, 2, 3) + key;
      //ݒ
      key := #0;
      //J[\ʒu
      SelStart := Length(Text);
    end;
  end;
  if (FDateTimeType = Month) or (FDateTimeType = Date)   or
     (FDateTimeType = Hour)  or (FDateTimeType = Minute) or (FDateTimeType = Second) then
  begin
    if not SysUtils.CharInSet(key, ['0'..'9']) then
    begin
      //ݒ
      Key := #0 ;
    end
    else
    begin
      //
      if Length(Text) <> 2 then
      begin
        Text := '  ';
      end;
      //ݒ
      Text := Copy(Text, 2, 1) + key;
      //ݒ
      key := #0;
      //J[\ʒu
      SelStart := Length(Text);
    end;
  end;
end;

constructor TDateTimeEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FDateTimeType := Year;
end;

procedure TDateTimeEdit.CreateParams(var Params: TCreateParams);
const
  Alignments: array [TAlignment] of Longint = (ES_LEFT, ES_RIGHT, ES_CENTER);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    DWORD(Style) := DWORD(Style) or DWORD(Alignments[FAlignment]) or DWORD(ES_MULTILINE);
    Style := Style or Alignments[FAlignment] or ES_MULTILINE;
  end;
end;

procedure TDateTimeEdit.SetDateTimeType(Value: TDatetimeType);
begin
  if FDatetimeType <> Value then
  begin
    FDatetimeType := Value;
  end;
end;

end.
