unit DisplayOff;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 440;
  FORM_HEIGHT_SET      = 190;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TRadioGroup = class(Vcl.ExtCtrls.TRadioGroup)
  published
    property OnKeyDown;
  end;

type
  TFormDisplayOff = class(TForm)
    Panel1: TPanel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    RadioGroup8: TRadioGroup;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure RadioGroupKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormDisplayOff: TFormDisplayOff;

implementation

{$R *.dfm}

uses
  Main;


//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormDisplayOff.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormDisplayOff.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormDisplayOff.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormDisplayOff.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormDisplayOff.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormDisplayOff', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormDisplayOff', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormDisplayOff', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormDisplayOff', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormDisplayOff', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //Cxgo^
  RadioGroup8.OnKeyDown := RadioGroupKeyDown;
end;

procedure TFormDisplayOff.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormDisplayOff', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormDisplayOff', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormDisplayOff', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormDisplayOff', 'Left',   FormDisplayOff.Left);
    IniFile.WriteInteger('FormDisplayOff', 'Top',    FormDisplayOff.Top);
    IniFile.WriteInteger('FormDisplayOff', 'Width',  FormDisplayOff.Width);
    IniFile.WriteInteger('FormDisplayOff', 'Height', FormDisplayOff.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteInteger('DisplayPowerOff',   'Index', RadioGroup8.ItemIndex);
  //j
  IniFile.Free;
end;

procedure TFormDisplayOff.FormResize(Sender: TObject);
begin
;
end;

procedure TFormDisplayOff.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormDisplayOff.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormDisplayOff.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormDisplayOff.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormDisplayOff.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormDisplayOff.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormDisplayOff.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'DisplayOff.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormDisplayOff, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormDisplayOff, StrLanguageFileName, Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  RadioGroup8.ItemIndex := IniFile.ReadInteger('DisplayPowerOff',   'Index',  1);
  //j
  IniFile.Free;
end;

procedure TFormDisplayOff.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile: TiniFile;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormDisplayOff, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    RadioGroup8.ItemIndex := IniFile.ReadInteger('DisplayPowerOff',   'Index',  1);
    //j
    IniFile.Free;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormDisplayOff, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    RadioGroup8.ItemIndex := IniFile.ReadInteger('DisplayPowerOff',   'Index',  1);
    //j
    IniFile.Free;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormDisplayOff.RadioGroupKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //RETURN
  if (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else
  begin
    //
  end;
end;

procedure TFormDisplayOff.ButtonOKClick(Sender: TObject);
var
  sSTr11: String;
begin
  //ScrnOff
  if  RadioGroup8.ItemIndex = 0 then
  begin
    //ݒ
    sStr11 := '';
    if FormMain.StrAnnsFMPath = '' then
    begin
      sStr11 := ExtractFilePath(ParamStr(0)) + SCREEN_OFF_EXE;
    end
    else
    begin
      sStr11 := FormMain.StrAnnsFMPath + SCREEN_OFF_EXE;
      if FileExists(sStr11) = FALSE then
      begin
        sStr11 := ExtractFilePath(ParamStr(0)) + SCREEN_OFF_EXE;
      end;
    end;

    //t@C
    if FileExists(sStr11) = TRUE then
    begin
      //I
      ModalResult := mrOK;
    end
    //t@CȂ
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@C܂' + #13#10 +
                           SCREEN_OFF_EXE;
      end
      else
      begin
        FormMain.StrMsg := 'Information : File is not exist.' + #13#10 +
                           SCREEN_OFF_EXE + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
  end
  else
  begin
      //I
      ModalResult := mrOK;
  end;
end;

procedure TFormDisplayOff.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

end.
