unit Drive;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls,
  MyUtility, IniFiles;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LIST_COLUM_WIDH_0    =  30; //
  LIST_COLUM_WIDH_1    =  60; //root
  LIST_COLUM_WIDH_2    = 105; //volume
  LIST_COLUM_WIDH_3    =  85; //type
  LIST_COLUM_WIDH_4    = 115; //serial
  LIST_COLUM_WIDH_5    =  55; //file
  LIST_COLUM_WIDH_6    = 220; //disk
  LIST_COLUM_WIDH_7    = 220; //free
  LIST_COLUM_WIDH_8    = 220; //use

type
  TFormDrive = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ListView1: TListView;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure SetListViewNewItem(iViewIndex: Integer; sItem: String);
    function  ChangetDrive(key: String; Sender: TObject): Boolean;

    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList1: TStringList;
    CsvList2: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormDrive: TFormDrive;

implementation

uses
  Main;

{$R *.dfm}


//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormDrive.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormDrive.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormDrive.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormDrive.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  iIndex1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormDrive', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormDrive', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormDrive', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormDrive', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormDrive', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;

  //
  ListView1.Columns.Add.Caption := '@';
  ListView1.Columns.Add.Caption := 'Root';
  ListView1.Columns.Add.Caption := 'Volume';
  ListView1.Columns.Add.Caption := 'Type';
  ListView1.Columns.Add.Caption := 'Serial';
  ListView1.Columns.Add.Caption := 'File';
  ListView1.Columns.Add.Caption := 'Disk';
  ListView1.Columns.Add.Caption := 'Free';
  ListView1.Columns.Add.Caption := 'Use';
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Visible := TRUE;
  ListView1.ReadOnly := TRUE;
  ListView1.HideSelection := FALSE;     //tH[JXړĂc

  //
  ListView1.Top := 85;
  ListView1.Height := 220;
  ListView1.Visible := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ListViewWidth2',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ListViewWidth2',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ListViewWidth2',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ListViewWidth2',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ListViewWidth2',  '4', LIST_COLUM_WIDH_4);
  ListView1.Columns[ 5].Width := IniFile.ReadInteger('ListViewWidth2',  '5', LIST_COLUM_WIDH_5);
  ListView1.Columns[ 6].Width := IniFile.ReadInteger('ListViewWidth2',  '6', LIST_COLUM_WIDH_6);
  ListView1.Columns[ 7].Width := IniFile.ReadInteger('ListViewWidth2',  '7', LIST_COLUM_WIDH_7);
  ListView1.Columns[ 8].Width := IniFile.ReadInteger('ListViewWidth2',  '8', LIST_COLUM_WIDH_8);
  //j
  IniFile.Free;

  //ݒ
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  iIndex1 := 0;
  for iRow1 := 1 to FormMain.StrListDriveInfo.Count-1 do
  begin
    //Ŋeڂݒ肵ăCfbNXZ
    SetListViewNewItem(iIndex1, FormMain.StrListDriveInfo[iRow1]);
    iIndex1 := iIndex1+1;
  end;
  ListView1.ItemIndex := 0;
  ListView1.Items.EndUpdate;
end;

procedure TFormDrive.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('FormDrive', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormDrive', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormDrive', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormDrive', 'Left',   FormDrive.Left);
    IniFile.WriteInteger('FormDrive', 'Top',    FormDrive.Top);
    IniFile.WriteInteger('FormDrive', 'Width',  FormDrive.Width);
    IniFile.WriteInteger('FormDrive', 'Height', FormDrive.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteInteger('ListViewWidth2',  '0', ListView1.Columns[ 0].Width);
  IniFile.WriteInteger('ListViewWidth2',  '1', ListView1.Columns[ 1].Width);
  IniFile.WriteInteger('ListViewWidth2',  '2', ListView1.Columns[ 2].Width);
  IniFile.WriteInteger('ListViewWidth2',  '3', ListView1.Columns[ 3].Width);
  IniFile.WriteInteger('ListViewWidth2',  '4', ListView1.Columns[ 4].Width);
  IniFile.WriteInteger('ListViewWidth2',  '5', ListView1.Columns[ 5].Width);
  IniFile.WriteInteger('ListViewWidth2',  '6', ListView1.Columns[ 6].Width);
  IniFile.WriteInteger('ListViewWidth2',  '7', ListView1.Columns[ 7].Width);
  IniFile.WriteInteger('ListViewWidth2',  '8', ListView1.Columns[ 8].Width);
  //j
  IniFile.Free;

  //j
  CsvList1.Free;
  CsvList2.Free;
end;

procedure TFormDrive.FormShow(Sender: TObject);
var
  sStr1: String;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormDrive.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormDrive.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormDrive.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormDrive.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormDrive.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormDrive.Handle, imClose);

  //hCu擾
  sStr1 := Copy(FormMain.StrCurrent, 1, 3);
  ChangetDrive(sStr1, Sender);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Drive.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormDrive, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormDrive, StrLanguageFileName, Sender);
  end;
end;

procedure TFormDrive.FormResize(Sender: TObject);
begin
  ListView1.Top      := 40;
  ListView1.Width    := Panel1.Width  -50;
  ListView1.Height   := Panel1.Height -95;
  ButtonOk.Top       := Panel1.Height -40;
  ButtonCancel.Top   := Panel1.Height -40;
end;

procedure TFormDrive.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormDrive.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormDrive, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormDrive, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormDrive.ButtonOKClick(Sender: TObject);
begin
  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    FormMain.StrRetFormDrive := ListView1.Items[ListView1.ItemIndex].SubItems[0];
  end
  else
  begin
    FormMain.StrRetFormDrive := '';
  end;

  //I
  ModalResult := mrOK;
end;

procedure TFormDrive.ButtonCancelClick(Sender: TObject);
begin
  //ݒ
  FormMain.StrRetFormDrive := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormDrive.SetListViewNewItem(iViewIndex: Integer; sItem: String);
var
  nItem: TListItem;
begin
  //WJ
  CsvList2.Clear;
  StringToCsvList(sItem, CsvList2);

  //1sݒ
  nItem := ListView1.Items.Add;
  nItem.Caption := '';
  //
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[0]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[1]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[2]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[3]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[4]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[5]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[6]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[7]);
end;

procedure TFormDrive.ListView1DblClick(Sender: TObject);
begin
  //s
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormDrive.ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ݒ
  if      (Shift = []) and (Key = VK_A) then
  begin
    if ChangetDrive('A:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_B) then
  begin
    if ChangetDrive('A:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_C) then
  begin
    if ChangetDrive('C:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_D) then
  begin
    if ChangetDrive('D:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_E) then
  begin
    if ChangetDrive('E:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_F) then
  begin
    if ChangetDrive('F:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_G) then
  begin
    if ChangetDrive('G:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_H) then
  begin
    if ChangetDrive('H:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_I) then
  begin
    if ChangetDrive('I:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_J) then
  begin
    if ChangetDrive('J:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_K) then
  begin
    if ChangetDrive('K:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_L) then
  begin
    if ChangetDrive('L:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_M) then
  begin
    if ChangetDrive('M:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_N) then
  begin
    if ChangetDrive('N:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_O) then
  begin
    if ChangetDrive('O:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_P) then
  begin
    if ChangetDrive('P:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_Q) then
  begin
    if ChangetDrive('Q:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_R) then
  begin
    if ChangetDrive('R:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_S) then
  begin
    if ChangetDrive('S:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_T) then
  begin
    if ChangetDrive('T:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_U) then
  begin
    if ChangetDrive('U:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_V) then
  begin
    if ChangetDrive('V:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_W) then
  begin
    if ChangetDrive('W:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_X) then
  begin
    if ChangetDrive('X:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_Y) then
  begin
    if ChangetDrive('Y:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else if (Shift = []) and (Key = VK_Z) then
  begin
    if ChangetDrive('Z:\', Sender) = TRUE then
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  else
  begin
    ;
  end;
end;

procedure TFormDrive.ListView1KeyPress(Sender: TObject; var Key: Char);
begin
  Key := char(0);
end;

procedure TFormDrive.ListView1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ݒ
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else
  begin
    ;
  end;
end;

function TFormDrive.ChangetDrive(key: String; Sender: TObject): Boolean;
var
  iRow1: Integer;
  iFind1: Integer;
begin
  Result := FALSE;
  iFind1 := -1;
  for iRow1 := 0 to ListView1.Items.Count-1 do
  begin
    if ListView1.Items[iRow1].SubItems[0] = key then
    begin
      ListView1.ItemIndex := iRow1;
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 <> -1 then
  begin
    Result := TRUE;
  end;
end;

end.

