unit Drop;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX2_WIDTH       = 695;

type
  TFormDrop = class(TForm)
    Panel2: TPanel;
    Label2: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ButtonOK: TButton;
    ButtonCancel: TButton;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox2DblClick(Sender: TObject);
    procedure ListBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormDrop: TFormDrop;

implementation

uses Main;

{$R *.dfm}


//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormDrop.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormDrop.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormDrop.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormDrop.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormDrop', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormDrop', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormDrop', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormDrop', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormDrop', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox2.Style := lbStandard;
  end;

  //ݒ
  for iRow1 := 0 to FormMain.StrListWindowName.Count-1 do
  begin
    ListBox2.Items.Add(FormMain.StrListWindowName.Strings[iRow1]);
    ListBox1.Items.Add(FormMain.StrListWindowHwnd.Strings[iRow1]);
  end;
  if ListBox2.Items.Count > 0 then
  begin
    ListBox2.ItemIndex := 0;
  end;
end;

procedure TFormDrop.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('Formv', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormDrop', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormDrop', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormDrop', 'Left',   FormDrop.Left);
    IniFile.WriteInteger('FormDrop', 'Top',    FormDrop.Top);
    IniFile.WriteInteger('FormDrop', 'Width',  FormDrop.Width);
    IniFile.WriteInteger('FormDrop', 'Height', FormDrop.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormDrop.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormDrop.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormDrop.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormDrop.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
//    FormDrop.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormDrop.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormDrop.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormDrop.Handle, imClose);

  //XN[o[\
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX2_WIDTH * 2, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Drop.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormDrop, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormDrop, StrLanguageFileName, Sender);
  end;
end;

procedure TFormDrop.FormResize(Sender: TObject);
begin
  ListBox2.Width   := Panel2.Width  -30  -35;
  ListBox2.Height  := Panel2.Height -100;
  ButtonOk.Top     := Panel2.Height -40;
  ButtonCancel.Top := Panel2.Height -40;
end;

procedure TFormDrop.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormDrop.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormDrop, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormDrop, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;


procedure TFormDrop.ButtonOKClick(Sender: TObject);
begin
  //s
  ListBox2DblClick(Sender);
end;

procedure TFormDrop.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormDrop := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormDrop.ListBox2Click(Sender: TObject);
begin
;
end;

procedure TFormDrop.ListBox2DblClick(Sender: TObject);
begin
  //Y
  if (ListBox2.Items.Count = 0) or (ListBox2.ItemIndex = -1) then
  begin
    //߂l
    FormMain.StrRetFormDrop := '';
    //I
    ModalResult := mrCancel;
  end
  //ݒ肠
  else
  begin
    //߂l
    FormMain.StrRetFormDrop := ListBox1.Items.Strings[ListBox2.ItemIndex];
    //I
    ModalResult := mrOK;
  end;
end;

procedure TFormDrop.ListBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ListBox2DblClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormDrop.ListBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormDrop.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

end.

