unit DropFile;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, ShlObj, Clipbrd, ShellAPI, ActiveX;

  const
  FORM_WIDTH_SET       = 410;
  FORM_HEIGHT_SET      = 250;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 715;

type
  TFormDropFile = class(TForm)
    Panel1: TPanel;
    ButtonMove: TButton;
    ButtonCancel: TButton;
    ButtonCopy: TButton;
    ButtonChange: TButton;
    Panel2: TPanel;
    ListBox1: TListBox;
    Panel3: TPanel;
    ButtonOperation: TButton;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure ButtonCopyClick(Sender: TObject);
    procedure ButtonMoveClick(Sender: TObject);
    procedure ButtonChangeClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOperationClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormDropFile: TFormDropFile;

implementation

{$R *.dfm}

uses
  Main, CopyEx, MoveEx;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormDropFile.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormDropFile.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormDropFile.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormDropFile.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormDropFile', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormDropFile', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormDropFile', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormDropFile', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormDropFile', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Panel1.Align := alClient;
  Panel2.Align := alClient;
  ListBox1.Align := alClient;

  //
  Panel1.Visible := TRUE;
  Panel2.Visible := FALSE;

  //ݒ
  ListBox1.Items.Clear;
  for iRow1 := 0 to FormMain.StrListFileDrop.Count-1 do
  begin
    ListBox1.Items.Add(FormMain.StrListFileDrop.Strings[iRow1]);
  end;
  //ݒ
  if ListBox1.Items.Count > 0 then
  begin
    ListBox1.ItemIndex := 0;
  end;

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;

end;

procedure TFormDropFile.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormDropFile', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormDropFile', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormDropFile', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormDropFile', 'Left',   FormDropFile.Left);
    IniFile.WriteInteger('FormDropFile', 'Top',    FormDropFile.Top);
    IniFile.WriteInteger('FormDropFile', 'Width',  FormDropFile.Width);
    IniFile.WriteInteger('FormDropFile', 'Height', FormDropFile.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormDropFile.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormDropFile.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormDropFile.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormDropFile.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
//    FormDropFile.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormDropFile.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormDropFile.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormDropFile.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'DropFile.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormDropFile, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormDropFile, StrLanguageFileName, Sender);
  end;
end;

procedure TFormDropFile.FormResize(Sender: TObject);
begin
  ButtonOperation.Left := (Panel3.Width  div 2) -170;
  ButtonCopy.Left      := (Panel3.Width  div 2) -130; //{^260Ȃ̂Ŕ130
  ButtonMove.Left      := (Panel3.Width  div 2) -130;
  ButtonChange.Left    := (Panel3.Width  div 2) -130;
  ButtonCancel.Left    := (Panel3.Width  div 2) -130;
end;

procedure TFormDropFile.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormDropFile.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormDropFile, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormDropFile, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormDropFile.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;


procedure TFormDropFile.ButtonCopyClick(Sender: TObject);
begin
        //߂l
        FormMain.StrRetFormDropFile := DROP_COPY_MODE;
        //I
        ModalResult := mrOK;
end;

procedure TFormDropFile.ButtonMoveClick(Sender: TObject);
begin
        //߂l
        FormMain.StrRetFormDropFile := DROP_MOVE_MODE;
        //I
        ModalResult := mrOK;
end;

procedure TFormDropFile.ButtonChangeClick(Sender: TObject);
begin
        //߂l
        FormMain.StrRetFormDropFile := DROP_CURRENT_MODE;
        //I
        ModalResult := mrOK;
end;

procedure TFormDropFile.ButtonCancelClick(Sender: TObject);
begin
        //߂l
        FormMain.StrRetFormDropFile := DROP_CANCEL_MODE;
        //I
        ModalResult := mrCancel;
end;

procedure TFormDropFile.ButtonOperationClick(Sender: TObject);
begin
  if Panel1.Visible = TRUE then
  begin
    Panel1.Visible := FALSE;
    Panel2.Visible := TRUE;
  end
  else
  begin
    Panel1.Visible := TRUE;
    Panel2.Visible := FALSE;
  end;
end;

end.
