unit Execute;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX2_WIDTH       = 695;

type
  TFormExecute = class(TForm)
    Panel2: TPanel;
    Label2: TLabel;
    ListBox2: TListBox;
    Edit1: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ListBox1: TListBox;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox2DblClick(Sender: TObject);
    procedure ListBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList2: TStringList;
    CsvList3: TStringList;
    CsvList4: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormExecute: TFormExecute;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormExecute.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormExecute.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormExecute.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormExecute.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExecute', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExecute', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExecute', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExecute', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExecute', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  ListBox1.Visible := FALSE;

  //m
  CsvList2 := TStringList.Create;
  CsvList3 := TStringList.Create;
  CsvList4 := TStringList.Create;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox2.Style := lbStandard;
  end;

  //ݒ
  for iRow1 := 0 to FormMain.StrListExecute.Count-1 do
  begin
    CsvList3.Clear;
    StringToCsvList(FormMain.StrListExecute.Strings[iRow1], CsvList3);
    if iRow1 = 0 then
    begin
      Edit1.Text := CsvList3[1];
    end;
      ListBox2.Items.Add(CsvList3[2]);
      ListBox1.Items.Add(CsvList3[3]);
  end;
  ListBox2.ItemIndex := 0;
  ListBox1.ItemIndex := 0;
end;

procedure TFormExecute.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('FormExecute', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormExecute', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormExecute', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormExecute', 'Left',   FormExecute.Left);
    IniFile.WriteInteger('FormExecute', 'Top',    FormExecute.Top);
    IniFile.WriteInteger('FormExecute', 'Width',  FormExecute.Width);
    IniFile.WriteInteger('FormExecute', 'Height', FormExecute.Height);
  end;
  //j
  IniFile.Free;

  //j
  CsvList2.Free;
  CsvList3.Free;
  CsvList4.Free;
end;

procedure TFormExecute.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormExecute.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormExecute.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormExecute.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormExecute.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormExecute.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormExecute.Handle, imClose);

  //XN[o[\
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX2_WIDTH * 2, 0);


  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Execute.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormExecute, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormExecute, StrLanguageFileName, Sender);
  end;
end;

procedure TFormExecute.FormResize(Sender: TObject);
begin
  ListBox2.Width := Panel2.Width -30  -35;
  Edit1.Width    := Panel2.Width -405 -35;
end;

procedure TFormExecute.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormExecute.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormExecute, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormExecute, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;


procedure TFormExecute.ButtonOKClick(Sender: TObject);
begin
  //s
  ListBox2DblClick(Sender);
end;

procedure TFormExecute.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormExecute     := '';
  FormMain.StrRetFormExecuteMode := ListBox1.Items.Strings[ListBox1.ItemIndex];
  //I
  ModalResult := mrCancel;
end;

procedure TFormExecute.ListBox2Click(Sender: TObject);
begin
  ListBox1.ItemIndex := ListBox2.ItemIndex;
end;

procedure TFormExecute.ListBox2DblClick(Sender: TObject);
begin
  //s
  FormMain.StrRetFormExecute     := FormMain.StrListExecute.Strings[ListBox2.ItemIndex];
  FormMain.StrRetFormExecuteMode := ListBox1.Items.Strings[ListBox1.ItemIndex];
  //I
  ModalResult := mrOK;
end;

procedure TFormExecute.ListBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ListBox2DblClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormExecute.ListBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormExecute.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

end.
