unit ExifData;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.Menus,
  Vcl.StdCtrls, Vcl.ExtCtrls;

const
  IFD_FIELD_MAX        =  50;
  EXIF_FIELD_MAX       = 100;
  GPS_FIELD_MAX        =  50;
  EXIF_MIN_SIZE         = 14;
  EXIF_HEADER_SAVE_SIZE = 65535;
  EXIF_END_MARK        = '[END]';
  EXIF_IFD             = 'IFD';
  EXIF_EXIF            = 'EXIF';
  EXIF_GPS             = 'GPS';
  EXIF_JPG             = '.jpg';
  EXIF_JPEG            = '.jpeg';
  EXIF_TIF             = '.tif';
  EXIF_TIFF            = '.tiff';
  EXIF_TYPE_JPG        = 'JPG';
  EXIF_TYPE_TIFF       = 'TIFF';
  EXIF_TYPE_MOTOROLA   = '۰';
  EXIF_TYPE_INTEL      = '';
  EXIF_TYPE_EXIF       = 'Exif';
  EXIF_TYPE_IFD        = 'IFD';
  EXIF_TYPE_JFIF       = 'JFIF';

{$IFDEF WIN32}
type
  //\
	TTagField = packed record
		sTag:			String;
    sNameJpn: String;
    sNameEng: String;
    sType:    String;
    sDetail:  String;
	end;
{$ENDIF}

{$IFDEF WIN64}
type
  //\
	TTagField = record
		sTag:			String;
    sNameJpn: String;
    sNameEng: String;
    sType:    String;
    sDetail:  String;
	end;
{$ENDIF}

{$IFDEF WIN32}
type
  //\
	TTagField2 = packed record
		sTag:			String;
		sType:		String;
		sCount:		String;
		sOffset:  String;
		sData:    String;
		sAddress: String;
	end;
{$ENDIF}

{$IFDEF WIN64}
type
  //\
	TTagField2 = record
		sTag:			String;
		sType:		String;
		sCount:		String;
		sOffset:  String;
		sData:    String;
		sAddress: String;
	end;
{$ENDIF}

    procedure InitTagField(Sender: TObject);
    function  GetValue(FileName: String; var StrListExif: TStringList; Sender: TObject): Boolean;
    procedure GetField(Stream: TBytesStream; Start: Integer; Count: Integer; FieldType: String; Intel: Boolean; Sender: TObject);
    procedure GetOffset(Stream: TBytesStream; Start: Integer; Count: Integer; FieldType: String; Intel: Boolean;Sender: TObject);

var
    sIfdField:   array[0..IFD_FIELD_MAX -1] of TTagField;
    sExifField:  array[0..EXIF_FIELD_MAX-1] of TTagField;
    sGpsField:   array[0..GPS_FIELD_MAX -1] of TTagField;

    sIfdField2:  array[0..IFD_FIELD_MAX -1] of TTagField2;
    sExifField2: array[0..EXIF_FIELD_MAX-1] of TTagField2;
    sGpsField2:  array[0..GPS_FIELD_MAX -1] of TTagField2;

//    bIntel: Boolean;

implementation

uses Main;

procedure InitTagField(Sender: TObject);
var
  iRow1: Integer;
begin

  sIfdField[ 0].sTag     := '0x0100';
  sIfdField[ 0].sNameJpn := '摜̕';
  sIfdField[ 0].sNameEng := 'ImageWidth';
  sIfdField[ 0].sType    := 'SHORT or LONG';
  sIfdField[ 0].sDetail  := '';

  sIfdField[ 1].sTag     := '0x0101';
  sIfdField[ 1].sNameJpn := '摜̍';
  sIfdField[ 1].sNameEng := 'ImageLength';
  sIfdField[ 1].sType    := 'SHORT or LONG';
  sIfdField[ 1].sDetail  := '';

  sIfdField[ 2].sTag     := '0x0102';
  sIfdField[ 2].sNameJpn := '摜̃rbg̐[';
  sIfdField[ 2].sNameEng := 'BitsPerSample';
  sIfdField[ 2].sType    := 'SHORT~3';
  sIfdField[ 2].sDetail  := '';

  sIfdField[ 3].sTag     := '0x0103';
  sIfdField[ 3].sNameJpn := 'k̎';
  sIfdField[ 3].sNameEng := 'Compression';
  sIfdField[ 3].sType    := 'SHORT';
  sIfdField[ 3].sDetail  := '';

  sIfdField[ 4].sTag     := '0x0106';
  sIfdField[ 4].sNameJpn := 'f\';
  sIfdField[ 4].sNameEng := 'PhotometricInterpretation';
  sIfdField[ 4].sType    := 'SHORT';
  sIfdField[ 4].sDetail  := '';

  sIfdField[ 5].sTag     := '0x0112';
  sIfdField[ 5].sNameJpn := '摜';
  sIfdField[ 5].sNameEng := 'Orientation';
  sIfdField[ 5].sType    := 'SHORT';
  sIfdField[ 5].sDetail  := '';

  sIfdField[ 6].sTag     := '0x0115';
  sIfdField[ 6].sNameJpn := 'R|[lg';
  sIfdField[ 6].sNameEng := 'SamplesPerPixel';
  sIfdField[ 6].sType    := 'SHORT';
  sIfdField[ 6].sDetail  := '';

  sIfdField[ 7].sTag     := '0x011C';
  sIfdField[ 7].sNameJpn := '摜f[^̕';
  sIfdField[ 7].sNameEng := 'PlanarConfiguration';
  sIfdField[ 7].sType    := 'SHORT';
  sIfdField[ 7].sDetail  := '';

  sIfdField[ 8].sTag     := '0x0212';
  sIfdField[ 8].sNameJpn := 'YCC̉f\(C̊Ԉ)';
  sIfdField[ 8].sNameEng := 'YCbCrSubSampling';
  sIfdField[ 8].sType    := 'SHORT~2';
  sIfdField[ 8].sDetail  := '';

  sIfdField[ 9].sTag     := '0x0213';
  sIfdField[ 9].sNameJpn := 'YCC̉f\(YC̈ʒu)';
  sIfdField[ 9].sNameEng := 'YCbCrPositioning';
  sIfdField[ 9].sType    := 'SHORT';
  sIfdField[ 9].sDetail  := '';

  sIfdField[10].sTag     := '0x011A';
  sIfdField[10].sNameJpn := '摜̉̕𑜓x';
  sIfdField[10].sNameEng := 'XResolution';
  sIfdField[10].sType    := 'RATIONAL';
  sIfdField[10].sDetail  := '';

  sIfdField[11].sTag     := '0x011B';
  sIfdField[11].sNameJpn := '摜̍̉𑜓x';
  sIfdField[11].sNameEng := 'YResolution';
  sIfdField[11].sType    := 'RATIONAL';
  sIfdField[11].sDetail  := '';

  sIfdField[12].sTag     := '0x0128';
  sIfdField[12].sNameJpn := '摜̕ƍ̉𑜓x̒P';
  sIfdField[12].sNameEng := 'ResolutionUnit';
  sIfdField[12].sType    := 'SHORT';
  sIfdField[12].sDetail  := '';

  sIfdField[13].sTag     := '0x0111';
  sIfdField[13].sNameJpn := '摜f[^̃P[V';
  sIfdField[13].sNameEng := 'StripOffsets';
  sIfdField[13].sType    := 'SHORT or LONG~?';
  sIfdField[13].sDetail  := '';

  sIfdField[14].sTag     := '0x0116';
  sIfdField[14].sNameJpn := 'XgbṽC';
  sIfdField[14].sNameEng := 'RowsPerStrip';
  sIfdField[14].sType    := 'SHORT or LONG';
  sIfdField[14].sDetail  := '';

  sIfdField[15].sTag     := '0x0117';
  sIfdField[15].sNameJpn := 'Xgbṽf[^';
  sIfdField[15].sNameEng := 'StripByteCounts';
  sIfdField[15].sType    := 'SHORT or LONG~?';
  sIfdField[15].sDetail  := '';

  sIfdField[16].sTag     := '0x0201';
  sIfdField[16].sNameJpn := 'JPEGSOIւ̃ItZbg';
  sIfdField[16].sNameEng := 'JPEGInterchangeFormat';
  sIfdField[16].sType    := 'LONG';
  sIfdField[16].sDetail  := '';

  sIfdField[17].sTag     := '0x0202';
  sIfdField[17].sNameJpn := 'JPEGf[^̃oCg';
  sIfdField[17].sNameEng := 'JPEGInterchangeFormatLength';
  sIfdField[17].sType    := 'LONG';
  sIfdField[17].sDetail  := '';

  sIfdField[18].sTag     := '0x012D';
  sIfdField[18].sNameJpn := 'ĐKJ[u';
  sIfdField[18].sNameEng := 'TransferFunction';
  sIfdField[18].sType    := 'SHORT~3~256';
  sIfdField[18].sDetail  := '';

  sIfdField[19].sTag     := '0x013E';
  sIfdField[19].sNameJpn := 'QƔF_̐FxWl';
  sIfdField[19].sNameEng := 'WhitePoint';
  sIfdField[19].sType    := 'RATIONAL~2';
  sIfdField[19].sDetail  := '';

  sIfdField[20].sTag     := '0x013F';
  sIfdField[20].sNameJpn := 'F̐FxWl';
  sIfdField[20].sNameEng := 'PrimaryChromaticities';
  sIfdField[20].sType    := 'RATIONAL~6';
  sIfdField[20].sDetail  := '';

  sIfdField[21].sTag     := '0x0211';
  sIfdField[21].sNameJpn := 'Fϊ}gNXW';
  sIfdField[21].sNameEng := 'YCbCrCoefficients';
  sIfdField[21].sType    := 'RATIONAL~3';
  sIfdField[21].sDetail  := '';

  sIfdField[22].sTag     := '0x0214';
  sIfdField[22].sNameJpn := 'QƍF_lƎQƔF_l';
  sIfdField[22].sNameEng := 'ReferenceBlackWhite';
  sIfdField[22].sType    := 'RATIONAL~6';
  sIfdField[22].sDetail  := '';

  sIfdField[23].sTag     := '0x0132';
  sIfdField[23].sNameJpn := 't@CύX';
  sIfdField[23].sNameEng := 'DateTime';
  sIfdField[23].sType    := 'ASCII~20';
  sIfdField[23].sDetail  := '';

  sIfdField[24].sTag     := '0x010E';
  sIfdField[24].sNameJpn := '摜^Cg';
  sIfdField[24].sNameEng := 'ImageDescription';
  sIfdField[24].sType    := 'ASCII~?';
  sIfdField[24].sDetail  := '';

  sIfdField[25].sTag     := '0x010F';
  sIfdField[25].sNameJpn := '摜͋@̃[J[';
  sIfdField[25].sNameEng := 'Make';
  sIfdField[25].sType    := 'ASCII~?';
  sIfdField[25].sDetail  := '';

  sIfdField[26].sTag     := '0x0110';
  sIfdField[26].sNameJpn := '摜͋@̃f';
  sIfdField[26].sNameEng := 'Model';
  sIfdField[26].sType    := 'ASCII~?';
  sIfdField[26].sDetail  := '';

  sIfdField[27].sTag     := '0x0131';
  sIfdField[27].sNameJpn := 'gp\tgEFA';
  sIfdField[27].sNameEng := 'Software';
  sIfdField[27].sType    := 'ASCII~?';
  sIfdField[27].sDetail  := '';

  sIfdField[28].sTag     := '0x013B';
  sIfdField[28].sNameJpn := 'Җ';
  sIfdField[28].sNameEng := 'Artist';
  sIfdField[28].sType    := 'ASCII~?';
  sIfdField[28].sDetail  := '';

  sIfdField[29].sTag     := '0x8298';
  sIfdField[29].sNameJpn := 'Be쌠/ҏW쌠';
  sIfdField[29].sNameEng := 'Copyright';
  sIfdField[29].sType    := 'ASCII~?';
  sIfdField[29].sDetail  := '';

  sIfdField[30].sTag     := '0x8769';
  sIfdField[30].sNameJpn := 'Exif IFDւ̃|C^';
  sIfdField[30].sNameEng := 'ExifIFDPointer';
  sIfdField[30].sType    := 'LONG';
  sIfdField[30].sDetail  := '';

  sIfdField[31].sTag     := '0x8825';
  sIfdField[31].sNameJpn := 'GPS IFDւ̃|C^';
  sIfdField[31].sNameEng := 'GPSIFDPointer';
  sIfdField[31].sType    := 'LONG';
  sIfdField[31].sDetail  := '';

  sIfdField[32].sTag     := '0xA005';
  sIfdField[32].sNameJpn := '݊IFDւ̃|C^';
  sIfdField[32].sNameEng := 'InteroperabilityIFDPointer';
  sIfdField[32].sType    := 'LONG';
  sIfdField[32].sDetail  := '';

  sIfdField[33].sTag     := '0x9C9B';
  sIfdField[33].sNameJpn := 'XP^Cg';
  sIfdField[33].sNameEng := 'Title';
  sIfdField[33].sType    := 'ASCII~?';
  sIfdField[33].sDetail  := '';

  sIfdField[34].sTag     := '0x9C9C';
  sIfdField[34].sNameJpn := 'XPRg';
  sIfdField[34].sNameEng := 'Comments';
  sIfdField[34].sType    := 'ASCII~?';
  sIfdField[34].sDetail  := '';

  sIfdField[35].sTag     := '0x9C9D';
  sIfdField[35].sNameJpn := 'XP쐬';
  sIfdField[35].sNameEng := 'Author';
  sIfdField[35].sType    := 'ASCII~?';
  sIfdField[35].sDetail  := '';

  sIfdField[36].sTag     := '0x9C9E';
  sIfdField[36].sNameJpn := 'XPL[[h';
  sIfdField[36].sNameEng := 'Keywords';
  sIfdField[36].sType    := 'ASCII~?';
  sIfdField[36].sDetail  := '';

  sIfdField[37].sTag     := '0x9C9F';
  sIfdField[37].sNameJpn := 'XP';
  sIfdField[37].sNameEng := 'Subject';
  sIfdField[37].sType    := 'ASCII~?';
  sIfdField[37].sDetail  := '';

  sIfdField[38].sTag     := '';
  sIfdField[38].sNameJpn := '';
  sIfdField[38].sNameEng := '';
  sIfdField[38].sType    := '';
  sIfdField[38].sDetail  := '';

  sExifField[ 0].sTag     := '0x9000';
  sExifField[ 0].sNameJpn := 'Exif o[W';
  sExifField[ 0].sNameEng := 'Exif Version';
  sExifField[ 0].sType    := 'UNDEFINED~4';
  sExifField[ 0].sDetail  := '';

  sExifField[ 1].sTag     := '0xA000';
  sExifField[ 1].sNameJpn := 'ΉtbVsbNXo[W';
  sExifField[ 1].sNameEng := 'FlashPixVersion';
  sExifField[ 1].sType    := 'UNDEFINED~4';
  sExifField[ 1].sDetail  := '';

  sExifField[ 2].sTag     := '0xA001';
  sExifField[ 2].sNameJpn := 'Fԏ';
  sExifField[ 2].sNameEng := 'ColorSpace';
  sExifField[ 2].sType    := 'SHORT';
  sExifField[ 2].sDetail  := '';

  sExifField[ 3].sTag     := '0x9101';
  sExifField[ 3].sNameJpn := 'eR|[lg̈Ӗ';
  sExifField[ 3].sNameEng := 'ComponentsConfiguration';
  sExifField[ 3].sType    := 'UNDEFINED~4';
  sExifField[ 3].sDetail  := '';

  sExifField[ 4].sTag     := '0x9102';
  sExifField[ 4].sNameJpn := '摜k[h';
  sExifField[ 4].sNameEng := 'CompressedBitsPerPixel';
  sExifField[ 4].sType    := 'RATIONAL';
  sExifField[ 4].sDetail  := '';

  sExifField[ 5].sTag     := '0xA002';
  sExifField[ 5].sNameJpn := '摜';
  sExifField[ 5].sNameEng := 'PixelXDimension';
  sExifField[ 5].sType    := 'SHORT or LONG';
  sExifField[ 5].sDetail  := '';

  sExifField[ 6].sTag     := '0xA003';
  sExifField[ 6].sNameJpn := '摜';
  sExifField[ 6].sNameEng := 'PixelYDimension';
  sExifField[ 6].sType    := 'SHORT or LONG';
  sExifField[ 6].sDetail  := '';

  sExifField[ 7].sTag     := '0x927C';
  sExifField[ 7].sNameJpn := '[J[m[g';
  sExifField[ 7].sNameEng := 'MakerNote';
  sExifField[ 7].sType    := 'UNDEFINED~?';
  sExifField[ 7].sDetail  := '';

  sExifField[ 8].sTag     := '0x9286';
  sExifField[ 8].sNameJpn := '[U[Rg';
  sExifField[ 8].sNameEng := 'UserComment';
  sExifField[ 8].sType    := 'UNDEFINED~?';
  sExifField[ 8].sDetail  := '';

  sExifField[ 9].sTag     := '0xA004';
  sExifField[ 9].sNameJpn := '֘At@C';
  sExifField[ 9].sNameEng := 'RelatedSoundFile';
  sExifField[ 9].sType    := 'ASCII~13';
  sExifField[ 9].sDetail  := '';

  sExifField[10].sTag     := '0x9003';
  sExifField[10].sNameJpn := '摜f[^̐';
  sExifField[10].sNameEng := 'DateTimeOriginal';
  sExifField[10].sType    := 'ASCII~20';
  sExifField[10].sDetail  := '';

  sExifField[11].sTag     := '0x9004';
  sExifField[11].sNameJpn := 'fW^f[^̍쐬';
  sExifField[11].sNameEng := 'DateTimeDigitized';
  sExifField[11].sType    := 'ASCII~20';
  sExifField[11].sDetail  := '';

  sExifField[12].sTag     := '0x9290';
  sExifField[12].sNameJpn := 'DateTimẽTuZbN';
  sExifField[12].sNameEng := 'SubSecTime';
  sExifField[12].sType    := 'ASCII~?';
  sExifField[12].sDetail  := '';

  sExifField[13].sTag     := '0x9291';
  sExifField[13].sNameJpn := 'DateTimeOriginal̃TuZbN';
  sExifField[13].sNameEng := 'SubSecTimeOriginal';
  sExifField[13].sType    := 'ASCII~?';
  sExifField[13].sDetail  := '';

  sExifField[14].sTag     := '0x9292';
  sExifField[14].sNameJpn := 'DateTimeDigitized̃TuZbN';
  sExifField[14].sNameEng := 'SubSecTimeDigitized';
  sExifField[14].sType    := 'ASCII~?';
  sExifField[14].sDetail  := '';

  sExifField[15].sTag     := '0x829A';
  sExifField[15].sNameJpn := 'Io';
  sExifField[15].sNameEng := 'ExposureTime';
  sExifField[15].sType    := 'RATIONAL';
  sExifField[15].sDetail  := '';

  sExifField[16].sTag     := '0x829D';
  sExifField[16].sNameJpn := 'F io[';
  sExifField[16].sNameEng := 'FNumber';
  sExifField[16].sType    := 'RATIONAL';
  sExifField[16].sDetail  := '';

  sExifField[17].sTag     := '0x8822';
  sExifField[17].sNameJpn := 'IovO';
  sExifField[17].sNameEng := 'ExposureProgram ';
  sExifField[17].sType    := 'SHORT';
  sExifField[17].sDetail  := '';

  sExifField[18].sTag     := '0x8824';
  sExifField[18].sNameJpn := 'XyNgx';
  sExifField[18].sNameEng := 'SpectralSensitivity';
  sExifField[18].sType    := 'ASCII~?';
  sExifField[18].sDetail  := '';

  sExifField[19].sTag     := '0x8827';
  sExifField[19].sNameJpn := 'ISO Xs[h[g';
  sExifField[19].sNameEng := 'ISOSpeedRatings ';
  sExifField[19].sType    := 'SHORT~?';
  sExifField[19].sDetail  := '';

  sExifField[20].sTag     := '0x8828';
  sExifField[20].sNameJpn := 'dϊ֐';
  sExifField[20].sNameEng := 'OECF';
  sExifField[20].sType    := 'UNDEFINED~?';
  sExifField[20].sDetail  := '';

  sExifField[21].sTag     := '0x9201';
  sExifField[21].sNameJpn := 'Vb^[Xs[h';
  sExifField[21].sNameEng := 'ShutterSpeedValue';
  sExifField[21].sType    := 'SRATIONAL';
  sExifField[21].sDetail  := '';

  sExifField[22].sTag     := '0x9202';
  sExifField[22].sNameJpn := 'il';
  sExifField[22].sNameEng := 'ApertureValue';
  sExifField[22].sType    := 'RATIONAL';
  sExifField[22].sDetail  := '';

  sExifField[23].sTag     := '0x9203';
  sExifField[23].sNameJpn := 'Pxl';
  sExifField[23].sNameEng := 'BrightnessValue';
  sExifField[23].sType    := 'SRATIONAL';
  sExifField[23].sDetail  := '';

  sExifField[24].sTag     := '0x9204';
  sExifField[24].sNameJpn := 'I␳l';
  sExifField[24].sNameEng := 'ExposureBiasValue';
  sExifField[24].sType    := 'SRATIONAL';
  sExifField[24].sDetail  := '';

  sExifField[25].sTag     := '0x9205';
  sExifField[25].sNameJpn := 'YŏFl';
  sExifField[25].sNameEng := 'MaxApertureValue';
  sExifField[25].sType    := 'RATIONAL';
  sExifField[25].sDetail  := '';

  sExifField[26].sTag     := '0x9206';
  sExifField[26].sNameJpn := 'ʑ̋';
  sExifField[26].sNameEng := 'SubjectDistance';
  sExifField[26].sType    := 'RATIONAL';
  sExifField[26].sDetail  := '';

  sExifField[27].sTag     := '0x9207';
  sExifField[27].sNameJpn := '';
  sExifField[27].sNameEng := 'MeteringMode';
  sExifField[27].sType    := 'SHORT';
  sExifField[27].sDetail  := '';

  sExifField[28].sTag     := '0x9208';
  sExifField[28].sNameJpn := '';
  sExifField[28].sNameEng := 'LightSource';
  sExifField[28].sType    := 'SHORT';
  sExifField[28].sDetail  := '';

  sExifField[29].sTag     := '0x9209';
  sExifField[29].sNameJpn := 'tbV';
  sExifField[29].sNameEng := 'Flash';
  sExifField[29].sType    := 'SHORT';
  sExifField[29].sDetail  := '';

  sExifField[30].sTag     := '0x920A';
  sExifField[30].sNameJpn := 'Yœ_';
  sExifField[30].sNameEng := 'FocalLength';
  sExifField[30].sType    := 'RATIONAL';
  sExifField[30].sDetail  := '';

  sExifField[31].sTag     := '0x9214';
  sExifField[31].sNameJpn := 'ʑ̃GA';
  sExifField[31].sNameEng := 'SubjectArea';
  sExifField[31].sType    := 'SHORT~(2 or 3 or 4)*2.2';
  sExifField[31].sDetail  := '';

  sExifField[32].sTag     := '0xA20B';
  sExifField[32].sNameJpn := 'tbVx';
  sExifField[32].sNameEng := 'FlashEnergy';
  sExifField[32].sType    := 'RATIONAL';
  sExifField[32].sDetail  := '';

  sExifField[33].sTag     := '0xA20C';
  sExifField[33].sNameJpn := 'Ԏg';
  sExifField[33].sNameEng := 'SpatialFrequencyResponse';
  sExifField[33].sType    := 'UNDEFINED~?';
  sExifField[33].sDetail  := '';

  sExifField[34].sTag     := '0xA20E';
  sExifField[34].sNameJpn := 'œ_ʂ̉̕𑜓x';
  sExifField[34].sNameEng := 'FocalPlaneXResolution';
  sExifField[34].sType    := 'RATIONAL';
  sExifField[34].sDetail  := '';

  sExifField[35].sTag     := '0xA20F';
  sExifField[35].sNameJpn := 'œ_ʂ̍̉𑜓x';
  sExifField[35].sNameEng := 'FocalPlaneYResolution';
  sExifField[35].sType    := 'RATIONAL';
  sExifField[35].sDetail  := '';

  sExifField[36].sTag     := '0xA210';
  sExifField[36].sNameJpn := 'œ_ʉ𑜓xP';
  sExifField[36].sNameEng := 'FocalPlaneResolutionUnit';
  sExifField[36].sType    := 'SHORT';
  sExifField[36].sDetail  := '';

  sExifField[37].sTag     := '0xA214';
  sExifField[37].sNameJpn := 'ʑ̈ʒu';
  sExifField[37].sNameEng := 'SubjectLocation';
  sExifField[37].sType    := 'SHORT~2';
  sExifField[37].sDetail  := '';

  sExifField[38].sTag     := '0xA215';
  sExifField[38].sNameJpn := 'IoCfbNX';
  sExifField[38].sNameEng := 'ExposureIndex';
  sExifField[38].sType    := 'RATIONAL';
  sExifField[38].sDetail  := '';

  sExifField[39].sTag     := '0xA217';
  sExifField[39].sNameJpn := 'ZT[';
  sExifField[39].sNameEng := 'SensingMethod';
  sExifField[39].sType    := 'SHORT';
  sExifField[39].sDetail  := '';

  sExifField[40].sTag     := '0xA300';
  sExifField[40].sNameJpn := 't@C\[X';
  sExifField[40].sNameEng := 'FileSource';
  sExifField[40].sType    := 'UNDEFINED';
  sExifField[40].sDetail  := '';

  sExifField[41].sTag     := '0xA301';
  sExifField[41].sNameJpn := 'V[^Cv';
  sExifField[41].sNameEng := 'SceneType';
  sExifField[41].sType    := 'UNDEFINED';
  sExifField[41].sDetail  := '';

  sExifField[42].sTag     := '0xA302';
  sExifField[42].sNameJpn := 'CFAp^[';
  sExifField[42].sNameEng := 'CFAPattern';
  sExifField[42].sType    := 'UNDEFINED~?';
  sExifField[42].sDetail  := '';

  sExifField[43].sTag     := '0xA401';
  sExifField[43].sNameJpn := 'XyVEGtFNg';
  sExifField[43].sNameEng := 'CustomRendered';
  sExifField[43].sType    := 'SHORT*2.2';
  sExifField[43].sDetail  := '';

  sExifField[44].sTag     := '0xA402';
  sExifField[44].sNameJpn := 'I[h';
  sExifField[44].sNameEng := 'ExposureMode';
  sExifField[44].sType    := 'SHORT*2.2';
  sExifField[44].sDetail  := '';

  sExifField[45].sTag     := '0xA403';
  sExifField[45].sNameJpn := 'zCgEoX';
  sExifField[45].sNameEng := 'WhiteBalance';
  sExifField[45].sType    := 'SHORT*2.2';
  sExifField[45].sDetail  := '';

  sExifField[46].sTag     := '0xA404';
  sExifField[46].sNameJpn := 'fW^EY[';
  sExifField[46].sNameEng := 'DigitalZoomRatio';
  sExifField[46].sType    := 'RATIONAL*2.2';
  sExifField[46].sDetail  := '';

  sExifField[47].sTag     := '0xA405';
  sExifField[47].sNameJpn := '35mmZœ_';
  sExifField[47].sNameEng := 'FocalLengthIn35mmFilm';
  sExifField[47].sType    := 'SHORT*2.2';
  sExifField[47].sDetail  := '';

  sExifField[48].sTag     := '0xA406';
  sExifField[48].sNameJpn := 'BeV[E^Cv';
  sExifField[48].sNameEng := 'SceneCaptureType';
  sExifField[48].sType    := 'SHORT*2.2';
  sExifField[48].sDetail  := '';

  sExifField[49].sTag     := '0xA407';
  sExifField[49].sNameJpn := 'QCERg[';
  sExifField[49].sNameEng := 'GainControl';
  sExifField[49].sType    := 'SHORT*2.2';
  sExifField[49].sDetail  := '';

  sExifField[50].sTag     := '0xA408';
  sExifField[50].sNameJpn := 'RgXg';
  sExifField[50].sNameEng := 'Contrast';
  sExifField[50].sType    := 'SHORT*2.2';
  sExifField[50].sDetail  := '';

  sExifField[51].sTag     := '0xA409';
  sExifField[51].sNameJpn := 'Oa';
  sExifField[51].sNameEng := 'Saturation';
  sExifField[51].sType    := 'SHORT*2.2';
  sExifField[51].sDetail  := '';

  sExifField[52].sTag     := '0xA40A';
  sExifField[52].sNameJpn := 'V[vlX';
  sExifField[52].sNameEng := 'Sharpness';
  sExifField[52].sType    := 'SHORT*2.2';
  sExifField[52].sDetail  := '';

  sExifField[53].sTag     := '0xA40B';
  sExifField[53].sNameJpn := 'BeRfBV';
  sExifField[53].sNameEng := 'DeviceSettingDescription';
  sExifField[53].sType    := 'UNDEFINED~?*2.2';
  sExifField[53].sDetail  := '';

  sExifField[54].sTag     := '0xA40C';
  sExifField[54].sNameJpn := 'ʑ̎Be[h';
  sExifField[54].sNameEng := 'SubjectDistanceRange';
  sExifField[54].sType    := 'SHORT*2.2';
  sExifField[54].sDetail  := '';

  sExifField[55].sTag     := '0xA420';
  sExifField[55].sNameJpn := '摜j[NID';
  sExifField[55].sNameEng := 'ImageUniqueID';
  sExifField[55].sType    := 'ASCII~33';
  sExifField[55].sDetail  := '';

  sExifField[56].sTag     := '0xA430';
  sExifField[56].sNameJpn := 'JLҖ';
  sExifField[56].sNameEng := 'CameraOwnerName';
  sExifField[56].sType    := 'ASCII~?';
  sExifField[56].sDetail  := '';

  sExifField[57].sTag     := '0xA431';
  sExifField[57].sNameJpn := 'JVAԍ';
  sExifField[57].sNameEng := 'BodySerialNumber';
  sExifField[57].sType    := 'ASCII~?';
  sExifField[57].sDetail  := '';

  sExifField[58].sTag     := '0xA432';
  sExifField[58].sNameJpn := 'Y̎dl';
  sExifField[58].sNameEng := 'LensSpecification';
  sExifField[58].sType    := 'LONG~4';
  sExifField[58].sDetail  := '';

  sExifField[59].sTag     := '0xA433';
  sExifField[59].sNameJpn := 'Ỹ[J';
  sExifField[59].sNameEng := 'LensMake';
  sExifField[59].sType    := 'ASCII~?';
  sExifField[59].sDetail  := '';

  sExifField[60].sTag     := '0xA434';
  sExifField[60].sNameJpn := 'Ỹf';
  sExifField[60].sNameEng := 'LensModel';
  sExifField[60].sType    := 'ASCII~?';
  sExifField[60].sDetail  := '';

  sExifField[61].sTag     := '0xA435';
  sExifField[61].sNameJpn := 'YVAԍ';
  sExifField[61].sNameEng := 'LensSerialNumbe';
  sExifField[61].sType    := 'ASCII~?';
  sExifField[61].sDetail  := '';

  sExifField[62].sTag     := '';
  sExifField[62].sNameJpn := '';
  sExifField[62].sNameEng := '';
  sExifField[62].sType    := '';
  sExifField[62].sDetail  := '';

  sExifField[63].sTag     := '';
  sExifField[63].sNameJpn := '';
  sExifField[63].sNameEng := '';
  sExifField[63].sType    := '';
  sExifField[63].sDetail  := '';

  sGpsField[ 0].sTag     := '0x0000';
  sGpsField[ 0].sNameJpn := 'GPS^Õo[W';
  sGpsField[ 0].sNameEng := 'GPSVersionID';
  sGpsField[ 0].sType    := 'BYTE~4';
  sGpsField[ 0].sDetail  := '';

  sGpsField[ 1].sTag     := '0x0001';
  sGpsField[ 1].sNameJpn := 'ܓx̓k';
  sGpsField[ 1].sNameEng := 'GPSLatitudeRef';
  sGpsField[ 1].sType    := 'ASCII~2';
  sGpsField[ 1].sDetail  := '';

  sGpsField[ 2].sTag     := '0x0002';
  sGpsField[ 2].sNameJpn := 'ܓxixAAbj';
  sGpsField[ 2].sNameEng := 'GPSLatitude';
  sGpsField[ 2].sType    := 'RATIONAL~3';
  sGpsField[ 2].sDetail  := '';

  sGpsField[ 3].sTag     := '0x0003';
  sGpsField[ 3].sNameJpn := 'ox̓';
  sGpsField[ 3].sNameEng := 'GPSLongitudeRef';
  sGpsField[ 3].sType    := 'ASCII~2';
  sGpsField[ 3].sDetail  := '';

  sGpsField[ 4].sTag     := '0x0004';
  sGpsField[ 4].sNameJpn := 'oxixAAbj';
  sGpsField[ 4].sNameEng := 'GPSLongitude';
  sGpsField[ 4].sType    := 'RATIONAL~3';
  sGpsField[ 4].sDetail  := '';

  sGpsField[ 5].sTag     := '0x0005';
  sGpsField[ 5].sNameJpn := 'x̊';
  sGpsField[ 5].sNameEng := 'GPSAltitudeRef';
  sGpsField[ 5].sType    := 'BYTE~1';
  sGpsField[ 5].sDetail  := '';

  sGpsField[ 6].sTag     := '0x0006';
  sGpsField[ 6].sNameJpn := 'ximj';
  sGpsField[ 6].sNameEng := 'GPSAltitude';
  sGpsField[ 6].sType    := 'RATIONAL';
  sGpsField[ 6].sDetail  := '';

  sGpsField[ 7].sTag     := '0x0007';
  sGpsField[ 7].sNameJpn := 'GPS̎ԁiqvj';
  sGpsField[ 7].sNameEng := 'GPSTimeStamp';
  sGpsField[ 7].sType    := 'RATIONAL~3';
  sGpsField[ 7].sDetail  := '';

  sGpsField[ 8].sTag     := '0x0008';
  sGpsField[ 8].sNameJpn := 'ʂɎgpGPSq';
  sGpsField[ 8].sNameEng := 'GPSSatellites';
  sGpsField[ 8].sType    := 'ASCII~?';
  sGpsField[ 8].sDetail  := '';

  sGpsField[ 9].sTag     := '0x0009';
  sGpsField[ 9].sNameJpn := 'GPSM@̏';
  sGpsField[ 9].sNameEng := 'GPSStatus';
  sGpsField[ 9].sType    := 'ASCII~2';
  sGpsField[ 9].sDetail  := '';

  sGpsField[10].sTag     := '0x000A';
  sGpsField[10].sNameJpn := 'GPS̑ʃ[h';
  sGpsField[10].sNameEng := 'GPSMeasureMode';
  sGpsField[10].sType    := 'ASCII~2';
  sGpsField[10].sDetail  := '';

  sGpsField[11].sTag     := '0x000B';
  sGpsField[11].sNameJpn := 'ʂ̐M';
  sGpsField[11].sNameEng := 'GPSDOP';
  sGpsField[11].sType    := 'RATIONAL';
  sGpsField[11].sDetail  := '';

  sGpsField[12].sTag     := '0x000C';
  sGpsField[12].sNameJpn := 'x̒P';
  sGpsField[12].sNameEng := 'GPSSpeedRef';
  sGpsField[12].sType    := 'ASCII~2';
  sGpsField[12].sDetail  := '';

  sGpsField[13].sTag     := '0x000D';
  sGpsField[13].sNameJpn := 'x';
  sGpsField[13].sNameEng := 'GPSSpeed';
  sGpsField[13].sType    := 'RATIONAL';
  sGpsField[13].sDetail  := '';

  sGpsField[14].sTag     := '0x000E';
  sGpsField[14].sNameJpn := 'is̊';
  sGpsField[14].sNameEng := 'GPSTrackRef';
  sGpsField[14].sType    := 'ASCII~2';
  sGpsField[14].sDetail  := '';

  sGpsField[15].sTag     := '0x000F';
  sGpsField[15].sNameJpn := 'isix';
  sGpsField[15].sNameEng := 'GPSTrack';
  sGpsField[15].sType    := 'RATIONAL';
  sGpsField[15].sDetail  := '';

  sGpsField[16].sTag     := '0x0010';
  sGpsField[16].sNameJpn := 'Be̊';
  sGpsField[16].sNameEng := 'GPSImgDirectionRef';
  sGpsField[16].sType    := 'ASCII~2';
  sGpsField[16].sDetail  := '';

  sGpsField[17].sTag     := '0x0011';
  sGpsField[17].sNameJpn := 'Beixj';
  sGpsField[17].sNameEng := 'GPSImgDirection';
  sGpsField[17].sType    := 'RATIONAL';
  sGpsField[17].sDetail  := '';

  sGpsField[18].sTag     := '0x0012';
  sGpsField[18].sNameJpn := 'ʂɗpn}f[^';
  sGpsField[18].sNameEng := 'GPSMapDatum';
  sGpsField[18].sType    := 'ASCII~?';
  sGpsField[18].sDetail  := '';

  sGpsField[19].sTag     := '0x0013';
  sGpsField[19].sNameJpn := 'ړIn̈ܓx̓k';
  sGpsField[19].sNameEng := 'GPSDestLatitudeRef';
  sGpsField[19].sType    := 'ASCII~2';
  sGpsField[19].sDetail  := '';

  sGpsField[20].sTag     := '0x0014';
  sGpsField[20].sNameJpn := 'ړIn̈ܓxixAAbj';
  sGpsField[20].sNameEng := 'GPSDestLatitude';
  sGpsField[20].sType    := 'RATIONAL';
  sGpsField[20].sDetail  := '';

  sGpsField[21].sTag     := '0x0015';
  sGpsField[21].sNameJpn := 'ړIňox̓';
  sGpsField[21].sNameEng := 'GPSDestLongitudeRef';
  sGpsField[21].sType    := 'ASCII~2';
  sGpsField[21].sDetail  := '';

  sGpsField[22].sTag     := '0x0016';
  sGpsField[22].sNameJpn := 'ړIňoxixAAb';
  sGpsField[22].sNameEng := 'GPSDestLongitude';
  sGpsField[22].sType    := 'RATIONAL';
  sGpsField[22].sDetail  := '';

  sGpsField[23].sTag     := '0x0017';
  sGpsField[23].sNameJpn := 'ړIn̕p̊';
  sGpsField[23].sNameEng := 'GPSBearingRef';
  sGpsField[23].sType    := 'ASCII~2';
  sGpsField[23].sDetail  := '';

  sGpsField[24].sTag     := '0x0018';
  sGpsField[24].sNameJpn := 'ړIn̕pixj';
  sGpsField[24].sNameEng := 'GPSBearing';
  sGpsField[24].sType    := 'RATIONAL';
  sGpsField[24].sDetail  := '';

  sGpsField[25].sTag     := '0x0019';
  sGpsField[25].sNameJpn := 'ړInւ̋̒P';
  sGpsField[25].sNameEng := 'GPSDestDistanceRef';
  sGpsField[25].sType    := 'ASCII~2';
  sGpsField[25].sDetail  := '';

  sGpsField[26].sTag     := '0x001A';
  sGpsField[26].sNameJpn := 'ړInւ̋';
  sGpsField[26].sNameEng := 'GPSDestDistance';
  sGpsField[26].sType    := 'RATIONAL';
  sGpsField[26].sDetail  := '';

  sGpsField[27].sTag     := '0x001B';
  sGpsField[27].sNameJpn := 'ʕ̖';
  sGpsField[27].sNameEng := 'GpsProcessingMethod';
  sGpsField[27].sType    := 'UNDEFINED~?';
  sGpsField[27].sDetail  := '';

  sGpsField[28].sTag     := '0x001C';
  sGpsField[28].sNameJpn := 'ʒn_̖';
  sGpsField[28].sNameEng := 'AreaInformation';
  sGpsField[28].sType    := 'UNDEFINED~?';
  sGpsField[28].sDetail  := '';

  sGpsField[29].sTag     := '0x001D';
  sGpsField[29].sNameJpn := 'GPSt';
  sGpsField[29].sNameEng := 'DateStamp';
  sGpsField[29].sType    := 'ASCII~11';
  sGpsField[29].sDetail  := '';

  sGpsField[30].sTag     := '0x001E';
  sGpsField[30].sNameJpn := 'GPS␳';
  sGpsField[30].sNameEng := 'Differrential';
  sGpsField[30].sType    := 'SHORT';
  sGpsField[30].sDetail  := '';

  for iRow1 := 0 to IFD_FIELD_MAX-1 do
  begin
    sIfdField2[iRow1].sTag     := '';
    sIfdField2[iRow1].sType    := '';
    sIfdField2[iRow1].sCount   := '';
    sIfdField2[iRow1].sOffset  := '';
    sIfdField2[iRow1].sData    := '';
    sIfdField2[iRow1].sAddress := '';
  end;

  for iRow1 := 0 to EXIF_FIELD_MAX-1 do
  begin
    sExifField2[iRow1].sTag     := '';
    sExifField2[iRow1].sType    := '';
    sExifField2[iRow1].sCount   := '';
    sExifField2[iRow1].sOffset  := '';
    sExifField2[iRow1].sData    := '';
    sExifField2[iRow1].sAddress := '';
  end;

  for iRow1 := 0 to GPS_FIELD_MAX-1 do
  begin
    sGpsField2[iRow1].sTag     := '';
    sGpsField2[iRow1].sType    := '';
    sGpsField2[iRow1].sCount   := '';
    sGpsField2[iRow1].sOffset  := '';
    sGpsField2[iRow1].sData    := '';
    sGpsField2[iRow1].sAddress := '';
  end;
end;

procedure GetField(Stream: TBytesStream; Start: Integer; Count: Integer; FieldType: String; Intel: Boolean; Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  Types: String;
  iIndex1: Integer;
  iCount1: Integer;
  aTag:    array[0..1] of Byte;
  aType:   array[0..1] of Byte;
  aCount:  array[0..3] of Byte;
  aOffset: array[0..3] of Byte;
begin
  for iIndex1 := 0 to Count-1 do
  begin
    //Motorola
    if Intel = FALSE then
    begin
      aTag   [0] := Stream.Bytes[Start +  0 + 12*iIndex1];
      aTag   [1] := Stream.Bytes[Start +  1 + 12*iIndex1];

      aType  [0] := Stream.Bytes[Start +  2 + 12*iIndex1];
      aType  [1] := Stream.Bytes[Start +  3 + 12*iIndex1];

      aCount [0] := Stream.Bytes[Start +  4 + 12*iIndex1];
      aCount [1] := Stream.Bytes[Start +  5 + 12*iIndex1];
      aCount [2] := Stream.Bytes[Start +  6 + 12*iIndex1];
      aCount [3] := Stream.Bytes[Start +  7 + 12*iIndex1];
      iCount1 := StrToInt('0x' + Format('%.2X', [aCount[0]]) +
                                 Format('%.2X', [aCount[1]]) +
                                 Format('%.2X', [aCount[2]]) +
                                 Format('%.2X', [aCount[3]]) );
      Types := '0x' + Format('%.2X', [aType[0]]) + Format('%.2X', [aType[1]]) ;

      //ubyte
      if      Types = '0x0001' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end;
      end

      //ascii
      else if Types = '0x0002' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end;
      end

      //ushort
      else if Types = '0x0003' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end;
      end

      //sbyte
      else if Types = '0x0006' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end;
      end

      //undefined
      else if Types = '0x0007' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end;
      end

      //sshort
      else if Types = '0x0008' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end;
      end

      else
      begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
      end;
    end

    //Intel
    else
    begin
      aTag   [0] := Stream.Bytes[Start +  1 + 12*iIndex1];
      aTag   [1] := Stream.Bytes[Start +  0 + 12*iIndex1];

      aType  [0] := Stream.Bytes[Start +  3 + 12*iIndex1];
      aType  [1] := Stream.Bytes[Start +  2 + 12*iIndex1];

      aCount [0] := Stream.Bytes[Start +  7 + 12*iIndex1];
      aCount [1] := Stream.Bytes[Start +  6 + 12*iIndex1];
      aCount [2] := Stream.Bytes[Start +  5 + 12*iIndex1];
      aCount [3] := Stream.Bytes[Start +  4 + 12*iIndex1];
      iCount1 := StrToInt('0x' + Format('%.2X', [aCount[0]]) +
                                 Format('%.2X', [aCount[1]]) +
                                 Format('%.2X', [aCount[2]]) +
                                 Format('%.2X', [aCount[3]]) );
      Types := '0x' + Format('%.2X', [aType[0]]) + Format('%.2X', [aType[1]]) ;

      //ubyte
      if      Types = '0x0001' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
        end;
      end

      //ascii
      else if Types = '0x0002' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8+ 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
        end;
      end

      //ushort
      else if Types = '0x0003' then
      begin

        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 10 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
        end;
      end

      //sbyte
      else if Types = '0x0006' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
        end;
      end

      //undefined
      else if Types = '0x0007' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := 0;
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 3 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := 0;
        end
        else if iCount1 = 4 then
        begin
          aOffset[0] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 11 + 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
        end;
      end

      //sshort
      else if Types = '0x0008' then
      begin
        if      iCount1 = 1 then
        begin
          aOffset[0] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[2] := 0;
          aOffset[3] := 0;
        end
        else if iCount1 = 2 then
        begin
          aOffset[0] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start +  8 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start + 10+ 12*iIndex1];
        end
        else
        begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
        end;
      end

      else
      begin
          aOffset[0] := Stream.Bytes[Start + 11 + 12*iIndex1];
          aOffset[1] := Stream.Bytes[Start + 10 + 12*iIndex1];
          aOffset[2] := Stream.Bytes[Start +  9 + 12*iIndex1];
          aOffset[3] := Stream.Bytes[Start +  8 + 12*iIndex1];
      end;
    end;

    //쐬
    sStr1 := '0x' + Format('%.2X', [aTag   [0]]) +
                    Format('%.2X', [aTag   [1]]);
    sStr2 := '0x' + Format('%.2X', [aType  [0]]) +
                    Format('%.2X', [aType  [1]]);
    sStr3 := '0x' + Format('%.2X', [aCount [0]]) +
                    Format('%.2X', [aCount [1]]) +
                    Format('%.2X', [aCount [2]]) +
                    Format('%.2X', [aCount [3]]);
    sStr4 := '0x' + Format('%.2X', [aOffset[0]]) +
                    Format('%.2X', [aOffset[1]]) +
                    Format('%.2X', [aOffset[2]]) +
                    Format('%.2X', [aOffset[3]]);
    sStr5 := '0x' + Format('%.8X', [Start + 12*iIndex1]);
    //ݒ
    if      FieldType = EXIF_IFD then
    begin
      sIfdField2[iIndex1].sTag     := sStr1;
      sIfdField2[iIndex1].sType    := sStr2;
      sIfdField2[iIndex1].sCount   := sStr3;
      sIfdField2[iIndex1].sOffset  := sStr4;
      sIfdField2[iIndex1].sAddress := sStr5;
    end
    else if FieldType = EXIF_EXIF then
    begin
      sExifField2[iIndex1].sTag     := sStr1;
      sExifField2[iIndex1].sType    := sStr2;
      sExifField2[iIndex1].sCount   := sStr3;
      sExifField2[iIndex1].sOffset  := sStr4;
      sExifField2[iIndex1].sAddress := sStr5;
    end
    else if FieldType = EXIF_GPS then
    begin
      sGpsField2[iIndex1].sTag     := sStr1;
      sGpsField2[iIndex1].sType    := sStr2;
      sGpsField2[iIndex1].sCount   := sStr3;
      sGpsField2[iIndex1].sOffset  := sStr4;
      sGpsField2[iIndex1].sAddress := sStr5;
    end
    else
    begin
      ;
    end;
  end;
end;

function GetValue(FileName: String; var StrListExif: TStringList; Sender: TObject): Boolean;
var
  Stream1: TBytesStream;
  File1: TSearchRec;
  iRow1: Integer;
  iStart1: Integer;
  iStart4: Integer;
  iCount1: Integer;
  hFindData1: THandle;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  bIntel: Boolean;
begin
  //
  Result := TRUE;

  //t@CTCY擾
  hFindData1 := FindFirst(FileName, faAnyFile, File1);
  try
    ;
  finally
    FindClose(File1);
  end;

  //s
  if hFindData1 <> 0 then
  begin
    Result := FALSE;
    Exit;
  end;

  //TCYmF
  if File1.Size < EXIF_MIN_SIZE then
  begin
    Result := FALSE;
    Exit;
  end;

  //
  InitTagField(Sender);

    //m
    Stream1  := TBytesStream.Create;
    //ǂݍ
    try
      //t@C̓eXg[ɓǂݏo
      Stream1.LoadFromFile(FileName);

      //JPEG + Exif (Motorola)
      if      (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and  //JPG
              (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E1) and  //Œ
              (Stream1.Bytes[ 6] = $45) and (Stream1.Bytes[ 7] = $78) and  //Ex
              (Stream1.Bytes[ 8] = $69) and (Stream1.Bytes[ 9] = $66) and  //if
              (Stream1.Bytes[10] = $00) and (Stream1.Bytes[11] = $00) and  //
              (Stream1.Bytes[12] = $4D) and (Stream1.Bytes[13] = $4D) and  //Motorola
              (Stream1.Bytes[14] = $00) and (Stream1.Bytes[15] = $2A) then //Œ
      begin
        //ZOg 16
        if (Stream1.Bytes[ 4] = $00) and (Stream1.Bytes[ 5] = $10) then
        begin
          Result := FALSE;
        end
        else
        begin
          bIntel := FALSE;
          sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[20]]) + Format('%.2X', [Stream1.Bytes[21]]);
          iCount1 := StrToInt(sStr11);
          iStart1 := (2 + 2 + 2 + 6) + (2 + 2 + 4) + (2);
          GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
          iCount1 := StrToInt(sStr11);
          iStart1 := (2 + 2 + 2 + 6);
          GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        end;
      end


      //JPEG + Exif (Intel)
      else if (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and  //JPG
              (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E1) and  //Œ
              (Stream1.Bytes[ 6] = $45) and (Stream1.Bytes[ 7] = $78) and  //Ex
              (Stream1.Bytes[ 8] = $69) and (Stream1.Bytes[ 9] = $66) and  //if
              (Stream1.Bytes[10] = $00) and (Stream1.Bytes[11] = $00) and  //
              (Stream1.Bytes[12] = $49) and (Stream1.Bytes[13] = $49) and  //Intel
              (Stream1.Bytes[14] = $2A) and (Stream1.Bytes[15] = $00) then //Œ
      begin
        //ZOg 16
        if (Stream1.Bytes[ 4] = $00) and (Stream1.Bytes[ 5] = $10) then
        begin
          Result := FALSE;
        end
        else
        begin
          bIntel := TRUE;
          sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[21]]) + Format('%.2X', [Stream1.Bytes[20]]);
          iCount1 := StrToInt(sStr11);
          iStart1 := (2 + 2 + 2 + 6) + (2 + 2 + 4) + (2);
          GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
          iCount1 := StrToInt(sStr11);
          iStart1 := (2 + 2 + 2 + 6);
          GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        end;
      end


      //TIFF + Exif (Motorola)
      else if (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $E1) and  //TIFF
              (Stream1.Bytes[ 4] = $45) and (Stream1.Bytes[ 5] = $78) and  //Ex
              (Stream1.Bytes[ 6] = $69) and (Stream1.Bytes[ 7] = $66) and  //if
              (Stream1.Bytes[ 8] = $00) and (Stream1.Bytes[ 9] = $00) and  //
              (Stream1.Bytes[10] = $4D) and (Stream1.Bytes[11] = $4D) and  //Motorola
              (Stream1.Bytes[12] = $00) and (Stream1.Bytes[13] = $2A) then //Œ
      begin
        //ZOg 16
        if (Stream1.Bytes[ 2] = $00) and (Stream1.Bytes[ 3] = $10) then
        begin
          Result := FALSE;
        end
        else
        begin
          bIntel := FALSE;
          sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[18]]) + Format('%.2X', [Stream1.Bytes[19]]);
          iCount1 := StrToInt(sStr11);
          iStart1 := (0 + 2 + 2 + 6) + (2 + 2 + 4) + (2);
          GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
          iCount1 := StrToInt(sStr11);
          iStart1 := (0 + 2 + 2 + 6);
          GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        end;
      end


      //TIFF + Exif (Intel)
      else if (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $E1) and  //TIFF
              (Stream1.Bytes[ 4] = $45) and (Stream1.Bytes[ 5] = $78) and  //Ex
              (Stream1.Bytes[ 6] = $69) and (Stream1.Bytes[ 7] = $66) and  //if
              (Stream1.Bytes[ 8] = $00) and (Stream1.Bytes[ 9] = $00) and  //
              (Stream1.Bytes[10] = $49) and (Stream1.Bytes[11] = $49) and  //Intel
              (Stream1.Bytes[12] = $2A) and (Stream1.Bytes[13] = $00) then //Œ
      begin

        //ZOg 16
        if (Stream1.Bytes[ 2] = $00) and (Stream1.Bytes[ 3] = $10) then
        begin
          Result := FALSE;
        end
        else
        begin
          bIntel := TRUE;
          sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[19]]) + Format('%.2X', [Stream1.Bytes[18]]);
          iCount1 := StrToInt(sStr11);
          iStart1 := (0 + 2 + 2 + 6) + (2 + 2 + 4) + (2);
          GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
          iCount1 := StrToInt(sStr11);
          iStart1 := (0 + 2 + 2 + 6);
          GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        end;
      end


      //TIFF Motorola
      else if (Stream1.Bytes[ 0] = $4D) and (Stream1.Bytes[ 1] = $4D) and  //Motorola
              (Stream1.Bytes[ 2] = $00) and (Stream1.Bytes[ 3] = $2A) then //Œ
      begin
        bIntel := FALSE;
        sStr12 := '0x' + Format('%.2X', [Stream1.Bytes[ 4]]) + Format('%.2X', [Stream1.Bytes[ 5]])
                       + Format('%.2X', [Stream1.Bytes[ 6]]) + Format('%.2X', [Stream1.Bytes[ 7]]);
        iStart4 := StrToInt(sStr12);
        sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[iStart4+0]]) + Format('%.2X', [Stream1.Bytes[iStart4+1]]);
        iCount1 := StrToInt(sStr11);
        iStart1 := StrToInt(sStr12) + (2);
        GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        iStart1 := 0;
        GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
      end


      //TIFF Intel
      else if (Stream1.Bytes[ 0] = $49) and (Stream1.Bytes[ 1] = $49) and  //Intel
              (Stream1.Bytes[ 2] = $2A) and (Stream1.Bytes[ 3] = $00) then //Œ
      begin
        bIntel := TRUE;
        sStr12 := '0x' + Format('%.2X', [Stream1.Bytes[ 7]]) + Format('%.2X', [Stream1.Bytes[ 6]])
                       + Format('%.2X', [Stream1.Bytes[ 5]]) + Format('%.2X', [Stream1.Bytes[ 4]]);
        iStart4 := StrToInt(sSTr12);
        sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[iStart4+1]]) + Format('%.2X', [Stream1.Bytes[iStart4+0]]);
        iCount1 := StrToInt(sStr11);
        iStart1 := StrToInt(sStr12) + (2);
        GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        iStart1 := 0;
        GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
      end


      //JPEG + JFIF + Exif (Motorola)
      else if (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and  //JPG
              (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E0) and  //Œ
              (Stream1.Bytes[ 6] = $4A) and (Stream1.Bytes[ 7] = $46) and  //JF
              (Stream1.Bytes[ 8] = $49) and (Stream1.Bytes[ 9] = $46) and  //IF
              (Stream1.Bytes[10] = $00) and                                //

              (Stream1.Bytes[20] = $FF) and (Stream1.Bytes[21] = $E1) and  //Œ
              (Stream1.Bytes[24] = $45) and (Stream1.Bytes[23] = $78) and  //Ex
              (Stream1.Bytes[26] = $69) and (Stream1.Bytes[27] = $66) and  //if
              (Stream1.Bytes[27] = $00) and (Stream1.Bytes[29] = $00) and  //
              (Stream1.Bytes[30] = $4D) and (Stream1.Bytes[31] = $4D) and  //Motorola
              (Stream1.Bytes[32] = $00) and (Stream1.Bytes[33] = $2A) then //Œ
      begin
        bIntel := FALSE;
        sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[21+18]]) + Format('%.2X', [Stream1.Bytes[20+18]]);
        iCount1 := StrToInt(sStr11);
        iStart1 := 18 + (2 + 2 + 2 + 6) + (2 + 2 + 4) + (2);
        GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        iStart1 := 18 + (2 + 2 + 2 + 6);
        GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
      end


      //JPEG + JFIF + Exif (Intel)
      else if (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and  //JPG
              (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E0) and  //Œ
              (Stream1.Bytes[ 6] = $4A) and (Stream1.Bytes[ 7] = $46) and  //JF
              (Stream1.Bytes[ 8] = $49) and (Stream1.Bytes[ 9] = $46) and  //IF
              (Stream1.Bytes[10] = $00) and                                //

              (Stream1.Bytes[20] = $FF) and (Stream1.Bytes[21] = $E1) and  //Œ
              (Stream1.Bytes[24] = $45) and (Stream1.Bytes[25] = $78) and  //Ex
              (Stream1.Bytes[26] = $69) and (Stream1.Bytes[27] = $66) and  //if
              (Stream1.Bytes[28] = $00) and (Stream1.Bytes[29] = $00) and  //
              (Stream1.Bytes[30] = $49) and (Stream1.Bytes[31] = $49) and  //Intel
              (Stream1.Bytes[32] = $2A) and (Stream1.Bytes[33] = $00) then //Œ
      begin
        bIntel := TRUE;
        sStr11 := '0x' + Format('%.2X', [Stream1.Bytes[21+18]]) + Format('%.2X', [Stream1.Bytes[20+18]]);
        iCount1 := StrToInt(sStr11);
        iStart1 := 18 + (2 + 2 + 2 + 6) + (2 + 2 + 4) + (2);
        GetField(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
        iStart1 := 18 + (2 + 2 + 2 + 6);
        GetOffset(Stream1, iStart1, iCount1, EXIF_IFD, bIntel, Sender);
      end


      //
      else
      begin
          Result := FALSE;
      end;

    finally
      //j
      FreeAndNil(Stream1);
    end;

    //ꗗf[^̍쐬
    StrListExif.Clear;
    for iRow1 := 0 to IFD_FIELD_MAX-1 do
    begin
      //
      if sIfdField2[iRow1].sTag = '' then
      begin
        Continue;
      end;
      //1sݒ
      sStr13 := sIfdField2[iRow1].sTag    + #09 +
                sIfdField2[iRow1].sType   + #09 +
                sIfdField2[iRow1].sCount  + #09 +
                sIfdField2[iRow1].sOffset + #09 +
                sIfdField2[iRow1].sData   + #09 +
                sIfdField2[iRow1].sAddress;
      StrListExif.Add(sStr13);
    end;
end;


procedure GetOffset(Stream: TBytesStream; Start: Integer; Count: Integer; FieldType: String; Intel: Boolean; Sender: TObject);
var
  sStr1: String;
  Types: String;
  Offset: String;
  iIndex1: Integer;
  iRow1: Integer;
  iByte1: Integer;
  iCount1: Integer;
  uShort1:  array[0..1] of Byte;
  sShort1:  array[0..1] of Byte;
  uLong1:   array[0..3] of Byte;
  uLong2:   array[0..3] of Byte;
  sLong1:   array[0..3] of Byte;
  sLong2:   array[0..3] of Byte;
  sFloat1:  array[0..3] of Byte;
  sDouble1: array[0..7] of Byte;
  bIntel: Boolean;
begin
  //ݒ
  bIntel := Intel;

  for iIndex1 := 0 to Count-1 do
  begin
    //ݒ
    if      FieldType = EXIF_IFD then
    begin
      Types   :=          sIfdField2[iIndex1].sType;
      Offset  :=          sIfdField2[iIndex1].sOffset;
      iCount1 := StrToInt(sIfdField2[iIndex1].sCount);
      sStr1   := '---';
    end
    else if FieldType = EXIF_EXIF then
    begin
      Types   :=          sExifField2[iIndex1].sType;
      Offset  :=          sExifField2[iIndex1].sOffset;
      iCount1 := StrToInt(sExifField2[iIndex1].sCount);
      sStr1   := '---';
    end
    else if FieldType = EXIF_GPS then
    begin
      Types   :=          sGpsField2[iIndex1].sType;
      Offset  :=          sGpsField2[iIndex1].sOffset;
      iCount1 := StrToInt(sGpsField2[iIndex1].sCount);
      sStr1   := '---';
    end
    else
    begin
      iCount1 := 0;
      sStr1   := '---';
    end;

    //ubyte
    if      Types = '0x0001'  then
    begin
      //oCgݒ
      iByte1 := 1;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        if iCount1 = 1 then
        begin
          sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ';
        end;
        if iCount1 = 2 then
        begin
          sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 5, 2))]) + ' @ ';
        end;
        if iCount1 = 3 then
        begin
          sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 5, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 7, 2))]) + ' @ ';
        end;
        if iCount1 = 4 then
        begin
          sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 5, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 7, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 9, 2))]) + ' @ ';
        end;
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          sStr1 := sStr1 + Format('%u', [Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1)]]) + ' @ ';
        end;
      end;
    end

    //ascii
    else if Types = '0x0002'  then
    begin
      //oCgݒ
      iByte1 := 1;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        if iCount1 = 1 then
        begin
          sStr1 := Chr(Ord(StrToInt('0x' + Copy(Offset, 3, 2)))) + ' @ ';
        end;
        if iCount1 = 2 then
        begin
          sStr1 := Chr(Ord(StrToInt('0x' + Copy(Offset, 3, 2)))) + ' @ ' +
                   Chr(Ord(StrToInt('0x' + Copy(Offset, 5, 2)))) + ' @ ';
        end;
        if iCount1 = 3 then
        begin
          sStr1 := Chr(Ord(StrToInt('0x' + Copy(Offset, 3, 2)))) + ' @ ' +
                   Chr(Ord(StrToInt('0x' + Copy(Offset, 5, 2)))) + ' @ ' +
                   Chr(Ord(StrToInt('0x' + Copy(Offset, 7, 2)))) + ' @ ';
        end;
        if iCount1 = 4 then
        begin
          sStr1 := Chr(Ord(StrToInt('0x' + Copy(Offset, 3, 2)))) + ' @ ' +
                   Chr(Ord(StrToInt('0x' + Copy(Offset, 5, 2)))) + ' @ ' +
                   Chr(Ord(StrToInt('0x' + Copy(Offset, 7, 2)))) + ' @ ' +
                   Chr(Ord(StrToInt('0x' + Copy(Offset, 9, 2)))) + ' @ ';
        end;
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          sStr1 := sStr1 + Chr(Ord(Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1)]));
        end;
      end;
    end

    //ushort
    else if Types = '0x0003'  then
    begin
      //oCgݒ
      iByte1 := 2;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        if iCount1 = 1 then
        begin
          sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2))]) + ' @ ';
        end;
        if iCount1 = 2 then
        begin
          sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2))]) + ' @ ' +
                   Format('%u', [StrToInt('0x' + Copy(Offset, 7, 2) + Copy(Offset, 9, 2))]) + ' @ ';
        end;
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            uShort1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            uShort1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sStr1 := sStr1 + Format('%u', [USHORT(uShort1)]) + ' @ ';
          end
          //Intel
          else
          begin
            uShort1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            uShort1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sStr1 := sStr1 + Format('%u', [USHORT(uShort1)]) + ' @ ';
          end;
        end;
      end;
    end

    //ulong
    else if Types = '0x0004'  then
    begin
      //oCgݒ
      iByte1 := 4;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        sStr1 := Format('%u', [StrToInt('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2) + Copy(Offset, 7, 2) + Copy(Offset, 9, 2))]) + ' @ ';
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            uLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            uLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            uLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            uLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sStr1 := sStr1 + Format('%u', [ULONG(uLong1)]) + ' @ ';
          end
          //Intel
          else
          begin
            uLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            uLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            uLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            uLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sStr1 := sStr1 + Format('%u', [ULONG(uLong1)]) + ' @ ';
          end;
        end;
      end;
    end

    //rational(ulong + ulong)
    else if Types = '0x0005'  then
    begin
      //oCgݒ
      iByte1 := 8;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            uLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            uLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            uLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            uLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            uLong2[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 7];
            uLong2[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 6];
            uLong2[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 5];
            uLong2[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 4];
            sStr1 := sStr1 + Format('%u', [ULONG(uLong1)]) + ' / ' + Format('%u', [ULONG(uLong2)]) + ' @ ';
          end
          //Intel
          else
          begin
            uLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            uLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            uLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            uLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            uLong2[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 4];
            uLong2[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 5];
            uLong2[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 6];
            uLong2[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 7];
            sStr1 := sStr1 + Format('%u', [ULONG(uLong1)]) + ' / ' + Format('%u', [ULONG(uLong2)]) + ' @ ';
          end;
        end;
      end;
    end

    //sbyte
    else if Types = '0x0006'  then
    begin
      //oCgݒ
      iByte1 := 1;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        if iCount1 = 1 then
        begin
          sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ';
        end;
        if iCount1 = 2 then
        begin
          sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 5, 2))]) + ' @ ';
        end;
        if iCount1 = 3 then
        begin
          sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 5, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 7, 2))]) + ' @ ';
        end;
        if iCount1 = 4 then
        begin
          sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 5, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 7, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 9, 2))]) + ' @ ';
        end;
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          sStr1 := sStr1 + Format('%d', [Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1)]]) + ' @ ';
        end;
      end;
    end

    //undef
    else if Types = '0x0007'  then
    begin
      //oCgݒ
      iByte1 := 1;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        if iCount1 = 1 then
        begin
          sStr1 := '0x' + Copy(Offset, 3, 2) + ' @ ';
        end;
        if iCount1 = 2 then
        begin
          sStr1 := '0x' + Copy(Offset, 3, 2) + ' @ ' +
                   '0x' + Copy(Offset, 5, 2) + ' @ ';
        end;
        if iCount1 = 3 then
        begin
          sStr1 := '0x' + Copy(Offset, 3, 2) + ' @ ' +
                   '0x' + Copy(Offset, 5, 2) + ' @ ' +
                   '0x' + Copy(Offset, 7, 2) + ' @ ';
        end;
        if iCount1 = 4 then
        begin
          sStr1 := '0x' + Copy(Offset, 3, 2) + ' @ ' +
                   '0x' + Copy(Offset, 5, 2) + ' @ ' +
                   '0x' + Copy(Offset, 7, 2) + ' @ ' +
                   '0x' + Copy(Offset, 9, 2) + ' @ ';
        end;
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          sStr1 := sStr1 + Format('0x%X', [Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1)]]) + ' @ ';
        end;
      end;
    end

    //sshort
    else if Types = '0x0008'  then
    begin
      //oCgݒ
      iByte1 := 2;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        if iCount1 = 1 then
        begin
          sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2))]) + ' @ ';
        end;
        if iCount1 = 2 then
        begin
          sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2))]) + ' @ ' +
                   Format('%d', [StrToInt('0x' + Copy(Offset, 7, 2) + Copy(Offset, 9, 2))]) + ' @ ';
        end;
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            sShort1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sShort1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sStr1 := sStr1 + Format('%d', [SHORT(sShort1)]) + ' @ ';
          end
          //Intel
          else
          begin
            sShort1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sShort1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sStr1 := sStr1 + Format('%d', [SHORT(sShort1)]) + ' @ ';
          end;
        end;
      end;
    end

    //slong
    else if Types = '0x0009'  then
    begin
      //oCgݒ
      iByte1 := 4;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        sStr1 := Format('%d', [StrToInt('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2) + Copy(Offset, 7, 2) + Copy(Offset, 9, 2))]) + ' @ ';
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            sLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sStr1 := sStr1 + Format('%d', [LONG(sLong1)]) + ' @ ';
          end
          //Intel
          else
          begin
            sLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sStr1 := sStr1 + Format('%d', [LONG(sLong1)]) + ' @ ';
         end;
        end;
      end;
    end

    //srational(slong + slong)
    else if Types = '0x000A'  then
    begin
      //oCgݒ
      iByte1 := 8;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            sLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sLong2[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 7];
            sLong2[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 6];
            sLong2[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 5];
            sLong2[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 4];
            sStr1 := sStr1 + Format('%d', [LONG(sLong1)]) + ' / ' + Format('%d', [LONG(sLong2)]) + ' @ ';
          end
          //Intel
          else
          begin
            sLong1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sLong1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sLong1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sLong1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sLong2[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 4];
            sLong2[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 5];
            sLong2[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 6];
            sLong2[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 7];
            sStr1 := sStr1 + Format('%d', [LONG(sLong1)]) + ' / ' + Format('%d', [LONG(sLong2)]) + ' @ ';
          end;
        end;
      end;
    end

    //float
    else if Types = '0x000B'  then
    begin
      //oCgݒ
      iByte1 := 4;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
        sStr1 := Format('%f', [StrToFloat('0x' + Copy(Offset, 3, 2) + Copy(Offset, 5, 2) + Copy(Offset, 7, 2) + Copy(Offset, 9, 2))]) + ' @ ';
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            sFloat1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sFloat1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sFloat1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sFloat1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sStr1 := sStr1 + Format('%f', [single(sFloat1)]) + ' @ ';
          end
          //Intel
          else
          begin
            sFloat1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sFloat1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sFloat1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sFloat1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sStr1 := sStr1 + Format('%f', [single(sFloat1)]) + ' @ ';
          end;
        end;
      end;
    end

    //double
    else if Types = '0x000C'  then
    begin
      //oCgݒ
      iByte1 := 8;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
      end
      //offsetgp
      else
      begin
        sStr1 := '';
        for iRow1 := 0 to iCount1-1 do
        begin
          //Motorola
          if bIntel = FALSE then
          begin
            sDouble1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 7];
            sDouble1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 6];
            sDouble1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 5];
            sDouble1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 4];
            sDouble1[4] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sDouble1[5] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sDouble1[6] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sDouble1[7] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sStr1 := sStr1 + Format('%f', [DOUBLE(sDouble1)]) + ' @ ';
          end
          //Intel
          else
          begin
            sDouble1[0] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 0];
            sDouble1[1] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 1];
            sDouble1[2] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 2];
            sDouble1[3] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 3];
            sDouble1[4] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 4];
            sDouble1[5] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 5];
            sDouble1[6] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 6];
            sDouble1[7] := Stream.Bytes[Start + StrToInt(Offset) + (iByte1*iRow1) + 7];
            sStr1 := sStr1 + Format('%f', [DOUBLE(sDouble1)]) + ' @ ';
          end;
        end;
      end;
    end

    //
    else
    begin
      //oCgݒ
      iByte1 := 1;
      //offset̂܂܎gp
      if (iByte1 * iCount1) <= 4 then
      begin
      end
      //offsetgp
      else
      begin
      end;
    end;

    //ݒ
    if      FieldType = EXIF_IFD then
    begin
      sIfdField2[iIndex1].sData := sStr1;
    end
    else if FieldType = EXIF_EXIF then
    begin
      sExifField2[iIndex1].sData := sStr1;
    end
    else if FieldType = EXIF_GPS then
    begin
      sGpsField2[iIndex1].sData := sStr1;
    end
    else
    begin
      ;
    end;
  end;
end;

end.
