unit Extention;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  MyUtility, IniFiles;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 540;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  LISTBOX8_WIDTH       = 690;
  GROUP_COUNT          = 101;


type
  TFormExtention = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    Panel3: TPanel;
    Panel6: TPanel;
    Panel5: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ListBox8: TListBox;
    ListBox9: TListBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure GetFileList(Sender: TObject);
    procedure ListBox8Click(Sender: TObject);
    procedure ListBox9Click(Sender: TObject);
    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox9DblClick(Sender: TObject);
    procedure ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox9KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListExt: TStringList;
    StrListPrg: TStringList;
    StrListLoad: TStringList;
    StrListExtArray: array [0..GROUP_COUNT-1] of TStringList;
    StrListPrgArray: array [0..GROUP_COUNT-1] of TStringList;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormExtention: TFormExtention;

implementation

{$R *.dfm}

uses
  Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormExtention.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormExtention.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormExtention.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormExtention.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormExtention.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExtention', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExtention', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExtention', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExtention', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExtention', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //Ɗm
    StrListExt := TStringList.Create;
    StrListPrg := TStringList.Create;
    StrListLoad := TStringList.Create;
  for iRow1 := 0 to High(StrListExtArray)-1 do
  begin
    StrListExtArray[iRow1] := TStringList.Create;
    StrListPrgArray[iRow1] := TStringList.Create;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //j
  IniFile.Free;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox8.Style := lbOwnerDrawFixed;
    ListBox9.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox8.Style := lbStandard;
    ListBox9.Style := lbStandard;
  end;

end;

procedure TFormExtention.FormDestroy(Sender: TObject);
var
  irow1: Integer;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormExtention', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormExtention', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormExtention', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormExtention', 'Left',   FormExtention.Left);
    IniFile.WriteInteger('FormExtention', 'Top',    FormExtention.Top);
    IniFile.WriteInteger('FormExtention', 'Width',  FormExtention.Width);
    IniFile.WriteInteger('FormExtention', 'Height', FormExtention.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListPrg.Free;
  StrListExt.Free;
  StrListLoad.Free;
  for iRow1 := 0 to High(StrListExtArray)-1 do
  begin
    StrListExtArray[iRow1].Free;
    StrListPrgArray[iRow1].Free;
  end;
end;

procedure TFormExtention.FormResize(Sender: TObject);
begin
  Panel6.Height :=  Panel3.ClientHeight div 2;
end;

procedure TFormExtention.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormExtention.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormExtention.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormExtention.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormExtention.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormExtention.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  ListBox8.SetFocus;

  //XN[o[\
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 2, 0);
  ListBox9.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 2, 0);


  //IMEIt
  SetImeMode(FormExtention.Handle, imClose);

  //擾
  GetFileList(Sender);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Extention.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormExtention, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormExtention, StrLanguageFileName, Sender);
  end;
end;

procedure TFormExtention.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormExtention, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormExtention, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormExtention.ButtonOKClick(Sender: TObject);
begin
  //ݒ
  if ListBox8.Items.Count > 0 then
  begin
    FormMain.StrRetFormExtention1 := ListBox8.Items[ListBox8.ItemIndex];
    FormMain.StrRetFormExtention2 := ListBox9.Items[ListBox8.ItemIndex];
  end
  else
  begin
    FormMain.StrRetFormExtention1 := '';
    FormMain.StrRetFormExtention2 := '';
  end;

  //I
  ModalResult := mrOK;
end;

procedure TFormExtention.ButtonCancelClick(Sender: TObject);
begin
  //ݒ
  FormMain.StrRetFormExtention1 := '';
  FormMain.StrRetFormExtention2 := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormExtention.GetFileList(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr11: String;
  sStr12: String;
  iRow1: Integer;
  iRow2: Integer;
  iRow3: Integer;
  iIndex1: Integer;
begin
  //ݒ
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + FILENAME_EXT;
  end
  else
  begin
    sStr1 := FormMain.StrAnnsFMPath + FILENAME_EXT;
  end;

  //Ǎ
  if FileExists(sStr1) = TRUE then
  begin
    StrListLoad.LoadFromFile(sStr1);
  end
  else
  begin
    ListBox8.Items.Clear;
    ListBox9.Items.Clear;
  end;

  //
  StrListExt.Clear;
  StrListPrg.Clear;


  //
  for iRow1 := 0 to High(StrListExtArray)-1 do
  begin
    StrListExtArray[iRow1].Clear;
    StrListPrgArray[iRow1].Clear;
  end;

  //ݒ
  iIndex1 := 0;
  for iRow1 := 0 to StrListLoad.Count-1 do
  begin
    //擾
    sStr1 := StrListLoad.Strings[iRow1] ;
    //1
    if Length(sStr1) >= 1 then
    begin
      sStr2 := Copy(sStr1, 1, 1);
    end;
    //2
    if Length(sStr1) >= 2 then
    begin
      sStr3 := Copy(sStr1, 1, 2);
    end;

    //ȍ~̓Rg
    if sStr3 = '//' then
    begin
      Break;
    end;

    //؂
    if      sStr2 = '/' then
    begin
      iIndex1 := iIndex1+1;
    end
    //gq
    else if sStr2 = '.' then
    begin
      StrListExtArray[iIndex1].Add(sStr1);
    end
    //vO
    else
    begin
      StrListPrgArray[iIndex1].Add(sStr1);
    end;
  end;


  //\
  ListBox8.Items.Clear;
  ListBox9.Items.Clear;
  for iRow1 := 0 to High(StrListExtArray)-1 do
  begin
     if StrListPrgArray[iRow1].Count > 0 then
     begin
       for iRow2 := 0 to StrListPrgArray[iRow1].Count-1 do
       begin
         //vO
         sStr11 := StrListPrgArray[iRow1].Strings[iRow2];
         //gq
         sStr12 := '';
         for iRow3 := 0 to StrListExtArray[iRow1].Count-1 do
         begin
           sStr12 := sStr12 + StrListExtArray[iRow1].Strings[iRow3] + ';';
         end;
         ListBox8.Items.Add(sStr12);
         ListBox9.Items.Add(sStr11)
       end;
     end;
  end;

  //ݒ
  if ListBox8.Items.Count > 0 then
  begin
    ListBox8.ItemIndex := 0;
    ListBox9.ItemIndex := 0;
  end;
  //tH[JXݒ
  ListBox8.SetFocus;
end;


procedure TFormExtention.ListBox8Click(Sender: TObject);
begin
  ListBox9.ItemIndex := ListBox8.ItemIndex;
end;

procedure TFormExtention.ListBox9Click(Sender: TObject);
begin
  ListBox8.ItemIndex := ListBox9.ItemIndex;
end;

procedure TFormExtention.ListBox8DblClick(Sender: TObject);
begin
  //s
  ButtonOK.SetFocus;
  ButtonOkClick(Sender);
end;

procedure TFormExtention.ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //RETURN
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOkClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormExtention.ListBox9DblClick(Sender: TObject);
begin
  //s
  ButtonOK.SetFocus;
  ButtonOkClick(Sender);
end;

procedure TFormExtention.ListBox9KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //RETURN
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOkClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

end.
