unit FileName;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET  = 640;
  FORM_HEIGHT_SET = 320;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';
  LISTBOX8_WIDTH  = 640;

type
  TFormFileName = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox8: TListBox;
    Panel3: TPanel;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    CheckBox1: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure CheckBox1Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;
    BoolFormShow: Boolean;

  public
    { Public 錾 }

  end;

var
  FormFileName: TFormFileName;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFileName.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFileName.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFileName.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFileName.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFileName.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //
  BoolFormShow := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFileName', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFileName', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFileName', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFileName', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFileName', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  CheckBox1.Checked   := IniFile.ReadBool('FormFileName', 'Sort',   FALSE);
  if CheckBox1.Checked = TRUE then
  begin
    ListBox8.Sorted := TRUE;
  end;
  //j
  IniFile.Free;

  //Ǎ
  if FileExists(ExtractFilepath(ParamStr(0)) + PACK_FILENAME_TXT) = TRUE then
  begin
    FormMain.StrListPackFileNameHistory.LoadFromFile(ExtractFilepath(ParamStr(0)) + PACK_FILENAME_TXT, TEncoding.Unicode);
  end;
  ListBox8.Items.Assign(FormMain.StrListPackFileNameHistory);

  //ݒ
  if ListBox8.Items.Count > 0 then
  begin
    ListBox8.ItemIndex := 0;
  end;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox8.Style := lbStandard;
  end;
end;

procedure TFormFileName.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFileName', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFileName', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFileName', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFileName', 'Left',   FormFileName.Left);
    IniFile.WriteInteger('FormFileName', 'Top',    FormFileName.Top);
    IniFile.WriteInteger('FormFileName', 'Width',  FormFileName.Width);
    IniFile.WriteInteger('FormFileName', 'Height', FormFileName.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteBool('FormFileName', 'Sort', CheckBox1.Checked);
  //j
  IniFile.Free;
end;

procedure TFormFileName.FormResize(Sender: TObject);
begin
;
end;

procedure TFormFileName.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFileName.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFileName.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFileName.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFileName.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFileName.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  ListBox8.SetFocus;

  //XN[o[\
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 2, 0);

  //IMEIt
  SetImeMode(FormFileName.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FileName.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFilename, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFilename, StrLanguageFileName, Sender);
  end;

  //ݒ
  BoolFormShow := TRUE;
end;

procedure TFormFileName.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //Return
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFilename, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFilename, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFileName.ButtonOKClick(Sender: TObject);
begin
  //ݒȂ
  if Listbox8.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : History item is enpty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //I
  else if Listbox8.ItemIndex = -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : IĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : History item is not selected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //s
  else
  begin
    //߂l
    FormMain.StrRetFormFileName := ListBox8.Items.Strings[ListBox8.ItemIndex];
    //I
    ModalResult := mrOK;
  end;
end;

procedure TFormFileName.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;


procedure TFormFileName.ListBox8DblClick(Sender: TObject);
begin
  //s
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormFileName.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin

  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;

end;

procedure TFormFileName.CheckBox1Click(Sender: TObject);
begin
  if BoolFormShow = TRUE then
  begin
    //ݒ
    if CheckBox1.Checked = TRUE then
    begin
      ListBox8.Sorted := TRUE;
    end
    else
    begin
      ListBox8.Sorted := FALSE;
    end;

    //Ǎ
    if FileExists(ExtractFilepath(ParamStr(0)) + PACK_FILENAME_TXT) = TRUE then
    begin
      FormMain.StrListPackFileNameHistory.LoadFromFile(ExtractFilepath(ParamStr(0)) + PACK_FILENAME_TXT, TEncoding.Unicode);
    end;
    ListBox8.Items.Assign(FormMain.StrListPackFileNameHistory);

    //ݒ
    if ListBox8.Items.Count > 0 then
    begin
      ListBox8.ItemIndex := 0;
    end;
  end;
end;

end.
