unit FolderSize;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  IniFiles, Vcl.StdCtrls, Vcl.Menus, Vcl.ExtCtrls, Masks;

const
  FORM_WIDTH_SET         = 580;
  FORM_HEIGHT_SET        = 320;
  CSVLIST_COLUMN_MAX     = 64;
  CSVLIST_COLUMN_WIDTH_0 = 72;
  CSVLIST_COLUMN_WIDTH   = 256;
  TITLE_FOLDER_SIZE      = 'tH_TCY';
  TITLE_FOLDER_SIZE_ENG  = 'Folder Size';

type
  TFormFolderSize = class(TForm)
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuEscape: TMenuItem;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    Panel1: TPanel;
    ButtonRun: TButton;
    ButtonStop: TButton;
    ButtonCancel: TButton;
    PopupMenu1: TPopupMenu;
    PopUpCopy1: TMenuItem;
    ButtonGetList: TButton;
    PopUpSelectAll: TMenuItem;
    MenuQuit: TMenuItem;
    Timer1: TTimer;
    MenuSetting: TMenuItem;
    MenuShowLast: TMenuItem;
    MenuShowMainTopLeft: TMenuItem;
    Timer2: TTimer;
    Panel2: TPanel;
    Memo2: TMemo;
    Memo1: TMemo;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);

    procedure ButtonRunClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonGetListClick(Sender: TObject);

    procedure MenuEscapeClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);
    procedure MenuShowLastClick(Sender: TObject);
    procedure MenuShowTileClick(Sender: TObject);
    procedure MenuShowMainTopLeftClick(Sender: TObject);
    procedure LoadResultFile(Sender: TObject);

    procedure PopUpCopy1Click(Sender: TObject);
    procedure PopUpSelectAllClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListKeyMap: TStringList;
    StrListText: TStringList;
    BoolStop: Boolean;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFolderSize: TFormFolderSize;

implementation

uses
  Main, MyUtility;

{$R *.dfm}

//WindowsAPIR[obN֐ EBhE̗
function EnumWindowsProc(Wnd: HWND; lParam: Longint): Bool; stdcall; export;
var
  szCaption: array [0..255] of Char;
begin
  //ݒ
  Result:= TRUE;
  //EBhEnh擾
  GetWindowText(Wnd, szCaption, sizeof(szCaption));
  //gȊȎSĂݒ肷
  if (Wnd <> FormMain.Handle) then
  begin
    FormMain.StrListWindowName2.Add(StrPas(szCaption));
    FormMain.StrListWindowHwnd2.Add(IntToStr(Wnd));
  end;
end;

procedure TFormFolderSize.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFolderSize.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool('FormFolderSize', 'MenuShowLast',        MenuShowLast.Checked);
  IniFile.WriteBool('FormFolderSize', 'MenuShowMainTopLeft', MenuShowMainTopLeft.Checked);
  //j
  IniFile.Free;

  //IMEIt
  SetImeMode(FormFolderSize.Handle, imClose);
end;

procedure TFormFolderSize.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormFolderSize.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //
  Memo1.Modified := FALSE;
  Memo1.ReadOnly := TRUE;
  Memo1.Lines.Clear;

  Memo2.Modified := FALSE;
  Memo2.ReadOnly := TRUE;
  Memo2.Lines.Clear;

  ButtonRun.Enabled    := TRUE;
  ButtonStop.Enabled   := FALSE;
  ButtonCancel.Enabled := TRUE;

  //
  Timer1.Enabled := FALSE;
  Timer2.Enabled := FALSE;

  //m
  StrListKeyMap := TStringList.Create;
  StrListText := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  FormPosLeft   := IniFile.ReadInteger('FormFolderSize', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFolderSize', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFolderSize', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFolderSize', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFolderSize', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;

  FormMain.FRichEditViewColor     := StringToColor(IniFile.ReadString('FRichEditView',      'Color',     ColorToString(clWhite)));
  FormMain.FRichEditViewFontColor := StringToColor(IniFile.ReadString('FRichEditView',      'FontColor', ColorToString(clBlack)));
  FormMain.FRichEditViewFontName  :=               IniFile.ReadString('FRichEditView',      'FontName',  'lr SVbN');
  FormMain.FRichEditViewFontSize  :=      StrToInt(IniFile.ReadString('FRichEditView',      'FontSize',  '14'));

  Memo1.Color      := FormMain.FRichEditViewColor;
  Memo1.Font.Color := FormMain.FRichEditViewFontColor;
  Memo1.Font.Name  := FormMain.FRichEditViewFontName;
  Memo1.Font.Size  := FormMain.FRichEditViewFontSize;

  Memo2.Color      := FormMain.FRichEditViewColor;
  Memo2.Font.Color := FormMain.FRichEditViewFontColor;
  Memo2.Font.Name  := FormMain.FRichEditViewFontName;
  Memo2.Font.Size  := FormMain.FRichEditViewFontSize;

  MenuShowLast.Checked        := IniFile.ReadBool('FormFolderSize', 'MenuShowLast',        TRUE);
  MenuShowMainTopLeft.Checked := IniFile.ReadBool('FormFolderSize', 'MenuShowMainTopLeft', FALSE);

  //j
  IniFile.Free;

  //ݒ
  SetShortCutKey(Sender);
end;

procedure TFormFolderSize.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFolderSize', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFolderSize', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFolderSize', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFolderSize', 'Left',   FormFolderSize.Left);
    IniFile.WriteInteger('FormFolderSize', 'Top',    FormFolderSize.Top);
    IniFile.WriteInteger('FormFolderSize', 'Width',  FormFolderSize.Width);
    IniFile.WriteInteger('FormFolderSize', 'Height', FormFolderSize.Height);
  end;

  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
  StrListText.Free;

end;

procedure TFormFolderSize.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //{
  if      ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFolderSize, StrLanguageFileName, Sender);
    //\
    LoadResultFile(Sender);
    //j[ݒ
    PopUpCopy1.Caption := 'Rs[(&C)';
    PopUpSelectAll.Caption := 'SI(&A)';
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFolderSize, StrLanguageFileName, Sender);
    //\
    LoadResultFile(Sender);
    //j[ݒ
    PopUpCopy1.Caption := 'Copy(&C)';
    PopUpSelectAll.Caption := 'Select All(&A)';
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFolderSize.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFolderSize.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFolderSize.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFolderSize.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFolderSize.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFolderSize.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFolderSize.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FolderSize.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFolderSize, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFolderSize, StrLanguageFileName, Sender);
  end;

  //\
  LoadResultFile(Sender);

  //tH[JXݒ
  ButtonRun.SetFocus;

  //j[ݒ
  if BoolJapanese = TRUE then
  begin
    PopUpCopy1.Caption     := 'Rs[(&C)';
    PopUpSelectAll.Caption := 'SI(&A)';
  end
  else
  begin
    PopUpCopy1.Caption     := 'Copy(&C)';
    PopUpSelectAll.Caption := 'Select All(&A)';
  end;

  //ݒ
  Timer1.Enabled := TRUE;

  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    Timer2.Enabled := TRUE;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    Timer2.Enabled := TRUE;
  end;
end;

procedure TFormFolderSize.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;

  if MenuShowLast.Checked = TRUE then
  begin
      //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
      MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
      MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
      MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
      MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
      MonitorRight  := MonitorLeft + MonitorWidth;
      MonitorButtom := MonitorTop  + MonitorHeight;

      //\ł ȌԂŕ\
      if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
         ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
         ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
         ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
      begin
        FormFolderSize.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
      end
      //ʓɕ\łȂ ftHgŕ\
      else
      begin
        FormFolderSize.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
      end;
  end;

  if MenuShowMainTopLeft.Checked = TRUE then
  begin
    FormFolderSize.SetBounds(FormMain.Left + 20, FormMain.Top - 20, FormFolderSize.Width, FormFolderSize.Height);
  end;

end;

procedure TFormFolderSize.Timer2Timer(Sender: TObject);
begin
  //Zbg
  Timer2.Enabled := FALSE;

  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł' + #13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł' +#13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormFolderSize.FormResize(Sender: TObject);
begin
  Memo2.Height := Panel2.Height div 3;
end;

procedure TFormFolderSize.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFolderSize.MenuEscapeClick(Sender: TObject);
begin
  //I
  ModalResult := mrOK;
end;

procedure TFormFolderSize.MenuQuitClick(Sender: TObject);
begin
  //I
  ModalResult := mrOK;
end;

procedure TFormFolderSize.MenuShowLastClick(Sender: TObject);
begin
  MenuShowLast.Checked        := TRUE;
  MenuShowMainTopLeft.Checked := FALSE;
  Timer1.Enabled := TRUE;
end;

procedure TFormFolderSize.MenuShowTileClick(Sender: TObject);
begin
  MenuShowLast.Checked        := FALSE;
  MenuShowMainTopLeft.Checked := FALSE;
  Timer1.Enabled := TRUE;
end;

procedure TFormFolderSize.MenuShowMainTopLeftClick(Sender: TObject);
begin
  MenuShowLast.Checked        := FALSE;
  MenuShowMainTopLeft.Checked := TRUE;
  Timer1.Enabled := TRUE;
end;

procedure TFormFolderSize.PopUpCopy1Click(Sender: TObject);
begin
  if Sender = Memo1 then
  begin
    if Memo1.SelLength > 0 then
    begin
      Memo1.CopyToClipboard;
    end;
  end;
  if Sender = Memo2 then
  begin
    if Memo2.SelLength > 0 then
    begin
      Memo2.CopyToClipboard;
    end;
  end;
end;

procedure TFormFolderSize.PopUpSelectAllClick(Sender: TObject);
begin
  if Sender = Memo1 then
  begin
    if Memo1.SelLength > 0 then
    begin
      Memo1.SelectAll;
    end;
  end;
  if Sender = Memo2 then
  begin
    if Memo2.SelLength > 0 then
    begin
      Memo2.SelectAll;
    end;
  end;
end;

procedure TFormFolderSize.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //annsfm
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
  begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if StrListKeyMap.Count > 0 then
    begin
      SetShortCutNew('1017', MenuQuit, Sender);
      SetShortCutNew('1311', MenuEscape, Sender);
    end;
  end;
end;

procedure TFormFolderSize.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormFolderSize.ButtonStopClick(Sender: TObject);
begin
  //ݒ
  BoolStop := TRUE;
  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : f܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Operation had stopped.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
end;

procedure TFormFolderSize.ButtonCancelClick(Sender: TObject);
begin
  MenuEscapeClick(Sender);
end;

procedure TFormFolderSize.ButtonGetListClick(Sender: TObject);
var
  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList5: TStringList;
  StrList6: TStringList;
  StrList7: TStringList;
  StrList8: TStringList;
  StrList9: TStringList;
  StrList10: TStringList;
  StrList11: TStringList;
  StrList12: TStringList;
  CsvList1: TStringList;
  CsvList2: TStringList;
  CsvList3: TStringList;
  iRow1: Integer;
  iRow2: Integer;
  iVal1: Integer;
  iLen1: Integer;
  i64Int1: Int64;
  i64Int2: Int64;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr21: String;
  sStr22: String;
  File2: TWin32FindData;
  hFindData1: THandle;

  procedure ThisListFilesDrive(
                DirName    :String;      //       fBNgtpX
                TheList    :TStringList  //       ꗗi[ TStringList
            );
  var
    sStr2: string;
    sStr3: String;
    sStr4: String;
    sStr5: String;
    sStr6: String;
    i64Int1: Int64;
    File2: TWin32FindData;
    hFindData1: THandle;
  begin
    //ݒ
    if Copy(DirName, Length(DirName), 1) <> '\' then
    begin
      DirName := DirName + '\';
    end;
    sStr2 := DirName + '*.*';
    //t@Č
    hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
    if hFindData1 <> INVALID_HANDLE_VALUE then
    begin
      repeat
        //
        if BoolStop= TRUE then
        begin
          Break;
        end;
        //efBNg܂͎qfBNg̔
        if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
        begin
          //
          sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
          //t
          sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                    SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
          //TCY͐̂܂
          i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
          sStr6   := IntToStr(i64Int1);

          //t@C̐ݒ
          sStr3 := DirName + String(File2.cFileName);
          //fBNg̔)
          if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
          begin
            //tH_ɂ
            sStr3 := sStr3 + '\';
            //ǉ
            TheList.Add(sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr3);
            //ċNIɌ
            Application.ProcessMessages;
            ThisListFilesDrive(sStr3, TheList);
            Application.ProcessMessages;
          end
          else
          begin
            //ǉ
            TheList.Add(sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr3);
          end;
        end;
      //Č
      until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
      //I
      WinApi.Windows.FindClose(hFindData1);
    end;
    //
    Application.ProcessMessages;
  end;

begin
  //m
  StrList1  := TStringList.Create;
  StrList2  := TStringList.Create;
  StrList3  := TStringList.Create;
  StrList5  := TStringList.Create;
  StrList6  := TStringList.Create;
  StrList7  := TStringList.Create;
  StrList8  := TStringList.Create;
  StrList9  := TStringList.Create;
  StrList10 := TStringList.Create;
  StrList11 := TStringList.Create;
  StrList12 := TStringList.Create;
  CsvList1  := TStringList.Create;
  CsvList2  := TStringList.Create;
  CsvList3  := TStringList.Create;
  //\[g
  StrList1.Sorted := TRUE;

  //t@Cǂݍ
  sStr4 := ExtractFilePath(ParamStr(0)) + FOLDER_SIZE_TXT;
  if FileExists(sStr4) = TRUE then
  begin
    //
    i64Int2 := 0;
    //ݒ
    BoolStop := FALSE;
    ButtonRun.Enabled     := FALSE;
    ButtonGetList.Enabled := FALSE;
    ButtonStop.Enabled    := TRUE;
    ButtonCancel.Enabled  := FALSE;
    ButtonStop.SetFocus;
    Application.ProcessMessages;
    //Ǎ
    StrList6.LoadFromFile(sStr4, TEncoding.Unicode);

    //擾
    for iRow1 := 0 to StrList6.Count-1 do
    begin
      //
      Application.ProcessMessages;
      //~
      if     BoolStop = TRUE then
      begin
        break;
      end;

      //
      Application.ProcessMessages;
      //擪
      if      iRow1 = 0 then
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList6.Strings[0], CsvList1);
        //pX
        sStr5 := CsvList1[1];
        //
        StrList7.Add(CsvList1[0] + #09 + CsvList1[1]);
      end
      //Ō
      else if iRow1 = StrList6.Count-1 then
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList6.Strings[StrList6.Count-1], CsvList1);
        //
        StrList7.Add(CsvList1[0] + #09 + ConvertInt64ToStr20(i64Int2));
      end
      //
      else
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList6.Strings[iRow1], CsvList1);
        //tH_
        if Copy(CsvList1[0], Length(CsvList1[0]), 1) = '\' then
        begin
          //~
          if     BoolStop = TRUE then
          begin
            break;
          end;

          //z
          StrList5.Clear;
          Application.ProcessMessages;
          ThisListFilesDrive(sStr5 + CsvList1[0], StrList5);
          Application.ProcessMessages;
          i64Int1 := 0;
          for iRow2 := 0 to StrList5.Count-1 do
          begin
             //
             Application.ProcessMessages;
            //WJ
            CsvList2.Clear;
            StringToCsvList(StrList5.Strings[iRow2], CsvList2);
            //tH_
            if Copy(CsvList2[3], Length(CsvList2[3]), 1) = '\' then
            begin
              if (FormMain.StrWildCard = '') or (FormMain.StrWildCard = '*.*') then
              begin
                  //ǉ
                  StrList8.Add(CsvList2[3] + #09 + CsvList2[0] + #09 + CsvList2[1] + #09 + CsvList2[2] + #09 + ExtractfileName(CsvList2[3]));
              end
              else
              begin
                //ChJ[hŌ
                if MatchesMask(String(CsvList2[3]), FormMain.StrWildCard) = TRUE then
                begin
                  //ǉ
                  StrList8.Add(CsvList2[3] + #09 + CsvList2[0] + #09 + CsvList2[1] + #09 + CsvList2[2] + #09 + ExtractfileName(CsvList2[3]));
                end;
              end;
            end
            //t@C
            else
            begin
              if (FormMain.StrWildCard = '') or (FormMain.StrWildCard = '*.*') then
              begin
                  //TCY
                  sStr1 := CsvList2[2];
                  sStr2 := StringReplace(sStr1, ',', '', [rfReplaceAll]);
                  sStr3 := StringReplace(sStr2, ' ', '', [rfReplaceAll]);
                  i64Int1 := i64Int1 + StrToInt64(sStr3);
                  //ǉ
                  StrList8.Add(CsvList2[3] + #09 + CsvList2[0] + #09 + CsvList2[1] + #09 + CsvList2[2] + #09 + ExtractfileName(CsvList2[3]));
              end
              else
              begin
                //ChJ[hŌ
                if MatchesMask(String(CsvList2[3]), FormMain.StrWildCard) = TRUE then
                begin
                  //TCY
                  sStr1 := CsvList2[2];
                  sStr2 := StringReplace(sStr1, ',', '', [rfReplaceAll]);
                  sStr3 := StringReplace(sStr2, ' ', '', [rfReplaceAll]);
                  i64Int1 := i64Int1 + StrToInt64(sStr3);
                  //ǉ
                  StrList8.Add(CsvList2[3] + #09 + CsvList2[0] + #09 + CsvList2[1] + #09 + CsvList2[2] + #09 + ExtractfileName(CsvList2[3]));
                end;
              end;
            end;
          end;
          //ǉ
          StrList7.Add(CsvList1[0] + #09 + ConvertInt64ToStr20(i64Int1));
          //v
          i64Int2 := i64Int2 + i64Int1;
        end
        //t@C
        else
        begin
          //t@Č
          hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr5 + CsvList1[0]), File2);
          if hFindData1 <> INVALID_HANDLE_VALUE then
          begin
            //efBNg܂͎qfBNg̔
            if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
            begin
              //
              sStr14  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
              //t
              sStr15 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                         SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
              //TCY͐̂܂
              i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
              sStr16  := IntToStr(i64Int1);

              if (FormMain.StrWildCard = '') or (FormMain.StrWildCard = '*.*') then
              begin
                  //v
                  i64Int2 := i64Int2 + i64Int1;
                  //ǉ
                  StrList7.Add(CsvList1[0] + #09 + sStr16);
                  //ǉ
                  StrList8.Add(sStr5 + CsvList1[0] + #09 + sStr14 + #09 + sStr15 + #09 + sStr16 + #09 + CsvList1[0]);
              end
              else
              begin
                //ChJ[hŌ
                if MatchesMask(String(CsvList2[3]), FormMain.StrWildCard) = TRUE then
                begin
                  //v
                  i64Int2 := i64Int2 + i64Int1;
                  //ǉ
                  StrList7.Add(CsvList1[0] + #09 + sStr16);
                  //ǉ
                  StrList8.Add(sStr5 + CsvList1[0] + #09 + sStr14 + #09 + sStr15 + #09 + sStr16 + #09 + CsvList1[0]);
                end;
              end;
            end;
          end;
          //I
          WinApi.Windows.FindClose(hFindData1);
        end;
      end;
    end;

    //ɏI
    if (BoolStop = FALSE) then
    begin
      //ۑ
      StrList7.SaveToFile(sStr4, TEncoding.Unicode);
      //\
      LoadResultFile(Sender);

      //tH_擾
      for iRow1 := 0 to StrList8.Count-1 do
      begin
        CsvList3.Clear;
        StringToCsvList(StrList8.Strings[iRow1], CsvList3);
        StrList1.Add(ExtractFilePath(CsvList3[0]));
      end;
      //t@Cp
      for iRow1 := 0 to StrList1.Count-1 do
      begin
        StrList2.Add('0');
      end;

      //ɒǉ
      for iRow1 := 0 to StrList8.Count-1 do
      begin
        //
        Application.ProcessMessages;
        CsvList3.Clear;
        StringToCsvList(StrList8.Strings[iRow1], CsvList3);
        for iRow2 := 0 to StrList1.Count-1 do
        begin
          if (ExtractFilePath(CsvList3[0]) = StrList1.Strings[iRow2]) and (ExtractFilename(CsvList3[0]) <> '') then
          begin
            iVal1 := StrToInt(StrList2.Strings[iRow2]);
            iVal1 := iVal1 + 1;
            StrList2.Strings[iRow2] := IntToStr(iVal1);
          end;
        end;
        StrList1.Add(ExtractFilePath(CsvList3[0]));
      end;

      //Xg쐬
      for iRow1 := 0 to StrList1.Count-1 do
      begin
        StrList3.Add(StrList1.Strings[iRow1] + #09 + 'Num=' + StrList2.Strings[iRow1]);
      end;

      //擪Ƀt@CW߂
      for iRow1 := 0 to StrList8.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrList8.Strings[iRow1], CsvList1);
        sStr21 := ExtractFilePath(CsvList1[0]);
        sStr22 := ExtractFileName(CsvList1[0]);
        iLen1 := Length(AnsiString(sStr21));
        StrList11.Add(Format('%.5d',[iLen1]) + ' ' + sStr22 + #09 + StrList8.Strings[iRow1]);
      end;
      StrList11.Sorted := TRUE;
      for iRow1 := 0 to StrList11.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrList11.Strings[iRow1], CsvList1);
        StrList12.Add(CsvList1[1]);
      end;

      //ꗗǉ
      StrList9.Assign(Memo1.Lines);
      StrList9.AddStrings(StrList12);

      StrList10.AddStrings(StrList3);

      //\
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Assign(StrList9);
      Memo1.Lines.EndUpdate;

      Memo2.Lines.BeginUpdate;
      Memo2.Lines.Assign(StrList10);
      Memo2.Lines.EndUpdate;
    end;
  end;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;
  StrList5.Free;
  StrList6.Free;
  StrList7.Free;
  StrList8.Free;
  StrList9.Free;
  StrList10.Free;
  StrList11.Free;
  StrList12.Free;
  CsvList1.Free;
  CsvList2.Free;
  CsvList3.Free;

  //ݒ
  BoolStop := FALSE;
  ButtonRun.Enabled     := TRUE;
  ButtonGetList.Enabled := TRUE;
  ButtonStop.Enabled    := FALSE;
  ButtonCancel.Enabled  := TRUE;
  ButtonGetList.SetFocus;
  Application.ProcessMessages;
end;

procedure TFormFolderSize.ButtonRunClick(Sender: TObject);
var
  StrList5: TStringList;
  StrList6: TStringList;
  StrList7: TStringList;
  CsvList1: TStringList;
  CsvList2: TStringList;
  iRow1: Integer;
  iRow2: Integer;
  i64Int1: Int64;
  i64Int2: Int64;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;

  procedure ThisListFilesDrive(
                DirName    :String;      //       fBNgtpX
                TheList    :TStringList  //       ꗗi[ TStringList
            );
  var
    sStr2: string;
    sStr3: String;
    sStr4: String;
    sStr5: String;
    sStr6: String;
    i64Int1: Int64;
    File2: TWin32FindData;
    hFindData1: THandle;
  begin
    //ݒ
    if Copy(DirName, Length(DirName), 1) <> '\' then
    begin
      DirName := DirName + '\';
    end;
    sStr2 := DirName + '*.*';
    //t@Č
    hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
    if hFindData1 <> INVALID_HANDLE_VALUE then
    begin
      repeat
        //
        if BoolStop= TRUE then
        begin
          Break;
        end;
        //efBNg܂͎qfBNg̔
        if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
        begin
          //
          sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
          //t
          sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                    SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
          //TCY͐̂܂
          i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
          sStr6   := IntToStr(i64Int1);

          //t@C̐ݒ
          sStr3 := DirName + String(File2.cFileName);
          //fBNg̔)
          if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
          begin
            //tH_ɂ
            sStr3 := sStr3 + '\';
            //ǉ
            TheList.Add(sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr3);
            //ċNIɌ
            Application.ProcessMessages;
            ThisListFilesDrive(sStr3, TheList);
            Application.ProcessMessages;
          end
          else
          begin
            //ǉ
            TheList.Add(sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr3);
          end;
        end;
      //Č
      until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
      //I
      WinApi.Windows.FindClose(hFindData1);
    end;
    //
    Application.ProcessMessages;
  end;

begin
  //m
  StrList5 := TStringList.Create;
  StrList6 := TStringList.Create;
  StrList7 := TStringList.Create;
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;


  //t@Cǂݍ
  sStr4 := ExtractFilePath(ParamStr(0)) + FOLDER_SIZE_TXT;
  if FileExists(sStr4) = TRUE then
  begin
    //
    i64Int2 := 0;
    //ݒ
    BoolStop := FALSE;
    ButtonRun.Enabled     := FALSE;
    ButtonGetList.Enabled := FALSE;
    ButtonStop.Enabled    := TRUE;
    ButtonCancel.Enabled  := FALSE;
    ButtonStop.SetFocus;
    //Ǎ
    StrList6.LoadFromFile(sStr4, TEncoding.Unicode);

    //擾
    for iRow1 := 0 to StrList6.Count-1 do
    begin
      //~
      if     BoolStop = TRUE then
      begin
        break;
      end;

      //擪
      if      iRow1 = 0 then
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList6.Strings[0], CsvList1);
        //pX
        sStr5 := CsvList1[1];
        //
        StrList7.Add(CsvList1[0] + #09 + CsvList1[1]);
      end
      //Ō
      else if iRow1 = StrList6.Count-1 then
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList6.Strings[StrList6.Count-1], CsvList1);
        //
        StrList7.Add(CsvList1[0] + #09 + ConvertInt64ToStr20(i64Int2));
      end
      //
      else
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList6.Strings[iRow1], CsvList1);
        //tH_
        if Copy(CsvList1[0], Length(CsvList1[0]), 1) = '\' then
        begin
          //~
          if     BoolStop = TRUE then
          begin
            break;
          end;

          //z
          StrList5.Clear;
          Application.ProcessMessages;
          ThisListFilesDrive(sStr5 + CsvList1[0], StrList5);
          Application.ProcessMessages;
          i64Int1 := 0;
          for iRow2 := 0 to StrList5.Count-1 do
          begin
            //WJ
            CsvList2.Clear;
            StringToCsvList(StrList5.Strings[iRow2], CsvList2);
            //tH_
            if Copy(CsvList2[3], Length(CsvList2[3]), 1) = '\' then
            begin
              ;
            end
            //t@C
            else
            begin
              //TCY
              sStr1 := CsvList2[2];
              sStr2 := StringReplace(sStr1, ',', '', [rfReplaceAll]);
              sStr3 := StringReplace(sStr2, ' ', '', [rfReplaceAll]);
              i64Int1 := i64Int1 + StrToInt64(sStr3);
            end;
          end;
          //ǉ
          StrList7.Add(CsvList1[0] + #09 + ConvertInt64ToStr20(i64Int1));
          //v
          i64Int2 := i64Int2 + i64Int1;
        end
        //t@C
        else
        begin
          //TCY
          sStr1 := CsvList1[1];
          sStr2 := StringReplace(sStr1, ',', '', [rfReplaceAll]);
          sStr3 := StringReplace(sStr2, ' ', '', [rfReplaceAll]);
          i64Int1 := StrToInt64(sStr3);
          //ǉ
          StrList7.Add(CsvList1[0] + #09 + ConvertInt64ToStr20(i64Int1));
          //v
          i64Int2 := i64Int2 + i64Int1;
        end;

      end;
    end;

    //ɏI
    if BoolStop = FALSE then
    begin
      //ۑ
      StrList7.SaveToFile(sStr4, TEncoding.Unicode);
      //\
      LoadResultFile(Sender);
    end;
  end
  else
  begin
    ;
  end;

  //j
  StrList5.Free;
  StrList6.Free;
  StrList7.Free;
  CsvList1.Free;
  CsvList2.Free;

  //ݒ
  BoolStop := FALSE;
  ButtonRun.Enabled     := TRUE;
  ButtonGetList.Enabled := TRUE;
  ButtonStop.Enabled    := FALSE;
  ButtonCancel.Enabled  := TRUE;
  ButtonRun.SetFocus;
end;

procedure TFormFolderSize.LoadResultFile(Sender: TObject);
var
  iRow1: Integer;
  iMax1: Integer;
  iMax2: Integer;
  sStr1: String;
  sStr2: String;
  sStr4: String;
  CsvList1: TStringList;
begin
  //t@Cǂݍ
  sStr4 := ExtractFilePath(ParamStr(0)) + FOLDER_SIZE_TXT;
  if FileExists(sStr4) = TRUE then
  begin
      //NA
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Clear;
      Memo1.Lines.EndUpdate;
      Memo2.Lines.BeginUpdate;
      Memo2.Lines.Clear;
      Memo2.Lines.EndUpdate;

      //m
      CsvList1 := TStringList.Create;
      //Ǎ
      StrListText.LoadFromFile(sStr4, TEncoding.Unicode);
      //ő啶擾
      iMax1 := 0;
      iMax2 := 0;
      for iRow1 := 0 to StrListText.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrListText.Strings[iRow1], CsvList1);
        if Length(AnsiString(CsvList1[0])) > iMax1 then
        begin
          iMax1 := Length(AnsiString(CsvList1[0]));
        end;
        if Length(AnsiString(CsvList1[1])) > iMax2 then
        begin
          iMax2 := Length(AnsiString(CsvList1[1]));
        end;
      end;

      //ݒ
      Memo1.Lines.BeginUpdate;
      for iRow1 := 0 to StrListText.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrListText.Strings[iRow1], CsvList1);
        if iRow1 = 0 then
        begin
          if BoolJapanese = TRUE then
          begin
            sStr1 := '߽     : ' + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
            sStr2 := CsvList1[1] + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
          end
          else
          begin
            sStr1 := 'Path      : ' + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
            sStr2 := CsvList1[1]    + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
          end;
        end
        else if iRow1 = StrListText.Count-1 then
        begin
          if BoolJapanese = TRUE then
          begin
            sStr1 := 'v      : ' + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
            sStr2 := CsvList1[1]    + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
          end
          else
          begin
            sStr1 := 'Total     : ' + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
            sStr2 := CsvList1[1]    + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
          end;
        end
        else
        begin
          sStr1 := CsvList1[0] + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
          sStr2 := CsvList1[1] + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
        end;
        Memo1.Lines.Add(sStr1 + '  ' + sStr2)
      end;
          if BoolJapanese = TRUE then
          begin
            Memo1.Lines.Add('ܲ޶ : ' + FormMain.StrWildCard);
            Memo1.Lines.Add('-------------------------------');
          end
          else
          begin
            Memo1.Lines.Add('Wild Card : ' + FormMain.StrWildCard);
            Memo1.Lines.Add('-------------------------------');
          end;
      //
      Memo1.Lines.EndUpdate;

      //j
      CsvList1.Free;
  end;
end;


end.
