unit FtpDelete;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,

  IniFiles, MyUtility, StrUtils,

  IdFTP, IdFTPList, IdAllFTPListParsers,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdAntiFreezeBase, Vcl.IdAntiFreeze,
  IdFTPCommon, IdURI, HTTPApp, Vcl.StdCtrls, Vcl.ExtCtrls;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 695;

type
  TFormFtpDelete = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    ButtonCancel: TButton;
    ListBox1: TListBox;
    ButtonOK: TButton;
    IdFTP1: TIdFTP;
    Label25: TLabel;
    ButtonAbort: TButton;
    Label1: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Label29: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    function  FtpConnect(Sender: TObject): Boolean;
    function  FtpDisConnect(Sender: TObject): Boolean;
    function  FtpGetDirAndFilesListCurrent(ADir: String; TheList: TStringList): Boolean;
    procedure FtpGetDirAndFilesList(ADir: String; TheList: TStringList);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolAbort: Boolean;
    BoolFileDeleteFinish: Boolean;
    BoolJapanese: Boolean;
    StrListSrc: TStringList;
    StrListSrcFolder: TStringList;
    StrListFtpList: TStringList;
    IntFtpCount: Integer;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFtpDelete: TFormFtpDelete;

implementation

uses
  Main;

{$R *.dfm}

//explorer
//t@C̕Ń\[g
//name<TAB>....
function CompareLogical2(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos21: Integer;
  sStr11: String;
  sStr12: String;
begin
  //PosEx  StrUtils Kv
  //ŏ<TAB>
  iPos11 := PosEx(#09, List[Index1], 1);
  //t@C𒊏o
  sStr11 := Copy(List[Index1], 1, iPos11-1);

  //ŏ<TAB>
  iPos21 := PosEx(#09, List[Index2], 1);
  //t@C𒊏o
  sStr12 := Copy(List[Index2], 1, iPos21-1);

  //r
  Result := StrCmpLogicalW(PWideChar(WideString(sStr11)), PWideChar(WideString(sStr12)));
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFtpDelete.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFtpDelete.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFtpDelete.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFtpDelete.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFtpDelete', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFtpDelete', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFtpDelete', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFtpDelete', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFtpDelete', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListSrc       := TStringList.Create;
  StrListSrcFolder := TStringList.Create;
  StrListFtpList   := TStringList.Create;

  //ݒ
  Edit1.Text := FormMain.StrSetFormFtpDelete;

  //ݒ
  ButtonAbort.Enabled := FALSE;

  //ݒ
  BoolFileDeleteFinish := FALSE;

  //Ǎ
  ListBox1.Items.Clear;
  if FileExists(FormMain.StrExtractBase + FTP_DELETE_TXT) = TRUE then
  begin
    ListBox1.Items.LoadFromFile(FormMain.StrExtractBase + FTP_DELETE_TXT, TEncoding.Unicode);
  end;
  //ݒ
  if ListBox1.Items.Count = 0 then
  begin
    ListBox1.ItemIndex := 0;
  end;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;

  //XV
  if BoolJapanese = TRUE then
  begin
    Label1.Caption := 'S  : ' + IntToStr(ListBox1.Items.Count);
  end
  else
  begin
    Label1.Caption := 'Total : ' + IntToStr(ListBox1.Items.Count);
  end;

  //XV
  Label25.Caption := 'Src=0';
  Label29.Caption := 'Delete=0';
end;

procedure TFormFtpDelete.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFtpDelete', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFtpDelete', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFtpDelete', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFtpDelete', 'Left',   FormFtpDelete.Left);
    IniFile.WriteInteger('FormFtpDelete', 'Top',    FormFtpDelete.Top);
    IniFile.WriteInteger('FormFtpDelete', 'Width',  FormFtpDelete.Width);
    IniFile.WriteInteger('FormFtpDelete', 'Height', FormFtpDelete.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListSrc.Free;
  StrListSrcFolder.Free;
  StrListFtpList.Free;
end;

procedure TFormFtpDelete.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFtpDelete.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFtpDelete.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFtpDelete.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFtpDelete.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFtpDelete.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFtpDelete.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpDelete.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFtpDelete, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFtpDelete, StrLanguageFileName, Sender);
  end;
end;

procedure TFormFtpDelete.FormResize(Sender: TObject);
begin
  ListBox1.Width   := Panel1.ClientWidth  -40;
  ListBox1.Height  := Panel1.ClientHeight -155;
  ButtonOK.Top     := Panel1.ClientHeight -35;
  ButtonAbort.Top  := Panel1.ClientHeight -35;
  ButtonCancel.Top := Panel1.ClientHeight -35;
  Label1.Top       := Panel1.ClientHeight -32;
  Label25.Top      := Panel1.ClientHeight -57;
  Label29.Top      := Panel1.ClientHeight -57;
end;

procedure TFormFtpDelete.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFtpDelete.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFtpDelete, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFtpDelete, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFtpDelete.ButtonOKClick(Sender: TObject);
var
  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList4: TStringList;
  CsvList1: TStringList;
  CsvList2: TStringList;

  sStr31: String;

  iRow1: Integer;
  iRow2: Integer;
  iDelete1: Integer;

  bExcept1: Boolean;
begin

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;
  StrList4 := TStringList.Create;
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;

  //XV
  ButtonOK.Enabled     := FALSE;
  ButtonOK.Refresh;
  ButtonAbort.Enabled  := TRUE;
  ButtonAbort.Refresh;
  ButtonCancel.Enabled := FALSE;
  ButtonCancel.Refresh;

  //XV
  Label25.Caption := 'Src=0';
  Label25.Refresh;
  Label29.Caption := 'Delete=0';
  Label29.Refresh;

  //NA
  StrListSrc.Clear;
  StrListSrcFolder.Clear;

  //ݒ
  BoolAbort := FALSE;
  bExcept1 := FALSE;

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //݂
    StrList4.Clear;
    FtpGetDirAndFilesListCurrent(Edit1.Text, StrList4);
    //ǉ
    StrList4.Insert(0, Edit1.Text + #09 + #09 + #09);

    //s
    for iRow1 := 0 to ListBox1.Items.Count-1 do
    begin
      //NA
      StrList1.Clear;
      StrList2.Clear;
      StrList3.Clear;
      StrList1.Sorted := FALSE;

      //tH_
      if Copy(ListBox1.Items.Strings[iRow1], Length(ListBox1.Items.Strings[iRow1]), 1) = '/' then
      begin
        //z̃tH_
        FtpGetDirAndFilesList(Edit1.Text + ListBox1.Items.Strings[iRow1], StrList1);

        //]
        StrList2.Sorted := TRUE;
        StrList3.Sorted := TRUE;
        for iRow2 := 0 to StrList1.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList1.Strings[iRow2], CsvList2);
          //tH_
          if Copy(CsvList2[0], Length(CsvList2[0]), 1) = '/' then
          begin
            //
            StrList3.Add(StrList1.Strings[iRow2]);
          end
          //t@C
          else
          begin
            //
            StrList2.Add(StrList1.Strings[iRow2]);
          end;
        end;

        //f
        StrListSrc.AddStrings(StrList2);

        //f
        for iRow2 := 0 to StrList4.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList4.Strings[iRow2], CsvList2);
          //
          if CsvList2[0] = (Edit1.Text + ListBox1.Items.Strings[iRow1]) then
          begin
            StrListSrcFolder.Add(StrList4.Strings[iRow2]);
            Break;
          end;
        end;
        //f
        StrListSrcFolder.AddStrings(StrList3);
      end
      //t@C
      else
      begin
        for iRow2 := 0 to StrList4.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList4.Strings[iRow2], CsvList2);
          //
          if CsvList2[0] = (Edit1.Text + ListBox1.Items.Strings[iRow1]) then
          begin
            StrListSrc.Add(StrList4.Strings[iRow2]);
            Break;
          end;
        end;
      end;

      //XV
      Label25.Caption := 'Src=' + IntToStr(StrListSrc.Count);
      Label25.Refresh;
      Application.ProcessMessages;
    end;

    //XV
    Label25.Caption := 'Src=' + IntToStr(StrListSrc.Count);
    Label25.Refresh;
    Application.ProcessMessages;

    //\[g
    StrListSrc.Sorted := FALSE;
    StrListSrc.CustomSort(CompareLogical2);
    //\[g
    StrListSrcFolder.Sorted := FALSE;
    StrListSrcFolder.CustomSort(CompareLogical2);
  end
  else
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //I
    Exit;
  end;


  //f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : f܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Operation had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //s
    iDelete1 := 0;
    for iRow1 := StrListSrc.Count-1 downto 0 do
    begin
      //XV
      iDelete1 := iDelete1+1;
      //XV
      Label29.Caption := 'Delete=' + IntToStr(iDelete1);
      Label29.Refresh;
      Application.ProcessMessages;

      //WJ
      CsvList2.Clear;
      StringToCsvList(StrListSrc.Strings[iRow1], CsvList2);
      sStr31 := CsvList2[0];
      //폜
      try
        IdFTP1.Delete(CsvList2[0]);
      except
        bExcept1 := TRUE;
        Break;
      end;
    end;

    //s
    for iRow1 := StrListSrcFolder.Count-1 downto 0 do
    begin
      //XV
      iDelete1 := iDelete1+1;
      //XV
      Label29.Caption := 'Delete=' + IntToStr(iDelete1);
      Label29.Refresh;
      Application.ProcessMessages;

      //WJ
      CsvList2.Clear;
      StringToCsvList(StrListSrcFolder.Strings[iRow1], CsvList2);
      sStr31 := CsvList2[0];

      //݂
      StrList4.Clear;
      FtpGetDirAndFilesListCurrent(sStr31, StrList4);

      //zɂ͉
      if StrList4.Count = 0 then
      begin
        //폜
        try
          //[głȂꍇ͈xɈړ
          if Edit1.Text <> '/' then
          begin
            IdFTP1.ChangeDirUp;
            IdFTP1.RemoveDir(CsvList2[0]);
          end
          //[g̏ꍇ͕KtH_Ɉړ
          else
          begin
            IdFTP1.ChangeDir('/DCIM/');
            IdFTP1.RemoveDir(CsvList2[0]);
          end;
        except
          bExcept1 := TRUE;
          Break;
        end;
      end;
    end;
  end
  else
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //I
    Exit;
  end;


  if bExcept1 = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : tH_܂̓t@C폜ł܂ł' + #13#10 +
                          sStr31;
    end
    else
    begin
      FormMain.StrMsg := 'Error : Delete file or folder failed.' + #13#10 +
                          sStr31 + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ݒ
  BoolFileDeleteFinish := TRUE;

  //
  ButtonOK.Enabled     := TRUE;
  ButtonOK.Refresh;
  ButtonAbort.Enabled  := FALSE;
  ButtonAbort.Refresh;
  ButtonCancel.Enabled := TRUE;
  ButtonCancel.Refresh;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : t@CƃtH_̍폜܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Delete file or folder had done.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
end;

procedure TFormFtpDelete.ButtonCancelClick(Sender: TObject);
begin
  if BoolFileDeleteFinish = TRUE then
  begin
    //I
    ModalResult := mrOK;
  end
  else
  begin
    //I
    ModalResult := mrCancel;
  end;
end;

procedure TFormFtpDelete.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

function  TFormFtpDelete.FtpConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  if FormMain.StrServerName = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Server name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if FormMain.StrPortNumber = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //ݒ
  IdFTP1.Host     :=          FormMain.StrServerName;
  IdFTP1.Port     := StrToInt(FormMain.StrPortNumber);
  IdFTP1.Username :=          FormMain.StrUserName;
  IdFTP1.Password :=          FormMain.StrPassword;
  IdFTP1.Passive  :=          FormMain.BoolPassiveMode;
  //
  try
    //ڑ
    IdFTP1.Connect;
  except
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : ڑɎs܂';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Network connect failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  Result := TRUE;

end;

function  TFormFtpDelete.FtpDisConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      //ؒf
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //
  Result := TRUE;
end;


procedure TFormFtpDelete.FtpGetDirAndFilesList(ADir: String; TheList: TStringList);
var
  LFileList : TStringList;
  iRow1     : Integer;
  iRow2     : Integer;
  LCount    : Integer;
  LListItem : TIdFTPListItem;
  LFileName : String;
  LFileSize : Int64;
  LFileDate : TDateTime;
  LFilePermission: String;
  LCurDir   : String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
begin
  //m
  LFileList := TStringList.Create;
  //s
  try
    try
      //ύX
      IdFTP1.ChangeDir(ADir);
    except
      ;
    end;
    //擾
    IdFTP1.List;

    //List\bhsDirectoryListingŃt@C̃Xg擾ł
    LCount := IdFTP1.DirectoryListing.Count;
    //DirectroyListing͐VList\bhsƏĂ܂
    //čċȀꍇ͗płȂ̂ŕʃXg쐬
    LFileList.Clear;
    //s
    for iRow1 := 0 to LCount - 1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;

      //ꗗ擾
      LListItem := IdFTP1.DirectoryListing[iRow1];
      //t@C
      LFileName := LListItem.FileName;
      //t@CTCY
      LFileSize := LListItem.Size;
      //t@C̍ŏIXV
      LFileDate := LListItem.ModifiedDate;
      //t@C̃p[~bV
      LFilePermission := LListItem.PermissionDisplay;

      //q܂͐e
      if (LFileName = '.') or (LFileName = '..') then
      begin
        Continue;
      end;

      //fBNg
      if LListItem.ItemType = ditDirectory then
      begin
        //擾
        LCurDir := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
        LFileList.Add(LCurDir);
      end;


      //ݒ
      if LListItem.ItemType = ditDirectory then
      begin
        sStr1 := IdFTP1.RetrieveCurrentDir + '/' + LFileName + '/';
      end
      else
      begin
        sStr1 := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
      end;
      //ݒ
      if LFilePermission = '' then
      begin
        sStr2 := '*****-**-*';
      end
      else
      begin
        sStr2 := LFilePermission;
      end;
      //ϊ
      DateTimeToString(sStr3, 'yyyy/MM/dd', LFileDate);
      DateTimeToString(sStr4, 'HH:mm:ss', LFileDate);
      //ϊ
      sStr5 := ConvertInt64ToStr20(LFileSize);

      //ǉ
      //[0]name [1]attr [2]date [3]time [4]size
      TheList.Add(sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);

      //폜Ȃ̂Ńt@CtH_
      //tH_
      if LListItem.ItemType = ditDirectory then
      begin
        //XV
        IntFtpCount := IntFtpCount+1;
        if (IntFtpCount mod 10) = 0 then
        begin
          Label25.Caption := 'Src='    + IntToStr(IntFtpCount);
          Label25.Refresh;
          Application.ProcessMessages;
        end;
      end
      //t@C
      else
      begin
        //XV
        IntFtpCount := IntFtpCount+1;
        if (IntFtpCount mod 10) = 0 then
        begin
          Label25.Caption := 'Src='    + IntToStr(IntFtpCount);
          Label25.Refresh;
          Application.ProcessMessages;
        end;
      end;
    end;

    //̎_SLɉwfBNg΃pXœĂ
    //wfBNgċAIɌListBoxItemɒǉĂ
    for iRow2 := 0 to LFileList.Count - 1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;
      //擾
      FtpGetDirAndFilesList(LFileList[iRow2], TheList);
    end;
  finally
    //j
    FreeAndNil(LFileList);
  end;
end;


function  TFormFtpDelete.FtpGetDirAndFilesListCurrent(ADir: String; TheList: TStringList): Boolean;
var
  FTPListItems: TIdFTPListItems;
  FTPListItem:  TIdFTPListItem;
  sFileName: String;
  iFileSize: Integer;
  ModifiedDate: TDateTime;
  sPermissionDisplay: string;
  sItemType: String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  iRow1: Integer;
begin
  //
  Result := TRUE;

  try
    //ύX
    IdFTP1.ChangeDir(ADir);
  except
    ;
  end;
  //t@C̈ꗗ擾
  IdFTP1.List;
  FTPListItems := IdFTP1.DirectoryListing;

  //t@C\
  for iRow1 := 0 to FTPListItems.Count - 1 do
  begin
    //t@C
    FTPListItem := FTPListItems.Items[iRow1];
    //t@C
    sFileName := FTPListItem.FileName;
    //t@CTCY
    iFileSize := FTPListItem.Size;
    //t@C̍ŏIXV
    ModifiedDate := FTPListItem.ModifiedDate;
    //p[~bV
    sPermissionDisplay := FTPListItem.PermissionDisplay;
    //
    case FTPListItem.ItemType of
      ditDirectory:       sItemType := 'Directory';
      ditFile:            sItemType := 'File';
      ditSymbolicLink:    sItemType := 'SymbolicLink';
      ditSymbolicLinkDir: sItemType := 'SymbolicLinkDir';
      ditBlockDev:        sItemType := 'BlockDev';
      ditCharDev:         sItemType := 'CharDev';
      ditFIFO:            sItemType := 'FIFO';
      ditSocket:          sItemType := 'Socket';
    end;

    //ݒ
    if sItemType = 'Directory' then
    begin
      sStr1 := sFileName + '/';
    end
    else
    begin
      sStr1 := sFileName;
    end;
    //ݒ
    if sPermissionDisplay = '' then
    begin
      sStr2 := '*****-**-*';
    end
    else
    begin
      sStr2 := sPermissionDisplay;
    end;
    //ϊ
    DateTimeToString(sStr3, 'yyyy/MM/dd', ModifiedDate);
    DateTimeToString(sStr4, 'HH:mm:ss', ModifiedDate);
    //ϊ
    sStr5 := ConvertInt64ToStr20(iFileSize);

    //ǉ
    //[0]name [1]attr [2]date [3]time [4]size
    TheList.Add(ADir + sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);
  end;
end;

procedure TFormFtpDelete.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
