unit FtpMakeFolder;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility,

  IdFTP, IdFTPList, IdAllFTPListParsers,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdAntiFreezeBase, Vcl.IdAntiFreeze,
  IdFTPCommon, IdURI, HTTPApp;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 240;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormFtpMakeFolder = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Edit2: TEdit;
    Edit1: TEdit;
    IdFTP1: TIdFTP;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);

    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);

    function  FtpConnect(Sender: TObject): Boolean;
    function  FtpDisConnect(Sender: TObject): Boolean;
    function  FtpGetDirAndFilesListCurrent(ADir: String; TheList: TStringList): Boolean;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListFtpList: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFtpMakeFolder: TFormFtpMakeFolder;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFtpMakeFolder.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFtpMakeFolder.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFtpMakeFolder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFtpMakeFolder.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFtpMakeFolder.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFtpMakeFolder', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFtpMakeFolder', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFtpMakeFolder', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFtpMakeFolder', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFtpMakeFolder', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListFtpList        := TStringList.Create;

  //
  Edit1.Text := FormMain.StrSetFormFtpMakeFolder;
  Edit1.Font.Color := clBlue;
  Edit1.ReadOnly   := TRUE;
  Edit2.Text := '';

end;

procedure TFormFtpMakeFolder.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFtpMakeFolder', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFtpMakeFolder', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFtpMakeFolder', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFtpMakeFolder', 'Left',   FormFtpMakeFolder.Left);
    IniFile.WriteInteger('FormFtpMakeFolder', 'Top',    FormFtpMakeFolder.Top);
    IniFile.WriteInteger('FormFtpMakeFolder', 'Width',  FormFtpMakeFolder.Width);
    IniFile.WriteInteger('FormFtpMakeFolder', 'Height', FormFtpMakeFolder.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListFtpList.Free;
end;

procedure TFormFtpMakeFolder.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFtpMakeFolder.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFtpMakeFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFtpMakeFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFtpMakeFolder.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFtpMakeFolder.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFtpMakeFolder.Handle, imClose);

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //݂擾
    FtpGetDirAndFilesListCurrent(Edit1.Text, StrListFtpList);
    //ǉ
    StrListFtpList.Insert(0, Edit1.Text + #09 + #09 + #09);
  end;
  //StrListFtpList.SaveToFile(FormMain.StrExtractBase + 'StrListFtpList.txt');

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpMakeFolder.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFtpMakeFolder, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFtpMakeFolder, StrLanguageFileName, Sender);
  end;
end;


procedure TFormFtpMakeFolder.FormResize(Sender: TObject);
begin
  Edit1.Width    := Panel1.Width -60;
  Edit2.Width    := Panel1.Width -60;
end;

procedure TFormFtpMakeFolder.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFtpMakeFolder, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFtpMakeFolder, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFtpMakeFolder.ButtonOKClick(Sender: TObject);
var
  iRow1: Integer;
  iFind1: Integer;
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  bExcept1: Boolean;
  CsvList1: TStringList;
begin
//  AX^XN (*)
//  c_ (|)
//  ~L (\)
//  R (:)
//  dp (")
//  s (菬) (<)
//  s () (>)
//  ^╄ (?)
//  XbV (/)

  //
  iPos1 := Pos('*', Edit2.Text);
  iPos2 := Pos('|', Edit2.Text);
  iPos3 := Pos('\', Edit2.Text);
  iPos4 := Pos(':', Edit2.Text);
  iPos5 := Pos('"', Edit2.Text);
  iPos6 := Pos('<', Edit2.Text);
  iPos7 := Pos('>', Edit2.Text);
  iPos8 := Pos('?', Edit2.Text);
  iPos9 := Pos('/', Edit2.Text);
  if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
     (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
     (iPos9 > 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;


  //㔼폜
  sStr14 := TrimRight(Edit2.Text);
  //u
  sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
  Edit2.Text := sStr18;

  //ݒ
  sStr2 := Edit1.Text + Edit2.Text;
  //m
  CsvList1 := TStringList.Create;
  //
  iFind1 := -1;
  for iRow1 := 0 to StrListFtpList.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListFtpList.Strings[iRow1], CsvList1);
    //tH_̏ꍇ̓t@CƂĈČ
    if Copy(CsvList1[0], Length(CsvList1[0]), 1) = '/' then
    begin
      sStr3 := Copy(CsvList1[0], 1, Length(CsvList1[0])-1);
    end
    else
    begin
      sStr3 := CsvList1[0];
    end;
    if UpperCase(sStr2) = UpperCase(sStr3) then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  //j
  CsvList1.Free;

  //
  if iFind1 <> -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃tH_܂̓t@C݂܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same folder or file is exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //fBNg쐬
  sStr4 := Edit1.Text + Edit2.Text;
  if Copy(sStr4, Length(sStr4), 1) <> '/' then
  begin
    sStr4 := sStr4 + '/';
  end;

  //s
  bExcept1 := FALSE;
  try
    //ڑ
    if FtpConnect(Sender) = TRUE then
    begin
      //쐬
      IdFTP1.MakeDir(sStr4);
    end;
  except
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : tH_쐬ł܂ł';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Folder can not make.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    bExcept1 := TRUE;
  end;

  //
  if bExcept1 = TRUE then
  begin
    Exit;
  end
  else
  begin
    //ؒf
    FtpDisConnect(Sender);
    //߂l
    FormMain.StrRetFormFtpMakeFolder := sStr4;
    //I
    ModalResult := mrOK;
  end;

end;

procedure TFormFtpMakeFolder.ButtonCancelClick(Sender: TObject);
begin
  //ؒf
  FtpDisConnect(Sender);
  //߂l
  FormMain.StrRetFormFtpMakeFolder := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormFtpMakeFolder.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormFtpMakeFolder.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormFtpMakeFolder.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

function  TFormFtpMakeFolder.FtpConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  if FormMain.StrServerName = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Serber name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if FormMain.StrPortNumber = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //ݒ
  IdFTP1.Host     :=          FormMain.StrServerName;
  IdFTP1.Port     := StrToInt(FormMain.StrPortNumber);
  IdFTP1.Username :=          FormMain.StrUserName;
  IdFTP1.Password :=          FormMain.StrPassword;
  IdFTP1.Passive  :=          FormMain.BoolPassiveMode;
  //
  try
    //ڑ
    IdFTP1.Connect;
  except
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : ڑɎs܂';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Network connect failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  Result := TRUE;

end;

function  TFormFtpMakeFolder.FtpDisConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      //ؒf
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //
  Result := TRUE;
end;

function  TFormFtpMakeFolder.FtpGetDirAndFilesListCurrent(ADir: String; TheList: TStringList): Boolean;
var
  FTPListItems: TIdFTPListItems;
  FTPListItem:  TIdFTPListItem;
  sFileName: String;
  iFileSize: Integer;
  ModifiedDate: TDateTime;
  sPermissionDisplay: string;
  sItemType: String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  iRow1: Integer;
begin
  //
  Result := TRUE;

  try
    //ύX
    IdFTP1.ChangeDir(ADir);
  except
    ;
  end;
  //t@C̈ꗗ擾
  IdFTP1.List;
  FTPListItems := IdFTP1.DirectoryListing;

  //t@C\
  for iRow1 := 0 to FTPListItems.Count - 1 do
  begin
    //t@C
    FTPListItem := FTPListItems.Items[iRow1];
    //t@C
    sFileName := FTPListItem.FileName;
    //t@CTCY
    iFileSize := FTPListItem.Size;
    //t@C̍ŏIXV
    ModifiedDate := FTPListItem.ModifiedDate;
    //p[~bV
    sPermissionDisplay := FTPListItem.PermissionDisplay;
    //
    case FTPListItem.ItemType of
      ditDirectory:       sItemType := 'Directory';
      ditFile:            sItemType := 'File';
      ditSymbolicLink:    sItemType := 'SymbolicLink';
      ditSymbolicLinkDir: sItemType := 'SymbolicLinkDir';
      ditBlockDev:        sItemType := 'BlockDev';
      ditCharDev:         sItemType := 'CharDev';
      ditFIFO:            sItemType := 'FIFO';
      ditSocket:          sItemType := 'Socket';
    end;

    //ݒ
    if sItemType = 'Directory' then
    begin
      sStr1 := sFileName + '/';
    end
    else
    begin
      sStr1 := sFileName;
    end;
    //ݒ
    if sPermissionDisplay = '' then
    begin
      sStr2 := '*****-**-*';
    end
    else
    begin
      sStr2 := sPermissionDisplay;
    end;
    //ϊ
    DateTimeToString(sStr3, 'yyyy/MM/dd', ModifiedDate);
    DateTimeToString(sStr4, 'HH:mm:ss', ModifiedDate);
    //ϊ
    sStr5 := ConvertInt64ToStr20(iFileSize);

    //ǉ
    //[0]name [1]attr [2]date [3]time [4]size
    TheList.Add(ADir + sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);
  end;
end;


end.

