unit FtpSelectCopy;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  IniFiles, Vcl.StdCtrls, Vcl.ExtCtrls;

const
  FORM_WIDTH_SET       = 700;
  FORM_HEIGHT_SET      = 300;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormFtpSelectCopy = class(TForm)
    Panel1: TPanel;
    ButtonSameDate: TButton;
    ButtonOverWrite: TButton;
    ButtonNew: TButton;
    ButtonCancel: TButton;
    ButtonRename: TButton;
    CheckBox6: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonSameDateClick(Sender: TObject);
    procedure ButtonOverWriteClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure ButtonRenameClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFtpSelectCopy: TFormFtpSelectCopy;

implementation

{$R *.dfm}

uses
  Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFtpSelectCopy.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFtpSelectCopy.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFtpSelectCopy.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFtpSelectCopy.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFtpSelectCopy.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormFtpSelectCopy', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFtpSelectCopy', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFtpSelectCopy', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFtpSelectCopy', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFtpSelectCopy', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  CheckBox6.Checked := IniFile.ReadBool('FormFtpSelectCopy', 'TimeStampWithin',  FALSE);
  //j
  IniFile.Free;
end;

procedure TFormFtpSelectCopy.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFtpSelectCopy', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFtpSelectCopy', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFtpSelectCopy', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFtpSelectCopy', 'Left',   FormFtpSelectCopy.Left);
    IniFile.WriteInteger('FormFtpSelectCopy', 'Top',    FormFtpSelectCopy.Top);
    IniFile.WriteInteger('FormFtpSelectCopy', 'Width',  FormFtpSelectCopy.Width);
    IniFile.WriteInteger('FormFtpSelectCopy', 'Height', FormFtpSelectCopy.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool('FormFtpSelectCopy', 'TimeStampWithin',  CheckBox6.Checked);
  //j
  IniFile.Free;
end;

procedure TFormFtpSelectCopy.FormResize(Sender: TObject);
begin
;
end;

procedure TFormFtpSelectCopy.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFtpSelectCopy.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFtpSelectCopy.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFtpSelectCopy.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFtpSelectCopy.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFtpSelectCopy.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFtpSelectCopy.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpSelectCopy.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFtpSelectCopy, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFtpSelectCopy, StrLanguageFileName, Sender);
  end;
end;

procedure TFormFtpSelectCopy.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFtpSelectCopy, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFtpSelectCopy, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFtpSelectCopy.ButtonSameDateClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_DATE;
  ModalResult := mrOK;
end;

procedure TFormFtpSelectCopy.ButtonOverWriteClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_OVERWRITE;
  ModalResult := mrOK;
end;

procedure TFormFtpSelectCopy.ButtonNewClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_NEW;
  ModalResult := mrOK;
end;

procedure TFormFtpSelectCopy.ButtonRenameClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_RENAME;
  ModalResult := mrOK;
end;

procedure TFormFtpSelectCopy.ButtonCancelClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_NONE;
  ModalResult := mrCancel;
end;

end.
