unit FtpSort;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  IniFiles, Vcl.StdCtrls, Vcl.ExtCtrls;

const
  FORM_WIDTH_SET       = 510;
  FORM_HEIGHT_SET      = 345;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormFtpSort = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ButtonName: TButton;
    ButtonExt: TButton;
    ButtonDate: TButton;
    ButtonSize: TButton;
    ButtonNone: TButton;
    ButtonUp: TButton;
    ButtonDown: TButton;
    ButtonCancel: TButton;
    CheckBox5: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox21: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonNameClick(Sender: TObject);
    procedure ButtonExtClick(Sender: TObject);
    procedure ButtonDateClick(Sender: TObject);
    procedure ButtonSizeClick(Sender: TObject);
    procedure ButtonNoneClick(Sender: TObject);
    procedure ButtonUpClick(Sender: TObject);
    procedure ButtonDownClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

  private
    { Private 錾 }
    iSortMode1: Integer;

    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFtpSort: TFormFtpSort;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFtpSort.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFtpSort.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFtpSort.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFtpSort.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFtpSort', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFtpSort', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFtpSort', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFtpSort', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFtpSort', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  ButtonUp.Enabled := FALSE;
  ButtonDown.Enabled := FALSE;

  //explorar
  CheckBox5.Checked    := FormMain.BoolSortExplorer;
  //SJIS
  CheckBox14.Checked   := FormMain.BoolSortSJIS;
  //SJIS
  CheckBox21.Checked   := FormMain.BoolSortUnicode;

end;

procedure TFormFtpSort.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFtpSort', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFtpSort', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFtpSort', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFtpSort', 'Left',   FormFtpSort.Left);
    IniFile.WriteInteger('FormFtpSort', 'Top',    FormFtpSort.Top);
    IniFile.WriteInteger('FormFtpSort', 'Width',  FormFtpSort.Width);
    IniFile.WriteInteger('FormFtpSort', 'Height', FormFtpSort.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormFtpSort.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFtpSort.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFtpSort.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFtpSort.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFtpSort.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFtpSort.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFtpSort.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpSort.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFtpSort, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFtpSort, StrLanguageFileName, Sender);
  end;
end;

procedure TFormFtpSort.FormResize(Sender: TObject);
begin
;
end;

procedure TFormFtpSort.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFtpSort.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFtpSort, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFtpSort, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFtpSort.ButtonNameClick(Sender: TObject);
begin
  //0:None 1:Name 2:Ext 3:Date 4:Size
  //\[g
  iSortMode1 := 1;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormFtpSort.ButtonExtClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 2;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormFtpSort.ButtonDateClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 3;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormFtpSort.ButtonSizeClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 4;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormFtpSort.ButtonNoneClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 0;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormFtpSort.ButtonUpClick(Sender: TObject);
begin
  //0:annsFM 1:exploler
  //0:unicode 1:SJIS
  //0: 1:~
  //0:O...
  if CheckBox5.Checked = FALSE then
  begin
    FormMain.StrRetFormFtpSortExplorer := '0';
  end
  else
  begin
    FormMain.StrRetFormFtpSortExplorer := '1';
  end;

  if CheckBox14.Checked = FALSE then
  begin
    FormMain.StrRetFormSortAnnsFM := '0';
  end
  else
  begin
    FormMain.StrRetFormSortAnnsFM := '1';
  end;

  if CheckBox21.Checked = FALSE then
  begin
    FormMain.StrRetFormSortUnicode := '0';
  end
  else
  begin
    FormMain.StrRetFormSortUnicode := '1';
  end;

  FormMain.StrRetFormFtpSortOrder := '0';
  FormMain.StrRetFormFtpSortMode  := IntToStr(iSortMode1);
  //I
  ModalResult := mrOK;
end;

procedure TFormFtpSort.ButtonDownClick(Sender: TObject);
begin
  //0:annsFM 1:exploler
  //0:unicode 1:SJIS
  //0: 1:~
  //0:O...
  if CheckBox5.Checked = FALSE then
  begin
    FormMain.StrRetFormFtpSortExplorer := '0';
  end
  else
  begin
    FormMain.StrRetFormFtpSortExplorer := '1';
  end;

  if CheckBox14.Checked = FALSE then
  begin
    FormMain.StrRetFormSortAnnsFM := '0';
  end
  else
  begin
    FormMain.StrRetFormSortAnnsFM := '1';
  end;

  if CheckBox21.Checked = FALSE then
  begin
    FormMain.StrRetFormSortUnicode := '0';
  end
  else
  begin
    FormMain.StrRetFormSortUnicode := '1';
  end;

  FormMain.StrRetFormFtpSortOrder := '1';
  FormMain.StrRetFormFtpSortMode  := IntToStr(iSortMode1);
  //I
  ModalResult := mrOK;
end;

procedure TFormFtpSort.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

end.

