unit FtpTree;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.StdCtrls,
  IniFiles, MyUtility, StrUtils,
  IdFTPList, IdAllFTPListParsers,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdExplicitTLSClientServerBase,
  IdFTP;

const
  FORM_WIDTH_SET       = 370;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormFtpTree = class(TForm)
    TreeView1: TTreeView;
    MainMenu: TMainMenu;
    MenuKey: TMenuItem;
    MenuReturn: TMenuItem;
    MenuOthers: TMenuItem;
    MenuEscape: TMenuItem;
    MenuKeyBoard: TMenuItem;
    MenuColorSet: TMenuItem;
    MenuFontBold: TMenuItem;
    N1: TMenuItem;
    IdFTP1: TIdFTP;
    Timer1: TTimer;
    ListBox1: TListBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Label1: TLabel;
    MenuQuit: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure TreeView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure MenuMakeFolderClick(Sender: TObject);
    procedure MenuReturnClick(Sender: TObject);
    procedure MenuDriveChangeClick(Sender: TObject);
    procedure MenuKeyBoardClick(Sender: TObject);
    procedure MenuEscapeClick(Sender: TObject);
    procedure MenuColorSetClick(Sender: TObject);
    procedure MenuFontBoldClick(Sender: TObject);

    procedure TreeView1KeyPress(Sender: TObject; var Key: Char);
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1AdvancedCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);

    procedure LayerDown(Sender: TObject);
    procedure LayerUp(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure InitKeyMap(ExeType: Integer; Sender: TObject);

    function  FtpConnect(Sender: TObject): Boolean;
    function  FtpDisConnect(Sender: TObject): Boolean;
    function  FtpFileList(Sender: TObject): Boolean;
    function  FtpAttributeToStrEx(Information: String): String;

    procedure Timer1Timer(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure MenuQuitClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListLayer: TStringList;
    StrListFolder: TStringList;
    StrListAddFolder: TStringList;
    StrListFtpList: TStringList;
    StrListKeyMapCheck1: TStringList;
    StrListKeyMapCheck2: TStringList;
    BoolKeyMapSame:Boolean;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFtpTree: TFormFtpTree;

implementation

{$R *.dfm}

uses Main, KeyBoard;

//BonsFM
function CompareBonsFM2(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos21: Integer;
  sStr11: String;
  sStr12: String;
begin
  //PosEx  StrUtils Kv
  //ŏ<TAB>
  iPos11 := PosEx(#09, List[Index1], 1);
  //t@C𒊏o
  sStr11 := Copy(List[Index1], 1, iPos11-1);

  //ŏ<TAB>
  iPos21 := PosEx(#09, List[Index2], 1);
  //t@C𒊏o
  sStr12 := Copy(List[Index2], 1, iPos21-1);

  //r
  Result := CompareStr(sStr11, sStr12);
end;

//explorer
//t@C̕Ń\[g
//name<TAB>....
function CompareLogical2(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos21: Integer;
  sStr11: String;
  sStr12: String;
begin
  //PosEx  StrUtils Kv
  //ŏ<TAB>
  iPos11 := PosEx(#09, List[Index1], 1);
  //t@C𒊏o
  sStr11 := Copy(List[Index1], 1, iPos11-1);

  //ŏ<TAB>
  iPos21 := PosEx(#09, List[Index2], 1);
  //t@C𒊏o
  sStr12 := Copy(List[Index2], 1, iPos21-1);

  //r
  Result := StrCmpLogicalW(PWideChar(WideString(sStr11)), PWideChar(WideString(sStr12)));
end;


//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFtpTree.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFtpTree.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
  //ؒf
  FtpDisConnect(Sender);
end;

procedure TFormFtpTree.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFtpTree.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  StrList1: TStringList;
  sStr1: String;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFtpTree', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFtpTree', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFtpTree', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFtpTree', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFtpTree', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //Zbg
  Timer1.Enabled := FALSE;

  //m
  StrListLayer := TStringList.Create;
  StrListFolder := TStringList.Create;
  StrListAddFolder := TStringList.Create;
  StrListFtpList := TStringList.Create;
  StrListKeyMapCheck1 := TStringList.Create;
  StrListKeyMapCheck2 := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  MenuFontBold.Checked := IniFile.ReadBool('FormFtpTree', 'FontBold',  FALSE);
  //j
  IniFile.Free;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    MenuColorSet.Checked := IniFile.ReadBool('FormFtpTree', 'SameColor', FALSE);
    MenuColorSet.Enabled := TRUE;
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    MenuColorSet.Checked := TRUE;
    MenuColorSet.Enabled := FALSE;
    ListBox1.Style := lbStandard;
  end;

  //ݒ
  InitKeyMap(0, Sender);

  //m
  StrList1 := TStringList.Create;
  //t@CǍ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FTP_TREE_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrList1.LoadFromFile(sStr1, TEncoding.Unicode);
    //ڐ
    if StrList1.Count = FormMain.StrListKeyMapOriginalTree.Count then
    begin
      //@\擾
      FormMain.GetFunctionList(StrList1,                           StrListKeyMapCheck1, Sender);
      FormMain.GetFunctionList(FormMain.StrListKeyMapOriginalTree, StrListKeyMapCheck2, Sender);
      //Ƃ肠ڐ𓯂ɂĂ
      BoolKeyMapSame := TRUE;
      //ǂ`FbN
      for iRow1 := 0 to StrListKeyMapCheck2.Count-1 do
      begin
        //Ⴄ
        if StrListKeyMapCheck1.Strings[iRow1] <> StrListKeyMapCheck2.Strings[iRow1] then
        begin
          //Ⴄ
          BoolKeyMapSame := FALSE;
          //f
          Break;
        end;
      end;

      //
      if BoolKeyMapSame = FALSE then
      begin
        //XV
        FormMain.StrListKeyMapTree.Assign(FormMain.StrListKeyMapOriginalTree);
        //ۑ
        FormMain.StrListKeyMapTree.SaveToFile(sStr1, TEncoding.Unicode);
      end;
    end
    else
    begin
      //XV
      FormMain.StrListKeyMapTree.Assign(FormMain.StrListKeyMapOriginalTree);
      //ۑ
      FormMain.StrListKeyMapTree.SaveToFile(sStr1, TEncoding.Unicode);
      //ڐႤ
      BoolKeyMapSame := FALSE;
    end;
  end
  else
  begin
    //ۑ
    FormMain.StrListKeyMapTree.Assign(FormMain.StrListKeyMapOriginalTree);
    FormMain.StrListKeyMapTree.SaveToFile(sStr1, TEncoding.Unicode);
    //ڐ
    BoolKeyMapSame := TRUE;
  end;
  //j
  StrList1.Free;

  //ݒ
  SetShortCutKey(Sender);

end;

procedure TFormFtpTree.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFtpTree', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFtpTree', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFtpTree', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFtpTree', 'Left',   FormFtpTree.Left);
    IniFile.WriteInteger('FormFtpTree', 'Top',    FormFtpTree.Top);
    IniFile.WriteInteger('FormFtpTree', 'Width',  FormFtpTree.Width);
    IniFile.WriteInteger('FormFtpTree', 'Height', FormFtpTree.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    //ۑ
    IniFile.WriteBool('FormFtpTree', 'SameColor', MenuColorSet.Checked);
  end
  else
  begin
    //
  end;
  //ۑ
  IniFile.WriteBool('FormFtpTree', 'FontBold',  MenuFontBold.Checked);
  //j
  IniFile.Free;

  //j
  StrListLayer.Free;
  StrListFolder.Free;
  StrListAddFolder.Free;
  StrListFtpList.Free;
  StrListKeyMapCheck1.Free;
  StrListKeyMapCheck2.Free;
end;

procedure TFormFtpTree.FormResize(Sender: TObject);
begin
;
end;

procedure TFormFtpTree.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFtpTree.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFtpTree.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFtpTree.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFtpTree.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFtpTree.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFtpTree.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpTree.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFtpTree, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFtpTree, StrLanguageFileName, Sender);
  end;

  //N
  Timer1.Enabled := TRUE;
end;

procedure TFormFtpTree.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFtpTree.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //{
  if      ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFtpTree, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFtpTree, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFtpTree.MenuColorSetClick(Sender: TObject);
begin
  if MenuColorSet.Checked = TRUE then
  begin
    MenuColorSet.Checked := FALSE;
  end
  else
  begin
    MenuColorSet.Checked := TRUE;
  end;
  //`
  TreeView1.Repaint;
end;

procedure TFormFtpTree.Timer1Timer(Sender: TObject);
var
  tn1: TTreeNode;
  sStr5: String;
  sStr6: String;
begin
  //Zbg
  Timer1.Enabled := FALSE;

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //ݒ
    sStr5 := '/';
    sStr6 := '----';

    //ݎ擾
    tn1 := TreeView1.Selected;
    //qm[hǉ
    TreeView1.Items.AddChild(tn1, sStr5 + ' [' + sStr6 + ']');

    //ݒ
    TreeView1.SetFocus;
    TreeView1.Items.Item[0].Selected := TRUE;
  end;
end;

procedure TFormFtpTree.TreeView1AdvancedCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);

var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  sStr1: String;
  sStr2: String;

begin

  //擾
  sStr1 := Node.Text;

  //
  if MenuColorSet.Checked = TRUE then
  begin
    //ݒ
    TreeView1.Color := FormMain.FListViewColor;
    //[gȊO
    if Length(sStr1) >= 6 then
    begin
      //c:\
      //tool\ [rhsa] Len=12
      sStr2 := Copy(sStr1, Length(sStr1)-7+1, 7);
      iPos1 := Pos(UpperCase('s'), UpperCase(sStr2));
      iPos2 := Pos(UpperCase('h'), UpperCase(sStr2));
      iPos3 := Pos(UpperCase('r'), UpperCase(sStr2));
      if      iPos1 > 0 then
      begin
        TreeView1.Canvas.Font.Color := FormMain.FSystemColor;
        if MenuFontBold.Checked = TRUE then
        begin
          TreeView1.Canvas.Font.Style := [fsBold];
        end
        else
        begin
          TreeView1.Canvas.Font.Style := [];
        end;
      end
      else if iPos2 > 0 then
      begin
        TreeView1.Canvas.Font.Color := FormMain.FHiddenColor;
        if MenuFontBold.Checked = TRUE then
        begin
          TreeView1.Canvas.Font.Style := [fsBold];
        end
        else
        begin
          TreeView1.Canvas.Font.Style := [];
        end;
      end
      else if iPos3 > 0 then
      begin
        TreeView1.Canvas.Font.Color := FormMain.FReadOnlyColor;
        if MenuFontBold.Checked = TRUE then
        begin
          TreeView1.Canvas.Font.Style := [fsBold];
        end
        else
        begin
          TreeView1.Canvas.Font.Style := [];
        end;
      end
      else
      begin
        TreeView1.Canvas.Font.Color := FormMain.FDirectoryColor;
        if MenuFontBold.Checked = TRUE then
        begin
          TreeView1.Canvas.Font.Style := [fsBold];
        end
        else
        begin
          TreeView1.Canvas.Font.Style := [];
        end;
      end;
    end
    else
    begin
        TreeView1.Canvas.Font.Color := FormMain.FDirectoryColor;
        if MenuFontBold.Checked = TRUE then
        begin
          TreeView1.Canvas.Font.Style := [fsBold];
        end
        else
        begin
          TreeView1.Canvas.Font.Style := [];
        end;
    end;
  end
  else
  begin
    //ݒ
    TreeView1.Color := clWhite;
    TreeView1.Canvas.Font.Color := clBlack;
    if MenuFontBold.Checked = TRUE then
    begin
      TreeView1.Canvas.Font.Style := [fsBold];
    end
    else
    begin
      TreeView1.Canvas.Font.Style := [];
    end;
  end;
end;

procedure TFormFtpTree.TreeView1Click(Sender: TObject);
begin
  LayerDown(Sender);
end;

procedure TFormFtpTree.TreeView1DblClick(Sender: TObject);
begin
  //MenuReturnClick(Sender);
end;

procedure TFormFtpTree.TreeView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    MenuReturnClick(Sender);
  end
  else if (Shift = []) and (key = VK_LEFT) then
  begin
    LayerUp(Sender);
  end
  else if (Shift = []) and (key = VK_RIGHT) then
  begin
    LayerDown(Sender);
  end
  else
  begin
    //
  end;
end;

procedure TFormFtpTree.TreeView1KeyPress(Sender: TObject; var Key: Char);
begin
  Key := char(0);
end;

procedure TFormFtpTree.LayerDown(Sender: TObject);
var
  tn1: TTreeNode;
  tn2: TTreeNode;
  iRow1: Integer;
  iRow2: Integer;
  iPos1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iFind1: Integer;
  sStr1: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  CsvList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList4: TStringList;
  StrList5: TStringList;
  StrList11: TStringList;
  StrList12: TStringList;
  StrList13: TStringList;
  StrList14: TStringList;
begin
  //ݎ擾
  tn1 := TreeView1.Selected;
  //e擾
  tn2 := tn1.Parent;

  //m
  StrList2 := TStringList.Create;

  //[g̏ꍇ
  if tn2 = nil then
  begin
    sStr1 := Copy(TreeView1.Selected.Text, 1, Length(TreeView1.Selected.Text)-7);
  end
  //[gȊO
  else
  begin
    //݂ǉ
    //tool\ [rhsa] Len=12
    sStr4 := Copy(tn1.text, 1, Length(tn1.Text)-7);
    StrList2.Add(sStr4);

    //[gɂȂ܂
    while (tn2 <> nil) do
    begin
      //ǉ
      sStr4 := Copy(tn2.text, 1, Length(tn2.Text)-7);
      StrList2.Add(sStr4);
      //Ď擾
      tn2 := tn2.Parent;
    end;

    //tpX쐬
    sStr1 := '';
    for iRow1 := StrList2.Count-1 downto 0 do
    begin
      sStr1 := sStr1 + StrList2.Strings[iRow1];
    end;
  end;

  //j
  StrList2.Free;

  //m
  CsvList1 := TStringList.Create;
  StrList3 := TStringList.Create;
  StrList4 := TStringList.Create;
  StrList5 := TStringList.Create;
  StrList11 := TStringList.Create;
  StrList12 := TStringList.Create;
  StrList13 := TStringList.Create;
  StrList14 := TStringList.Create;
  StrList3.Sorted := FALSE;
  StrList4.Sorted := FALSE;
  StrList11.Sorted := FALSE;
  StrList12.Sorted := FALSE;
  StrList13.Sorted := FALSE;
  StrList14.Sorted := FALSE;

  //tH_ύX
  IdFTP1.ChangeDir(sStr1);
  //Xg擾
  FtpFileList(Sender);

  //ݒ
  for iRow1 := 0 to StrListFtpList.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListFtpList.Strings[iRow1], CsvList1);
    //tH_
    if Copy(CsvList1[0], Length(CsvList1[0]), 1) = '/' then
    begin
      StrList3.Add(CsvList1[0]);
      StrList4.Add(FtpAttributeToStrEx(CsvList1[1]));
    end;
  end;

  //
  for iRow1 := 0 to StrList3.Count-1 do
  begin
    iPos11 := Pos(UpperCase('s'), UpperCase(StrList4.Strings[iRow1]));
    iPos12 := Pos(UpperCase('h'), UpperCase(StrList4.Strings[iRow1]));
    iPos13 := Pos(UpperCase('r'), UpperCase(StrList4.Strings[iRow1]));
    if      iPos11 > 0 then
    begin
      StrList11.Add(StrList3.Strings[iRow1] + #09 + StrList4.Strings[iRow1]);
    end
    else if iPos12 > 0 then
    begin
      StrList12.Add(StrList3.Strings[iRow1] + #09 + StrList4.Strings[iRow1]);
    end
    else if iPos13 > 0 then
    begin
      StrList13.Add(StrList3.Strings[iRow1] + #09 + StrList4.Strings[iRow1]);
    end
    else
    begin
      StrList14.Add(StrList3.Strings[iRow1] + #09 + StrList4.Strings[iRow1]);
    end;

  end;

  //Ǎ
  if FormMain.BoolSortExplorer = TRUE then
  begin
    StrList11.CustomSort(CompareLogical2);
    StrList12.CustomSort(CompareLogical2);
    StrList13.CustomSort(CompareLogical2);
    StrList14.CustomSort(CompareLogical2);
  end
  else
  begin
    StrList11.CustomSort(CompareBonsFM2);
    StrList12.CustomSort(CompareBonsFM2);
    StrList13.CustomSort(CompareBonsFM2);
    StrList14.CustomSort(CompareBonsFM2);
  end;

  //
  for iRow1 := 0 to StrList11.Count-1 do
  begin
    StrList5.Add(StrList11.Strings[iRow1]);
  end;
  for iRow1 := 0 to StrList12.Count-1 do
  begin
    StrList5.Add(StrList12.Strings[iRow1]);
  end;
  for iRow1 := 0 to StrList13.Count-1 do
  begin
    StrList5.Add(StrList13.Strings[iRow1]);
  end;
  for iRow1 := 0 to StrList14.Count-1 do
  begin
    StrList5.Add(StrList14.Strings[iRow1]);
  end;

  //ݒ
  if StrList5.Count > 0 then
  begin
    //NA
    StrListFolder.Clear;
    //ݒ
    for iRow1 := 0 to StrList5.Count-1 do
    begin
      //ݒ
      StrListFolder.Add(StrList5.Strings[iRow1]);
    end;

    //ߋɒǉ
    iFind1 := -1;
    if sStr1 <> '/' then
    begin
      for iRow2 := 0 to StrListAddFolder.Count-1 do
      begin
        if UpperCase(sStr1) = UpperCase(StrListAddFolder.Strings[iRow2]) then
        begin
          iFind1 := iRow2;
          Break;
        end;
      end;
    end;
    //ǉĂȂ
    if ifind1 = -1 then
    begin
      //ǉ
      StrListAddFolder.Add(sStr1);
      //qm[h
      for iRow1 := 0 to StrList5.Count-1 do
      begin
        iPos1 := Pos(#09, StrList5.Strings[iRow1]);
        sStr5 := Copy(StrList5.Strings[iRow1], 1,       iPos1-1);
        sStr6 := Copy(StrList5.Strings[iRow1], iPos1+1, Length(StrList5.Strings[iRow1]));
        //qm[hǉ
        TreeView1.Items.AddChild(tn1, sStr5 + ' [' + sStr6 + ']');
      end;
    end;
  end;

  //j
  CsvList1.Free;
  StrList3.Free;
  StrList4.Free;
  StrList5.Free;
  StrList11.Free;
  StrList12.Free;
  StrList13.Free;
  StrList14.Free;
end;

procedure TFormFtpTree.LayerUp(Sender: TObject);
begin
;
end;


procedure TFormFtpTree.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin

  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;

end;

procedure TFormFtpTree.MenuDriveChangeClick(Sender: TObject);
begin
;
end;


procedure TFormFtpTree.MenuEscapeClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormTree := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormFtpTree.MenuFontBoldClick(Sender: TObject);
begin
  if MenuFontBold.Checked = TRUE then
  begin
    MenuFontBold.Checked := FALSE;
  end
  else
  begin
    MenuFontBold.Checked := TRUE;
  end;
  //`
  TreeView1.Repaint;
end;

procedure TFormFtpTree.MenuKeyBoardClick(Sender: TObject);
var
  bResult: Boolean;
begin
  //
  FormMain.IntKeyMapTypeIndex := KEYBORD_MAP_FTP_TREE;
  //
  FormKeyBoard := TFormKeyBoard.Create(Application);
  try
    //\
    if FormKeyBoard.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormKeyBoard.Free;
  end;

  //
  if bResult = TRUE then
  begin
    //ݒ
    SetShortCutKey(Sender);
  end;
end;

procedure TFormFtpTree.MenuMakeFolderClick(Sender: TObject);
begin
;
end;

procedure TFormFtpTree.MenuQuitClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormTree := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormFtpTree.MenuReturnClick(Sender: TObject);
var
  tn1: TTreeNode;
  tn2: TTreeNode;
  iRow1: Integer;
  sStr1: String;
  sStr4: String;
  StrList2: TStringList;
begin
  //ݎ擾
  tn1 := TreeView1.Selected;
  //e擾
  tn2 := tn1.Parent;

  //m
  StrList2 := TStringList.Create;

  //[g̏ꍇ
  if tn2 = nil then
  begin
    sStr1 := Copy(TreeView1.Selected.Text, 1, Length(TreeView1.Selected.Text)-7);
  end
  //[gȊO
  else
  begin
    //݂ǉ
    //tool\ [rhsa] Len=12
    sStr4 := Copy(tn1.text, 1, Length(tn1.Text)-7);
    StrList2.Add(sStr4);

    //[gɂȂ܂
    while (tn2 <> nil) do
    begin
      //ǉ
      sStr4 := Copy(tn2.text, 1, Length(tn2.Text)-7);
      StrList2.Add(sStr4);
      //Ď擾
      tn2 := tn2.Parent;
    end;

    //tpX쐬
    sStr1 := '';
    for iRow1 := StrList2.Count-1 downto 0 do
    begin
      sStr1 := sStr1 + StrList2.Strings[iRow1];
    end;
  end;

  //j
  StrList2.Free;

  //߂l
  FormMain.StrRetFormFtpTree := sStr1;
  //I
  ModalResult := mrOK;
end;

procedure TFormFtpTree.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FTP_TREE_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      FormMain.StrListKeyMapTree.LoadFromFile(sStr1, TEncoding.Unicode);
    end
    //t@CȂꍇ́AftHgŐݒ肳ĂeɂȂĂ
    else
    begin
      FormMain.StrListKeyMapTree.SaveToFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if FormMain.StrListKeyMapTree.Count > 0 then
    begin

      SetShortCutNew('1001', MenuReturn, Sender);
      SetShortCutNew('1002', MenuEscape, Sender);
      SetShortCutNew('1003', MenuQuit, Sender);

      SetShortCutNew('1101', MenuKeyBoard, Sender);
      SetShortCutNew('1102', MenuColorSet, Sender);
      SetShortCutNew('1103', MenuFontBold, Sender);

    end;
end;

procedure TFormFtpTree.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to FormMain.StrListKeyMapTree.Count-1 do
  begin
    //擾
    sStr11 := FormMain.StrListKeyMapTree.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormFtpTree.InitKeyMap(ExeType: Integer; Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
    //NA
    FormMain.StrListKeyMapOriginalTree.Clear;

    //
    sStr1 := MenuReturn.Caption;
    sStr2 := ShortCutToText(VK_RETURN);
    FormMain.StrListKeyMapOriginalTree.Add(SHORTCUT_ITEM_KEY + #09 + sStr1 + #09 + sStr2 + #09 + '1001');

    sStr1 := MenuEscape.Caption;
    sStr2 := ShortCutToText(VK_ESCAPE);
    FormMain.StrListKeyMapOriginalTree.Add(SHORTCUT_ITEM_KEY + #09 + sStr1 + #09 + sStr2 + #09 + '1002');

    sStr1 := MenuQuit.Caption;
    sStr2 := ShortCutToText(VK_Q);
    FormMain.StrListKeyMapOriginalTree.Add(SHORTCUT_ITEM_KEY + #09 + sStr1 + #09 + sStr2 + #09 + '1003');

    //
    sStr1 := MenuKeyBoard.Caption;
    sStr2 := ShortCutToText(0);
    FormMain.StrListKeyMapOriginalTree.Add(SHORTCUT_ITEM_OTHERS + #09 + sStr1 + #09 + sStr2 + #09 + '1101');

    sStr1 := MenuColorSet.Caption;
    sStr2 := ShortCutToText(VK_C);
    FormMain.StrListKeyMapOriginalTree.Add(SHORTCUT_ITEM_OTHERS + #09 + sStr1 + #09 + sStr2 + #09 + '1102');

    sStr1 := MenuFontBold.Caption;
    sStr2 := ShortCutToText(VK_B);
    FormMain.StrListKeyMapOriginalTree.Add(SHORTCUT_ITEM_OTHERS + #09 + sStr1 + #09 + sStr2 + #09 + '1103');

end;


function  TFormFtpTree.FtpConnect(Sender: TObject): Boolean;
begin
//    StrServerName: String;
//    StrPortNumber: String;
//    StrUserName: String;
//    StrPassword: String;
//    StrFtpFolderName: String;
//    StrLocalFolder: String;

  //
  Result := FALSE;

  if FormMain.StrServerName = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Server name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if FormMain.StrPortNumber = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //ݒ
  IdFTP1.Host     :=          FormMain.StrServerName;
  IdFTP1.Port     := StrToInt(FormMain.StrPortNumber);
  IdFTP1.Username :=          FormMain.StrUserName;
  IdFTP1.Password :=          FormMain.StrPassword;
  IdFTP1.Passive  :=          FormMain.BoolPassiveMode;
  //
  try
    //ڑ
    IdFTP1.Connect;
  except
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : ڑɎs܂';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Network connect failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  Result := TRUE;

end;

function  TFormFtpTree.FtpDisConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      //ؒf
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //
  Result := TRUE;
end;

function  TFormFtpTree.FtpFileList(Sender: TObject): Boolean;
var
  FTPListItems: TIdFTPListItems;
  FTPListItem:  TIdFTPListItem;
  sFileName: String;
  iFileSize: Integer;
  ModifiedDate: TDateTime;
  sPermissionDisplay: string;
  sItemType: String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  iRow1: Integer;
  CsvList1: TStringList;
begin
  //
  Result := TRUE;

  //t@C̈ꗗ擾
  IdFTP1.List;
  FTPListItems := IdFTP1.DirectoryListing;

  //NA
  StrListFtpList.Clear;

  //t@C\
  for iRow1 := 0 to FTPListItems.Count - 1 do
  begin
    //t@C
    FTPListItem := FTPListItems.Items[iRow1];
    //t@C
    sFileName := FTPListItem.FileName;
    //t@CTCY
    iFileSize := FTPListItem.Size;
    //t@C̍ŏIXV
    ModifiedDate := FTPListItem.ModifiedDate;
    //p[~bV
    sPermissionDisplay := FTPListItem.PermissionDisplay;
    //
    case FTPListItem.ItemType of
      ditDirectory:       sItemType := 'Directory';
      ditFile:            sItemType := 'File';
      ditSymbolicLink:    sItemType := 'SymbolicLink';
      ditSymbolicLinkDir: sItemType := 'SymbolicLinkDir';
      ditBlockDev:        sItemType := 'BlockDev';
      ditCharDev:         sItemType := 'CharDev';
      ditFIFO:            sItemType := 'FIFO';
      ditSocket:          sItemType := 'Socket';
    end;

    //ݒ
    if sItemType = 'Directory' then
    begin
      sStr1 := sFileName + '/';
    end
    else
    begin
      sStr1 := sFileName;
    end;
    //ݒ
    if sPermissionDisplay = '' then
    begin
      sStr2 := '*****-**-*';
    end
    else
    begin
      sStr2 := sPermissionDisplay;
    end;
    //ϊ
    DateTimeToString(sStr3, 'yyyy/MM/dd', ModifiedDate);
    DateTimeToString(sStr4, 'HH:mm:ss', ModifiedDate);
    //ϊ
    sStr5 := ConvertInt64ToStr20(iFileSize);

    //ǉ
    StrListFtpList.Add(sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);
  end;


  //m
  CsvList1 := TStringList.Create;
  //XV
  ListBox1.Items.BeginUpdate;
  //NA
  ListBox1.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListFtpList.Count-1 do
  begin
    CsvList1.Clear;
    StringToCsvlist(StrListFtpList.Strings[iRow1], CsvList1);
    ListBox1.Items.Add(CsvList1[1] + ' ' + CsvList1[2] + ' ' + CsvList1[3] + ' ' + CsvList1[4] + ' ' + CsvList1[0]);
  end;
  //XV
  ListBox1.Items.EndUpdate;
  //j
  CsvList1.Free;
end;

function  TFormFtpTree.FtpAttributeToStrEx(Information: String): String;
begin
//drwxr-xr-x
//u-rw-r--r--vudrwxr-xr-xv̐擪̓10ɂĂłA
//ŏ̂Pڂ̓t@Cʂ\Ă܂B
//- t@C
//d fBNg
//i V{bNN
//2ڂ4ڂ̓t@C̏L҂ɑ΂錠\A
//5ڂ7ڂ̓t@C̏LO[vɑ΂錠\A
//8ڂ10ڂ͂̑ɑ΂錠\Ă܂
//   if Copy(Information);
  Result := '----';
end;


end.
