unit Help;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Menus, Vcl.StdCtrls, Vcl.ComCtrls,
  IniFiles, GDIPAPI, GDIPOBJ, GDIPUTIL;

const
  FORM_WIDTH_SET    = 840;
  FORM_HEIGHT_SET   = 540;

  IMAGE_SCALE_MAX       = 1000;
  IMAGE_SCALE_MIN       =   10;
  IMAGE_SCALE_NORMAL    =  100;
  IMAGE_SCALE_STEP_LOW  =   10;
  IMAGE_SCALE_STEP_HIGH =   20;
  IMAGE_MAX_SIZE        = 1024*50;
  IMAGE_SPI_MAX_SIZE    = 1024*50;
  IMAGE_WIC_MAX_SIZE    = 1024*50;

type
  TFormHelp = class(TForm)
    Panel91: TPanel;
    Panel1: TPanel;
    TreeView1: TTreeView;
    Memo1: TMemo;
    Splitter1: TSplitter;
    ButtonHelp: TButton;
    ButtonAndroid: TButton;
    ButtonImage: TButton;
    Panel9: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ButtonQA: TButton;
    Panel2: TPanel;
    Splitter2: TSplitter;
    TreeView2: TTreeView;
    Memo2: TMemo;
    PopupMenu1: TPopupMenu;
    PopUpCopy1: TMenuItem;
    PopupMenu2: TPopupMenu;
    PopUpCopy2: TMenuItem;
    PopupMenu3: TPopupMenu;
    PopUpCopy3: TMenuItem;
    ButtonWin64: TButton;
    ButtonCSV: TButton;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel10: TPanel;
    Image1: TImage;
    PopupMenu4: TPopupMenu;
    PopUpCopy4: TMenuItem;
    PopupMenu5: TPopupMenu;
    PopUpCopy5: TMenuItem;
    Panel3: TPanel;
    Splitter3: TSplitter;
    TreeView3: TTreeView;
    Memo3: TMemo;
    Panel4: TPanel;
    Splitter4: TSplitter;
    TreeView4: TTreeView;
    Memo4: TMemo;
    Panel5: TPanel;
    Splitter5: TSplitter;
    TreeView5: TTreeView;
    Memo5: TMemo;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1KeyPress(Sender: TObject; var Key: Char);

    procedure ButtonHelpClick(Sender: TObject);
    procedure ButtonAndroidClick(Sender: TObject);
    procedure ButtonImageClick(Sender: TObject);

    function  ViewFileWic(FileName: String; InitPos: Boolean; Sender: TObject): Boolean;
    procedure ButtonQAClick(Sender: TObject);
    procedure TreeView2Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView2DblClick(Sender: TObject);
    procedure TreeView2KeyPress(Sender: TObject; var Key: Char);
    procedure PopUpCopy1Click(Sender: TObject);
    procedure PopUpCopy2Click(Sender: TObject);
    procedure ButtonWin64Click(Sender: TObject);
    procedure ButtonCSVClick(Sender: TObject);
    procedure TreeView3Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView4Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView5Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView3DblClick(Sender: TObject);
    procedure TreeView4DblClick(Sender: TObject);
    procedure TreeView5DblClick(Sender: TObject);
    procedure TreeView3KeyPress(Sender: TObject; var Key: Char);
    procedure TreeView4KeyPress(Sender: TObject; var Key: Char);
    procedure TreeView5KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListOutLine: TStringList;
    StrListOutLine2: TStringList;
    StrListOutLine3: TStringList;
    StrListOutLine4: TStringList;
    StrListOutLine5: TStringList;
    StrListHelp: TStringList;
    StrListHelp2: TStringList;
    StrListHelp3: TStringList;
    StrListHelp4: TStringList;
    StrListHelp5: TStringList;
    IntImageIndex: Integer;
    IntImageScale: Integer;
    IntImageRotate: Integer;
    IntImageScaleHeight: Integer;
    IntImageScaleWidth: Integer;
    IntImageReadHeight: Integer;
    IntImageReadWidth: Integer;
    IntImageSrcWidth: Integer;
    IntImageSrcHeight: Integer;
    IntCompressRate: Integer;
    BoolJapanese: Boolean;
    BoolShowMem: Boolean;
    StrFileNameCurrent: String;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormHelp: TFormHelp;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormHelp.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormHelp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormHelp.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormHelp.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormHelp', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormHelp', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormHelp', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormHelp', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormHelp', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListOutLine  := TStringList.Create;
  StrListOutLine2 := TStringList.Create;
  StrListOutLine3 := TStringList.Create;
  StrListOutLine4 := TStringList.Create;
  StrListOutLine5 := TStringList.Create;
  StrListHelp  := TStringList.Create;
  StrListHelp2 := TStringList.Create;
  StrListHelp3 := TStringList.Create;
  StrListHelp4 := TStringList.Create;
  StrListHelp5 := TStringList.Create;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //
  Splitter1.Left  := IniFile.ReadInteger('HelpTreeView1', 'Width',  170);
  Splitter2.Left  := IniFile.ReadInteger('HelpTreeView2', 'Width',  170);
  Splitter3.Left  := IniFile.ReadInteger('HelpTreeView3', 'Width',  170);
  Splitter4.Left  := IniFile.ReadInteger('HelpTreeView4', 'Width',  170);
  Splitter5.Left  := IniFile.ReadInteger('HelpTreeView5', 'Width',  170);
  TreeView1.Width := IniFile.ReadInteger('HelpTreeView1', 'Width',  170);
  TreeView2.Width := IniFile.ReadInteger('HelpTreeView2', 'Width',  170);
  TreeView3.Width := IniFile.ReadInteger('HelpTreeView3', 'Width',  170);
  TreeView4.Width := IniFile.ReadInteger('HelpTreeView4', 'Width',  170);
  TreeView5.Width := IniFile.ReadInteger('HelpTreeView5', 'Width',  170);
  //j
  IniFile.Free;

  //
  Panel1.Align := alClient;
  Panel2.Align := alClient;
  Panel3.Align := alClient;
  Panel4.Align := alClient;
  Panel5.Align := alClient;
  Panel9.Align := alClient;
  //
  Panel1.Visible := TRUE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;
  Panel5.Visible := FALSE;
  Panel9.Visible := FALSE;
  //
  IntImageIndex  := -1;
  //ݒ
  Label1.Caption := '';
  Label2.Caption := '';

end;

procedure TFormHelp.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormHelp', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormHelp', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormHelp', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormHelp', 'Left',   FormHelp.Left);
    IniFile.WriteInteger('FormHelp', 'Top',    FormHelp.Top);
    IniFile.WriteInteger('FormHelp', 'Width',  FormHelp.Width);
    IniFile.WriteInteger('FormHelp', 'Height', FormHelp.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteInteger('HelpTreeView1', 'Width',  TreeView1.Width);
  IniFile.WriteInteger('HelpTreeView2', 'Width',  TreeView2.Width);
  IniFile.WriteInteger('HelpTreeView3', 'Width',  TreeView3.Width);
  IniFile.WriteInteger('HelpTreeView4', 'Width',  TreeView4.Width);
  IniFile.WriteInteger('HelpTreeView5', 'Width',  TreeView5.Width);
  //j
  IniFile.Free;

  //j
  StrListOutLine.Free;
  StrListOutLine2.Free;
  StrListOutLine3.Free;
  StrListOutLine4.Free;
  StrListOutLine5.Free;
  StrListHelp.Free;
  StrListHelp2.Free;
  StrListHelp3.Free;
  StrListHelp4.Free;
  StrListHelp5.Free;

end;

procedure TFormHelp.FormResize(Sender: TObject);
begin
  //\ς
  if (BoolShowMem = TRUE) and (StrFileNameCurrent <> '') then
  begin
    //\
    ViewFileWic(StrFileNameCurrent, FALSE, Sender);
  end;
end;

procedure TFormHelp.FormShow(Sender: TObject);
var
  iRow1: Integer;
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  TabStops: array [0..0] of DWord;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormHelp.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormHelp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormHelp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormHelp.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormHelp.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormHelp.Handle, imClose);

  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + HELP_TXT;
  if FileExists(sStr1) = TRUE then
  begin
    StrListHelp.LoadFromFile(sStr1);
    Memo1.Lines.LoadFromFile(sStr1);
  end
  else
  begin
    StrListHelp.Clear;
    Memo1.Lines.Clear;
  end;
  //ݒ
  TabStops[0] := 4*4;
  Memo1.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  Memo1.Invalidate;

  //ݒ
  StrListOutLine.Clear;
  //ZNV
  for iRow1 := 0 to StrListHelp.Count-1 do
  begin
    //OUTLINE_MARK_1    = '';
    //OUTLINE_MARK_2    = '';
    //OUTLINE_MARK_3    = '';
    //OUTLINE_MARK_4    = '';
    //OUTLINE_MARK_5    = '';
    sStr1 := StrListHelp.Strings[iRow1];
    sStr2 := StringReplace(sStr1, #9, '',   [rfReplaceAll]);
    sStr3 := StringReplace(sStr2, ' ', '',  [rfReplaceAll]);
    sStr4 := StringReplace(sStr3, '@', '', [rfReplaceAll]);
    iPos1 := Pos(OUTLINE_MARK_1, sStr4);
    iPos2 := Pos(OUTLINE_MARK_2, sStr4);
    iPos3 := Pos(OUTLINE_MARK_3, sStr4);
    iPos4 := Pos(OUTLINE_MARK_4, sStr4);
    iPos5 := Pos(OUTLINE_MARK_5, sStr4);
    if (iPos1 = 1) then
    begin
      //ǉ
      StrListOutLine.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos2 = 1) then
    begin
      //ǉ
      StrListOutLine.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos3 = 1) then
    begin
      //ǉ
      StrListOutLine.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos4 = 1) then
    begin
      //ǉ
      StrListOutLine.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos5 = 1) then
    begin
      //ǉ
      StrListOutLine.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
  end;
  //ۑ
  StrListOutLine.SaveToFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE_LIST, TEncoding.Unicode);

  //Kw\sȏꍇ̃G[̂ try except end gp
  try
    //Ǎ
    TreeView1.LoadFromFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE_LIST, TEncoding.Unicode);
    //XV
    TreeView1.Items.BeginUpdate;
    //ݒ
    for iRow1 :=0 to TreeView1.Items.Count-1 do
    begin
      if TreeView1.Items[iRow1].Level> 0 then
      begin
        if      TreeView1.Items[iRow1].Level = 1 then
        begin
          TreeView1.Items[iRow1].ImageIndex := 1;
        end;
      end;
    end;
  except
    //
   end;
  //XV
  TreeView1.Items.EndUpdate;


  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + HELP_QA_TXT;
  if FileExists(sStr1) = TRUE then
  begin
    StrListHelp2.LoadFromFile(sStr1);
    Memo2.Lines.LoadFromFile(sStr1);
  end
  else
  begin
    StrListHelp2.Clear;
    Memo2.Lines.Clear;
  end;
  //ݒ
  TabStops[0] := 4*4;
  Memo2.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  Memo2.Invalidate;

  //ݒ
  StrListOutLine2.Clear;
  //ZNV
  for iRow1 := 0 to StrListHelp2.Count-1 do
  begin
    //OUTLINE_MARK_1    = '';
    //OUTLINE_MARK_2    = '';
    //OUTLINE_MARK_3    = '';
    //OUTLINE_MARK_4    = '';
    //OUTLINE_MARK_5    = '';
    sStr1 := StrListHelp2.Strings[iRow1];
    sStr2 := StringReplace(sStr1, #9, '',   [rfReplaceAll]);
    sStr3 := StringReplace(sStr2, ' ', '',  [rfReplaceAll]);
    sStr4 := StringReplace(sStr3, '@', '', [rfReplaceAll]);
    iPos1 := Pos(OUTLINE_MARK_1, sStr4);
    iPos2 := Pos(OUTLINE_MARK_2, sStr4);
    iPos3 := Pos(OUTLINE_MARK_3, sStr4);
    iPos4 := Pos(OUTLINE_MARK_4, sStr4);
    iPos5 := Pos(OUTLINE_MARK_5, sStr4);
    if (iPos1 = 1) then
    begin
      //ǉ
      StrListOutLine2.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos2 = 1) then
    begin
      //ǉ
      StrListOutLine2.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos3 = 1) then
    begin
      //ǉ
      StrListOutLine2.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos4 = 1) then
    begin
      //ǉ
      StrListOutLine2.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos5 = 1) then
    begin
      //ǉ
      StrListOutLine2.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
  end;
  //ۑ
  StrListOutLine2.SaveToFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE2_LIST, TEncoding.Unicode);

  //Kw\sȏꍇ̃G[̂ try except end gp
  try
    //Ǎ
    TreeView2.LoadFromFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE2_LIST, TEncoding.Unicode);
    //XV
    TreeView2.Items.BeginUpdate;
    //ݒ
    for iRow1 :=0 to TreeView2.Items.Count-1 do
    begin
      if TreeView2.Items[iRow1].Level> 0 then
      begin
        if      TreeView2.Items[iRow1].Level = 1 then
        begin
          TreeView2.Items[iRow1].ImageIndex := 1;
        end;
      end;
    end;
  except
    //
   end;
  //XV
  TreeView2.Items.EndUpdate;


  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + HELP_ANDROID_TXT;
  if FileExists(sStr1) = TRUE then
  begin
    StrListHelp3.LoadFromFile(sStr1);
    Memo3.Lines.LoadFromFile(sStr1);
  end
  else
  begin
    StrListHelp3.Clear;
    Memo3.Lines.Clear;
  end;
  //ݒ
  TabStops[0] := 4*4;
  Memo3.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  Memo3.Invalidate;

  //ݒ
  StrListOutLine3.Clear;
  //ZNV
  for iRow1 := 0 to StrListHelp3.Count-1 do
  begin
    //OUTLINE_MARK_1    = '';
    //OUTLINE_MARK_2    = '';
    //OUTLINE_MARK_3    = '';
    //OUTLINE_MARK_4    = '';
    //OUTLINE_MARK_5    = '';
    sStr1 := StrListHelp3.Strings[iRow1];
    sStr2 := StringReplace(sStr1, #9, '',   [rfReplaceAll]);
    sStr3 := StringReplace(sStr2, ' ', '',  [rfReplaceAll]);
    sStr4 := StringReplace(sStr3, '@', '', [rfReplaceAll]);
    iPos1 := Pos(OUTLINE_MARK_1, sStr4);
    iPos2 := Pos(OUTLINE_MARK_2, sStr4);
    iPos3 := Pos(OUTLINE_MARK_3, sStr4);
    iPos4 := Pos(OUTLINE_MARK_4, sStr4);
    iPos5 := Pos(OUTLINE_MARK_5, sStr4);
    if (iPos1 = 1) then
    begin
      //ǉ
      StrListOutLine3.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos2 = 1) then
    begin
      //ǉ
      StrListOutLine3.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos3 = 1) then
    begin
      //ǉ
      StrListOutLine3.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos4 = 1) then
    begin
      //ǉ
      StrListOutLine3.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos5 = 1) then
    begin
      //ǉ
      StrListOutLine3.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
  end;
  //ۑ
  StrListOutLine3.SaveToFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE3_LIST, TEncoding.Unicode);

  //Kw\sȏꍇ̃G[̂ try except end gp
  try
    //Ǎ
    TreeView3.LoadFromFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE3_LIST, TEncoding.Unicode);
    //XV
    TreeView3.Items.BeginUpdate;
    //ݒ
    for iRow1 :=0 to TreeView3.Items.Count-1 do
    begin
      if TreeView3.Items[iRow1].Level> 0 then
      begin
        if      TreeView3.Items[iRow1].Level = 1 then
        begin
          TreeView3.Items[iRow1].ImageIndex := 1;
        end;
      end;
    end;
  except
    //
   end;
  //XV
  TreeView3.Items.EndUpdate;


  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + HELP_WIN64_TXT;
  if FileExists(sStr1) = TRUE then
  begin
    StrListHelp4.LoadFromFile(sStr1);
    Memo4.Lines.LoadFromFile(sStr1);
  end
  else
  begin
    StrListHelp4.Clear;
    Memo4.Lines.Clear;
  end;
  //ݒ
  TabStops[0] := 4*4;
  Memo4.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  Memo4.Invalidate;

  //ݒ
  StrListOutLine4.Clear;
  //ZNV
  for iRow1 := 0 to StrListHelp4.Count-1 do
  begin
    //OUTLINE_MARK_1    = '';
    //OUTLINE_MARK_2    = '';
    //OUTLINE_MARK_3    = '';
    //OUTLINE_MARK_4    = '';
    //OUTLINE_MARK_5    = '';
    sStr1 := StrListHelp4.Strings[iRow1];
    sStr2 := StringReplace(sStr1, #9, '',   [rfReplaceAll]);
    sStr3 := StringReplace(sStr2, ' ', '',  [rfReplaceAll]);
    sStr4 := StringReplace(sStr3, '@', '', [rfReplaceAll]);
    iPos1 := Pos(OUTLINE_MARK_1, sStr4);
    iPos2 := Pos(OUTLINE_MARK_2, sStr4);
    iPos3 := Pos(OUTLINE_MARK_3, sStr4);
    iPos4 := Pos(OUTLINE_MARK_4, sStr4);
    iPos5 := Pos(OUTLINE_MARK_5, sStr4);
    if (iPos1 = 1) then
    begin
      //ǉ
      StrListOutLine4.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos2 = 1) then
    begin
      //ǉ
      StrListOutLine4.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos3 = 1) then
    begin
      //ǉ
      StrListOutLine4.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos4 = 1) then
    begin
      //ǉ
      StrListOutLine4.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos5 = 1) then
    begin
      //ǉ
      StrListOutLine4.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
  end;
  //ۑ
  StrListOutLine4.SaveToFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE4_LIST, TEncoding.Unicode);

  //Kw\sȏꍇ̃G[̂ try except end gp
  try
    //Ǎ
    TreeView4.LoadFromFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE4_LIST, TEncoding.Unicode);
    //XV
    TreeView4.Items.BeginUpdate;
    //ݒ
    for iRow1 :=0 to TreeView4.Items.Count-1 do
    begin
      if TreeView4.Items[iRow1].Level> 0 then
      begin
        if      TreeView4.Items[iRow1].Level = 1 then
        begin
          TreeView4.Items[iRow1].ImageIndex := 1;
        end;
      end;
    end;
  except
    //
   end;
  //XV
  TreeView4.Items.EndUpdate;


    //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + HELP_CSV_TXT;
  if FileExists(sStr1) = TRUE then
  begin
    StrListHelp5.LoadFromFile(sStr1);
    Memo5.Lines.LoadFromFile(sStr1);
  end
  else
  begin
    StrListHelp5.Clear;
    Memo5.Lines.Clear;
  end;
  //ݒ
  TabStops[0] := 4*4;
  Memo5.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  Memo5.Invalidate;

  //ݒ
  StrListOutLine5.Clear;
  //ZNV
  for iRow1 := 0 to StrListHelp5.Count-1 do
  begin
    //OUTLINE_MARK_1    = '';
    //OUTLINE_MARK_2    = '';
    //OUTLINE_MARK_3    = '';
    //OUTLINE_MARK_4    = '';
    //OUTLINE_MARK_5    = '';
    sStr1 := StrListHelp5.Strings[iRow1];
    sStr2 := StringReplace(sStr1, #9, '',   [rfReplaceAll]);
    sStr3 := StringReplace(sStr2, ' ', '',  [rfReplaceAll]);
    sStr4 := StringReplace(sStr3, '@', '', [rfReplaceAll]);
    iPos1 := Pos(OUTLINE_MARK_1, sStr4);
    iPos2 := Pos(OUTLINE_MARK_2, sStr4);
    iPos3 := Pos(OUTLINE_MARK_3, sStr4);
    iPos4 := Pos(OUTLINE_MARK_4, sStr4);
    iPos5 := Pos(OUTLINE_MARK_5, sStr4);
    if (iPos1 = 1) then
    begin
      //ǉ
      StrListOutLine5.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos2 = 1) then
    begin
      //ǉ
      StrListOutLine5.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos3 = 1) then
    begin
      //ǉ
      StrListOutLine5.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos4 = 1) then
    begin
      //ǉ
      StrListOutLine5.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
    if (iPos5 = 1) then
    begin
      //ǉ
      StrListOutLine5.Add(sStr1 + StringOfChar(' ', OUTLINE_ADD_SPACE) + Format('%.05d', [iRow1]));
    end;
  end;
  //ۑ
  StrListOutLine5.SaveToFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE5_LIST, TEncoding.Unicode);

  //Kw\sȏꍇ̃G[̂ try except end gp
  try
    //Ǎ
    TreeView5.LoadFromFile(ExtractFilePath(ParamStr(0)) + HELP_OUTLINE5_LIST, TEncoding.Unicode);
    //XV
    TreeView5.Items.BeginUpdate;
    //ݒ
    for iRow1 :=0 to TreeView5.Items.Count-1 do
    begin
      if TreeView5.Items[iRow1].Level> 0 then
      begin
        if      TreeView5.Items[iRow1].Level = 1 then
        begin
          TreeView5.Items[iRow1].ImageIndex := 1;
        end;
      end;
    end;
  except
    //
   end;
  //XV
  TreeView5.Items.EndUpdate;



  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Help.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormHelp, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormHelp, StrLanguageFileName, Sender);
  end;

  //ݒ
  BoolShowMem := TRUE;
  TreeView1.SetFocus;

  //j[ݒ
  if BoolJapanese = TRUE then
  begin
    PopUpCopy1.Caption := 'Rs[(&C)';
    PopUpCopy2.Caption := 'Rs[(&C)';
    PopUpCopy3.Caption := 'Rs[(&C)';
  end
  else
  begin
    PopUpCopy1.Caption := 'Copy(&C)';
    PopUpCopy2.Caption := 'Copy(&C)';
    PopUpCopy3.Caption := 'Copy(&C)';
  end;
end;

procedure TFormHelp.PopUpCopy1Click(Sender: TObject);
begin
  if Memo1.SelLength > 0 then
  begin
    Memo1.CopyToClipboard;
  end;
end;

procedure TFormHelp.PopUpCopy2Click(Sender: TObject);
begin
  if Memo2.SelLength > 0 then
  begin
    Memo2.CopyToClipboard;
  end;
end;

procedure TFormHelp.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormHelp, StrLanguageFileName, Sender);
    //j[ݒ
    PopUpCopy1.Caption := 'Rs[(&C)';
    PopUpCopy2.Caption := 'Rs[(&C)';
    PopUpCopy3.Caption := 'Rs[(&C)';
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormHelp, StrLanguageFileName, Sender);
    //j[ݒ
    PopUpCopy1.Caption := 'Copy(&C)';
    PopUpCopy2.Caption := 'Copy(&C)';
    PopUpCopy3.Caption := 'Copy(&C)';
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormHelp.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormHelp.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView1.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView1.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo1.Lines.Count-1) then
      begin
        iRow1 := Memo1.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo1.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo1.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, iLine2, 0);
      //tH[JX͈ړȂ
//      Memo1.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView1DblClick(Sender: TObject);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView1.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView1.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sstr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo1.Lines.Count-1) then
      begin
        iRow1 := Memo1.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo1.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo1.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, iLine2, 0);
      Memo1.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView1KeyPress(Sender: TObject; var Key: Char);
begin
 //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormHelp.TreeView2Change(Sender: TObject; Node: TTreeNode);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView2.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView2.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo2.Lines.Count-1) then
      begin
        iRow1 := Memo2.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo2.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo2.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo2.SelStart := Memo2.Perform(EM_LINEINDEX, iLine2, 0);
      //tH[JX͈ړȂ
//      Memo1.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView2DblClick(Sender: TObject);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView2.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView2.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo2.Lines.Count-1) then
      begin
        iRow1 := Memo2.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo2.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo2.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo2.SelStart := Memo2.Perform(EM_LINEINDEX, iLine2, 0);
      Memo2.SetFocus;
    end;
  end;
end;


procedure TFormHelp.TreeView2KeyPress(Sender: TObject; var Key: Char);
begin
 //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormHelp.TreeView3Change(Sender: TObject; Node: TTreeNode);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView3.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView3.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo3.Lines.Count-1) then
      begin
        iRow1 := Memo3.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo3.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo3.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo3.SelStart := Memo3.Perform(EM_LINEINDEX, iLine2, 0);
      //tH[JX͈ړȂ
//      Memo1.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView3DblClick(Sender: TObject);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView3.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView3.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo3.Lines.Count-1) then
      begin
        iRow1 := Memo3.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo3.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo3.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo3.SelStart := Memo3.Perform(EM_LINEINDEX, iLine2, 0);
      Memo3.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView3KeyPress(Sender: TObject; var Key: Char);
begin
 //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormHelp.TreeView4Change(Sender: TObject; Node: TTreeNode);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView4.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView4.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo4.Lines.Count-1) then
      begin
        iRow1 := Memo4.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo4.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo4.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo4.SelStart := Memo4.Perform(EM_LINEINDEX, iLine2, 0);
      //tH[JX͈ړȂ
//      Memo1.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView4DblClick(Sender: TObject);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView4.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView4.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo4.Lines.Count-1) then
      begin
        iRow1 := Memo4.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo4.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo4.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo4.SelStart := Memo4.Perform(EM_LINEINDEX, iLine2, 0);
      Memo4.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView4KeyPress(Sender: TObject; var Key: Char);
begin
 //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormHelp.TreeView5Change(Sender: TObject; Node: TTreeNode);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView1.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView5.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo5.Lines.Count-1) then
      begin
        iRow1 := Memo5.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo5.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo5.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo5.SelStart := Memo5.Perform(EM_LINEINDEX, iLine2, 0);
      //tH[JX͈ړȂ
//      Memo1.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView5DblClick(Sender: TObject);
var
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //
  if BoolShowMem = TRUE then
  begin
    if (TreeView5.Items.Count > 0) then
    begin
      //擾
      sStr1 := TreeView5.Selected.Text;
      sStr2 := Copy(sStr1, Length(sStr1)-4, Length(sStr1));
      sStr3 := Copy(sStr1, 1, Length(sStr1) - OUTLINE_ADD_SPACE - 5);
      iPos1 := StrToInt(sStr2);

      //
      if iPos1 < 0 then
      begin
        iRow1 := 0;
      end
      else if iPos1 > (Memo5.Lines.Count-1) then
      begin
        iRow1 := Memo5.Lines.Count-1
      end
      else
      begin
        iRow1 := iPos1;
      end;

      //݂̃J[\̂s
      //iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
      //ʂ̍ŏs
      iLine1 := Memo5.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړs
      iLine2 := iRow1;
      //ړ
      Memo5.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
      Memo5.SelStart := Memo5.Perform(EM_LINEINDEX, iLine2, 0);
      Memo5.SetFocus;
    end;
  end;
end;

procedure TFormHelp.TreeView5KeyPress(Sender: TObject; var Key: Char);
begin
 //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormHelp.ButtonHelpClick(Sender: TObject);
begin
  Panel1.Visible := TRUE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;
  Panel5.Visible := FALSE;
  Panel9.Visible := FALSE;
  //ݒ
  Label1.Caption := '';
  Label2.Caption := '';
end;

procedure TFormHelp.ButtonQAClick(Sender: TObject);
begin
  Panel1.Visible := FALSE;
  Panel2.Visible := TRUE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;
  Panel5.Visible := FALSE;
  Panel9.Visible := FALSE;
  //ݒ
  Label1.Caption := '';
  Label2.Caption := '';
end;

procedure TFormHelp.ButtonAndroidClick(Sender: TObject);
begin
  Panel1.Visible := FALSE;
  Panel2.Visible := FALSE;
  Panel3.Visible := TRUE;
  Panel4.Visible := FALSE;
  Panel5.Visible := FALSE;
  Panel9.Visible := FALSE;
  //ݒ
  Label1.Caption := '';
  Label2.Caption := '';
end;

procedure TFormHelp.ButtonWin64Click(Sender: TObject);
begin
  Panel1.Visible := FALSE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := TRUE;
  Panel5.Visible := FALSE;
  Panel9.Visible := FALSE;
end;

procedure TFormHelp.ButtonCSVClick(Sender: TObject);
begin
  Panel1.Visible := FALSE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;
  Panel5.Visible := TRUE;
  Panel9.Visible := FALSE;
end;

procedure TFormHelp.ButtonImageClick(Sender: TObject);
var
  sStr1: String;
begin
  Panel1.Visible := FALSE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;
  Panel5.Visible := FALSE;
  Panel9.Visible := TRUE;

  IntImageIndex := IntImageIndex+1;
  if IntImageIndex > 17 then
  begin
    IntImageIndex := 0;
  end;

  if IntImageIndex = 0 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_01_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP ̧װ';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Filer';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 1 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_02_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'WebDAV ̧װ';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'WebDAV Filer';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 2 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_03_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'AndrodʂōォuFTP ServervuWebDAV ServervuMLUSBvuނLv';
      Label2.Caption := 'ʐ^͋ߏ̔LŁuԂv';
    end
    else
    begin
      Label1.Caption := 'Android screen shot: [FTP Server][WebDAV Server][MLUSB][Fishing Diary]';
      Label2.Caption := 'Image is [Gabu chan], she lives near here.';
    end;
  end;
  if IntImageIndex = 3 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_04_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'MLUSB T[oN';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'MLUSB Server Run';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 4 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_05_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'MLUSB T[oݒmF';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'MLUSB Server Information';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 5 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_06_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'WebDAV Server ~';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'WebDAV Server Stop';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 6 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_07_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'WebDAV Server N';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'WebDAV Server Start';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 7 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_08_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server ڰ';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server Internal Storage';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 8 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_09_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server ڰނ́uSDJ[hvw';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server Internal Storage[SD Card]';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 9 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_10_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server ~';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server Stop';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 10 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_11_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server N ڰ';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server Start Internal Storage';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 11 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_12_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server Oڰ';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server External Storage';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 12 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_13_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server Oڰނ́u̫ށvw';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server External Storage select [Custom Folder]';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 13 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_14_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server Oڰނ́u̫ށvŁuSDށvw';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server External Storage select [SD Card] in [Custom Folder]';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 14 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_15_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server Oڰނ́u̫ށvŁuSDށv́uٰāvw';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server External Storage select [Root] in [SD Card] in [Custom Folder]';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 15 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_16_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server OڰނŁu̫ށvSDނݒ肳Ă';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server External Storage selected [SD Card] in [Custom Folder]';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 16 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_17_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server ~';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server Stop';
      Label2.Caption := '';
    end;
  end;
  if IntImageIndex = 17 then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + HELP_IMAGE_18_JPG;
    ViewFileWic(sStr1, TRUE, Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      Label1.Caption := 'FTP Server N Oڰ';
      Label2.Caption := '';
    end
    else
    begin
      Label1.Caption := 'FTP Server Start External Storage';
      Label2.Caption := '';
    end;
  end;
end;

function  TFormHelp.ViewFileWic(FileName: String; InitPos: Boolean; Sender: TObject): Boolean;
var
  Img1: TWICImage;
  SrcBmp: TGPBitMap;
  DstBmp: TBitMap;
  TmpBmp: TBitMap;
  Graphics: TGPGraphics;
  sStr1: String;
  iWidth2: integer;
  iWidth3: integer;
  iHeight2: integer;
  iHeight3: integer;
  VerticalRate: Real;
  HorizontalRate: Real;
begin
  //t@C͂Őݒ
  StrFileNameCurrent := FileName;

  //ŏ̏ꍇ
  if InitPos = TRUE then
  begin
    //XP[͖߂
    IntImageScale := IMAGE_SCALE_NORMAL;
  end;

  //
  try
    //t@C
    sStr1 := Formmain.StrExtractBase + TEMP_WIC_JPG;
    //ŏ̏ꍇ̓t@Cɕۑ
    if InitPos = TRUE then
    begin
      //쐬
      Img1 := TWICImage.Create;
      //
      try
        //t@Cǂݍ
        Img1.LoadFromFile(FileName);
        //t@Cɕۑ
        Img1.ImageFormat := wifJpeg;
        Img1.SaveToFile(sStr1);
      finally
        //j
        Img1.Free;
      end;
    end;
  //
  except
    // m
    TmpBmp := TBitMap.Create;
    try
      TmpBmp.SaveToFile(sStr1);
    finally
      //j
      TmpBmp.Free;
    end;

  end;

  //
  try
    //쐬
    SrcBmp := TGPBitMap.Create(sStr1);
    DstBmp := TBitMap.Create;
    //
    try
      //]
      if      IntImageRotate = 3 then
      begin
        SrcBmp.RotateFlip(Rotate270FlipNone);
      end
      else if IntImageRotate = 2 then
      begin
        SrcBmp.RotateFlip(Rotate180FlipNone);
      end
      else if IntImageRotate = 1 then
      begin
        SrcBmp.RotateFlip(Rotate90FlipNone);
      end
      else
      begin
        //
      end;

      //p̐ݒ
      IntImageReadHeight := SrcBmp.GetHeight;
      IntImageReadWidth  := SrcBmp.GetWidth;
      IntImageSrcHeight  := SrcBmp.GetHeight;
      IntImageSrcWidth   := SrcBmp.GetWidth;

        //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
        VerticalRate   := IntImageSrcHeight / Panel10.Height;
        HorizontalRate := IntImageSrcWidth  / Panel10.Width;
        if (VerticalRate > 1) and (HorizontalRate > 1) then
        begin
          if (VerticalRate >= HorizontalRate) then
          begin
            iHeight2 := Panel10.Height;
            iWidth2  := Round(iHeight2 * IntImageSrcWidth / IntImageSrcHeight);
            IntCompressRate := Round(iHeight2 / SrcBmp.GetHeight * 100);
          end
          else
          begin
            iWidth2  := Panel10.Width;
            iHeight2 := Round(iWidth2 * IntImageSrcHeight / IntImageSrcWidth);
            IntCompressRate := Round(iWidth2 / SrcBmp.GetWidth * 100);
          end;
        end
        else if (VerticalRate > 1) then
        begin
          iHeight2 := Panel10.Height;
          iWidth2  := Round(iHeight2 * IntImageSrcWidth / IntImageSrcHeight);
          IntCompressRate := Round(iHeight2 / SrcBmp.GetHeight * 100);
        end
        else if (HorizontalRate > 1) then
        begin
          iWidth2  := Panel10.Width;
          iHeight2 := Round(iWidth2 * IntImageSrcHeight / IntImageSrcWidth);
          IntCompressRate := Round(iWidth2 / SrcBmp.GetWidth * 100);
        end
        else
        begin
          iHeight2 := IntImageSrcHeight;
          iWidth2  := IntImageSrcWidth;
          IntCompressRate := Round(iWidth2 / SrcBmp.GetWidth * 100);
        end;

        //ݒ
        DstBmp.Width  := iWidth2;
        DstBmp.Height := iHeight2;
        //\p̐ݒ
        IntImageScaleWidth  := iWidth2;
        IntImageScaleHeight := iHeight2;
        //ݒ
        iWidth3  := iWidth2;
        iHeight3 := iHeight2;

      //쐬
      Graphics  := TGPGraphics.Create(DstBmp.Canvas.Handle);
      //
      try
        //쐬eDstɔf
        if Graphics.DrawImage(SrcBmp, 0, 0, iWidth3, iHeight3) <> OK then
        begin
          //s
          Result := FALSE;
       end
         else
        begin
          //
          Result := TRUE;
        end;
      finally
        //j
        Graphics.Free;
      end;

        //\
        Image1.Height := DstBmp.Height;
        Image1.Width  := DstBmp.Width;
        Image1.Left := Round((Panel10.Width  -  Image1.Width ) div 2);
        Image1.Top  := Round((Panel10.Height -  Image1.Height) div 2);
        //摜\
        Image1.Stretch := FALSE;
        Image1.Picture.Graphic := DstBmp;
    finally
      //j
      DstBmp.Free;
      SrcBmp.Free;
    end;
  //
  except
    //s
    Image1.Picture.Graphic := nil;
    Result := FALSE;
  end;

end;

end.
