unit InputDateTime;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, IniFiles;

const
  FORM_WIDTH_SET       = 800;
  FORM_HEIGHT_SET      = 600;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormInputDateTime = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Memo1: TMemo;
    Memo2: TMemo;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    function  CheckFileFolderName(Sender: TObject): Boolean;

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputDateTime: TFormInputDateTime;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputDateTime.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputDateTime.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputDateTime.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputDateTime.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputDateTime.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormInputDateTime', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputDateTime', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputDateTime', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputDateTime', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputDateTime', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //ݒ
  Edit1.Text := FormMain.StrRetFormInputDateTime;
  Memo1.Align := alClient;
  Memo2.Align := alClient;

end;

procedure TFormInputDateTime.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputDateTime', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputDateTime', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputDateTime', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputDateTime', 'Left',   FormInputDateTime.Left);
    IniFile.WriteInteger('FormInputDateTime', 'Top',    FormInputDateTime.Top);
    IniFile.WriteInteger('FormInputDateTime', 'Width',  FormInputDateTime.Width);
    IniFile.WriteInteger('FormInputDateTime', 'Height', FormInputDateTime.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormInputDateTime.FormResize(Sender: TObject);
begin
;
end;

procedure TFormInputDateTime.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputDateTime.KeyPreview := TRUE;
  //ݒ
  Edit1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputDateTime.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputDateTime.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputDateTime.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputDateTime.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputDateTime.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputDateTime.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputDateTime, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputDateTime, StrLanguageFileName, Sender);
  end;
  if BoolJapanese = TRUE then
  begin
    //{
    Memo1.Visible := TRUE;
    Memo2.Visible := FALSE;
  end
  else
  begin
    //p
    Memo1.Visible := FALSE;
    Memo2.Visible := TRUE;
  end;
end;

procedure TFormInputDateTime.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputDateTime, StrLanguageFileName, Sender);
    //{
    Memo1.Visible := TRUE;
    Memo2.Visible := FALSE;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputDateTime, StrLanguageFileName, Sender);
    //p
    Memo1.Visible := FALSE;
    Memo2.Visible := TRUE;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputDateTime.ButtonOKClick(Sender: TObject);
begin
  //`FbN
  if CheckFileFolderName(Sender) = FALSE then
  begin
    Exit;
  end;

  //ݒ
  FormMain.StrRetFormInputDateTime := Edit1.Text;
  //I
  ModalResult := mrOK;
end;

procedure TFormInputDateTime.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

function  TFormInputDateTime.CheckFileFolderName(Sender: TObject): Boolean;
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
begin
//  AX^XN (*)
//  c_ (|)
//  ~L (\)
//  R (:)
//  dp (")
//  s (菬) (<)
//  s () (>)
//  ^╄ (?)
//  XbV (/)

  //
  iPos1 := Pos('*', Edit1.Text);
  iPos2 := Pos('|', Edit1.Text);
  iPos3 := Pos('\', Edit1.Text);
  iPos4 := Pos(':', Edit1.Text);
  iPos5 := Pos('"', Edit1.Text);
  iPos6 := Pos('<', Edit1.Text);
  iPos7 := Pos('>', Edit1.Text);
  iPos8 := Pos('?', Edit1.Text);
  iPos9 := Pos('/', Edit1.Text);
  if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
     (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
     (iPos9 > 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
  end
  else
  begin
    Result := TRUE;
  end;
end;


end.
