unit InputFilename;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 750;
  FORM_HEIGHT_SET      = 330;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormInputFilename = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Label3: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit3: TEdit;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputFilename: TFormInputFilename;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputFilename.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputFilename.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputFilename.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputFilename.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormInputFilename', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputFilename', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputFilename', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputFilename', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputFilename', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;
end;

procedure TFormInputFilename.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputFilename', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputFilename', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputFilename', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputFilename', 'Left',   FormInputFilename.Left);
    IniFile.WriteInteger('FormInputFilename', 'Top',    FormInputFilename.Top);
    IniFile.WriteInteger('FormInputFilename', 'Width',  FormInputFilename.Width);
    IniFile.WriteInteger('FormInputFilename', 'Height', FormInputFilename.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormInputFilename.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputFilename.KeyPreview := TRUE;
  //ݒ
  Edit1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputFilename.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputFilename.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
//    FormInputFilename.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputFilename.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputFilename.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputFileName.Handle, imClose);

  //ݒ
  Edit1.Text := FormMain.StrRetFormInputFilename;
  Edit2.Text := FormMain.StrRetFormInputFilename;
  Edit3.Text := FormMain.StrSetFormInputFilename;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputFilename.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputFilename, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputFilename, StrLanguageFileName, Sender);
  end;
end;

procedure TFormInputFilename.FormResize(Sender: TObject);
begin
  Edit1.Width := Panel1.ClientWidth - 40;
  Edit2.Width := Panel1.ClientWidth - 40;
  Edit3.Width := Panel1.ClientWidth - 40;
end;

procedure TFormInputFilename.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;


procedure TFormInputFilename.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputFilename, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputFilename, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputFilename.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOkClick(Sender);
  end;
end;

procedure TFormInputFilename.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormInputFilename.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormInputFilename.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormInputFilename.ButtonOKClick(Sender: TObject);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
begin
  //
  if Edit1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@Cݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Filename is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  if UpperCase(Edit1.Text) = UpperCase(FormMain.StrRetFormInputFilename) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃t@Cł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Filename is same.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  if Edit1.Text <> '' then
  begin
    iPos1 := Pos('*', Edit1.Text);
    iPos2 := Pos('|', Edit1.Text);
    iPos3 := Pos('\', Edit1.Text);
    iPos4 := Pos(':', Edit1.Text);
    iPos5 := Pos('"', Edit1.Text);
    iPos6 := Pos('<', Edit1.Text);
    iPos7 := Pos('>', Edit1.Text);
    iPos8 := Pos('?', Edit1.Text);
    iPos9 := Pos('/', Edit1.Text);
    if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
       (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
       (iPos9 > 0) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Some letters can not accept.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //㔼폜
  sStr14 := TrimRight(Edit1.Text);
  //u
  sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
  Edit1.Text := sStr18;

  //
  if FileExists(FormMain.StrSetFormInputFileName + Edit1.Text) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@C܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same file exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //߂l
  FormMain.StrRetFormInputFilename := Edit1.Text;
  //I
  ModalResult := mrOK;
end;

procedure TFormInputFilename.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormInputFilename := '';
  //I
  ModalResult := mrCancel;
end;

end.

