unit InputNetwork;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, Vcl.Menus;

const
  FORM_WIDTH_SET  = 800;
  FORM_HEIGHT_SET = 410;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

type
  TFormInputNetwork = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    PopupMenu1: TPopupMenu;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure Edit5KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox3KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TstringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }
  end;

var
  FormInputNetwork: TFormInputNetwork;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputNetwork.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputNetwork.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputNetwork.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputNetwork.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputNetwork.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormInputNetwork', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputNetwork', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputNetwork', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputNetwork', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputNetwork', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TstringList.Create;

  //ݒ
  Edit1.ReadOnly := TRUE;
  Edit1.Font.Color := clBlue;
  Memo1.Visible := TRUE;
  Memo2.Visible := FALSE;
end;

procedure TFormInputNetwork.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputNetwork', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputNetwork', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputNetwork', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputNetwork', 'Left',   FormInputNetwork.Left);
    IniFile.WriteInteger('FormInputNetwork', 'Top',    FormInputNetwork.Top);
    IniFile.WriteInteger('FormInputNetwork', 'Width',  FormInputNetwork.Width);
    IniFile.WriteInteger('FormInputNetwork', 'Height', FormInputNetwork.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
end;

procedure TFormInputNetwork.FormResize(Sender: TObject);
begin
;
end;

procedure TFormInputNetwork.FormShow(Sender: TObject);
var
  sStr9: String;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputNetwork.KeyPreview := TRUE;
  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputNetwork.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputNetwork.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputNetwork.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputNetwork.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputNetwork.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputNetwork.txt';
  if BoolJapanese = TRUE then
  begin
    //ݒ
    Memo1.Visible := TRUE;
    Memo2.Visible := FALSE;
    //{
    FormMain.SetJapanese(FormInputNetwork, StrLanguageFileName, Sender);
  end
  else
  begin
    //ݒ
    Memo1.Visible := FALSE;
    Memo2.Visible := TRUE;
    //p
    FormMain.SetEnglish(FormInputNetwork, StrLanguageFileName, Sender);
  end;

  //ݒ
  sStr9 := ExtractFilePath(ParamStr(0)) + NET_TXT;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListitems.LoadFromFile(sStr9, TEncoding.Unicode);
    //擾
    Edit1.Text          :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 0];
    Edit2.Text          :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 1];
    ComboBox1.ItemIndex := StrToInt(StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 2]);
    ComboBox2.Text      :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 3];
    Edit3.Text          :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 4];
    Edit4.Text          :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 5];
    Edit5.Text          :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 6];
    ComboBox3.ItemIndex := StrToInt(StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 7]);
  end
  else
  begin
    //ݒ
    if FormMain.BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ݒt@C܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Setting file is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormInputNetwork.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputNetwork, StrLanguageFileName, Sender);
    //ݒ
    Memo1.Visible := TRUE;
    Memo2.Visible := FALSE;
    ComboBox1.ItemIndex := StrToInt(StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 2]);
    ComboBox2.Text      :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 3];
    ComboBox3.ItemIndex := StrToInt(StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 7]);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputNetwork, StrLanguageFileName, Sender);
    //ݒ
    Memo1.Visible := FALSE;
    Memo2.Visible := TRUE;
    ComboBox1.ItemIndex := StrToInt(StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 2]);
    ComboBox2.Text      :=          StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 3];
    ComboBox3.ItemIndex := StrToInt(StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 7]);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputNetwork.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormInputNetwork.ButtonOKClick(Sender: TObject);
var
  sStr9: String;
begin
  //
  if Edit2.Text = '' then
  begin
    //ݒ
    if FormMain.BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 0] := Edit1.Text;
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 1] := Edit2.Text;
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 2] := IntToStr(ComboBox1.ItemIndex);
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 3] := ComboBox2.Text;
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 4] := Edit3.Text;
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 5] := Edit4.Text;
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 6] := Edit5.Text;
  StrListItems.Strings[(FormMain.IntNetworkIndex * 8) + 7] := IntToStr(ComboBox3.ItemIndex);

  //ݒ
   sStr9 := ExtractFilePath(ParamStr(0)) + NET_TXT;
  //ۑ
  StrListItems.SaveToFile(sStr9, TEncoding.Unicode);

  //I
  ModalResult := mrOK;
end;

procedure TFormInputNetwork.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.Edit5KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNetwork.ComboBox3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
