unit InputNewFilename;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET  = 750;
  FORM_HEIGHT_SET = 325;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

type
  TFormInputNewFilename = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Edit1: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    ButtonEdit: TButton;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure SetEditItem(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ButtonEditClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputNewFilename: TFormInputNewFilename;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputNewFilename.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputNewFilename.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputNewFilename.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputNewFilename.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputNewFilename.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormInputNewFilename', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputNewFilename', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputNewFilename', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputNewFilename', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputNewFilename', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  RadioGroup1.ItemIndex := IniFile.ReadInteger('InputNewFilename', 'Index', 1);
  //j
  IniFile.Free;

  //ݒ
  SetEditItem(Sender);
end;

procedure TFormInputNewFilename.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputNewFilename', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputNewFilename', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputNewFilename', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputNewFilename', 'Left',   FormInputNewFilename.Left);
    IniFile.WriteInteger('FormInputNewFilename', 'Top',    FormInputNewFilename.Top);
    IniFile.WriteInteger('FormInputNewFilename', 'Width',  FormInputNewFilename.Width);
    IniFile.WriteInteger('FormInputNewFilename', 'Height', FormInputNewFilename.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteInteger('InputNewFilename', 'Index', RadioGroup1.ItemIndex);
  //j
  IniFile.Free;
end;

procedure TFormInputNewFilename.FormResize(Sender: TObject);
begin
  Edit1.Width := Panel1.ClientWidth - 40;
end;

procedure TFormInputNewFilename.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputNewFilename.KeyPreview := TRUE;
  //ݒ
  Edit1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputNewFilename.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputNewFilename.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputNewFilename.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputNewFilename.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputNewFilename.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputNewFilename.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputNewFilename, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputNewFilename, StrLanguageFileName, Sender);
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  RadioGroup1.ItemIndex := IniFile.ReadInteger('InputNewFilename', 'Index', 1);
  //j
  IniFile.Free;
end;

procedure TFormInputNewFilename.RadioGroup1Click(Sender: TObject);
begin
  SetEditItem(Sender);
end;

procedure TFormInputNewFilename.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile: TiniFile;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputNewFilename, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    RadioGroup1.ItemIndex := IniFile.ReadInteger('InputNewFilename', 'Index', 1);
    //j
    IniFile.Free;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputNewFilename, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    RadioGroup1.ItemIndex := IniFile.ReadInteger('InputNewFilename', 'Index', 1);
    //j
    IniFile.Free;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputNewFilename.ButtonEditClick(Sender: TObject);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  IniFile: TiniFile;
begin
  //
  if Edit1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@Cݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Filename is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  if Edit1.Text <> '' then
  begin
    iPos1 := Pos('*', Edit1.Text);
    iPos2 := Pos('|', Edit1.Text);
    iPos3 := Pos('\', Edit1.Text);
    iPos4 := Pos(':', Edit1.Text);
    iPos5 := Pos('"', Edit1.Text);
    iPos6 := Pos('<', Edit1.Text);
    iPos7 := Pos('>', Edit1.Text);
    iPos8 := Pos('?', Edit1.Text);
    iPos9 := Pos('/', Edit1.Text);
    if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
       (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
       (iPos9 > 0) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //㔼폜
  sStr14 := TrimRight(Edit1.Text);
  //u
  sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
  Edit1.Text := sStr18;

  //
  if FileExists(FormMain.StrCurrent + Edit1.Text) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@C܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same file exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('NewFile', 'Target', NEWFILE_EDIT);
  //j
  IniFile.Free;

  //߂l
  FormMain.StrRetFormInputNewFilename := Edit1.Text;
  //I
  ModalResult := mrOK;
end;

procedure TFormInputNewFilename.ButtonOKClick(Sender: TObject);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  IniFile: TiniFile;
begin
  //
  if Edit1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@Cݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Filename is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  if Edit1.Text <> '' then
  begin
    iPos1 := Pos('*', Edit1.Text);
    iPos2 := Pos('|', Edit1.Text);
    iPos3 := Pos('\', Edit1.Text);
    iPos4 := Pos(':', Edit1.Text);
    iPos5 := Pos('"', Edit1.Text);
    iPos6 := Pos('<', Edit1.Text);
    iPos7 := Pos('>', Edit1.Text);
    iPos8 := Pos('?', Edit1.Text);
    iPos9 := Pos('/', Edit1.Text);
    if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
       (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
       (iPos9 > 0) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //㔼폜
  sStr14 := TrimRight(Edit1.Text);
  //u
  sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
  Edit1.Text := sStr18;

  //
  if FileExists(FormMain.StrCurrent + Edit1.Text) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@C܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same file exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('NewFile', 'Target', NEWFILE_NONE);
  //j
  IniFile.Free;

  //߂l
  FormMain.StrRetFormInputNewFilename := Edit1.Text;
  //I
  ModalResult := mrOK;
end;

procedure TFormInputNewFilename.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormInputNewFilename.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    if Edit1.Text = '' then
    begin
      //
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormInputNewFilename.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputNewFilename.SetEditItem(Sender: TObject);
begin
  if      (RadioGroup1.ItemIndex = 0) then
  begin
    Edit1.Text := '';
  end
  else if (RadioGroup1.ItemIndex = 1) then
  begin
    Edit1.Text := RadioGroup1.Items.Strings[RadioGroup1.ItemIndex];
  end
  else if (RadioGroup1.ItemIndex = 2) then
  begin
    Edit1.Text := RadioGroup1.Items.Strings[RadioGroup1.ItemIndex];
  end
  else if (RadioGroup1.ItemIndex = 3) then
  begin
    //N𓀗pɐݒ
    Edit1.Text := FormatDateTime('yyyy-mm-dd', Now) + '.txt';
  end
  else if (RadioGroup1.ItemIndex = 4) then
  begin
    //N𓀗pɐݒ
    Edit1.Text := FormatDateTime('yyyy-mm-dd hh-nn-ss', Now) + '.txt';
  end
  else
  begin
    Edit1.Text := '';
  end;
end;

end.
