unit JumpFolder;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, Clipbrd, Vcl.Menus, System.UITypes;

const
  FORM_WIDTH_SET  = 770;
  FORM_HEIGHT_SET = 540;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';
  LISTBOX8_WIDTH  = 690;

type
  TFormJumpFolder = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ListBox8: TListBox;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuOperation: TMenuItem;
    MenuInput: TMenuItem;
    MenuDelete: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuEscape: TMenuItem;
    N1: TMenuItem;
    MenuColorSet: TMenuItem;
    MenuQuit: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure SetItemList(Sender: TObject);
    procedure MenuInputClick(Sender: TObject);
    procedure MenuDeleteClick(Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuPasteClick(Sender: TObject);
    procedure MenuEscapeClick(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure MenuColorSetClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TStringList;
    StrCopyItem: String;
    StrListKeyMap: TStringList;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormJumpFolder: TFormJumpFolder;

implementation

uses  Main, InputFolder;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormJumpFolder.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormJumpFolder.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormJumpFolder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormJumpFolder.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormJumpFolder.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormJumpFolder', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormJumpFolder', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormJumpFolder', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormJumpFolder', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormJumpFolder', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TStringList.Create;
  StrListKeyMap := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox8.Style := lbOwnerDrawFixed;
    MenuColorSet.Checked := IniFile.ReadBool('FormJumpFolder', 'SameColor', FALSE);
    MenuColorSet.Enabled := TRUE;
    if MenuColorSet.Checked = TRUE then
    begin
      ListBox8.Color := FormMain.ListView1.Color;
      Panel3.Color   := FormMain.ListView1.Color;
    end;
  end
  else
  begin
    ListBox8.Style := lbStandard;
    MenuColorSet.Checked := TRUE;
    MenuColorSet.Enabled := FALSE;
  end;
  //j
  IniFile.Free;

  //ݒ
  if FormMain.IntJumpFolderTypeIndex = JUMP_FOLDER_BROWSE then
  begin
    MenuOperation.Enabled := FALSE;
  end
  else
  begin
    MenuOperation.Enabled := TRUE;
  end;

  //ݒ
  SetShortCutKey(Sender);
end;

procedure TFormJumpFolder.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormJumpFolder', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormJumpFolder', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormJumpFolder', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormJumpFolder', 'Left',   FormJumpFolder.Left);
    IniFile.WriteInteger('FormJumpFolder', 'Top',    FormJumpFolder.Top);
    IniFile.WriteInteger('FormJumpFolder', 'Width',  FormJumpFolder.Width);
    IniFile.WriteInteger('FormJumpFolder', 'Height', FormJumpFolder.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    //ۑ
    IniFile.WriteBool('FormJumpFolder', 'SameColor', MenuColorSet.Checked);
  end
  else
  begin
    //
  end;
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
  StrListKeyMap.Free;
end;

procedure TFormJumpFolder.FormShow(Sender: TObject);
var
  sStr9: String;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormJumpFolder.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormJumpFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormJumpFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormJumpFolder.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormJumpFolder.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //mF
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JP2;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath +  FILENAME_JP2;
  end;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9);
    //\
    SetItemList(Sender);
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A              ');
    StrListitems.Add('  B              ');
    StrListitems.Add('  C              ');
    StrListitems.Add('  D              ');
    StrListitems.Add('  E              ');
    StrListitems.Add('  F              ');
    StrListitems.Add('  G              ');
    StrListitems.Add('  H              ');
    StrListitems.Add('  I              ');
    StrListitems.Add('  J              ');
    StrListitems.Add('  K              ');
    StrListitems.Add('  L              ');
    StrListitems.Add('  M              ');
    StrListitems.Add('  N              ');
    StrListitems.Add('  O              ');
    StrListitems.Add('  P              ');
    StrListitems.Add('  Q              ');
    StrListitems.Add('  R              ');
    StrListitems.Add('  S              ');
    StrListitems.Add('  T              ');
    StrListitems.Add('  U              ');
    StrListitems.Add('  V              ');
    StrListitems.Add('  W              ');
    StrListitems.Add('  X              ');
    StrListitems.Add('  Y              ');
    StrListitems.Add('  Z              ');
    StrListitems.Add('  0              ');
    StrListitems.Add('  1              ');
    StrListitems.Add('  2              ');
    StrListitems.Add('  3              ');
    StrListitems.Add('  4              ');
    StrListitems.Add('  5              ');
    StrListitems.Add('  6              ');
    StrListitems.Add('  7              ');
    StrListitems.Add('  8              ');
    StrListitems.Add('  9              ');
    StrListitems.Add('s+A              ');
    StrListitems.Add('s+B              ');
    StrListitems.Add('s+C              ');
    StrListitems.Add('s+D              ');
    StrListitems.Add('s+E              ');
    StrListitems.Add('s+F              ');
    StrListitems.Add('s+G              ');
    StrListitems.Add('s+H              ');
    StrListitems.Add('s+I              ');
    StrListitems.Add('s+J              ');
    StrListitems.Add('s+K              ');
    StrListitems.Add('s+L              ');
    StrListitems.Add('s+M              ');
    StrListitems.Add('s+N              ');
    StrListitems.Add('s+O              ');
    StrListitems.Add('s+P              ');
    StrListitems.Add('s+Q              ');
    StrListitems.Add('s+R              ');
    StrListitems.Add('s+S              ');
    StrListitems.Add('s+T              ');
    StrListitems.Add('s+U              ');
    StrListitems.Add('s+V              ');
    StrListitems.Add('s+W              ');
    StrListitems.Add('s+X              ');
    StrListitems.Add('s+Y              ');
    StrListitems.Add('s+Z              ');
    StrListitems.Add('s+0              ');
    StrListitems.Add('s+1              ');
    StrListitems.Add('s+2              ');
    StrListitems.Add('s+3              ');
    StrListitems.Add('s+4              ');
    StrListitems.Add('s+5              ');
    StrListitems.Add('s+6              ');
    StrListitems.Add('s+7              ');
    StrListitems.Add('s+8              ');
    StrListitems.Add('s+9              ');
    StrListitems.Add('c+A              ');
    StrListitems.Add('c+B              ');
    StrListitems.Add('c+C              ');
    StrListitems.Add('c+D              ');
    StrListitems.Add('c+E              ');
    StrListitems.Add('c+F              ');
    StrListitems.Add('c+G              ');
    StrListitems.Add('c+H              ');
    StrListitems.Add('c+I              ');
    StrListitems.Add('c+J              ');
    StrListitems.Add('c+K              ');
    StrListitems.Add('c+L              ');
    StrListitems.Add('c+M              ');
    StrListitems.Add('c+N              ');
    StrListitems.Add('c+O              ');
    StrListitems.Add('c+P              ');
    StrListitems.Add('c+Q              ');
    StrListitems.Add('c+R              ');
    StrListitems.Add('c+S              ');
    StrListitems.Add('c+T              ');
    StrListitems.Add('c+U              ');
    StrListitems.Add('c+V              ');
    StrListitems.Add('c+W              ');
    StrListitems.Add('c+X              ');
    StrListitems.Add('c+Y              ');
    StrListitems.Add('c+Z              ');
    StrListitems.Add('c+0              ');
    StrListitems.Add('c+1              ');
    StrListitems.Add('c+2              ');
    StrListitems.Add('c+3              ');
    StrListitems.Add('c+4              ');
    StrListitems.Add('c+5              ');
    StrListitems.Add('c+6              ');
    StrListitems.Add('c+7              ');
    StrListitems.Add('c+8              ');
    StrListitems.Add('c+9              ');
    //ۑ
    StrListItems.SaveToFile(sStr9);
    //\
    SetItemList(Sender);
  end;

  //ݒ
  ListBox8.SetFocus;

  //XN[o[\
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 2, 0);

  //IMEIt
  SetImeMode(FormJumpFolder.Handle, imClose);
  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'JumpFolder.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormJumpFolder, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormJumpFolder, StrLanguageFileName, Sender);
  end;
end;

procedure TFormJumpFolder.FormResize(Sender: TObject);
begin
  //
end;


procedure TFormJumpFolder.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //key
  if      (Shift = []) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_0) then
  begin
    ListBox8.ItemIndex := 26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_1) then
  begin
    ListBox8.ItemIndex := 27;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_2) then
  begin
    ListBox8.ItemIndex := 28;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_3) then
  begin
    ListBox8.ItemIndex := 29;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_4) then
  begin
    ListBox8.ItemIndex := 30;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_5) then
  begin
    ListBox8.ItemIndex := 31;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_6) then
  begin
    ListBox8.ItemIndex := 32;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_7) then
  begin
    ListBox8.ItemIndex := 33;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_8) then
  begin
    ListBox8.ItemIndex := 34;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_9) then
  begin
    ListBox8.ItemIndex := 35;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //shift
  else if (Shift = [ssShift]) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_0) then
  begin
    ListBox8.ItemIndex := 26+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_1) then
  begin
    ListBox8.ItemIndex := 27+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_2) then
  begin
    ListBox8.ItemIndex := 28+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_3) then
  begin
    ListBox8.ItemIndex := 29+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_4) then
  begin
    ListBox8.ItemIndex := 30+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_5) then
  begin
    ListBox8.ItemIndex := 31+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_6) then
  begin
    ListBox8.ItemIndex := 32+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_7) then
  begin
    ListBox8.ItemIndex := 33+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_8) then
  begin
    ListBox8.ItemIndex := 34+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_9) then
  begin
    ListBox8.ItemIndex := 35+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //ctrl
  else if (Shift = [ssCtrl]) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_0) then
  begin
    ListBox8.ItemIndex := 26+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_1) then
  begin
    ListBox8.ItemIndex := 27+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_2) then
  begin
    ListBox8.ItemIndex := 28+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_3) then
  begin
    ListBox8.ItemIndex := 29+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_4) then
  begin
    ListBox8.ItemIndex := 30+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_5) then
  begin
    ListBox8.ItemIndex := 31+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_6) then
  begin
    ListBox8.ItemIndex := 32+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_7) then
  begin
    ListBox8.ItemIndex := 33+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_8) then
  begin
    ListBox8.ItemIndex := 34+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_9) then
  begin
    ListBox8.ItemIndex := 35+36+36;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormJumpFolder, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormJumpFolder, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormJumpFolder.ButtonOKClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  IniFile: TIniFile;
begin
  //ݒȂ
  if Listbox8.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is enpty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //I
  else if Listbox8.ItemIndex = -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eIĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is not selected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //s
  else
  begin
    //ݒ
    sStr1 := Copy(StrListItems.Strings[ListBox8.itemIndex], 18, Length(StrListItems.Strings[ListBox8.itemIndex]));

    //ExẽhCuύX
    if      UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%d') then
    begin
      sStr2 := FormMain.StrExeDrive + Copy(sStr1, 3,  Length(sStr1));
    end
    else if UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%p') then
    begin
      sStr2 := FormMain.StrExePath  + Copy(sStr1, 3,  Length(sStr1));
    end
    else
    begin
      sStr2 := sStr1;
    end;

    //mF
    if sStr2 = '' then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : tH_ݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Folder is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //ݒ
    if Copy(sStr2, Length(sStr2), 1) <> '\' then
    begin
      sStr3 := sStr2 + '\';
    end
    else
    begin
      sStr3 := sStr2;
    end;

    //
    if DirectoryExists(ExtractFilePath(sStr3)) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : o^̃tH_܂' + #13#10 +
                            sStr3;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Registered file is not exist.' + #13#10 +
                            sStr3@+ #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //ݒ
      IniFile.WriteString('Return', 'Target', RETURN_FOLDER_LOWER);
      //j
      IniFile.Free;

      //߂l
      FormMain.StrRetFormJumpFolder := sStr3;
      //I
      ModalResult := mrOK;
    end;
  end;
end;

procedure TFormJumpFolder.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;


procedure TFormJumpFolder.ListBox8DblClick(Sender: TObject);
begin
  //OK
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormJumpFolder.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //
  if MenuColorSet.Checked = TRUE then
  begin
    //ListBox ̃X^C lbOwnerDrawFixed w肷
    with (Control as TListBox) do
    begin
      //tH[JX
      if (odFocused in State) = TRUE then
      begin
        //I
        if odSelected in State then
        begin
          Canvas.Brush.Color := FormMain.ListView1.Color;
          Canvas.Font.Color  := FormMain.FDirectoryColor;
        end
        //I
        else
        begin
          Canvas.Brush.Color := FormMain.ListView1.Color;
          Canvas.Font.Color  := FormMain.FDirectoryColor;
        end;
      end
      //tH[JXȂ
      else
      begin
        //I
        if odSelected in State then
        begin
          Canvas.Brush.Color := clAqua;
          Canvas.Font.Color  := clWindowText;
        end
        //I
        else
        begin
          Canvas.Brush.Color := FormMain.ListView1.Color;
          Canvas.Font.Color  := FormMain.FDirectoryColor;
        end;
      end;
      //`
      Canvas.FillRect(Rect);
      Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
    end;
  end
  else
  begin
    //ListBox ̃X^C lbOwnerDrawFixed w肷
    with (Control as TListBox) do
    begin
      //tH[JX
      if (odFocused in State) = TRUE then
      begin
        //I
        if odSelected in State then
        begin
          Canvas.Brush.Color := clHighlight;
          Canvas.Font.Color  := clWhite;
        end
        //I
        else
        begin
          Canvas.Brush.Color := clAqua;
          Canvas.Font.Color  := clWindowText;
        end;
      end
      //tH[JXȂ
      else
      begin
        //I
        if odSelected in State then
        begin
          Canvas.Brush.Color := clAqua;
          Canvas.Font.Color  := clWindowText;
        end
        //I
        else
        begin
          Canvas.Brush.Color := clWindow;
          Canvas.Font.Color  := clWindowText;
        end;
      end;
      //`
      Canvas.FillRect(Rect);
      Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
    end;
  end;
end;

procedure TFormJumpFolder.ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Return
  if (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormJumpFolder.MenuInputClick(Sender: TObject);
var
  bResult: Boolean;
  sStr9: String;
begin
  // 
  FormMain.IntJumpFolderIndex := ListBox8.ItemIndex;
  FormInputFolder := TFormInputFolder.Create(Application);
  try
    if FormInputFolder.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    // j
    FormInputFolder.Free;
  end;
  if bResult = TRUE then
  begin
    //Ǎ
    if FormMain.StrAnnsFMPath = '' then
    begin
      sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JP2;
    end
    else
    begin
      sStr9 := FormMain.StrAnnsFMPath +  FILENAME_JP2;
    end;
    StrListItems.LoadFromFile(sStr9);
    //ւ
    ListBox8.Items.Strings[ListBox8.ItemIndex] := StrListItems.Strings[ListBox8.ItemIndex];
  end;
end;

procedure TFormJumpFolder.MenuDeleteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr8: String;
  sStr9: String;
  wRet8: Word;
begin
  //擾
  sStr1 := StrListItems.Strings[ListBox8.ItemIndex];
  sStr2 := Copy(sStr1,  1, 3);
  sStr3 := Trim(Copy(sStr1,  5, 12));
  sStr4 := Copy(sStr1, 18, Length(sStr1));

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key : '    + Trim(sStr2) + #13#10 +
                                         #13#10 +
             'Name : '   + sStr3       + #13#10 +
             'Folder : ' + sStr4       + #13#10 +
                                         #13#10 +
             '폜܂H';
  end
  else
  begin
    sStr8 := 'Key : '    + Trim(sStr2) + #13#10 +
                                         #13#10 +
             'Name : '   + sStr3       + #13#10 +
             'Folder : ' + sStr4       + #13#10 +
                                         #13#10 +
             'Delete ?'                + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //ւ
    StrListItems.Strings[ListBox8.ItemIndex]   := sStr2 + '              ';
    //ۑ
    if FormMain.StrAnnsFMPath = '' then
    begin
      sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JP2;
    end
    else
    begin
      sStr9 := FormMain.StrAnnsFMPath +  FILENAME_JP2;
    end;
    StrListItems.SaveToFile(sStr9);

    //ւ
    ListBox8.Items.Strings[ListBox8.ItemIndex] := sStr2 + '              ';
  end
  else
  begin
    //
  end;
end;

procedure TFormJumpFolder.MenuEscapeClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormJumpFolder.MenuColorSetClick(Sender: TObject);
begin
  if MenuColorSet.Checked = TRUE then
  begin
    MenuColorSet.Checked := FALSE;
  end
  else
  begin
    MenuColorSet.Checked := TRUE;
  end;

  //ݒ
  if MenuColorSet.Checked = TRUE then
  begin
    ListBox8.Color := FormMain.ListView1.Color;
    Panel3.Color   := FormMain.ListView1.Color;
  end
  else
  begin
    ListBox8.Color := clWindow;
    Panel3.Color   := clWindow;
  end;
  //ĕ`
  FormJumpFolder.Repaint;
end;

procedure TFormJumpFolder.MenuCopyClick(Sender: TObject);
var
  sStr1: String;
  sStr4: String;
begin
  //擾
  sStr1 := StrListItems.Strings[ListBox8.ItemIndex];
  sStr4 := Copy(sStr1, 18, Length(sStr1));

  //
  if sStr4 = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : e󔒂Ȃ̂ŃRs[ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Copy can not operate , because of item is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  //ݒ
  StrCopyItem := StrListItems.Strings[ListBox8.ItemIndex];
end;

procedure TFormJumpFolder.MenuPasteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr21: String;
  sStr23: String;
  sStr24: String;
  wRet8: Word;
begin
  //
  if StrCopyItem = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \t̓eł' + #13#10 +
                         'ŏɃRs[sĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Paste items is empty.' + #13#10 +
                         'Copy must be done before Paste' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //擾
  sStr1  := StrListItems.Strings[ListBox8.ItemIndex];
  sStr2  := Copy(sStr1,  1, 3);
  sStr3  := Trim(Copy(sStr1,  5, 12));
  sStr4  := Copy(sStr1, 18, Length(sStr1));
  sStr21 := StrCopyItem;
  sStr23 := Trim(Copy(sStr21,  5, 12));
  sStr24 := Copy(sStr21, 18, Length(sStr21));

  //
  if sStr4 <> '' then
  begin
    //mF
    if BoolJapanese = TRUE then
    begin
      sStr8 := 'Key : '         + Trim(sStr2) + #13#10 +
                                                #13#10 +
               'Name(Old) : '   + sStr3       + #13#10 +
               'Name(New) : '   + sStr23      + #13#10 +
                                                #13#10 +
               'Folder(Old) : ' + sStr4       + #13#10 +
               'Folder(New) : ' + sStr24      + #13#10 +
                                                #13#10 +
               '㏑܂H';
    end
    else
    begin
      sStr8 := 'Key : '         + Trim(sStr2) + #13#10 +
                                                #13#10 +
               'Name(Old) : '   + sStr3       + #13#10 +
               'Name(New) : '   + sStr23      + #13#10 +
                                                #13#10 +
               'Folder(Old) : ' + sStr4       + #13#10 +
               'Folder(New) : ' + sStr24      + #13#10 +
                                                #13#10 +
               'Over Write ?'                 + #13#10 +
               '[YES] / [NO]';
    end;
    wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
    if wRet8 = mrYes then
    begin
      //s
    end
    else
    begin
      //~
      Exit;
    end;
  end;


  //擾
  sStr11 := Copy(StrListItems.Strings[ListBox8.ItemIndex],  1, 3);
  sStr12 := Copy(StrCopyItem,  4, Length(StrCopyItem));

  //ւ
  StrListItems.Strings[ListBox8.ItemIndex] := sStr11 + sStr12;
  //ۑ
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JP2;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath +  FILENAME_JP2;
  end;
  StrListItems.SaveToFile(sStr9);

  //ւ
  ListBox8.Items.Strings[ListBox8.ItemIndex] := StrListItems.Strings[ListBox8.ItemIndex];
end;

procedure TFormJumpFolder.MenuQuitClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormJumpFolder.SetItemList(Sender: TObject);
var
  iRow1: Integer;
begin
  //NA
  ListBox8.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
    ListBox8.Items.Add(StrListItems.Strings[iRow1]);
  end;
  ListBox8.ItemIndex := 0;
end;

procedure TFormJumpFolder.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //annsfm
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
  begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if StrListKeyMap.Count > 0 then
    begin
//      SetShortCutNew('1017', MenuQuit, Sender);
      SetShortCutNew('1311', MenuEscape, Sender);
    end;
  end;
end;

procedure TFormJumpFolder.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

end.

