unit JumpFolderEx;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, Clipbrd, MyUtility;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 500;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX2_WIDTH       = 690;

type
  TFormJumpFolderEx = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    ListBox2: TListBox;
    ListBox8: TListBox;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Label3: TLabel;
    ButtonCurrentMemoryFolder: TButton;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox2Enter(Sender: TObject);
    procedure ListBox8Click(Sender: TObject);
    procedure ListBox8Enter(Sender: TObject);
    procedure ButtonCurrentMemoryFolderClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormJumpFolderEx: TFormJumpFolderEx;

implementation

uses
  Main, JumpFolder;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormJumpFolderEx.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormJumpFolderEx.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormJumpFolderEx.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormJumpFolderEx.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormJumpFolderEx', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormJumpFolderEx', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormJumpFolderEx', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormJumpFolderEx', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormJumpFolderEx', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //ݒ
  ListBox2.Items.Assign(FormMain.StrListWindowName);
  ListBox2.ItemIndex := 0;

  //ݒ
  if FileExists(ExtractFilePath(ParamStr(0)) + CURRENT_TXT) = TRUE then
  begin
    FormMain.StrListCurrentHistory.LoadFromFile(ExtractFilePath(ParamStr(0)) + CURRENT_TXT, TEncoding.Unicode);
    ListBox8.Items.Assign(FormMain.StrListCurrentHistory);
  end;
  ListBox8.ItemIndex := 0;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox2.Style := lbOwnerDrawFixed;
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox2.Style := lbStandard;
    ListBox8.Style := lbStandard;
  end;

  //
  Edit1.Text := '';
end;

procedure TFormJumpFolderEx.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormJumpFolderEx', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormJumpFolderEx', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormJumpFolderEx', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormJumpFolderEx', 'Left',   FormJumpFolderEx.Left);
    IniFile.WriteInteger('FormJumpFolderEx', 'Top',    FormJumpFolderEx.Top);
    IniFile.WriteInteger('FormJumpFolderEx', 'Width',  FormJumpFolderEx.Width);
    IniFile.WriteInteger('FormJumpFolderEx', 'Height', FormJumpFolderEx.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormJumpFolderEx.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormJumpFolderEx.KeyPreview := TRUE;
  //ݒ
  Edit1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormJumpFolderEx.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormJumpFolderEx.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormJumpFolderEx.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormJumpFolderEx.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormJumpFolderEx.Handle, imClose);

  //XN[o[\
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX2_WIDTH * 2, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'JumpFolderEx.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormJumpFolderEx, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormJumpFolderEx, StrLanguageFileName, Sender);
  end;
end;

procedure TFormJumpFolderEx.FormResize(Sender: TObject);
begin
  Edit1.Width    := Panel1.Width  -30 -30;
  ListBox2.Width := Panel1.Width  -30 -30;
  ListBox8.Width := Panel1.Width  -30 -30;
end;

procedure TFormJumpFolderEx.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;


procedure TFormJumpFolderEx.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormJumpFolderEx, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormJumpFolderEx, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;


procedure TFormJumpFolderEx.ButtonCurrentMemoryFolderClick(Sender: TObject);
begin
  //ݒ
  Edit1.Text := FormMain.StrCurrentMemory;
  //
  Edit1.SetFocus;
end;

procedure TFormJumpFolderEx.ButtonOKClick(Sender: TObject);
var
  sStr2: String;
  iRow11: Integer;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  IniFile: TIniFile;
begin
  //ݒȂ
  if Edit1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is enpty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //s
  else
  begin
    //㔼폜
    sStr14 := TrimRight(Edit1.Text);
    //u
    sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
    sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
    sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
    sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
    Edit1.Text := sStr18;

    if Copy(Edit1.Text, Length(Edit1.Text), 1) = '\' then
    begin
      //
      if DirectoryExists(Edit1.Text) = FALSE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : tH_܂' + #13#10 +
                             Edit1.Text;
        end
        else
        begin
          FormMain.StrMsg := 'Error : Folder is not exist.' + #13#10 +
                             Edit1.Text + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end
    end
    else
    begin
      //
      if FileExists(Edit1.Text) = FALSE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C܂' + #13#10 +
                             Edit1.Text;
        end
        else
        begin
          FormMain.StrMsg := 'Error : File is not exist.' + #13#10 +
                             Edit1.Text + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
    end;

    //擾
    sStr2 := Edit1.Text;

    //
    for iRow11 := FormMain.StrListCurrentHistory.Count-1 downto 0 do
    begin
      if UpperCase(FormMain.StrListCurrentHistory.Strings[iRow11]) = UpperCase(sStr2) then
      begin
        FormMain.StrListCurrentHistory.Delete(iRow11);
      end;
    end;
    //擪ɒǉ
    FormMain.StrListCurrentHistory.Insert(0, sStr2);
    //폜
    for iRow11 := FormMain.StrListCurrentHistory.Count-1 downto COPY_MOVE_HISTORY_MAX do
    begin
      FormMain.StrListCurrentHistory.Delete(iRow11);
    end;
    //ۑ
    FormMain.StrListCurrentHistory.SaveToFile(ExtractFilePath(ParamStr(0)) + CURRENT_TXT, TEncoding.Unicode);

    //tH_
    if Copy(Edit1.Text, Length(Edit1.Text), 1) = '\' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //ݒ
      IniFile.WriteString('Return', 'Target', RETURN_FOLDER_LOWER);
      //j
      IniFile.Free;
    end
    //t@C
    else
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //ݒ
      IniFile.WriteString('Return', 'Target', RETURN_NAME);
      //j
      IniFile.Free;
    end;
    //߂l
    FormMain.StrRetFormJumpFolderEx := Edit1.Text;
    //I
    ModalResult := mrOK;
  end;
end;

procedure TFormJumpFolderEx.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormJumpFolderEx := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormJumpFolderEx.ListBox2Click(Sender: TObject);
var
  sStr1: String;
  iPos1: Integer;
  iPos2: Integer;
begin
  //ݒȂ
  if Listbox2.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : annsFM ݂܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : annsFM can not find.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //I
  else if Listbox2.ItemIndex = -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : annsFM IĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : annsFM is not selected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //s
  else
  begin
    //annsFM 
    iPos1 := Pos(ANNSFM, ListBox2.Items[ListBox2.ItemIndex]);
    if iPos1 > 0 then
    begin
      sStr1 := Copy(ListBox2.Items[ListBox2.ItemIndex], 1, iPos1);
      sStr1 := TrimRight(sStr1);
      Edit1.Text := sStr1;
    end;
    //BonsFMmini 
    iPos2 := Pos(BONSFM_MINI, ListBox2.Items[ListBox2.ItemIndex]);
    if iPos2 > 0 then
    begin
      sStr1 := Copy(ListBox2.Items[ListBox2.ItemIndex], 1, iPos2);
      sStr1 := TrimRight(sStr1);
      Edit1.Text := sStr1;
    end;
  end;
end;

procedure TFormJumpFolderEx.ListBox8Click(Sender: TObject);
var
  sStr1: String;
begin
  //ݒȂ
  if Listbox8.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̓e܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : History is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //I
  else if Listbox8.ItemIndex = -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̓eIĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : History is not selected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //s
  else
  begin
    sStr1 := ListBox8.Items[ListBox8.ItemIndex];
    Edit1.Text := sStr1;
  end;
end;

procedure TFormJumpFolderEx.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;

end;

procedure TFormJumpFolderEx.ListBox2Enter(Sender: TObject);
begin
  ListBox2Click(Sender);
end;

procedure TFormJumpFolderEx.ListBox2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ListBox2Click(Sender);
    key := VK_RETURN;
    Edit1KeyDown(Sender, Key, Shift);
  end
  else if Key = VK_UP then
  begin
    key := 0;
    ListBox2Click(Sender);
  end
  else if Key = VK_DOWN then
  begin
    key := 0;
    ListBox2Click(Sender);
  end
  else
  begin
    inherited KeyUp(Key, Shift);
  end;
end;

procedure TFormJumpFolderEx.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormJumpFolderEx.ListBox8Enter(Sender: TObject);
begin
  ListBox8Click(Sender);
end;

procedure TFormJumpFolderEx.ListBox8KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ListBox8Click(Sender);
    key := VK_RETURN;
    Edit1KeyDown(Sender, Key, Shift);
  end
  else if Key = VK_UP then
  begin
    key := 0;
    ListBox8Click(Sender);
  end
  else if Key = VK_DOWN then
  begin
    key := 0;
    ListBox8Click(Sender);
  end
  else
  begin
    inherited KeyUp(Key, Shift);
  end;
end;

procedure TFormJumpFolderEx.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormJumpFolderEx.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.
