unit KeyMap;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.ExtCtrls,
  IniFiles, Vcl.StdCtrls, Vcl.Menus, MyUtility;

const
  FORM_WIDTH_SET       = 860;
  FORM_HEIGHT_SET      = 480;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  LIST_COLUM_WIDH_0    = 150;
  LIST_COLUM_WIDH_1    = 315;
  LIST_COLUM_WIDH_2    = 200;
  LIST_COLUM_WIDH_3    = 110;
  LIST_COLUM_WIDH_4    =  10;

type
  TFormKeyMap = class(TForm)
    ListView1: TListView;
    Memo1: TMemo;
    Panel1: TPanel;
    ButtonSort0: TButton;
    ButtonCopyToClip: TButton;
    ButtonCancel: TButton;
    Label7: TLabel;
    Timer1: TTimer;
    Label8: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure SetKeySort0(Sender: TObject);
    procedure SetKeySort1(Sender: TObject);
    procedure SetKeySort2(Sender: TObject);
    procedure GetKeySort1(Sender: TObject);
    procedure GetKeySort2(Sender: TObject);
    procedure ButtonSort0Click(Sender: TObject);
    procedure ButtonCopyToClipClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ReadKeyMapFromFile(Sender: TObject);
    procedure SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListKeyMap: TStringList;
    StrListKeyMapClip: TStringList;
    StrListKeyMapKey0: TStringList;
    StrListKeyMapKey1: TStringList;
    StrListKeyMapKey2: TStringList;
    StrListKeyMapKey3: TStringList;
    StrListKeyMapKey4: TStringList;
    StrListKeyMapKey5: TStringList;
    StrListKeyMapKey6: TStringList;
    StrListKeyMapKey7: TStringList;
    StrListKeyMapKey8: TStringList;
    StrListKeyMapKey10: TStringList;
    BoolJapanese: Boolean;
    BoolFileExist: Boolean;
    StrLanguageFileName: String;
    IntSortMode: Integer;

  public
    { Public 錾 }

  end;

var
  FormKeyMap: TFormKeyMap;

implementation

uses
  Main;

{$R *.dfm}

//L[ݒŃ\[g
function CompareTab(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos15: Integer;
  iPos16: Integer;
  iPos17: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  iPos24: Integer;
  iPos25: Integer;
  iPos26: Integer;
  iPos27: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr19: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  sStr28: String;
  sStr29: String;
begin
  //ŏ
  sStr11 := List[Index1];
  iPos11 := Pos(#09, sStr11);
  //PԖڂTABȍ~
  sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
  iPos12 := Pos(#09, sStr12);
  //QԖڂTABȍ~
  sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
  iPos13 := Pos(#09, sStr13);
  //QԖڂƂRԖڂ̊
  sStr14 := Copy(sStr13, 1, iPos13-1);

  //
  iPos14 := Pos('Shift+', sStr14);
  iPos15 := Pos('Ctrl+'  ,sStr14);
  iPos16 := Pos('Alt+'  , sStr14);
  //ݒ
  iPos17 := 1000;
  if iPos14 > 0 then
  begin
    iPos17 := iPos17 + 100;
  end;
  if iPos15 > 0 then
  begin
    iPos17 := iPos17 + 10;
  end;
  if iPos16 > 0 then
  begin
    iPos17 := iPos17 + 1;
  end;
  //u
  sStr15 := StringReplace(sStr14, 'Shift+', '', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, 'Ctrl+',  '', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, 'Alt+',   '', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, ' ',      '', [rfReplaceAll]);
  //ݒ
  sStr19 := Format('%.04d', [iPos17]) + sStr18;


  //ŏ
  sStr21 := List[Index2];
  iPos21 := Pos(#09, sStr21);
  //PԖڂTABȍ~
  sStr22 := Copy(sStr21, iPos21+1, Length(sStr21));
  iPos22 := Pos(#09, sStr22);
  //QԖڂTABȍ~
  sStr23 := Copy(sStr22, iPos22+1, Length(sStr22));
  iPos23 := Pos(#09, sStr23);
  //QԖڂƂRԖڂ̊
  sStr24 := Copy(sStr23, 1, iPos23-1);

  //
  iPos24 := Pos('Shift+', sStr24);
  iPos25 := Pos('Ctrl+' , sStr24);
  iPos26 := Pos('Alt+'  , sStr24);
  //ݒ
  iPos27 := 1000;
  if iPos24 > 0 then
  begin
    iPos27 := iPos27 + 100;
  end;
  if iPos25 > 0 then
  begin
    iPos27 := iPos27 + 10;
  end;
  if iPos26 > 0 then
  begin
    iPos27 := iPos27 + 1;
  end;
  //u
  sStr25 := StringReplace(sStr24, 'Shift+', '', [rfReplaceAll]);
  sStr26 := StringReplace(sStr25, 'Ctrl+',  '', [rfReplaceAll]);
  sStr27 := StringReplace(sStr26, 'Alt+',   '', [rfReplaceAll]);
  sStr28 := StringReplace(sStr27, ' ',      '', [rfReplaceAll]);
  //ݒ
  sStr29 := Format('%.04d', [iPos27]) + sStr28;

  //
  Result := CompareText(sStr19, sStr29);
end;

//L[ݒŃ\[g
function CompareCommand(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos12: Integer;
  iPos21: Integer;
  iPos22: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
begin
  //ŏ
  sStr11 := List[Index1];
  iPos11 := Pos(#09, sStr11);
  //PԖڂTABȍ~
  sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
  iPos12 := Pos(#09, sStr12);
  //PԖڂƂQԖڂ̊
  sStr13 := Copy(sStr12, 1, iPos12-1);

  //ŏ
  sStr21 := List[Index2];
  iPos21 := Pos(#09, sStr21);
  //PԖڂTABȍ~
  sStr22 := Copy(sStr21, iPos21+1, Length(sStr21));
  iPos22 := Pos(#09, sStr22);
  //PԖڂƂQԖڂ̊
  sStr23 := Copy(sStr22, 1, iPos22-1);

  //
  Result := CompareText(sStr13, sStr23);
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormKeyMap.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormKeyMap.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormKeyMap.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormKeyMap.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormKeyMap.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormKeyMap', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormKeyMap', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormKeyMap', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormKeyMap', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormKeyMap', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListKeyMap := TStringList.Create;
  StrListKeyMapClip := TStringList.Create;
  StrListKeyMapKey0 := TStringList.Create;
  StrListKeyMapKey1 := TStringList.Create;
  StrListKeyMapKey2 := TStringList.Create;
  StrListKeyMapKey3 := TStringList.Create;
  StrListKeyMapKey4 := TStringList.Create;
  StrListKeyMapKey5 := TStringList.Create;
  StrListKeyMapKey6 := TStringList.Create;
  StrListKeyMapKey7 := TStringList.Create;
  StrListKeyMapKey8 := TStringList.Create;
  StrListKeyMapKey10 := TStringList.Create;

  //FormShow̑Oɂǂݍ
  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //
  Timer1.Enabled := FALSE;
  IntSortMode := 0;
  Label7.Caption := 'annsFM';
  if BoolJapanese = TRUE then
  begin
    Label8.Caption := 'JeS';
  end
  else
  begin
    Label8.Caption := 'Category';
  end;

  //ݒ
  ListView1.Items.Clear;
  if BoolJapanese = TRUE  then
  begin
    ListView1.Columns.Add.Caption  := 'JeS';
    ListView1.Columns.Add.Caption  := 'R}h';
    ListView1.Columns.Add.Caption  := '݂̃L[';
    ListView1.Columns.Add.Caption  := '@\';
    ListView1.Columns.Add.Caption  := '';
  end
  else
  begin
    ListView1.Columns.Add.Caption  := 'Category';
    ListView1.Columns.Add.Caption  := 'Command';
    ListView1.Columns.Add.Caption  := 'Current Key';
    ListView1.Columns.Add.Caption  := 'Function';
    ListView1.Columns.Add.Caption  := '';
  end;
  //ݒ
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.ReadOnly := TRUE;

end;

procedure TFormKeyMap.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormKeyMap', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormKeyMap', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormKeyMap', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormKeyMap', 'Left',   FormKeyMap.Left);
    IniFile.WriteInteger('FormKeyMap', 'Top',    FormKeyMap.Top);
    IniFile.WriteInteger('FormKeyMap', 'Width',  FormKeyMap.Width);
    IniFile.WriteInteger('FormKeyMap', 'Height', FormKeyMap.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
  StrListKeyMapClip.Free;
  StrListKeyMapKey0.Free;
  StrListKeyMapKey1.Free;
  StrListKeyMapKey2.Free;
  StrListKeyMapKey3.Free;
  StrListKeyMapKey4.Free;
  StrListKeyMapKey5.Free;
  StrListKeyMapKey6.Free;
  StrListKeyMapKey7.Free;
  StrListKeyMapKey8.Free;
  StrListKeyMapKey10.Free;
end;

procedure TFormKeyMap.FormResize(Sender: TObject);
begin
  ListView1.Columns[0].Width := LIST_COLUM_WIDH_0;
  ListView1.Columns[2].Width := LIST_COLUM_WIDH_2;
  ListView1.Columns[3].Width := LIST_COLUM_WIDH_3;
  ListView1.Columns[4].Width := LIST_COLUM_WIDH_4;
  ListView1.Columns[1].Width := FormkeyMap.ClientWidth     -
                                ListView1.Columns[0].Width -
                                ListView1.Columns[2].Width -
                                ListView1.Columns[3].Width -
                                ListView1.Columns[4].Width - 30;
end;

procedure TFormKeyMap.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormkeyMap.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormKeyMap.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormKeyMap.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormKeyMap.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormKeyMap.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'KeyMap.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormKeyMap, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormKeyMap, StrLanguageFileName, Sender);
  end;

  if BoolJapanese = TRUE  then
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
  end
  else
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
  end;

  //\
  SetKeySort0(Sender);
end;

procedure TFormKeyMap.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormKeyMap, StrLanguageFileName, Sender);
    //{
    ListView1.Columns[0].Caption  := 'JeS';
    ListView1.Columns[1].Caption  := 'R}h';
    ListView1.Columns[2].Caption  := '݂̃L[';
    ListView1.Columns[3].Caption  := '@\';
    ListView1.Columns[4].Caption  := '';
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //\
    SetKeySort0(Sender);

    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Dark Mode ł́AXg̕܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : List can not view, when Dark Mode.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormKeyMap, StrLanguageFileName, Sender);
    //p
    ListView1.Columns[0].Caption  := 'Category';
    ListView1.Columns[1].Caption  := 'Command';
    ListView1.Columns[2].Caption  := 'Current Key';
    ListView1.Columns[3].Caption  := 'Function';
    ListView1.Columns[4].Caption  := '';
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //\
    SetKeySort0(Sender);

    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Dark Mode ł́AXg̕܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : List can not view, when Dark Mode.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormKeyMap.SetKeySort0(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow1].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr17);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

  //ݒ
  StrListKeyMapClip.Assign(StrListKeyMap);
end;

procedure TFormKeyMap.SetKeySort1(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //
  iRow2 := 0;
  StrListKeyMapClip.Clear;

  //ݒ
  for iRow1 := 0 to StrListKeyMapKey1.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey1.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey2.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey2.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey3.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey3.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey4.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey4.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey5.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey5.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey6.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey6.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey7.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey7.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey8.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey8.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey0.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey0.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    StrListKeyMapClip.Add(sStr11);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

end;

procedure TFormKeyMap.SetKeySort2(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey10.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapkey10.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow1].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr17);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

  //ݒ
  StrListKeyMapClip.Assign(StrListKeyMapkey10);
end;

procedure TFormKeyMap.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : L[{[hݒ̃t@C܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Keyboard map file is not exist.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
end;

procedure TFormKeyMap.GetKeySort1(Sender: TObject);
var
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos15: Integer;
  iPos16: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
begin
  //ݒ
  StrListKeyMapKey0.Clear;
  StrListKeyMapKey1.Clear;
  StrListKeyMapKey2.Clear;
  StrListKeyMapKey3.Clear;
  StrListKeyMapKey4.Clear;
  StrListKeyMapKey5.Clear;
  StrListKeyMapKey6.Clear;
  StrListKeyMapKey7.Clear;
  StrListKeyMapKey8.Clear;

  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //ŏ
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#09, sStr11);
    //PԖڂTABȍ~
    sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
    iPos12 := Pos(#09, sStr12);
    //QԖڂTABȍ~
    sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
    iPos13 := Pos(#09, sStr13);
    //QԖڂƂRԖڂ̊
    sStr14 := Copy(sStr13, 1, iPos13-1);

    //
    iPos14 := Pos('Shift+', sStr14);
    iPos15 := Pos('Ctrl+'  ,sStr14);
    iPos16 := Pos('Alt+'  , sStr14);

    //
    if sStr14 = '' then                                         //
    begin
      StrListKeyMapKey0.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 = 0) and (iPos16 = 0) then //
    begin
      StrListKeyMapKey1.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 = 0) and (iPos16 = 0) then  //shift
    begin
      StrListKeyMapKey2.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 > 0) and (iPos16 = 0) then  //shift Ctrl
    begin
      StrListKeyMapKey3.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 = 0) and (iPos16 > 0) then  //shift alt
    begin
      StrListKeyMapKey4.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 > 0) and (iPos16 > 0) then  //shift ctl alt
    begin
      StrListKeyMapKey5.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 > 0) and (iPos16 = 0) then  //ctrl
    begin
      StrListKeyMapKey6.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 > 0) and (iPos16 > 0) then  //ctrl alt
    begin
      StrListKeyMapKey7.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 = 0) and (iPos16 > 0) then //alt
    begin
      StrListKeyMapKey8.Add(sStr11);
    end
    else
    begin
      //
    end;
  end;

  //\[g
  StrListKeyMapKey1.CustomSort(CompareTab);
  StrListKeyMapKey2.CustomSort(CompareTab);
  StrListKeyMapKey3.CustomSort(CompareTab);
  StrListKeyMapKey4.CustomSort(CompareTab);
  StrListKeyMapKey5.CustomSort(CompareTab);
  StrListKeyMapKey6.CustomSort(CompareTab);
  StrListKeyMapKey7.CustomSort(CompareTab);
  StrListKeyMapKey8.CustomSort(CompareTab);

end;

procedure TFormKeyMap.GetKeySort2(Sender: TObject);
begin
  //ݒ
  StrListKeyMapKey10.Clear;
  StrListKeyMapKey10.Assign(StrListKeyMap);

  //\[g
  StrListKeyMapKey10.CustomSort(CompareCommand);
end;

procedure TFormKeyMap.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormKeyMap.ButtonCopyToClipClick(Sender: TObject);
begin
  Memo1.Lines.Assign(StrListKeyMapClip);
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
end;

procedure TFormKeyMap.ButtonSort0Click(Sender: TObject);
begin
  IntSortMode := IntSortMode+1;
  if IntSortMode > 2 then
  begin
    IntSortMode := 0;
  end;

  if      IntSortMode = 0 then
  begin
    SetKeySort0(Sender);
    if BoolJapanese = TRUE then
    begin
      Label8.Caption := 'JeS';
    end
    else
    begin
      Label8.Caption := 'Category';
    end;
  end
  else if IntSortMode = 1 then
  begin
    GetKeySort2(Sender);
    SetKeySort2(Sender);
    if BoolJapanese = TRUE then
    begin
      Label8.Caption := 'R}h';
    end
    else
    begin
      Label8.Caption := 'Command';
    end;
  end
  else if IntSortMode = 2 then
  begin
    GetKeySort1(Sender);
    SetKeySort1(Sender);
    if BoolJapanese = TRUE then
    begin
      Label8.Caption := '݂̃L[';
    end
    else
    begin
      Label8.Caption := 'Current Key';
    end;
  end
  else
  begin
    //
  end;
end;

procedure TFormKeyMap.SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
var
  sStr3: String;
  sStr4: String;
  iRow1: Integer;
  iRow2: Integer;
  CsvList1: TStringList;
  CsvList2: TStringList;
  StrList1: TStringList;
begin
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;
  StrList1 := TStringList.Create;

  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Main.txt';
    end;
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_PACK then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Pack.txt';
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_EXTRACT then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Extract.txt';
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Browse.txt';
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_TREE then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Tree.txt';
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_FTP_TREE then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpTree.txt';
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_FTP_FILER then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpFiler.txt';
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_IMAGE_GRID then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'ImageGrid.txt';
  end;

  //t@Cǂݍ
  if FileExists(sStr3) = TRUE then
  begin
    //t@Cǂݍ
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    //
    for iRow1 := 0 to StrListMap.Count-1 do
    begin
      //WJ
      CsvList1.Clear;
      StringToCsvList(StrListMap.Strings[iRow1], CsvList1);
      //
      for iRow2 := 0 to StrList1.Count-1 do
      begin
        //WJ
        CsvList2.Clear;
        StringToCsvList(StrList1.Strings[iRow2], CsvList2);
        //v
        if CsvList1[3]  = CsvList2[0] then
        begin
          if      (CsvList1[0] = SHORTCUT_ITEM_KEY) or (CsvList1[0] = SHORTCUT_ITEM_KEY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_KEY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_KEY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SHIFT) or (CsvList1[0] = SHORTCUT_ITEM_SHIFT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_CTRL) or (CsvList1[0] = SHORTCUT_ITEM_CTRL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_CTRL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_CTRL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OTHERS) or (CsvList1[0] = SHORTCUT_ITEM_OTHERS_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_DRIVE) or (CsvList1[0] = SHORTCUT_ITEM_DRIVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_DRIVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_DRIVE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_LAUNCHER) or (CsvList1[0] = SHORTCUT_ITEM_LAUNCHER_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_LAUNCHER;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_LAUNCHER_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_HELP) or (CsvList1[0] = SHORTCUT_ITEM_HELP_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_HELP;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_HELP_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_FILE) or (CsvList1[0] = SHORTCUT_ITEM_FILE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_FILE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_FILE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OPERATION) or (CsvList1[0] = SHORTCUT_ITEM_OPERATION_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OPERATION;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OPERATION_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_WINDOW) or (CsvList1[0] = SHORTCUT_ITEM_WINDOW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_WINDOW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_WINDOW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_DIRECTORY) or (CsvList1[0] = SHORTCUT_ITEM_DIRECTORY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_DIRECTORY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_DIRECTORY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SETTING) or (CsvList1[0] = SHORTCUT_ITEM_SETTING_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SETTING;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SETTING_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG) or (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_EDIT) or (CsvList1[0] = SHORTCUT_ITEM_EDIT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_EDIT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_EDIT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_VIEW) or (CsvList1[0] = SHORTCUT_ITEM_VIEW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_VIEW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_VIEW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_MOVE) or (CsvList1[0] = SHORTCUT_ITEM_MOVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_MOVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_MOVE_ENg;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_TOOL) or (CsvList1[0] = SHORTCUT_ITEM_TOOL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_TOOL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_TOOL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OPTION) or (CsvList1[0] = SHORTCUT_ITEM_OPTION_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OPTION;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OPTION_ENG;
            end;
          end
          else
          begin
            sStr4 := CsvList1[0];
          end;

          if LanguageJpn = TRUE then
          begin
            //Đݒ
            StrListMap.Strings[iRow1] := sStr4 + #09 + CsvList2[4] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end
          else
          begin
            //Đݒ
            StrListMap.Strings[iRow1] := sStr4 + #09  + CsvList2[5] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end;
          //
          Break;
        end;
      end;
    end;
  end;

  CsvList1.Free;
  CsvList2.Free;
  StrList1.Free;
end;

procedure TFormKeyMap.ReadKeyMapFromFile(Sender: TObject);
var
  sStr1: String;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //Ǎ
  if IniFile.ReadBool('ShowKeyMapItem', 'All',  TRUE) = TRUE then
  begin
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
    begin
      if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
      begin
        sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
        Label7.Caption := 'annsFM';
      end;
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_PACK then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_PACK_LIST;
      Label7.Caption := 'Pack';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_EXTRACT then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_EXTRACT_LIST;
      Label7.Caption := 'Unpack';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_BROWSE_LIST;
      Label7.Caption := 'Browse';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_TREE then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_TREE_LIST;
      Label7.Caption := 'Tree';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_FTP_TREE then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FTP_TREE_LIST;
      Label7.Caption := 'FtpTree';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_FTP_FILER then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FTP_FILER_LIST;
      Label7.Caption := 'FtpFiler';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_IMAGE_GRID  then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_IMAGE_GRID_LIST;
      Label7.Caption := 'ImageGrid';
    end;
  end
  else
  begin
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
    begin
      if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
      begin
        sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_ANNSFM_LIST;
        Label7.Caption := 'annsFM';
      end;
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_PACK then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_PACK_LIST;
      Label7.Caption := 'Pack';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_EXTRACT then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_EXTRACT_LIST;
      Label7.Caption := 'Unpack';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_BROWSE_LIST;
      Label7.Caption := 'Browse';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_TREE then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_TREE_LIST;
      Label7.Caption := 'Tree';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_FTP_TREE then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_FTP_TREE_LIST;
      Label7.Caption := 'FtpTree';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_FTP_FILER then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_FTP_FILER_LIST;
      Label7.Caption := 'FtpFiler';
    end;
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_IMAGE_GRID then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYDIFF_IMAGE_GRID_LIST;
      Label7.Caption := 'ImageGrid';
    end;
  end;

  //j
  IniFile.Free;


  //Ǎ
  if FileExists(sStr1) = TRUE then
  begin
    BoolFileExist  := TRUE;
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  else
  begin
    BoolFileExist  := FALSE;
  end;

  //\
  SetKeySort0(Sender);

  //\
  if BoolFileExist = FALSE then
  begin
    Timer1.Enabled := TRUE;
  end;
end;

end.

