unit MakeFolder;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 240;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormMakeFolder = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Label3: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);

    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormMakeFolder: TFormMakeFolder;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormMakeFolder.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormMakeFolder.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormMakeFolder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(FormMakeFolder.Handle, imClose);
end;

procedure TFormMakeFolder.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormMakeFolder.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormMakeFolder', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormMakeFolder', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormMakeFolder', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormMakeFolder', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormMakeFolder', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Edit1.Text := FormMain.StrSetFormMakeFolder;
  Edit1.Font.Color := clBlue;
  Edit1.ReadOnly   := TRUE;
  Edit2.Text := '';

end;

procedure TFormMakeFolder.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormMakeFolder', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormMakeFolder', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormMakeFolder', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormMakeFolder', 'Left',   FormMakeFolder.Left);
    IniFile.WriteInteger('FormMakeFolder', 'Top',    FormMakeFolder.Top);
    IniFile.WriteInteger('FormMakeFolder', 'Width',  FormMakeFolder.Width);
    IniFile.WriteInteger('FormMakeFolder', 'Height', FormMakeFolder.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormMakeFolder.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormMakeFolder.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormMakeFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormMakeFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormMakeFolder.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormMakeFolder.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormMakeFolder.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'MakeFolder.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormMakeFolder, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormMakeFolder, StrLanguageFileName, Sender);
  end;
end;


procedure TFormMakeFolder.FormResize(Sender: TObject);
begin
  Edit1.Width    := Panel1.Width - 40;
  Edit2.Width    := Panel1.Width - 40;
end;

procedure TFormMakeFolder.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormMakeFolder, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormMakeFolder, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormMakeFolder.ButtonOKClick(Sender: TObject);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
  iRow1: Integer;
  iRow11: Integer;
  iFind1: Integer;
  sStr2: String;
  sStr3: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  IniFile: TIniFile;
  CsvList1: TStringList;
begin
//  AX^XN (*)
//  c_ (|)
//  ~L (\)
//  R (:)
//  dp (")
//  s (菬) (<)
//  s () (>)
//  ^╄ (?)
//  XbV (/)

  //
  iPos1 := Pos('*', Edit2.Text);
  iPos2 := Pos('|', Edit2.Text);
  iPos3 := Pos('\', Edit2.Text);
  iPos4 := Pos(':', Edit2.Text);
  iPos5 := Pos('"', Edit2.Text);
  iPos6 := Pos('<', Edit2.Text);
  iPos7 := Pos('>', Edit2.Text);
  iPos8 := Pos('?', Edit2.Text);
  iPos9 := Pos('/', Edit2.Text);
  if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
     (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
     (iPos9 > 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;


  //㔼폜
  sStr14 := TrimRight(Edit2.Text);
  //u
  sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
  Edit2.Text := sStr18;

  //ݒ
  sStr2 := Edit1.Text + Edit2.Text;
  //m
  CsvList1 := TStringList.Create;
  //
  iFind1 := -1;
  for iRow1 := 0 to FormMain.StrListItems.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(FormMain.StrListItems.Strings[iRow1], CsvList1);
    //ݒ
    sStr3 := Edit1.Text + CsvList1[8];
    //r
    if UpperCase(sStr2) = UpperCase(sStr3) then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  //j
  CsvList1.Free;

  //
  if iFind1 <> -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃tH_܂̓t@C݂܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same folder or file is exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ݒ
  sStr2 := Edit1.Text + Edit2.Text;
  if Copy(sStr2, Length(sStr2), 1) <> '\' then
  begin
    sStr2 := sStr2 + '\';
  end;

  //fBNg쐬
  if ForceDirectories(sStr2) = TRUE then
  begin
    //
    for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto 0 do
    begin
      if UpperCase(FormMain.StrListCopyMoveHistory.Strings[iRow11]) = UpperCase(ExtractFilePath(sStr2)) then
      begin
        FormMain.StrListCopyMoveHistory.Delete(iRow11);
      end;
    end;
    //擪ɒǉ
    FormMain.StrListCopyMoveHistory.Insert(0, ExtractFilePath(sStr2));
    //폜
    for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto COPY_MOVE_HISTORY_MAX do
    begin
      FormMain.StrListCopyMoveHistory.Delete(iRow11);
    end;
    //ۑ
    FormMain.StrListCopyMoveHistory.SaveToFile(ExtractFilePath(ParamStr(0)) + COPY_MOVE_TXT, TEncoding.Unicode);

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    IniFile.WriteString('Return', 'Target', RETURN_NAME);
    //j
    IniFile.Free;

    //߂l
    FormMain.StrRetFormMakeFolder := sStr2;
    //I
    ModalResult := mrOK;
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : tH_쐬ł܂ł';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Folder can not make.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormMakeFolder.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormMakeFolder := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormMakeFolder.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormMakeFolder.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormMakeFolder.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.

