unit MoveEx;

interface
  {$WARN UNIT_PLATFORM     OFF} //W1005
  {$WARN SYMBOL_PLATFORM   OFF} //W1002
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate
  {$WARN SYMBOL_DEPRECATED OFF} //W1000  for FileCtrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Shellapi, Filectrl, IniFiles, MyUtility, System.IOUtils,
  System.DateUtils,
  Math, ShlObj, ActiveX;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 500;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 695;

type
  TFormMoveEx = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ComboBox1: TComboBox;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonList: TButton;
    ButtonJumpFolder: TButton;
    ButtonTree: TButton;
    Label6: TLabel;
    ButtonBrowse: TButton;
    Label5: TLabel;
    CheckBox1: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
    procedure ButtonJumpFolderClick(Sender: TObject);
    procedure ButtonTreeClick(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox2Click(Sender: TObject);

    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;

    function  GetSrcListDrive(FolderName: String; Sender: TObject): Boolean;
    function  GetDstListDrive(FolderName: String; Sender: TObject): Boolean;
    function  GetDstListFileDrive(FolderName: String; Sender: TObject): Boolean;

    function  MoveExplorerExClick(Sender: TObject): Boolean;
    function  ThisMoveFiles(MoveMode: Integer; Sender: TObject): Boolean;
    function  DeleteSrcFolder(Sender: TObject): Boolean;

    procedure ThisListFilesDrive(
              DirName    :String;      //       fBNgtpX
              TheList    :TStringList  //       ꗗi[ TStringList
              );

    procedure ThisListFilesDriveCurrent(
              DirName    :String;      //       fBNgtpX
              TheList    :TStringList  //       ꗗi[ TStringList
              );
    procedure ButtonBrowseClick(Sender: TObject);
    procedure ListBox2Enter(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList2: TStringList;
    CsvList3: TStringList;
    CsvList4: TStringList;
    StrListSrc: TStringList;
    StrListDst: TStringList;
    StrListNew: TStringList;
    StrListSrcFolder: TStringList;
    StrListNewFolder: TStringList;
    StrListDeleteFile: TStringList;
    BoolFileTimeWithin: Boolean;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormMoveEx: TFormMoveEx;

implementation

uses
  Main, JumpFolder, Browse, Tree, SelectMove;

{$R *.dfm}

//WindowsAPIR[obN֐ EBhE̗
function EnumWindowsProc(Wnd: HWND; lParam: Longint): Bool; stdcall; export;
var
  szCaption: array [0..255] of Char;
begin
  //ݒ
  Result:= TRUE;
  //EBhEnh擾
  GetWindowText(Wnd, szCaption, sizeof(szCaption));
  //gȊȎSĂݒ肷
  if (Wnd <> FormMain.Handle) then
  begin
    FormMain.StrListWindowName2.Add(StrPas(szCaption));
    FormMain.StrListWindowHwnd2.Add(IntToStr(Wnd));
  end;
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormMoveEx.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormMoveEx.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormMoveEx.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormMoveEx.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  sStr1: String;
  sStr4: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormMoveEx', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormMoveEx', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormMoveEx', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormMoveEx', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormMoveEx', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //g
  CheckBox1.Checked := IniFile.ReadBool('GetMySelfBonsFM', 'Add', FALSE);
  //j
  IniFile.Free;

  //ݒ
  ComboBox1.AutoComplete := FALSE;

  //쐬
  CsvList2 := TStringList.Create;;
  CsvList3 := TStringList.Create;;
  CsvList4 := TStringList.Create;;
  StrListSrc    := TStringList.Create;
  StrListDst    := TStringList.Create;
  StrListNew    := TStringList.Create;
  StrListSrcFolder  := TStringList.Create;
  StrListNewFolder  := TStringList.Create;
  StrListDeleteFile := TStringList.Create;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + MOVE_TXT) = TRUE then
  begin
    FormMain.StrListCopyMoveSrc.LoadFromFile(FormMain.StrExtractBase + MOVE_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.Clear;
  for iRow1 := 0 to FormMain.StrListCopyMoveSrc.Count-1 do
  begin
//    CsvList2.Clear;
//    StringToCsvList(FormMain.StrListCopyMoveSrc.Strings[iRow1], CsvList2);
//    ListBox1.Items.Add(CsvList2[0]);
    //擪ƍŌオ \ Ȃ " 폜
    sStr1 := FormMain.StrListCopyMoveSrc.Strings[iRow1];
    if (Copy(sStr1, 1, 1) = '\') and (Copy(sStr1, Length(sStr1), 1) = '\') then
    begin
      ListBox1.Items.Add(Copy(sStr1, 2, Length(sStr1)-2));
    end
    else
    begin
      ListBox1.Items.Add(sStr1);
    end;
  end;
  if ListBox1.Items.Count > 0 then
  begin
    ListBox1.ItemIndex := 0;
  end;
  //ݒ
  ListBox2.Items.Assign(FormMain.StrListWindowName);
  ListBox2.ItemIndex := 0;

  //
  ComboBox1.Items.Assign(FormMain.StrListCopyMoveHistory);
  ComboBox1.Items.Insert(0, FormMain.StrSetFormMoveEx);
  ComboBox1.ItemIndex := 0;

  //Jg
  GetDir(0, sStr4);
  Label5.Caption := 'Current:' +  sStr4;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox2.Style := lbStandard;
  end;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    Label1.Caption := 'S : ' + IntToStr(ListBox1.Items.Count);
    Label6.Caption := 'Ώ : ';
  end
  else
  begin
    Label1.Caption := 'Total : ' + IntToStr(ListBox1.Items.Count);
    Label6.Caption := 'Target : ';
  end;
end;

procedure TFormMoveEx.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormMoveEx', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormMoveEx', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormMoveEx', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormMoveEx', 'Left',   FormMoveEx.Left);
    IniFile.WriteInteger('FormMoveEx', 'Top',    FormMoveEx.Top);
    IniFile.WriteInteger('FormMoveEx', 'Width',  FormMoveEx.Width);
    IniFile.WriteInteger('FormMoveEx', 'Height', FormMoveEx.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //g
  IniFile.WriteBool('GetMySelfBonsFM', 'Add', CheckBox1.Checked);
  //j
  IniFile.Free;

  //j
  CsvList2.Free;
  CsvList3.Free;
  CsvList4.Free;
  StrListSrc.Free;
  StrListDst.Free;
  StrListNew.Free;
  StrListSrcFolder.Free;
  StrListNewFolder.Free;
  StrListDeleteFile.Free;
end;

procedure TFormMoveEx.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormMoveEx.KeyPreview := TRUE;
  //ݒ
  ComboBox1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormMoveEx.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormMoveEx.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormMoveEx.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormMoveEx.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormMoveEx.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'MoveEx.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormMoveEx, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormMoveEx, StrLanguageFileName, Sender);
  end;
end;

procedure TFormMoveEx.FormResize(Sender: TObject);
begin
  ListBox1.Width       := Panel1.ClientWidth  -40;
  ListBox2.Width       := Panel1.ClientWidth  -40;
  ComboBox1.Width      := Panel1.ClientWidth  -40;
  ListBox1.Height      := Panel1.ClientHeight -300;
  Label3.Top           := Panel1.ClientHeight -225;
  ButtonTree.Top       := Panel1.ClientHeight -228;
  ButtonJumpFolder.Top := Panel1.ClientHeight -228;
  ButtonList.Top       := Panel1.ClientHeight -228;
  ButtonBrowse.Top     := Panel1.ClientHeight -228;
  ComboBox1.Top        := Panel1.ClientHeight -195;
  Label4.Top           := Panel1.ClientHeight -162;
  ListBox2.Top         := Panel1.ClientHeight -135;
  ButtonOk.Top         := Panel1.ClientHeight -35;
  ButtonCancel.Top     := Panel1.ClientHeight -35;
  Label1.Top           := Panel1.ClientHeight -33;
  Label6.Top           := Panel1.ClientHeight -33;
  Label5.Top           := Panel1.ClientHeight -257;
end;

procedure TFormMoveEx.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormMoveEx.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormMoveEx, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormMoveEx, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormMoveEx.ListBox2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ListBox2Click(Sender);
    key := VK_RETURN;
    ComboBox1KeyDown(Sender, Key, Shift);
  end
  else if Key = VK_UP then
  begin
    key := 0;
    ListBox2Click(Sender);
  end
  else if Key = VK_DOWN then
  begin
    key := 0;
    ListBox2Click(Sender);
  end
  else
  begin
    inherited KeyUp(Key, Shift);
  end;
end;

procedure TFormMoveEx.ListBox2Click(Sender: TObject);
var
  sStr1: String;
  iPos1: Integer;
  iPos2: Integer;
begin
  //
  if (ListBox2.Items.Count > 0) and (ListBox2.ItemIndex >= 0) then
  begin
    //annsFM 
    iPos1 := Pos(ANNSFM, ListBox2.Items[ListBox2.ItemIndex]);
    if iPos1 > 0 then
    begin
      sStr1 := Copy(ListBox2.Items[ListBox2.ItemIndex], 1, iPos1);
      sStr1 := TrimRight(sStr1);
      ComboBox1.Text := sStr1;
    end
    //annsFM 
    else
    begin
      //BonsFMmini 
      iPos2 := Pos(BONSFM_MINI, ListBox2.Items[ListBox2.ItemIndex]);
      if iPos2 > 0 then
      begin
        sStr1 := Copy(ListBox2.Items[ListBox2.ItemIndex], 1, iPos2);
        sStr1 := TrimRight(sStr1);
        ComboBox1.Text := sStr1;
      end;
    end;
  end;
end;

procedure TFormMoveEx.ButtonOKClick(Sender: TObject);
var
  bResult: Boolean;
  bResult1: Boolean;
  IniFile: TIniFile;
  iIndex1: Integer;
  iIndex2: Integer;
  iIndex3: Integer;
  sStr1: String;
  sStr2: String;
begin
  //
  if ComboBox1.Text = '' then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    iIndex3:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
    //j
    IniFile.Free;

    //s
    if      iIndex3 = 0 then
    begin
      ButtonListClick(Sender);
    end
    else if iIndex3 = 1 then
    begin
      ButtonTreeClick(Sender);
    end
    else if iIndex3 = 2 then
    begin
      ButtonBrowseClick(Sender);
    end
    else
    begin
      ButtonTreeClick(Sender);
    end;
    //
    Exit;
  end;

  //
  if ComboBox1.Text <> '' then
  begin
    //
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //1
  if Length(ComboBox1.Text) = 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information :  1 ł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder length is 1 letter.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //2̏ꍇ́AhCu擾
  else if Length(ComboBox1.Text) = 2 then
  begin
    //
    bResult1 := TRUE;
    if (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'A') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'B') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'C') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'D') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'E') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'F') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'G') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'H') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'I') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'J') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'K') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'L') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'M') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'N') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'O') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'P') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'Q') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'R') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'S') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'T') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'U') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'V') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'W') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'X') or
       (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'Y') or (UpperCase(Copy(ComboBox1.Text, 1, 1)) = 'Z') then
    begin
      if Copy(ComboBox1.Text, 2, 1) = ':' then
      begin
        //hCu擾
        sStr1   := UpperCase(Copy(ComboBox1.Text, 1, 1));
        iIndex1 := Ord('A');
        iIndex2 := Ord(Char(sStr1[1]));
        if FormMain.StrListDriveArray[iIndex2 - iIndex1].Count > 0 then
        begin
          sStr2 := FormMain.StrListDriveArray[iIndex2 - iIndex1].Strings[0];
          Combobox1.Text := ExtractFilePath(sStr2);
        end
        else
        begin
          //Ō \ t
          ComboBox1.Text := ComboBox1.Text + '\';
        end;
      end
      else
      begin
        bResult1 := FALSE;
      end;
    end
    else
    begin
      bResult1 := FALSE;
    end;
    //
    if bResult1 = FALSE then
    begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_̐ݒ肪sł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
    end;
  end
  //2ȊO
  else
  begin
    //Ō \ t
    if Copy(ComboBox1.Text, Length(ComboBox1.Text), 1) <> '\' then
    begin
      ComboBox1.Text := ComboBox1.Text + '\';
    end;
  end;

  //
  FormMain.IntMoveModeIndex := COPY_MOVE_MODE_NONE;
  //
  FormSelectMove := TFormSelectMove.Create(Application);
  try
    if FormSelectMove.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormSelectMove.Free;
  end;

  if bResult = TRUE then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    BoolFileTimeWithin := IniFile.ReadBool('FormSelectMove', 'TimeStampWithin',  FALSE);
    //j
    IniFile.Free;

    if FormMain.IntMoveModeIndex = COPY_MOVE_MODE_EXPLORER then
    begin
      if MoveExplorerExClick(Sender) = TRUE then
      begin
        //tH_폜
        if DeleteSrcFolder(Sender) = TRUE then
        begin
          //߂l
          FormMain.StrRetFormCopyEx := '';
          //I
          ModalResult := mrOK;
        end;
      end;
    end;
    if FormMain.IntMoveModeIndex = COPY_MOVE_MODE_DATE then
    begin
      if ThisMoveFiles(COPY_MOVE_MODE_DATE, Sender) = TRUE then
      begin
        //tH_폜
        if DeleteSrcFolder(Sender) = TRUE then
        begin
          //߂l
          FormMain.StrRetFormCopyEx := '';
          //I
          ModalResult := mrOK;
        end;
      end;
    end;
    if FormMain.IntMoveModeIndex = COPY_MOVE_MODE_OVERWRITE then
    begin
      if ThisMoveFiles(COPY_MOVE_MODE_OVERWRITE, Sender) = TRUE then
      begin
        //tH_폜
        if DeleteSrcFolder(Sender) = TRUE then
        begin
          //߂l
          FormMain.StrRetFormCopyEx := '';
          //I
          ModalResult := mrOK;
        end;
      end;
    end;
    if FormMain.IntMoveModeIndex = COPY_MOVE_MODE_NEW then
    begin
      if ThisMoveFiles(COPY_MOVE_MODE_NEW, Sender) = TRUE then
      begin
        //tH_폜
        if DeleteSrcFolder(Sender) = TRUE then
        begin
          //߂l
          FormMain.StrRetFormCopyEx := '';
          //I
          ModalResult := mrOK;
        end;
      end;
    end;
  end;
end;

procedure TFormMoveEx.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormMoveEx := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormMoveEx.ButtonTreeClick(Sender: TObject);
var
  bResult: Boolean;
begin
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := ExtractfilePath(FormMain.StrCurrent);
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if System.SysUtils.DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        ComboBox1.Text := FormMain.StrRetFormTree;
        ComboBox1.SetFocus;
      end
      else
      begin
        ComboBox1.SetFocus;
      end;
    end
    else
    begin
      ComboBox1.SetFocus;
    end;
end;

procedure TFormMoveEx.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if System.SysUtils.DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        ComboBox1.Text := FormMain.StrRetFormBrowse;
        ComboBox1.SetFocus;
      end
      else
      begin
        ComboBox1.SetFocus;
      end;
    end
    else
    begin
      ComboBox1.SetFocus;
    end;
end;

procedure TFormMoveEx.ButtonListClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if ComboBox1.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := ComboBox1.Text;
  end;
  if System.SysUtils.DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    ComboBox1.Text := sStr1;
    ComboBox1.SetFocus;
  end
  else
  begin
    ComboBox1.SetFocus;
  end;
end;

procedure TFormMoveEx.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormMoveEx.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;


procedure TFormMoveEx.ListBox2Enter(Sender: TObject);
begin
  ListBox2Click(Sender);
end;

procedure TFormMoveEx.ButtonJumpFolderClick(Sender: TObject);
var
  bResult: Boolean;
begin
  // 
  FormJumpFolder := TFormJumpFolder.Create(Application);
  try
    if FormJumpFolder.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    // j
    FormJumpFolder.Free;
  end;
  //ݒ肳ꂽ
  if bResult = TRUE then
  begin
    //tH_
    if System.SysUtils.DirectoryExists(FormMain.StrRetFormJumpFolder) = TRUE then
    begin
      ComboBox1.Text := FormMain.StrRetFormJumpFolder;
      ComboBox1.SetFocus;
    end
    else
    begin
      ComboBox1.SetFocus;
    end;
  end
  else
  begin
    ComboBox1.SetFocus;
  end;
end;

procedure TFormMoveEx.ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if ComboBox1.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonListClick(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonTreeClick(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonBrowseClick(Sender);
      end
      else
      begin
        ButtonTreeClick(Sender);
      end;
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormMoveEx.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

function TFormMoveEx.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;


function TFormMoveEx.MoveExplorerExClick(Sender: TObject): Boolean;

  function DeleteTopYenLastYen(sSrc: String): String;
  begin
    if (Copy(sSrc, 1, 1) = '"') and (Copy(sSrc, Length(sSrc), 1) = '"') then
    begin
      Result := Copy(sSrc, 2, Length(sSrc) - 2);
    end
    else
    begin
      Result := sSrc;
    end;
  end;

var
  shOpeStrct1: TSHFILEOPSTRUCT;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  iRow1: Integer;
  iRow11: Integer;
  iRet1: Integer;
begin
    //
    Result := TRUE;

    //쐬
    sStr1 := '';
    for iRow1  := 0 to ListBox1.Items.Count-1 do
    begin
      sStr1 := sStr1 + DeleteTopYenLastYen(ListBox1.Items.Strings[iRow1]) + #0;
    end;

    //ݒ
    //hbȌꍇ̂ FormMain.StrCurrent ̓_
    sStr3 := ExtractFilePath(ListBox1.Items.Strings[0]);

    //擾
    sStr2 := ComboBox1.Text;
    //
    if sStr2 = '' then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ړ̃tH_ݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Dst folder is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
      Exit;
    end;

    //ݒ
    if Copy(sStr2, Length(sStr2), 1) <> '\' then
    begin
      sStr2 := sStr2 + '\';
      ComboBox1.Text := sStr2;
    end;

    //
    if Length(sStr2) < Length('C:\')  then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ړ̃tH_̐ݒ肪Rȉł';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Dst folder name is less than 3 letters.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
      Exit;
    end;

    //
    if Pos('\\', sStr2) > 0 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ړ̃tH_̐ݒ \\ ̎w͂ł܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Dst folder name is not available \\.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
      Exit;
    end;

    //
    if System.SysUtils.DirectoryExists(sStr2) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ړ̃tH_܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Dst folder is not exist.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
      Exit;
    end;

    //tH_
    if UpperCase(sStr3) = UpperCase(sStr2) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ̃tH_ł͎sł܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Same folder can not operate.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
      Exit;
    end;


    //Ōɋ؂p #0 t
    //sStr1 := sStr1 + #0;
    //ŌɃ^[~lC^p #0t
    //sStr1 := sStr1 + #0;

    //ݒ
    shOpeStrct1.Wnd               := Application.Handle;
    shOpeStrct1.wFunc             := FO_MOVE;
    shOpeStrct1.pFrom             := PWideChar(sStr1);
    shOpeStrct1.pTo               := PWideChar(sStr2);
    shOpeStrct1.fFlags            := FOF_FILESONLY or FOF_NOCONFIRMATION;
//  shOpeStrct1.fFlags            := FOF_FILESONLY;
    shOpeStrct1.hNameMappings     := nil;
    shOpeStrct1.lpszProgressTitle := nil;
    //s
    iRet1 := SHFileOperation(shOpeStrct1);
    if iRet1 = 0 then
    begin
      //
      for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto 0 do
      begin
        if UpperCase(FormMain.StrListCopyMoveHistory.Strings[iRow11]) = UpperCase(ExtractFilePath(sStr2)) then
        begin
          FormMain.StrListCopyMoveHistory.Delete(iRow11);
        end;
      end;
      //擪ɒǉ
      FormMain.StrListCopyMoveHistory.Insert(0, ExtractFilePath(sStr2));
      //폜
      for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto COPY_MOVE_HISTORY_MAX do
      begin
        FormMain.StrListCopyMoveHistory.Delete(iRow11);
      end;
      //ۑ
      FormMain.StrListCopyMoveHistory.SaveToFile(ExtractFilePath(ParamStr(0)) + COPY_MOVE_TXT, TEncoding.Unicode);

      //߂l
      FormMain.StrRetFormMoveEx := '';
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : t@Cړł܂ł' + #13#10 +
                           'Err=' + IntToStr(iRet1);
      end
      else
      begin
        FormMain.StrMsg := 'Error : Move failed.' + #13#10 +
                           'Err=' + IntToStr(iRet1) + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
      Exit;
    end;

end;

function TFormMoveEx.ThisMoveFiles(MoveMode: Integer; Sender: TObject): Boolean;

  function DeleteTopYenLastYen(sSrc: String): String;
  begin
    if (Copy(sSrc, 1, 1) = '"') and (Copy(sSrc, Length(sSrc), 1) = '"') then
    begin
      Result := Copy(sSrc, 2, Length(sSrc) - 2);
    end
    else
    begin
      Result := sSrc;
    end;
  end;

var
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  iRow1: Integer;
  iCount1: Integer;
  iFind1: Integer;
  iPos1: Integer;
  File1: TWin32FindData;
  hFindData1: THandle;
  i64Int1: Int64;

  iRow11: Integer;
  iRow21: Integer;
  iRow41: Integer;
  iFind21: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr15: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr25: String;
  bCopy1: Boolean;
  date11: TDateTime;
  date21: TDateTime;

  shOpeStrct1: TSHFILEOPSTRUCT;
  iRet1: Integer;
  CsvList1: TStringList;
  CsvList2: TStringList;
  sStr31: String;
  sStr32: String;

  iAttr1: integer;
  iRet2: Integer;
  sStr41: String;
  sStr51: String;
  sStr52: String;
  sStr62: String;
  sStr72: String;

  iRet3: Integer;
  sStr81: String;
  sStr82: String;
  sStr83: String;
  sStr84: String;

  StrList1: TStringList;
begin
  //
  Result := TRUE;

  //ݒ
  //hbȌꍇ̂ FormMain.StrCurrent ̓_
  //BonsFM̂ \ tAannsFM ܂ BonsFM ̃hbOł \ ͕tȂ
  //sStr3 ͊tH_ŁAŌ \
  if Copy(ListBox1.Items.Strings[0], Length(ListBox1.Items.Strings[0]), 1) = '\' then
  begin
    sStr3 := ExtractFilePath(Copy(ListBox1.Items.Strings[0], 1, Length(ListBox1.Items.Strings[0])-1));
  end
  else
  begin
    sStr3 := ExtractFilePath(ListBox1.Items.Strings[0]);
  end;
  if Length(sStr3) = Length('C:') then
  begin
    sStr3 := sStr3 + '\';
  end;

  //擾
  sStr2 := ComboBox1.Text;
  //
  if sStr2 = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ړ̃tH_ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //ݒ
  if Copy(sStr2, Length(sStr2), 1) <> '\' then
  begin
    sStr2 := sStr2 + '\';
    ComboBox1.Text := sStr2;
  end;

  //
  if Length(sStr2) < Length('C:\') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ړ̃tH_̐ݒ肪Rȉł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder name is less than 3 letters.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //
  if Pos('\\', sStr2) > 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ړ̃tH_̐ݒ \\ ̎w͂ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder name is not available \\.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //
  if System.SysUtils.DirectoryExists(sStr2) = FALSE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ړ̃tH_܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //tH_
  //sStr3 ͊tH_ŁAŌ \
  //sStr2 ́AŌ \
  if UpperCase(sStr3) = UpperCase(sStr2) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃tH_ł͎sł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same folder can not operate.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;


  //\
  if BoolJapanese = TRUE then
  begin
    Label6.Caption := 'Ώ : ړ擾';
    Label6.Repaint;
  end
  else
  begin
    Label6.Caption := 'Target : Getting Src';
    Label6.Repaint;
  end;

  //ʌ
  //擾
  StrListSrc.Clear;
  StrListSrcFolder.Clear;
  for iRow1 := 0 to ListBox1.Items.Count-1 do
  begin
    //fBNg
    if (System.SysUtils.DirectoryExists(ListBox1.Items.Strings[iRow1]) = TRUE)then
    begin
      //tH_̔zǉ
      //ŁAt@CƃtH_ʂĕۑ
      if GetSrcListDrive(ListBox1.Items.Strings[iRow1], Sender) = FALSE then
      begin
        //\
        if BoolJapanese = TRUE then
        begin
          Label6.Caption := 'Ώ : ';
          Label6.Repaint;
        end
        else
        begin
          Label6.Caption := 'Target : ';
          Label6.Repaint;
        end;
        Result := FALSE;
        Exit;
      end;
    end
    else if (System.SysUtils.FileExists(ListBox1.Items.Strings[iRow1]) = TRUE)then
    begin
      //t@CTCY擾
      hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(ListBox1.Items.Strings[iRow1]), File1);
      try
        ;
      finally
        WinApi.Windows.FindClose(hFindData1);
      end;

      //
      if hFindData1 <> INVALID_HANDLE_VALUE then
      begin
        //
        sStr4  := SearchRecAttributeToStrEx(File1.dwFileAttributes);
        //t
        sStr5 :=  SearchRecFileTimeToDateEx(File1.ftLastWriteTime, FALSE) + ' ' +
                  SearchRecFileTimeToTimeEx(File1.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File1.nFileSizeLow or Int64(File1.nFileSizeHigh) shl 32;
        sStr6  := ConvertInt64ToStr20(i64Int1);
        //
        StrListSrc.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + ListBox1.Items.Strings[iRow1]);
      end;
    end
    else
    begin
      //
    end;
  end;
  //ۑ
  StrListSrc.SaveToFile(FormMain.StrExtractBase + COPY_SRC_FILE_TXT, TEncoding.Unicode);
  //ۑ
  StrListSrcFolder.SaveToFile(FormMain.StrExtractBase + COPY_SRC_FOLDER_TXT, TEncoding.Unicode);


  //\
  if BoolJapanese = TRUE then
  begin
    Label6.Caption := 'Ώ : ړ擾';
    Label6.Repaint;
  end
  else
  begin
    Label6.Caption := 'Target : Getting Dst';
    Label6.Repaint;
  end;

  //ʐ
  //擾
  StrListDst.Clear;
  for iRow1 := 0 to ListBox1.Items.Count-1 do
  begin
    //fBNg
    if (System.SysUtils.DirectoryExists(ListBox1.Items.Strings[iRow1]) = TRUE)then
    begin
      //tH_ȉ
      sStr41 := Copy(ListBox1.Items.Strings[iRow1], Length(sStr3)+1, Length(ListBox1.Items.Strings[iRow1]));
      //tH_̔zǉ
      if GetDstListDrive(sStr2 + sStr41, Sender) = FALSE then
      begin
        //\
        if BoolJapanese = TRUE then
        begin
          Label6.Caption := 'Ώ : ';
          Label6.Repaint;
        end
        else
        begin
          Label6.Caption := 'Target : ';
          Label6.Repaint;
        end;
        Result := FALSE;
        Exit;
      end;
    end;
  end;

  //m
  StrList1 := TStringList.Create;
  //t@C̔zǉ
  ThisListFilesDriveCurrent(sStr2, StrList1);
  //擾
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    if Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) <> '\' then
    begin
      StrListDst.Add(StrList1.Strings[iRow1]);
    end;
  end;
  //j
  StrList1.Free;

  //ۑ
  StrListDst.SaveToFile(FormMain.StrExtractBase + COPY_DST_FILE_TXT, TEncoding.Unicode);

  //\
  if BoolJapanese = TRUE then
  begin
    Label6.Caption := 'Ώ : ړΏۂ擾';
    Label6.Repaint;
  end
  else
  begin
    Label6.Caption := 'Target : Getting Target';
    Label6.Repaint;
  end;

  //t@C̃Xg쐬
  //Rs[͂QsZbg

  //NA
  StrListNew.Clear;

  //
  for iRow11 := 0 to StrListSrc.Count-1 do
  begin
    //擾
    sStr11 := Copy(StrListSrc.Strings[iRow11], 4+1+ 1,       10);
    sStr12 := Copy(StrListSrc.Strings[iRow11], 4+1+12,        8);
    sStr13 := Copy(StrListSrc.Strings[iRow11], 4+1+19+1+20+2, Length(StrListSrc.Strings[iRow11]));
    //tH_ȉ
    sStr15 := Copy(sStr13, Length(sStr3)+1, Length(sStr13));

    //ݒ
    sStr25 := sStr2 + sStr15;

    //t@C
    if Copy(sStr13, Length(sStr13), 1) <> '\' then
    begin

      //
      iFind21 := -1;
      for iRow21 := 0 to StrListDst.Count-1 do
      begin
        //擾
        sStr21 := Copy(StrListDst.Strings[iRow21], 4+1+ 1,        10);
        sStr22 := Copy(StrListDst.Strings[iRow21], 4+1+12,         8);
        sStr23 := Copy(StrListDst.Strings[iRow21], 4+1+19+1+20+2, Length(StrListDst.Strings[iRow21]));

        //
        if UpperCase(sStr25) = UpperCase(sStr23) then
        begin
          iFind21 := iRow21;
          Break;
        end;
      end;

      //ꂪȂ
      if iFind21 = -1 then
      begin
        sStr21  := '1900/01/01';
        sStr22  := '00:00:00';
        bCopy1 := TRUE;
      end
      //ꂪ
      else
      begin
        //l
        bCopy1 := FALSE;

        //ʂȂ
        if MoveMode = COPY_MOVE_MODE_NEW then
        begin
            bCopy1 := FALSE;
        end;
        //]Vꍇ
        if MoveMode = COPY_MOVE_MODE_DATE then
        begin
          //t
          date11 := StrToDateTime(sStr11 + ' ' + sStr12);
          //t
          date21 := StrToDateTime(sStr21 + ' ' + sStr22);
          //b
          i64Int1 := System.DateUtils.SecondsBetween(date11, date21);

          //2bȓ͓ƂĔr
          if BoolFileTimeWithin = TRUE then
          begin
            //2bȓ
            if Abs(i64Int1) <= 2 then
            begin
              ;
            end
            //2bȏ
            else
            begin
              //]V
              if date11 > date21 then
              begin
                bCopy1 := TRUE;
              end;
            end;
          end
          //Pɔr
          else
          begin
            //]V
            if date11 > date21 then
            begin
              bCopy1 := TRUE;
            end;
          end;
        end;
        //ʂ
        if MoveMode = COPY_MOVE_MODE_OVERWRITE then
        begin
            bCopy1 := TRUE;
        end;
      end;

      //Rs[
      if bCopy1 = TRUE then
      begin
        //
        StrListNew.Add(sStr11 + ' ' + sStr12 + ' ' + #09 + sStr13);
        //
        StrListNew.Add(sStr21 + ' ' + sStr22 + ' ' + #09 + sStr25);
      end;
    end
    //tH_
    else
    begin
    end;
  end;

  //ۑ
  StrListNew.SaveToFile(FormMain.StrExtractBase + COPY_NEW_FILE_TXT, TEncoding.Unicode);



  //tH_̃Xg쐬
  //Rs[͂Pŝ

  //NA
  StrListNewFolder.Clear;

  //
  for iRow11 := 0 to StrListSrcFolder.Count-1 do
  begin
    //擾
    sStr11 := Copy(StrListSrcFolder.Strings[iRow11], 1,             4); //attr
    sStr13 := Copy(StrListSrcFolder.Strings[iRow11], 4+1+19+1+20+2, Length(StrListSrcFolder.Strings[iRow11]));
    //tH_ȉ
    sStr15 := Copy(sStr13, Length(sStr3)+1, Length(sStr13));

    //ݒ
    sStr25 := sStr2 + sStr15;

    //
    StrListNewFolder.Add(sStr11 + #09 + sStr25);
  end;
  //ۑ
  StrListNewFolder.SaveToFile(FormMain.StrExtractBase + COPY_NEW_FOLDER_TXT, TEncoding.Unicode);


  //ʂȂ
  if MoveMode = COPY_MOVE_MODE_NEW then
  begin
    //ړȂȂ̂ŕsv
    //NA
    StrListDeleteFile.Clear;
    //ۑ
    StrListDeleteFile.SaveToFile(FormMain.StrExtractBase + COPY_DELETE_FILE_TXT, TEncoding.Unicode);
  end;
  //]Vꍇ ܂ ʂ
  if (MoveMode = COPY_MOVE_MODE_DATE) or (MoveMode = COPY_MOVE_MODE_OVERWRITE) then
  begin
    //㏑ŕʂ̂ŁAɃt@CĉŁÃXg쐬Aō폜
    //NA
    StrListDeleteFile.Clear;
    //ݒ
    sStr62 := '';
    for iRow1 := 0 to StrListNew.Count-1 do
    begin
      //m
      CsvList1 := TStringList.Create;
      if (iRow1 mod 2) = 0 then
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrListNew.Strings[iRow1+0] , CsvList1);
        if System.SysUtils.FileExists(CsvList1.Strings[1]) = TRUE then
        begin
          //ݒ
          sStr62 := sStr62 + DeleteTopYenLastYen(CsvList1.Strings[1]) + #0;
          //Opɐݒ
          StrListDeleteFile.Add(CsvList1.Strings[1]);
        end;
      end;
      //j
      CsvList1.Free;
    end;

    //ۑ
    StrListDeleteFile.SaveToFile(FormMain.StrExtractBase + COPY_DELETE_FILE_TXT, TEncoding.Unicode);
  end;

  //\
  if BoolJapanese = TRUE then
  begin
    Label6.Caption := 'Ώ : File=' + IntToStr(StrListNew.Count div 2)  + ' Folder='+ IntToStr(StrListNewFolder.Count);
    Label6.Repaint;
  end
  else
  begin
    Label6.Caption := 'Target : File=' + IntToStr(StrListNew.Count div 2)  + ' Folder='+ IntToStr(StrListNewFolder.Count);
    Label6.Repaint;
  end;

  //tH_̍쐬
  for iRow1 := 0 to ListBox1.Items.Count-1 do
  begin
    //fBNg
    if (System.SysUtils.DirectoryExists(ListBox1.Items.Strings[iRow1]) = TRUE)then
    begin
      //Ō \ 폜
      if Copy(ListBox1.Items.Strings[iRow1], Length(ListBox1.Items.Strings[iRow1]), 1) = '\' then
      begin
        sStr81 := Copy(ListBox1.Items.Strings[iRow1], 1, Length(ListBox1.Items.Strings[iRow1])-1);
      end
      else
      begin
        sStr81 := ListBox1.Items.Strings[iRow1];
      end;

      //t@C擾
      hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr81), File1);
      try
        ;
      finally
        WinApi.Windows.FindClose(hFindData1);
      end;

      //
      if hFindData1 <> INVALID_HANDLE_VALUE then
      begin
        //pX
        sStr82 := ExtractFilePath(sStr81);
        //Ō̃pX
        sStr83 := Copy(sStr81, Length(sStr82)+1, Length(sStr81));

        //tH_쐬
        if (System.SysUtils.DirectoryExists(ComboBox1.text + sStr83) = FALSE) then
        begin
          if ForceDirectories(ComboBox1.text + sStr83 + '\') = FALSE then
          begin
            //ݒ
            if BoolJapanese = TRUE then
            begin
              FormMain.StrMsg := 'Error : tH_̍쐬Ɏs܂' + #13#10 +
                                  ComboBox1.text + sStr83 + '\';
            end
            else
            begin
              FormMain.StrMsg := 'Error : Make folder failed.' + #13#10 +
                                  ComboBox1.text + sStr83 + '\' + #13#10 +
                                 '[OK]';
            end;
            ShowMessage(FormMain.StrMsg);
            Result := FALSE;
            Exit;
          end;
        end;

        //ݒ
        iRet3 := FileSetAttr(ComboBox1.text + sStr83, File1.dwFileAttributes);
        //s
        if iRet3 <> 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : tH_̕ύXs܂' + #13#10 +
                                ComboBox1.text + sStr83 + '\';
          end
          else
          begin
            FormMain.StrMsg := 'Error : Change attribute failed.' + #13#10 +
                                ComboBox1.text + sStr83 + '\' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Result := FALSE;
          Exit;
        end;
      end;
    end
    else if (System.SysUtils.FileExists(ListBox1.Items.Strings[iRow1]) = TRUE)then
    begin
    end
    else
    begin
      //
    end;
  end;


  //t@CRs[ƃtH_Rs[
  if (StrListNew.Count > 0) or (StrListNewFolder.Count > 0) then
  begin
    //t@C
    if StrListNew.Count > 0 then
    begin
      //m
      CsvList1 := TStringList.Create;
      CsvList2 := TStringList.Create;

      //ݒ
      sStr31 := '';
      sStr32 := '';
      for iRow1 := 0 to StrListNew.Count-1 do
      begin
        if (iRow1 mod 2) = 0 then
        begin
          //WJ
          CsvList1.Clear;
          StringToCsvList(StrListNew.Strings[iRow1+0] , CsvList1);
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrListNew.Strings[iRow1+1] , CsvList2);
          //ݒ
          sStr31 := sStr31 + DeleteTopYenLastYen(CsvList1.Strings[1]) + #0;
          sStr32 := sStr32 + DeleteTopYenLastYen(CsvList2.Strings[1]) + #0;
        end;
      end;

      //j
      CsvList1.Free;
      CsvList2.Free;


      //ݒ
      shOpeStrct1.Wnd               := Application.Handle;
      //ʂȂ
      if MoveMode = COPY_MOVE_MODE_NEW then
      begin
        shOpeStrct1.wFunc           := FO_MOVE; //ړ
      end;
      //]Vꍇ ܂ ʂ
      if (MoveMode = COPY_MOVE_MODE_DATE) or (MoveMode = COPY_MOVE_MODE_OVERWRITE) then
      begin
        shOpeStrct1.wFunc           := FO_COPY; //
      end;
      shOpeStrct1.pFrom             := PWideChar(sStr31 + #0);
      shOpeStrct1.pTo               := PWideChar(sStr32 + #0);
      shOpeStrct1.fFlags            := FOF_MULTIDESTFILES or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR;
//      shOpeStrct1.fFlags            := FOF_MULTIDESTFILES or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR;
      shOpeStrct1.hNameMappings     := nil;
      shOpeStrct1.lpszProgressTitle := nil;

      //s
      iRet1 := SHFileOperation(shOpeStrct1);
      if iRet1 = 0 then
      begin
        //
      end
      else
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@Cړł܂ł' + #13#10 +
                             'Err=' + IntToStr(iRet1);
        end
        else
        begin
          FormMain.StrMsg := 'Error : Move failed.' + #13#10 +
                             'Err=' + IntToStr(iRet1) + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Result := FALSE;
        Exit;
      end;
    end;

    //tH_
    if StrListNewFolder.Count > 0 then
    begin
      for iRow1 := 0 to StrListNewFolder.Count-1 do
      begin
        //m
        CsvList1 := TStringList.Create;
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrListNewFolder.Strings[iRow1] , CsvList1);
        sStr51 := CsvList1.Strings[0];
        sStr52 := CsvList1.Strings[1];
        //j
        CsvList1.Free;
        //tH_Ȃ
        if System.SysUtils.DirectoryExists(sStr52) = FALSE then
        begin
          //s
          if ForceDirectories(sStr52) = FALSE then
          begin
            //ݒ
            if BoolJapanese = TRUE then
            begin
              FormMain.StrMsg := 'Error : tH_̍쐬Ɏs܂' + #13#10 +
                                  sStr52;
            end
            else
            begin
              FormMain.StrMsg := 'Error : Make folder failed.' + #13#10 +
                                 sStr52 + #13#10 +
                                 '[OK]';
            end;
            ShowMessage(FormMain.StrMsg);
            Result := FALSE;
            Exit;
          end;
        end;

        //tH_
        if System.SysUtils.DirectoryExists(sStr52) = TRUE then
        begin
          //
          iAttr1 := 0;
          if Copy(sStr51, 1, 1) = 'R' then
          begin
            iAttr1 := iAttr1 + FILE_ATTRIBUTE_READONLY;
          end;
          if Copy(sStr51, 2, 1) = 'H' then
          begin
            iAttr1 := iAttr1 + FILE_ATTRIBUTE_HIDDEN;
          end;
          if Copy(sStr51, 3, 1) = 'S' then
          begin
            iAttr1 := iAttr1 + FILE_ATTRIBUTE_SYSTEM;
          end;
          if Copy(sStr51, 4, 1) = 'A' then
          begin
            iAttr1 := iAttr1 + FILE_ATTRIBUTE_ARCHIVE;
          end;
          //ύX
          iRet2 := FileSetAttr(sStr52, iAttr1);
          //s
          if iRet2 <> 0 then
          begin
            //ݒ
            if BoolJapanese = TRUE then
            begin
              FormMain.StrMsg := 'Error : tH_̕ύXs܂' + #13#10 +
                                  sStr52;
            end
            else
            begin
              FormMain.StrMsg := 'Error : Change attribute failed.' + #13#10 +
                                  sStr52 + #13#10 +
                                 '[OK]';
            end;
            ShowMessage(FormMain.StrMsg);
            Result := FALSE;
            Exit;
          end;
        end;
      end;
    end;


    //ʂȂ
    if MoveMode = COPY_MOVE_MODE_NEW then
    begin
      //ړȂ̂ŁAt@C͊ɂȂ
    end;
    //]Vꍇ ܂ ʂ
    if (MoveMode = COPY_MOVE_MODE_DATE) or (MoveMode = COPY_MOVE_MODE_OVERWRITE) then
    begin
      //Ώۂ
      if sStr62 <> '' then
      begin
        //\
        if BoolJapanese = TRUE then
        begin
          Label6.Caption := '폜Ώ : File=' + IntToStr(StrListDeleteFile.Count);
          Label6.Repaint;
        end
        else
        begin
          Label6.Caption := 'Delete Target : File=' + IntToStr(StrListDeleteFile.Count);
          Label6.Repaint;
        end;

        //ݒ
        shOpeStrct1.Wnd               := Application.Handle;
        shOpeStrct1.wFunc             := FO_DELETE;
        shOpeStrct1.pFrom             := PWideChar(sStr62 + #0);
        shOpeStrct1.pTo               := nil;
        shOpeStrct1.fFlags            := FOF_FILESONLY or FOF_NOCONFIRMATION;
        shOpeStrct1.hNameMappings     := nil;
        shOpeStrct1.lpszProgressTitle := nil;
        //s
        iRet1 := SHFileOperation(shOpeStrct1);
        if iRet1 = 0 then
        begin
          //
        end
        else
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : t@C폜ł܂ł' + #13#10 +
                                IntToStr(iRet1);
          end
          else
          begin
            FormMain.StrMsg := 'Error : Delete file failed.' + #13#10 +
                                IntToStr(iRet1) + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Result := FALSE;
          Exit;
        end;
      end;
    end;

    //
    for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto 0 do
    begin
      if UpperCase(FormMain.StrListCopyMoveHistory.Strings[iRow11]) = UpperCase(ExtractFilePath(sStr2)) then
      begin
        FormMain.StrListCopyMoveHistory.Delete(iRow11);
      end;
    end;
    //擪ɒǉ
    FormMain.StrListCopyMoveHistory.Insert(0, ExtractFilePath(sStr2));
    //폜
    for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto COPY_MOVE_HISTORY_MAX do
    begin
      FormMain.StrListCopyMoveHistory.Delete(iRow11);
    end;
    //ۑ
    FormMain.StrListCopyMoveHistory.SaveToFile(ExtractFilePath(ParamStr(0)) + COPY_MOVE_TXT, TEncoding.Unicode);
  end;
end;


function TFormMoveEx.GetSrcListDrive(FolderName: String; Sender: TObject): Boolean;
var
  iRow1: Integer;
  sStr3: String;

  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
begin
  //
  Result := TRUE;
  //mF
  if FolderName = '' then
  begin
    StrListSrc.Clear;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ړ̃tH_ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Src folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;
  if System.SysUtils.DirectoryExists(FolderName) = FALSE then
  begin
    StrListSrc.Clear;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ړ̃tH_܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Src folder is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //ݒ
  if Copy(FolderName, Length(FolderName), 1) = '\' then
  begin
    sStr3 := Copy(FolderName, 0, Length(FolderName)-1);
  end
  else
  begin
    sStr3 := FolderName;
  end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;

  //
  if System.SysUtils.DirectoryExists(sStr3) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;
    StrList2.Clear;
    StrList2.Sorted := FALSE;

    //z̃tH_
    ThisListFilesDrive(sStr3, Strlist1);

    //StrList1.SaveToFile(FormMain.StrExtractBase + 'StrlLst1.txt');

    //]
    StrList2.Sorted := TRUE;
    StrList3.Sorted := TRUE;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //tH_
      if Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) = '\' then
      begin
        //
        StrList3.Add(StrList1.Strings[iRow1]);
      end
      //t@C
      else
      begin
        //
        StrList2.Add(StrList1.Strings[iRow1]);
      end;
    end;

    //f
    StrListSrc.AddStrings(StrList2);
    StrListSrcFolder.AddStrings(StrList3);
  end;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;

end;

function TFormMoveEx.GetDstListDrive(FolderName: String; Sender: TObject): Boolean;
var
  iRow1: Integer;
  sStr3: String;

  StrList1: TStringList;
  StrList2: TStringList;
begin
  //
  Result := TRUE;

  //ݒ
  if Copy(FolderName, Length(FolderName), 1) = '\' then
  begin
    sStr3 := Copy(FolderName, 0, Length(FolderName)-1);
  end
  else
  begin
    sStr3 := FolderName;
  end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  //
  if System.SysUtils.DirectoryExists(sStr3) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;
    StrList2.Clear;
    StrList2.Sorted := FALSE;

    //z̃tH_
    ThisListFilesDrive(sStr3, Strlist1);

    //StrList1.SaveToFile(FormMain.StrExtractBase + 'StrlLst1.txt');

    //t@Ĉݓ]
    StrList2.Sorted := TRUE;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //t@C
      if Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) <> '\' then
      begin
        //
        StrList2.Add(StrList1.Strings[iRow1]);
      end;
    end;
    //f
    StrListDst.AddStrings(StrList2);
  end;

  //j
  StrList1.Free;
  StrList2.Free;

end;

function TFormMoveEx.GetDstListFileDrive(FolderName: String; Sender: TObject): Boolean;
var
  iRow1: Integer;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;

  File1: TWin32FindData;
  hFindData1: THandle;
  i64Int1: Int64;

  StrList1: TStringList;
  StrList2: TStringList;
begin
  //
  Result := TRUE;

  //ݒ
  if Copy(FolderName, Length(FolderName), 1) = '\' then
  begin
    sStr3 := Copy(FolderName, 0, Length(FolderName)-1);
  end
  else
  begin
    sStr3 := FolderName;
  end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  //
  if System.SysUtils.DirectoryExists(sStr3) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;
    StrList2.Clear;
    StrList2.Sorted := FALSE;

    //z̃tH_
    ThisListFilesDrive(sStr3, StrList1);

    //t@Ĉݓ]
    StrList2.Sorted := TRUE;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //t@C
      if Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) <> '\' then
      begin
        //t@CTCY擾
        hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(StrList1.Strings[iRow1]), File1);
        try
          ;
        finally
          WinApi.Windows.FindClose(hFindData1);
        end;

        //
        if hFindData1 <> INVALID_HANDLE_VALUE then
        begin
          //
          sStr4  := SearchRecAttributeToStrEx(File1.dwFileAttributes);
          //t
          sStr5 :=  SearchRecFileTimeToDateEx(File1.ftLastWriteTime, FALSE) + ' ' +
                    SearchRecFileTimeToTimeEx(File1.ftLastWriteTime, FALSE);
          //TCY
          i64Int1 := File1.nFileSizeLow or Int64(File1.nFileSizeHigh) shl 32;
          sStr6  := ConvertInt64ToStr20(i64Int1);
          //
          StrList2.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + StrList1.Strings[iRow1]);
        end;
      end;
    end;
    //f
    StrListDst.AddStrings(StrList2);
  end;

  //j
  StrList1.Free;
  StrList2.Free;

end;

procedure TFormMoveEx.ThisListFilesDrive(
              DirName    :String;      //       fBNgtpX
              TheList    :TStringList  //       ꗗi[ TStringList
          );
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                  SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr6  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDrive(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormMoveEx.ThisListFilesDriveCurrent(
              DirName    :String;      //       fBNgtpX
              TheList    :TStringList  //       ꗗi[ TStringList
          );
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                  SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr6  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
        end
        else
        begin
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

function  TformMoveEx.DeleteSrcFolder(Sender: TObject): Boolean;
var
  iRow1: Integer;
  sStr1: String;
  bRet1: Boolean;
  iRet3: Integer;

  StrList1: TStringList;
  StrList3: TStringList;
begin
  //
  Result := TRUE;

  //m
  StrList1 := TStringList.Create;
  StrList3 := TStringList.Create;

  //쐬
  StrList3.Sorted := TRUE;
  //tH_
  for iRow1 := 0 to StrListSrcFolder.Count-1 do
  begin
    StrList3.Add(StrListSrcFolder.Strings[iRow1]);
  end;
  //ݒ肳ꂽtH_
  for iRow1 := 0 to ListBox1.Items.Count-1 do
  begin
    //fBNg
    if (System.SysUtils.DirectoryExists(ListBox1.Items.Strings[iRow1]) = TRUE) then
    begin
      StrList3.Add('    '  + ' ' + '          ' + ' ' + '        ' + ' '  + '                    ' + ' ' + ListBox1.Items.Strings[iRow1]);
    end;
  end;

  //StrList3.SaveToFile(FormMain.StrExtractBase + 'StrlLst3.txt');

  //폜
  bRet1 := TRUE;
  for iRow1 := StrList3.Count-1 downto 0 do
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;

    //tH_
    sStr1 := Copy(StrList3.Strings[iRow1], 47, Length(StrList3.Strings[iRow1]));

    //tH_
    if System.SysUtils.DirectoryExists(sStr1) = TRUE then
    begin
      //z̃tH_
      ThisListFilesDrive(sStr1, Strlist1);

      //zɉȂ
      if StrList1.Count = 0 then
      begin
        //ݒ
        iRet3 := FileSetAttr(sStr1, 0);
        //s
        if iRet3 <> 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : tH_̕ύXs܂' + #13#10 +
                                sStr1;
          end
          else
          begin
            FormMain.StrMsg := 'Error : Change attribute failed.' + #13#10 +
                                sStr1 + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Result := FALSE;
          Exit;
        end;


        //폜
        if RemoveDir(sStr1) = FALSE then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : tH_폜ł܂ł' + #13#10 +
                                sStr1;
          end
          else
          begin
            FormMain.StrMsg := 'Error : Delete folder failed.' + #13#10 +
                                sStr1 + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          bRet1 := FALSE;
          Break;
        end;
      end;
    end;
  end;

  if bRet1 = FALSE then
  begin
    Result := FALSE;
  end;

  //j
  StrList1.Free;
  StrList3.Free;
end;


end.

