unit Network;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls,
  IniFiles, MyUtility, System.UITypes;

const
  FORM_WIDTH_SET  = 770;
  FORM_HEIGHT_SET = 600;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';
  LIST_COLUM_WIDH_0    =  30; //
  LIST_COLUM_WIDH_1    =  60; //root
  LIST_COLUM_WIDH_2    = 105; //volume
  LIST_COLUM_WIDH_3    =  85; //type
  LIST_COLUM_WIDH_4    = 115; //serial
  LIST_COLUM_WIDH_5    =  55; //file
  LIST_COLUM_WIDH_6    = 220; //disk
  LIST_COLUM_WIDH_7    = 220; //free
  LIST_COLUM_WIDH_8    = 220; //use
  LISTBOX1_WIDTH       = 150;
  LISTBOX2_WIDTH       = 600;

type
  TFormNetwork = class(TForm)
    Panel3: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonUpdate: TButton;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuOperation: TMenuItem;
    MenuInput: TMenuItem;
    MenuDelete: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    Panel4: TPanel;
    Panel5: TPanel;
    ListBox1: TListBox;
    Splitter1: TSplitter;
    ListBox2: TListBox;
    MenuEscape: TMenuItem;
    ListView1: TListView;
    MenuQuit: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonUpdateClick(Sender: TObject);

    procedure MenuInputClick(Sender: TObject);
    procedure MenuDeleteClick(Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuPasteClick(Sender: TObject);

    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure SetItemList(Sender: TObject);
    procedure SetListViewNewItem(iViewIndex: Integer; sItem: String);
    function  GetDriveList(DriveName: String; Sender: TObject): Boolean;

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure MenuEscapeClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TstringList;
    StrItemName: String;
    StrItemConnect: String;
    StrItemDrive: String;
    StrItemFolder: String;
    StrItemUser: String;
    StrItemPassword: String;
    StrItemReconnect: String;
    StrLanguageFileName: String;
    IntShortCutLen: Integer;
    IntNameLen: Integer;
    StrListKeyMap: TStringList;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormNetwork: TFormNetwork;

implementation

{$R *.dfm}

uses Main, InputNetwork;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormNetwork.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormNetwork.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormNetwork.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormNetwork.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormNetwork.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr9: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormNetwork', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormNetwork', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormNetwork', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormNetwork', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormNetwork', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TstringList.Create;
  StrListKeyMap := TStringList.Create;

  //
  ListView1.Columns.Add.Caption := '@';
  ListView1.Columns.Add.Caption := 'Root';
  ListView1.Columns.Add.Caption := 'Volume';
  ListView1.Columns.Add.Caption := 'Type';
  ListView1.Columns.Add.Caption := 'Serial';
  ListView1.Columns.Add.Caption := 'File';
  ListView1.Columns.Add.Caption := 'Disk';
  ListView1.Columns.Add.Caption := 'Free';
  ListView1.Columns.Add.Caption := 'Use';
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Visible := TRUE;
  ListView1.ReadOnly := TRUE;
  ListView1.HideSelection := FALSE;     //tH[JXړĂc

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ListViewWidth3',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ListViewWidth3',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ListViewWidth3',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ListViewWidth3',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ListViewWidth3',  '4', LIST_COLUM_WIDH_4);
  ListView1.Columns[ 5].Width := IniFile.ReadInteger('ListViewWidth3',  '5', LIST_COLUM_WIDH_5);
  ListView1.Columns[ 6].Width := IniFile.ReadInteger('ListViewWidth3',  '6', LIST_COLUM_WIDH_6);
  ListView1.Columns[ 7].Width := IniFile.ReadInteger('ListViewWidth3',  '7', LIST_COLUM_WIDH_7);
  ListView1.Columns[ 8].Width := IniFile.ReadInteger('ListViewWidth3',  '8', LIST_COLUM_WIDH_8);
  //ݒ
  ListBox1.Width := IniFile.ReadInteger('NetWorkListBox',  'Width', LISTBOX1_WIDTH);
  //j
  IniFile.Free;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox2.Style := lbStandard;
  end;

  //ݒ
  sStr9 := ExtractFilePath(ParamStr(0)) + NET_TXT;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListitems.LoadFromFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(Sender);
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    //쐬
    StrListitems.Add('A');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('B');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('C');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('D');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('E');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('F');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('G');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('H');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('I');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('J');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('K');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('L');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('M');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('N');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('O');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('P');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('Q');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('R');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('S');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('T');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('U');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('V');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('W');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('X');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('Y');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    StrListitems.Add('Z');
    StrListitems.Add('');
    StrListitems.Add('2');
    StrListitems.Add('Z:\');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('0');

    //ۑ
    StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(Sender);
  end;

  //\
  ListBox1Click(Sender);
end;

procedure TFormNetwork.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormNetwork', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormNetwork', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormNetwork', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormNetwork', 'Left',   FormNetwork.Left);
    IniFile.WriteInteger('FormNetwork', 'Top',    FormNetwork.Top);
    IniFile.WriteInteger('FormNetwork', 'Width',  FormNetwork.Width);
    IniFile.WriteInteger('FormNetwork', 'Height', FormNetwork.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteInteger('ListViewWidth3',  '0', ListView1.Columns[ 0].Width);
  IniFile.WriteInteger('ListViewWidth3',  '1', ListView1.Columns[ 1].Width);
  IniFile.WriteInteger('ListViewWidth3',  '2', ListView1.Columns[ 2].Width);
  IniFile.WriteInteger('ListViewWidth3',  '3', ListView1.Columns[ 3].Width);
  IniFile.WriteInteger('ListViewWidth3',  '4', ListView1.Columns[ 4].Width);
  IniFile.WriteInteger('ListViewWidth3',  '5', ListView1.Columns[ 5].Width);
  IniFile.WriteInteger('ListViewWidth3',  '6', ListView1.Columns[ 6].Width);
  IniFile.WriteInteger('ListViewWidth3',  '7', ListView1.Columns[ 7].Width);
  IniFile.WriteInteger('ListViewWidth3',  '8', ListView1.Columns[ 8].Width);
  //ݒ
  IniFile.WriteInteger('NetWorkListBox',  'Width', ListBox1.Width);
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
  StrListKeyMap.Free;
end;

procedure TFormNetwork.FormResize(Sender: TObject);
begin
  //
end;

procedure TFormNetwork.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormNetwork.KeyPreview := TRUE;
  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormNetwork.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormNetwork.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormNetwork.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormNetwork.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 3, 0);
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX2_WIDTH * 3, 0);

  //IMEIt
  SetImeMode(FormNetwork.Handle, imClose);

  //hCu擾
  ButtonUpdateClick(Sender);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'NetWork.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormNetWork, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormNetWork, StrLanguageFileName, Sender);
  end;
end;

procedure TFormNetwork.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //Return
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //key
  else if (Shift = []) and (key = VK_A) then
  begin
    ListBox1.ItemIndex := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_B) then
  begin
    ListBox1.ItemIndex := 1;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_C) then
  begin
    ListBox1.ItemIndex := 2;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_D) then
  begin
    ListBox1.ItemIndex := 3;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_E) then
  begin
    ListBox1.ItemIndex := 4;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_F) then
  begin
    ListBox1.ItemIndex := 5;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_G) then
  begin
    ListBox1.ItemIndex := 6;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_H) then
  begin
    ListBox1.ItemIndex := 7;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_I) then
  begin
    ListBox1.ItemIndex := 8;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_J) then
  begin
    ListBox1.ItemIndex := 9;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_K) then
  begin
    ListBox1.ItemIndex := 10;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_L) then
  begin
    ListBox1.ItemIndex := 11;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_M) then
  begin
    ListBox1.ItemIndex := 12;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_N) then
  begin
    ListBox1.ItemIndex := 13;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_O) then
  begin
    ListBox1.ItemIndex := 14;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_P) then
  begin
    ListBox1.ItemIndex := 15;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Q) then
  begin
    ListBox1.ItemIndex := 16;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_R) then
  begin
    ListBox1.ItemIndex := 17;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_S) then
  begin
    ListBox1.ItemIndex := 18;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_T) then
  begin
    ButtonOK.SetFocus;
    ListBox1.ItemIndex := 19;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_U) then
  begin
    ListBox1.ItemIndex := 20;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_V) then
  begin
    ListBox1.ItemIndex := 21;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_W) then
  begin
    ListBox1.ItemIndex := 22;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_X) then
  begin
    ListBox1.ItemIndex := 23;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Y) then
  begin
    ListBox1.ItemIndex := 24;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Z) then
  begin
    ListBox1.ItemIndex := 25;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormNetwork, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormNetwork, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormNetwork.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormNetwork.ButtonOKClick(Sender: TObject);
var
  cDrive: array [0..255] of Char;
  cPath : array [0..255] of Char;
  cBuff : array [0..255] of Char;
  NetRes: TNetResource;
  iRes: Cardinal;
begin
  //WNetCancelConnection3 

  //'0 ؒf';
  if StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2] = '0' then
  begin
    //ڑς
    if GetDriveList(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3], Sender) = TRUE then
    begin
      //ݒ
      StrPCopy(cBuff, Copy(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3], 1, Length(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3])-1));
      //ؒf
      try
        iRes := WNetCancelConnection2(cBuff, 0, False);
        if iRes = 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Information : ؒf܂';
          end
          else
          begin
            FormMain.StrMsg := 'Information : Network disconnected.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          //hCu擾
          ButtonUpdateClick(Sender);
        end
        else
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Information : ؒfł܂ł';
          end
          else
          begin
            FormMain.StrMsg := 'Information : Network can not disconnect.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
        end;
      finally
        ;
      end;
    end
    //ڑ
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ڑĂ܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Network is not connected.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
  end;

  //'1 ڑ';
  if StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2] = '1' then
  begin
    //ڑς
    if GetDriveList(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3], Sender) = TRUE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ɐڑĂ܂';
      end
      else
      begin
        FormMain.StrMsg := 'Network is already connected.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    //ڑ
    else
    begin
      //ݒ
      FillChar(NetRes, SizeOf(NetRes), 0);
      NetRes.dwType       := RESOURCETYPE_DISK;
      NetRes.lpLocalName  := StrPCopy(cDrive, Copy(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3], 1, Length(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3])-1));
      if Copy(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4], Length(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4]), 1) = '\' then
      begin
        NetRes.lpRemoteName := StrPCopy(cPath, Copy(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4], 1, Length(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4])-1));
      end
      else
      begin
        NetRes.lpRemoteName := StrPCopy(cPath, StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4]);
      end;

      //ڑ
      try
        //
        iRes := 0;

        //Đڑ͖
        if StrListItems.Strings[(ListBox1.ItemIndex * 8) + 7] = '0' then
        begin
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] <> '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] <> '')then
          begin
            iRes := WNetAddConnection2(NetRes, PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6]), PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5]), 0 );
          end;
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] =  '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] <> '')then
          begin
            iRes := WNetAddConnection2(NetRes, nil, PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5]), 0 );
          end;
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] <> '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] =  '')then
          begin
            iRes := WNetAddConnection2(NetRes, PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6]), nil, 0 );
          end;
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] =  '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] =  '')then
          begin
            iRes := WNetAddConnection2(NetRes, nil, nil, 0 );
          end;
        end;
        //Đڑ͗L
        if StrListItems.Strings[(ListBox1.ItemIndex * 8) + 7] = '1' then
        begin
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] <> '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] <> '')then
          begin
            iRes := WNetAddConnection2(NetRes, PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6]), PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5]), 1 );
          end;
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] =  '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] <> '')then
          begin
            iRes := WNetAddConnection2(NetRes, nil, PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5]), 1 );
          end;
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] <> '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] =  '')then
          begin
            iRes := WNetAddConnection2(NetRes, PChar(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6]), nil, 1 );
          end;
          if (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] =  '') and (StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] =  '')then
          begin
            iRes := WNetAddConnection2(NetRes, nil, nil, 1 );
          end;
        end;

        //
        if iRes = 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Information : ڑ܂';
          end
          else
          begin
            FormMain.StrMsg := 'Information : Network connected.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          //
          if GetDriveList(StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3], Sender) = TRUE then
          begin
            //hCu擾
            ButtonUpdateClick(Sender);
          end;
        end
        else
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : ڑł܂ł';
          end
          else
          begin
            FormMain.StrMsg := 'Error : Network connect failed.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
        end;
      finally
        ;
      end;
    end;
  end;

  //'1 ڑ';
  if StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2] = '2' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ݒł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Network setting is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormNetwork.ButtonUpdateClick(Sender: TObject);
  //hCu^Cv擾
  function GetType(RootPathName: string): string;
  var
    iRet1: Integer;
  begin
    iRet1 := GetDriveType(PWideChar(RootPathName));
    case iRet1 of
      DRIVE_NO_ROOT_DIR: Result := 'No Root';
      DRIVE_REMOVABLE:   Result := 'Removable';
      DRIVE_FIXED:       Result := 'HDD';
      DRIVE_REMOTE:      Result := 'Network';
      DRIVE_CDROM:       Result := 'CD-ROM';
      DRIVE_RAMDISK:     Result := 'RamDisk';
      else               Result := 'Unknown';
    end;
  end;
var
  StrList1: TStringList;
  sStr1: String;
  iRow1: Integer;

  iIndex1: Integer;
  iLogDrives: Cardinal;
  sDriveName : String;
  cVol: array[0..255] of Char;
  cFileSys: array[0..255] of Char;
  iSerialNumber: Cardinal;
  iMaxN: Cardinal;
  iFSF: Cardinal;
  iSectPerClstr: Cardinal;
  iBytePerSect: Cardinal;
  iFreeClstr: Cardinal;
  iClstr: Cardinal;
  iDiskSpace: Int64;
  iFreeSpace: Int64;
  iUsedSpace: Int64;
begin
  //m
  StrList1 := TStringList.Create;

  //ݎgp\ȃfBXNhCũrbg}XN擾
  iLogDrives := GetLogicalDrives;

  //hCu̍ő吔25(A-Z)
  for iIndex1 := 0 to 25 do
  begin
    //rbg
    if (iLogDrives and (1 shl iIndex1)) <> 0 then
    begin
      //ݒ
      sDriveName := Char(Ord('A') + iIndex1) + ':\';

      //hCȕ擾
      //USB ̃}`J[hŁAfBAĂȂꍇ FALSE Ԃ
      if GetVolumeInformation(PWideChar(sDriveName), cVol, 256, @iSerialNumber, iMaxN, iFSF, cFileSys, 256) = TRUE then
      begin
        //fBXN̎gp󋵎擾
        GetDiskFreeSpace(PWideChar(sDriveName), iSectPerClstr, iBytePerSect, iFreeClstr, iClstr);
        iDiskSpace := Int64(iClstr) * Int64(iBytePerSect) * Int64(iSectPerClstr);
        iFreeSpace := Int64(iFreeClstr) * Int64(iBytePerSect) * Int64(iSectPerClstr);
        iUsedSpace := iDiskSpace - iFreeSpace;

        //쐬
        sStr1 := sDriveName                        + #09 +
                 StrPas(cVol)                      + #09 +
                 GetType(sDriveName)               + #09 +
                 '0x' + IntToHex(iSerialNumber, 8) + #09 +
                 StrPas(cFileSys)                  + #09 +
                 ConvertInt64ToStr20(iDiskSpace)   + #09 +
                 ConvertInt64ToStr20(iFreeSpace)   + #09 +
                 ConvertInt64ToStr20(iUsedSpace);
      end
      else
      begin
        //쐬
        sStr1 := sDriveName + #09 +
                 ''         + #09 +
                 ''         + #09 +
                 ''         + #09 +
                 ''         + #09 +
                 ''         + #09 +
                 ''         + #09 +
                 '';
      end;
      //
      StrList1.Add(sStr1);
    end;
  end;

  //ݒ
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //Ŋeڂݒ肵ăCfbNXZ
    SetListViewNewItem(iRow1, StrList1[iRow1]);
  end;
  ListView1.ItemIndex := 0;
  ListView1.Items.EndUpdate;

  //j
  StrList1.Free;
end;

procedure TFormNetWork.SetListViewNewItem(iViewIndex: Integer; sItem: String);
var
  nItem: TListItem;
  CsvList2: TStringList;
begin
  //m
  CsvList2 := TStringList.Create;
  //WJ
  StringToCsvList(sItem, CsvList2);

  //1sݒ
  nItem := ListView1.Items.Add;
  nItem.Caption := '';
  //
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[0]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[1]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[2]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[3]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[4]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[5]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[6]);
  ListView1.Items.Item[iViewIndex].SubItems.add(CsvList2[7]);

  //j
  CsvList2.Free;
end;

procedure TFormNetwork.MenuInputClick(Sender: TObject);
var
  bResult: Boolean;
  sStr9: String;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //擾
  iIndex1 := ListBox1.TopIndex;
  iIndex2 := ListBox1.ItemIndex;
  // 
  FormMain.IntNetworkIndex := ListBox1.ItemIndex;
  FormInputNetwork := TFormInputNetwork.Create(Application);
  try
    if FormInputNetwork.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    // j
    FormInputNetwork.Free;
  end;
  if bResult = TRUE then
  begin
    //ݒ
    sStr9 := ExtractFilePath(ParamStr(0)) + NET_TXT;
    if FileExists(sStr9) = TRUE then
    begin
      //Ǎ
      StrListitems.LoadFromFile(sStr9, TEncoding.Unicode);
      //\
      SetItemList(Sender);
    end;
    if ListBox1.Items.Count > 0 then
    begin
      ListBox1.TopIndex  := iIndex1;
      ListBox1.ItemIndex := iIndex2;
    end;
    //\
    ListBox1Click(Sender);
  end;
end;

procedure TFormNetwork.MenuDeleteClick(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr8: String;
  sStr9: String;
  wRet8: Word;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //擾
  sStr11 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 0];
  sStr12 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 1];
  sStr13 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2];
  sStr14 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3];
  sStr15 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4];
  sStr16 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5];
  sStr17 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6];
  sStr18 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 7];

  //擾
  iIndex1 := ListBox1.TopIndex;
  iIndex2 := ListBox1.ItemIndex;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key='       + sStr11 + #13#10 +
             'Name='      + sStr12 + #13#10 +
             'Connect='   + sStr13 + #13#10 +
             'Drive='     + sStr14 + #13#10 +
             'Folder='    + sStr15 + #13#10 +
             'User='      + sStr16 + #13#10 +
             'Password='  + sStr17 + #13#10 +
             'Reconnect=' + sStr18 + #13#10 +
                                     #13#10 +
             '폜܂H';
  end
  else
  begin
    sStr8 := 'Key='       + sStr11 + #13#10 +
             'Name='      + sStr12 + #13#10 +
             'Connect='   + sStr13 + #13#10 +
             'Drive='     + sStr14 + #13#10 +
             'Folder='    + sStr15 + #13#10 +
             'User='      + sStr16 + #13#10 +
             'Password='  + sStr17 + #13#10 +
             'Reconnect=' + sStr18 + #13#10 +
                                     #13#10 +
             'Delete ?'            + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //ݒ
    sStr9 := ExtractFilePath(ParamStr(0)) + NET_TXT;
    if FileExists(sStr9) = TRUE then
    begin
      //Ǎ
      StrListitems.LoadFromFile(sStr9, TEncoding.Unicode);
      //\
      SetItemList(Sender);
    end;
    if ListBox1.Items.Count > 0 then
    begin
      ListBox1.TopIndex  := iIndex1;
      ListBox1.ItemIndex := iIndex2;
    end;
  end
  else
  begin
    //
  end;
end;

procedure TFormNetwork.MenuEscapeClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormNetwork.MenuCopyClick(Sender: TObject);
var
  sStr4: String;
begin
  //tH_擾
  sStr4 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4];

  //
  if sStr4 = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : tH_̓e󔒂Ȃ̂ŃRs[ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Copy can avialable, because of folder items is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //擾
  StrItemName      := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 1];
  StrItemConnect   := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2];
  StrItemDrive     := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3];
  StrItemFolder    := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4];
  StrItemUser      := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5];
  StrItemPassword  := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6];
  StrItemReconnect := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 7];
end;


procedure TFormNetwork.MenuPasteClick(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr8: String;
  sStr9: String;
  wRet8: Word;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //
  if StrItemFolder = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \t̓eł' + #13#10 +
                         'ŏɃRs[sĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Paste items is empty.' + #13#10 +
                         'Copy must be done before Paste' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //擾
  iIndex1 := ListBox1.TopIndex;
  iIndex2 := ListBox1.ItemIndex;

  //擾
  sStr11 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 0];
  sStr12 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 1];
  sStr13 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2];
  sStr14 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3];
  sStr15 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4];
  sStr16 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5];
  sStr17 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6];
  sStr18 := StrListItems.Strings[(ListBox1.ItemIndex * 8) + 7];

  //
  if sStr15 <> '' then
  begin
    //mF
    if BoolJapanese = TRUE then
    begin
      sStr8 := 'Key='      + sStr11 + #13#10 +
               'Name='     + sStr12 + #13#10 +
               'Connect='  + sStr13 + #13#10 +
               'Drive='    + sStr14 + #13#10 +
               'Folder='   + sStr15 + #13#10 +
               'User='     + sStr16 + #13#10 +
               'Password=' + sStr17 + #13#10 +
               'Reconect=' + sStr18 + #13#10 +
                                      #13#10 +
               '㏑܂H';
    end
    else
    begin
      sStr8 := 'Key='      + sStr11 + #13#10 +
               'Name='     + sStr12 + #13#10 +
               'Connect='  + sStr13 + #13#10 +
               'Drive='    + sStr14 + #13#10 +
               'Folder='   + sStr15 + #13#10 +
               'User='     + sStr16 + #13#10 +
               'Password=' + sStr17 + #13#10 +
               'Reconect=' + sStr18 + #13#10 +
                                      #13#10 +
               'Over Write ?'       + #13#10 +
               '[YES] / [NO]';
    end;
    wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
    if wRet8 = mrYes then
    begin
      //
    end
    else
    begin
      //
      Exit;
    end;
  end;

  //ݒ
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 1] := StrItemName;
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 2] := StrItemConnect;
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 3] := StrItemDrive;
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 4] := StrItemFolder;
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 5] := StrItemUser;
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 6] := StrItemPassword;
  StrListItems.Strings[(ListBox1.ItemIndex * 8) + 7] := StrItemReconnect;

  //ۑ
  sStr9 := ExtractFilePath(ParamStr(0)) + NET_TXT;
  StrListitems.SaveToFile(sStr9, TEncoding.Unicode);

  //ݒ
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListitems.LoadFromFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(Sender);
  end;
  if ListBox1.Items.Count > 0 then
  begin
    ListBox1.TopIndex  := iIndex1;
    ListBox1.ItemIndex := iIndex2;
  end;

end;


procedure TFormNetwork.MenuQuitClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormNetWork.SetItemList(Sender: TObject);
var
  iRow1: Integer;
  iMax1: Integer;
  iMax2: Integer;
  iMax3: Integer;
  iMax4: Integer;
  iMax5: Integer;
  iMax6: Integer;
  iMax7: Integer;
  iMax8: Integer;
  iLen1: Integer;
  iLen2: Integer;
  sStr1: String;
  sStr2: String;
begin
  //ő啶
  iMax1:= 1;
  iMax2:= 1;
  iMax3:= 1;
  iMax4:= 1;
  iMax5:= 1;
  iMax6:= 1;
  iMax7:= 1;
  iMax8:= 1;
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
    if (iRow1 mod 8) = 0 then
    begin
      if Length(AnsiString(StrListItems.Strings[iRow1+0])) > iMax1 then
      begin
        iMax1 := Length(AnsiString(StrListItems.Strings[iRow1+0]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+1])) > iMax2 then
      begin
        iMax2 := Length(AnsiString(StrListItems.Strings[iRow1+1]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+2])) > iMax3 then
      begin
        iMax3 := Length(AnsiString(StrListItems.Strings[iRow1+2]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+3])) > iMax4 then
      begin
        iMax4 := Length(AnsiString(StrListItems.Strings[iRow1+3]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+4])) > iMax5 then
      begin
        iMax5 := Length(AnsiString(StrListItems.Strings[iRow1+4]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+5])) > iMax6 then
      begin
        iMax6 := Length(AnsiString(StrListItems.Strings[iRow1+5]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+6])) > iMax7 then
      begin
        iMax7 := Length(AnsiString(StrListItems.Strings[iRow1+6]));
      end;
      if Length(AnsiString(StrListItems.Strings[iRow1+7])) > iMax8 then
      begin
        iMax8 := Length(AnsiString(StrListItems.Strings[iRow1+7]));
      end;
    end;
  end;

  //NA
  ListBox1.Items.Clear;
  IntShortCutLen := 1;
  IntNameLen     := 1;
  //ݒ
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
    if (iRow1 mod 8) = 0 then
    begin
      //
      sStr1 := '';
      //
      sStr2 := StrListItems.Strings[iRow1+0];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax1 - iLen1;
      if iLen2 > IntShortCutLen then
      begin
        IntShortCutLen := iLen2;
      end;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
      //
      sStr2 := StrListItems.Strings[iRow1+1];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax2 - iLen1;
      if iLen2 > IntNameLen then
      begin
        IntNameLen := iLen2;
      end;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
{
      //
      sStr2 := StrListItems.Strings[iRow1+2];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax3 - iLen1;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
      //
      sStr2 := StrListItems.Strings[iRow1+3];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax4 - iLen1;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
      //
      sStr2 := StrListItems.Strings[iRow1+4];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax5 - iLen1;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
      //
      sStr2 := StrListItems.Strings[iRow1+5];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax6 - iLen1;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
      //
      sStr2 := StrListItems.Strings[iRow1+6];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax7 - iLen1;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + ' ';
      //
      sStr2 := StrListItems.Strings[iRow1+7];
      iLen1 := Length(AnsiString(sStr2));
      iLen2 := iMax8 - iLen1;
      sStr1 := sStr1 + sStr2 + StringOfChar(' ', iLen2) + '';
}
      //
      ListBox1.Items.Add(sStr1);
    end;
  end;
  ListBox1.ItemIndex := 0;
end;

procedure TFormNetwork.ListBox1Click(Sender: TObject);
begin
  ///ݒ
  if BoolJapanese = TRUE then
  begin
    ListBox2.Items.Clear;
    ListBox2.Items.Add  ('V[gJbg : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+0]);
    ListBox2.Items.Add  ('O           : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+1]);
    if      StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] = '0' then
    begin
      ListBox2.Items.Add('ڑ/ؒf      : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] + ' ؒf');
    end
    else if StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] = '1' then
    begin
      ListBox2.Items.Add('ڑ/ؒf      : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] + ' ڑ');
    end
    else
    begin
      ListBox2.Items.Add('ڑ/ؒf      : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] + ' ݒ');
    end;
    ListBox2.Items.Add  ('hCu     : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+3]);
    ListBox2.Items.Add  ('lbg[N : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+4]);
    ListBox2.Items.Add  ('[U       : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+5]);
    ListBox2.Items.Add  ('pX[h     : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+6]);
    if StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] = '0' then
    begin
      ListBox2.Items.Add('Đڑ         : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+7] + ' ĐڑȂ');
    end
    else
    begin
      ListBox2.Items.Add('Đڑ         : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+7] + ' Đڑ');
    end;
    //
    ListBox2.ItemIndex := 0;
  end
  else
  begin
    ListBox2.Items.Clear;
    ListBox2.Items.Add  ('Short Cut          : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+0]);
    ListBox2.Items.Add  ('Name               : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+1]);
    if      StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] = '0' then
    begin
      ListBox2.Items.Add('Connect/DisConnect : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] + ' DisConnect');
    end
    else if StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] = '1' then
    begin
      ListBox2.Items.Add('Connect/DisConnect : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] + ' Connect');
    end
    else
    begin
      ListBox2.Items.Add('Connect/DisConnect : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] + ' Blank');
    end;
    ListBox2.Items.Add  ('Drive              : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+3]);
    ListBox2.Items.Add  ('Netttwork          : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+4]);
    ListBox2.Items.Add  ('User               : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+5]);
    ListBox2.Items.Add  ('Password           : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+6]);
    if StrListItems.Strings[(ListBox1.ItemIndex * 8)+2] = '0' then
    begin
      ListBox2.Items.Add('ReConnect          : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+7] + ' ReConnect Off');
    end
    else
    begin
      ListBox2.Items.Add('ReConnect          : ' + StrListItems.Strings[(ListBox1.ItemIndex * 8)+7] + ' ReConnect On');
    end;
    //
    ListBox2.ItemIndex := 0;
  end;
end;

procedure TFormNetwork.ListBox1DblClick(Sender: TObject);
begin
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormNetwork.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormNetwork.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

function  TFormNetwork.GetDriveList(DriveName: String; Sender: TObject): Boolean;
  //hCu^Cv擾
  function GetType(RootPathName: string): string;
  var
    iRet1: Integer;
  begin
    iRet1 := GetDriveType(PWideChar(RootPathName));
    case iRet1 of
      DRIVE_NO_ROOT_DIR: Result := 'No Root';
      DRIVE_REMOVABLE:   Result := 'Removable';
      DRIVE_FIXED:       Result := 'HDD';
      DRIVE_REMOTE:      Result := 'Network';
      DRIVE_CDROM:       Result := 'CD-ROM';
      DRIVE_RAMDISK:     Result := 'RamDisk';
      else               Result := 'Unknown';
    end;
  end;
var
  StrList1: TStringList;
  CsvList33: TStringList;

  iIndex1: Integer;
  iFind1: Integer;
  iRow1: Integer;
  sStr1: String;
  sDriveName : String;
  cVol: array[0..255] of Char;
  cFileSys: array[0..255] of Char;
  iLogDrives: Cardinal;
  iSerialNumber: Cardinal;
  iMaxN: Cardinal;
  iFSF: Cardinal;
  iSectPerClstr: Cardinal;
  iBytePerSect: Cardinal;
  iFreeClstr: Cardinal;
  iClstr: Cardinal;
  iDiskSpace: Int64;
  iFreeSpace: Int64;
  iUsedSpace: Int64;
begin
  //
  Result := TRUE;

  //m
  StrList1 := TStringList.Create;
  CsvList33 := TStringList.Create;

  //쐬
  sStr1 := 'Root'   + #09 + 'Volume' + #09 + 'Type' + #09 +
           'Serial' + #09 + 'File'   + #09 +
           'Disk'   + #09 + 'Free'   + #09 + 'Use';
  //ǉ
  StrList1.Add(sStr1);

  //ݎgp\ȃfBXNhCũrbg}XN擾
  iLogDrives := GetLogicalDrives;

  //hCu̍ő吔25(A-Z)
  for iIndex1 := 0 to 25 do
  begin
    //rbg
    if (iLogDrives and (1 shl iIndex1)) <> 0 then
    begin
      //ݒ
      sDriveName := Char(Ord('A') + iIndex1) + ':\';

      //hCȕ擾
      //USB ̃}`J[hŁAfBAĂȂꍇ FALSE Ԃ
      if GetVolumeInformation(PWideChar(sDriveName), cVol, 256, @iSerialNumber, iMaxN, iFSF, cFileSys, 256) = TRUE then
      begin
        //fBXN̎gp󋵎擾
        GetDiskFreeSpace(PWideChar(sDriveName), iSectPerClstr, iBytePerSect, iFreeClstr, iClstr);
        iDiskSpace := Int64(iClstr) * Int64(iBytePerSect) * Int64(iSectPerClstr);
        iFreeSpace := Int64(iFreeClstr) * Int64(iBytePerSect) * Int64(iSectPerClstr);
        iUsedSpace := iDiskSpace - iFreeSpace;

        //쐬
        sStr1 := sDriveName                        + #09 +
                 StrPas(cVol)                      + #09 +
                 GetType(sDriveName)               + #09 +
                 '0x' + IntToHex(iSerialNumber, 8) + #09 +
                 StrPas(cFileSys)                  + #09 +
                 ConvertInt64ToStr20(iDiskSpace)   + #09 +
                 ConvertInt64ToStr20(iFreeSpace)   + #09 +
                 ConvertInt64ToStr20(iUsedSpace);
        //ǉ
        StrList1.Add(sStr1);
      end;

    end;
  end;

  iFind1 := -1;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    CsvList33.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList33);
    if UpperCase(DriveName) = UpperCase(CsvList33[0]) then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //
    Result := FALSE;
  end;

  //j
  StrList1.Free;
  CsvList33.Free;
end;

procedure TFormNetWork.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //annsfm
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM  then
  begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if StrListKeyMap.Count > 0 then
    begin
      SetShortCutNew('1017', MenuQuit, Sender);
      SetShortCutNew('1311', MenuEscape, Sender);
    end;
  end;
end;

procedure TFormNetwork.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

end.
