unit NumberJump;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 780;
  FORM_HEIGHT_SET      = 340;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 640;

type
  TFormNumberJump = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    ListBox1: TListBox;
    ButtonJump: TButton;
    ButtonCancel: TButton;
    ButtonSet: TButton;
    Label2: TLabel;
    ButtonClear: TButton;
    ButtonAllClear: TButton;
    Label3: TLabel;
    ButtonSave: TButton;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure ButtonJumpClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ButtonSetClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonAllClearClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    BoolNumberJumpSet: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormNumberJump: TFormNumberJump;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormNumberJump.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormNumberJump.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormNumberJump.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormNumberJump.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormNumberJump.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormNumberJump', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormNumberJump', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormNumberJump', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormNumberJump', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormNumberJump', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  BoolNumberJumpSet := IniFile.ReadBool   ('NumberJump',    'Set',   FALSE);
  //j
  IniFile.Free;

  if BoolNumberJumpSet = TRUE then
  begin
    ButtonJump.Enabled := FALSE;
    ButtonSet.Enabled  := TRUE;
  end
  else
  begin
    ButtonJump.Enabled := TRUE;
    ButtonSet.Enabled  := FALSE;
  end;

  //ݒ
  ListBox1.Items.Add('1 ' + FormMain.StrNumberJump1);
  ListBox1.Items.Add('2 ' + FormMain.StrNumberJump2);
  ListBox1.Items.Add('3 ' + FormMain.StrNumberJump3);
  ListBox1.Items.Add('4 ' + FormMain.StrNumberJump4);
  ListBox1.Items.Add('5 ' + FormMain.StrNumberJump5);
  ListBox1.Items.Add('6 ' + FormMain.StrNumberJump6);
  ListBox1.Items.Add('7 ' + FormMain.StrNumberJump7);
  ListBox1.Items.Add('8 ' + FormMain.StrNumberJump8);
  ListBox1.Items.Add('9 ' + FormMain.StrNumberJump9);
  ListBox1.Items.Add('P ');

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;

end;

procedure TFormNumberJump.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormNumberJump', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormNumberJump', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormNumberJump', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormNumberJump', 'Left',   FormNumberJump.Left);
    IniFile.WriteInteger('FormNumberJump', 'Top',    FormNumberJump.Top);
    IniFile.WriteInteger('FormNumberJump', 'Width',  FormNumberJump.Width);
    IniFile.WriteInteger('FormNumberJump', 'Height', FormNumberJump.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormNumberJump.FormResize(Sender: TObject);
begin
;
end;

procedure TFormNumberJump.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormNumberJump.KeyPreview := TRUE;

  //ݒ
  ListBox1.ItemIndex := 0;
  ListBox1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormNumberJump.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormNumberJump.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormNumberJump.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormNumberJump.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormNumberJump.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 3, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'NumberJump.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormNumberJump, StrLanguageFileName, Sender);
    //ւ
    ListBox1.Items.Strings[9] := 'P ' + Copy(Label3.Caption, 1, Length(Label3.Caption)-4);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormNumberJump, StrLanguageFileName, Sender);
    //ւ
    ListBox1.Items.Strings[9] := 'P ' + Copy(Label3.Caption, 1, Length(Label3.Caption)-4);
  end;

  if BoolNumberJumpSet = TRUE then
  begin
    Label2.Caption := Copy(ButtonSet.Caption, 1, Length(ButtonSet.Caption)-4)
  end
  else
  begin
    Label2.Caption := Copy(ButtonJump.Caption, 1, Length(ButtonJump.Caption)-4)
  end;
end;

procedure TFormNumberJump.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile: TIniFile;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE)then
  begin
    //I
    ButtonCancelClick(Sender);
  end
  //Enter
  else if (Shift = []) and (key = VK_RETURN) and (ListBox1.Focused = TRUE) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //L
      ButtonSetClick(Sender);
    end
    else
    begin
      //Wv
      ButtonJumpClick(Sender);
    end;
  end
  //Delete
  else if (Shift = []) and (key = VK_DELETE) and (ListBox1.Focused = TRUE) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //NA
      ButtonClearClick(Sender);
    end
    else
    begin
      //NA
      ButtonClearClick(Sender);
    end;
  end
  //1
  else if ((Shift = []) and (key = VK_1)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD1) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump1 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump1;
      //I
      ModalResult := mrOK;
    end;
  end
  //2
  else if ((Shift = []) and (key = VK_2)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD2) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump2 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump2;
      //I
      ModalResult := mrOK;
    end;
  end
  //3
  else if ((Shift = []) and (key = VK_3)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD3) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump3 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump3;
      //I
      ModalResult := mrOK;
    end;
  end
  //4
  else if ((Shift = []) and (key = VK_4)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD4) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump4 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump4;
      //I
      ModalResult := mrOK;
    end;
  end
  //5
  else if ((Shift = []) and (key = VK_5)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD5) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump5 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump5;
      //I
      ModalResult := mrOK;
    end;
  end
  //6
  else if ((Shift = []) and (key = VK_6)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD6) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump6 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump6;
      //I
      ModalResult := mrOK;
    end;
  end
  //7
  else if ((Shift = []) and (key = VK_7)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD7) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump7 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump7;
      //I
      ModalResult := mrOK;
    end;
  end
  //8
  else if ((Shift = []) and (key = VK_8)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD8) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump8 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump8;
      //I
      ModalResult := mrOK;
    end;
  end
  //9
  else if ((Shift = []) and (key = VK_9)       and (ListBox1.Focused = TRUE)) or
          ((Shift = []) and (key = VK_NUMPAD9) and (ListBox1.Focused = TRUE)) then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //ݒ
      FormMain.StrNumberJump9 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := FormMain.StrNumberJump9;
      //I
      ModalResult := mrOK;
    end;
  end
  //P
  else if (Shift = []) and (key = VK_P) and (ListBox1.Focused = TRUE) then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    IniFile.WriteBool   ('NumberJump',    'Popup',   TRUE);
    //j
    IniFile.Free;

    //ݒ
    FormMain.MenuNumberJumpForm.Checked  := FALSE;
    FormMain.MenuNumberJumpPopup.Checked := TRUE;

    //I
    ModalResult := mrCancel;
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormNumberJump, StrLanguageFileName, Sender);
    //ւ
    ListBox1.Items.Strings[9] := 'P ' + Copy(Label3.Caption, 1, Length(Label3.Caption)-4);
    //ݒ
    if BoolNumberJumpSet = TRUE then
    begin
      Label2.Caption := Copy(ButtonSet.Caption, 1, Length(ButtonSet.Caption)-4)
    end
    else
    begin
      Label2.Caption := Copy(ButtonJump.Caption, 1, Length(ButtonJump.Caption)-4)
    end;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormNumberJump, StrLanguageFileName, Sender);
    //ւ
    ListBox1.Items.Strings[9] := 'P ' + Copy(Label3.Caption, 1, Length(Label3.Caption)-4);
    //ݒ
    if BoolNumberJumpSet = TRUE then
    begin
      Label2.Caption := Copy(ButtonSet.Caption, 1, Length(ButtonSet.Caption)-4)
    end
    else
    begin
      Label2.Caption := Copy(ButtonJump.Caption, 1, Length(ButtonJump.Caption)-4)
    end;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormNumberJump.ListBox1DblClick(Sender: TObject);
begin
  if ListBox1.Items.Count > 0 then
  begin
    if BoolNumberJumpSet = TRUE then
    begin
      //L
      ButtonSetClick(Sender);
    end
    else
    begin
      //Wv
      ButtonJumpClick(Sender);
    end;
  end;
end;

procedure TFormNumberJump.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormNumberJump.ButtonSaveClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  if (ListBox1.Items.Count > 0)then
  begin
    //擾
    sStr1 := ListBox1.Items.Strings[0];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump1 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[1];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump2 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[2];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump3 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[3];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump4 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[4];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump5 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[5];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump6 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[6];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump7 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[7];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump8 := sStr2;
    //擾
    sStr1 := ListBox1.Items.Strings[8];
    sStr2 := Copy(sStr1, 3, Length(sStr1));
    FormMain.StrNumberJump9 := sStr2;
  end;

  //I
  ModalResult := mrCancel;
end;

procedure TFormNumberJump.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormNumberJump.ButtonAllClearClick(Sender: TObject);
begin
  if (ListBox1.Items.Count > 0) then
  begin
    ListBox1.Items.Strings[0] := IntToStr(0+1);
    ListBox1.Items.Strings[1] := IntToStr(1+1);
    ListBox1.Items.Strings[2] := IntToStr(2+1);
    ListBox1.Items.Strings[3] := IntToStr(3+1);
    ListBox1.Items.Strings[4] := IntToStr(4+1);
    ListBox1.Items.Strings[5] := IntToStr(5+1);
    ListBox1.Items.Strings[6] := IntToStr(6+1);
    ListBox1.Items.Strings[7] := IntToStr(7+1);
    ListBox1.Items.Strings[8] := IntToStr(8+1);
  end;
end;

procedure TFormNumberJump.ButtonClearClick(Sender: TObject);
begin
  if (ListBox1.Items.Count > 0) then
  begin
    if (ListBox1.ItemIndex >= 0) and (ListBox1.ItemIndex <= 8) then
    begin
      ListBox1.Items.Strings[ListBox1.ItemIndex] := IntToStr(ListBox1.ItemIndex+1);
    end;
  end;
end;

procedure TFormNumberJump.ButtonJumpClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  IniFile: TiniFile;
begin
  if (ListBox1.Items.Count > 0) and (ListBox1.ItemIndex >= 0) then
  begin
    //擾
    sStr1 := ListBox1.Items.Strings[ListBox1.ItemIndex];
    sStr2 := Copy(sStr1, 1, 1);
    sStr3 := Copy(sStr1, 3, Length(sStr1));
    //
    if sStr2 = 'P' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //ݒ
      IniFile.WriteBool   ('NumberJump',    'Popup',   TRUE);
      //j
      IniFile.Free;

      //ݒ
      FormMain.MenuNumberJumpForm.Checked  := FALSE;
      FormMain.MenuNumberJumpPopup.Checked := TRUE;

      //I
      ModalResult := mrCancel;
    end
    else
    begin
      //ݒ
      FormMain.StrRetFormNumberJump := sStr3;
      //I
      ModalResult := mrOK;
    end;
  end;
end;

procedure TFormNumberJump.ButtonSetClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  IniFile: TiniFile;
begin
  if (ListBox1.Items.Count > 0) and (ListBox1.ItemIndex >= 0) then
  begin
    //擾
    sStr1 := ListBox1.Items.Strings[ListBox1.ItemIndex];
    sStr2 := Copy(sStr1, 1, 1);
    //
    if      sStr2 = '1' then
    begin
      //ݒ
      FormMain.StrNumberJump1 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '2' then
    begin
      //ݒ
      FormMain.StrNumberJump2 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '3' then
    begin
      //ݒ
      FormMain.StrNumberJump3 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '4' then
    begin
      //ݒ
      FormMain.StrNumberJump4 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '5' then
    begin
      //ݒ
      FormMain.StrNumberJump5 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '6' then
    begin
      //ݒ
      FormMain.StrNumberJump6 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '7' then
    begin
      //ݒ
      FormMain.StrNumberJump7 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '8' then
    begin
      //ݒ
      FormMain.StrNumberJump8 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = '9' then
    begin
      //ݒ
      FormMain.StrNumberJump9 := ExtractFilePath(FormMain.StrCurrent);
      //I
      ModalResult := mrOK;
    end
    else if sStr2 = 'P' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //ݒ
      IniFile.WriteBool   ('NumberJump',    'Popup',   TRUE);
      //j
      IniFile.Free;

      //ݒ
      FormMain.MenuNumberJumpForm.Checked  := FALSE;
      FormMain.MenuNumberJumpPopup.Checked := TRUE;

      //I
      ModalResult := mrCancel;
    end
    else
    begin
      //
    end;
  end;
end;

end.
