unit RunMacro;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  MyUtility, IniFiles, System.UITypes;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 540;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  LISTBOX8_WIDTH       = 690;

type
  TFormRunMacro = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ListBox8: TListBox;
    Panel4: TPanel;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    Panel5: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure GetFileList(Sender: TObject);

    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);


  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListFile: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormRunMacro: TFormRunMacro;

implementation

{$R *.dfm}

uses
  Main;

//explorer
function CompareLogical(List: TStringList; Index1, Index2: Integer): Integer;
begin
  //r
  Result := StrCmpLogicalW(PWideChar(WideString(List[Index1])), PWideChar(WideString(List[Index2])));
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormRunMacro.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormRunMacro.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormRunMacro.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormRunMacro.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormRunMacro.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr9: String;
  sStr8: String;
  wRet8: Word;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormRunMacro', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormRunMacro', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormRunMacro', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormRunMacro', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormRunMacro', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListFile := TStringList.Create;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox8.Style := lbStandard;
  end;

  //mF
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FOLDER_MACRO;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath + FOLDER_MACRO;
  end;

  //쐬
  if DirectoryExists(sStr9) = FALSE then
  begin
    //mF
    if BoolJapanese = TRUE then
    begin
      sStr8 := 'Information : tH_쐬܂H' + #13#10 +
               FOLDER_MACRO;
    end
    else
    begin
      sStr8 := 'Information : Make folder ?' + #13#10 +
               FOLDER_MACRO + #13#10 +
               '[YES] / [NO]';
    end;
    wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
    if wRet8 = mrYes then
    begin
      //쐬
      if System.SysUtils.ForceDirectories(sStr9) = FALSE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : tH_쐬ł܂ł' + #13#10 +
                             FOLDER_MACRO;
        end
        else
        begin
          FormMain.StrMsg := 'Error : Folder can not make.' + #13#10 +
                             FOLDER_MACRO + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
    end
    else
    begin
      Exit;
    end;
  end;
end;

procedure TFormRunMacro.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormRunMacro', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormRunMacro', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormRunMacro', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormRunMacro', 'Left',   FormRunMacro.Left);
    IniFile.WriteInteger('FormRunMacro', 'Top',    FormRunMacro.Top);
    IniFile.WriteInteger('FormRunMacro', 'Width',  FormRunMacro.Width);
    IniFile.WriteInteger('FormRunMacro', 'Height', FormRunMacro.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListFile.Free;
end;

procedure TFormRunMacro.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormRunMacro, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormRunMacro, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormRunMacro.FormResize(Sender: TObject);
begin
;
end;

procedure TFormRunMacro.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormRunMacro.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormRunMacro.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormRunMacro.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormRunMacro.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormRunMacro.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  ListBox8.SetFocus;

  //XN[o[\
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 2, 0);


  //IMEIt
  SetImeMode(FormRunMacro.Handle, imClose);

  //擾
  GetFileList(Sender);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'RunMacro.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormRunMacro, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormRunMacro, StrLanguageFileName, Sender);
  end;
end;

procedure TFormRunMacro.ButtonOKClick(Sender: TObject);
begin
  //ݒ
  if ListBox8.Items.Count > 0 then
  begin
    FormMain.StrRetFormRunMacro := ListBox8.Items[ListBox8.ItemIndex];
  end
  else
  begin
    FormMain.StrRetFormRunMacro := '';
  end;

  //I
  ModalResult := mrOK;
end;

procedure TFormRunMacro.ButtonCancelClick(Sender: TObject);
begin
  //ݒ
  FormMain.StrRetFormRunMacro := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormRunMacro.ListBox1DblClick(Sender: TObject);
begin
  //s
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormRunMacro.ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
;
end;

procedure TFormRunMacro.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  Key := char(0);
end;

procedure TFormRunMacro.ListBox1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ݒ
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else
  begin
    ;
  end;
end;

procedure TFormRunMacro.ListBox8DblClick(Sender: TObject);
begin
  //OK
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormRunMacro.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin

  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;


end;

procedure TFormRunMacro.ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Return
  if (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormRunMacro.GetFileList(Sender: TObject);
var
  File1: TSearchRec;
  sStr1: String;
  sStr3: String;
  iRow1: Integer;
begin
  //ݒ
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + FOLDER_MACRO + '\';
  end
  else
  begin
    sStr1 := FormMain.StrAnnsFMPath + FOLDER_MACRO + '\';
  end;

  //wfBNĝׂĂ̎ނ̃t@C
  StrListFile.Clear;
  StrListFile.Sorted := FALSE;
  if FindFirst(sStr1 + '*.*', faAnyFile, File1) = 0 then
  begin
    //
    try
      //
      repeat
         //tH_JgfBNgefBNg͑ΏۊO
         if not((File1.Attr and faDirectory > 0)) and (File1.Name <> '.') and (File1.Name <> '..') then
         begin
           if UpperCase(ExtractFileExt(File1.Name)) = UpperCase(FILEEXT_MCR) then
           begin
            //t@Cɒǉ
            StrListFile.Add(sStr1 + File1.Name);
           end;
         end;
       until (FindNext(File1) <> 0);
    finally
      FindClose(File1);
    end;
  end;

  //\[g
  StrListFile.CustomSort(CompareLogical);

  //\
  ListBox8.Items.Clear;
  for iRow1 := 0 to StrListFile.Count-1 do
  begin
    sStr3 := ExtractFileName(StrListFile.Strings[iRow1]);
    ListBox8.Items.Add(sStr3);
  end;


  //ݒ
  if ListBox8.Items.Count > 0 then
  begin
    //ݒ
    ListBox8.ItemIndex := 0;
    //tH[JXݒ
    ListBox8.SetFocus;
  end
  else
  begin
    //ݒ
    ListBox8.ItemIndex := -1;
    //tH[JXݒ
    ListBox8.SetFocus;
  end;

end;


end.
