unit SelectCopy;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 700;
  FORM_HEIGHT_SET      = 350;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormSelectCopy = class(TForm)
    Panel1: TPanel;
    ButtonSameDate: TButton;
    ButtonOverWrite: TButton;
    ButtonNew: TButton;
    ButtonExplorer: TButton;
    ButtonCancel: TButton;
    ButtonRename: TButton;
    CheckBox6: TCheckBox;
    ButtonMakeFolder: TButton;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonSameDateClick(Sender: TObject);
    procedure ButtonOverWriteClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure ButtonExplorerClick(Sender: TObject);
    procedure ButtonRenameClick(Sender: TObject);
    procedure ButtonMakeFolderClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormSelectCopy: TFormSelectCopy;

implementation

{$R *.dfm}

uses
  Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormSelectCopy.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormSelectCopy.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSelectCopy.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormSelectCopy.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormSelectCopy.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormSelectCopy', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSelectCopy', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSelectCopy', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSelectCopy', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSelectCopy', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  CheckBox6.Checked := IniFile.ReadBool('FormSelectCopy', 'TimeStampWithin',  FALSE);
  //j
  IniFile.Free;
end;

procedure TFormSelectCopy.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSelectCopy', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSelectCopy', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSelectCopy', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSelectCopy', 'Left',   FormSelectCopy.Left);
    IniFile.WriteInteger('FormSelectCopy', 'Top',    FormSelectCopy.Top);
    IniFile.WriteInteger('FormSelectCopy', 'Width',  FormSelectCopy.Width);
    IniFile.WriteInteger('FormSelectCopy', 'Height', FormSelectCopy.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool('FormSelectCopy', 'TimeStampWithin',  CheckBox6.Checked);
  //j
  IniFile.Free;
end;

procedure TFormSelectCopy.FormResize(Sender: TObject);
begin
;
end;

procedure TFormSelectCopy.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSelectCopy.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSelectCopy.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSelectCopy.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSelectCopy.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSelectCopy.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormSelectCopy.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'SelectCopy.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormSelectCopy, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormSelectCopy, StrLanguageFileName, Sender);
  end;
end;

procedure TFormSelectCopy.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormSelectCopy, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormSelectCopy, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormSelectCopy.ButtonSameDateClick(Sender: TObject);
begin
  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_DATE;
  ModalResult := mrOK;
end;

procedure TFormSelectCopy.ButtonOverWriteClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_OVERWRITE;
  ModalResult := mrOK;
end;

procedure TFormSelectCopy.ButtonNewClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_NEW;
  ModalResult := mrOK;
end;

procedure TFormSelectCopy.ButtonRenameClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_RENAME;
  ModalResult := mrOK;
end;

procedure TFormSelectCopy.ButtonExplorerClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_EXPLORER;
  ModalResult := mrOK;
end;

procedure TFormSelectCopy.ButtonMakeFolderClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_MAKE_FOLDER;
  ModalResult := mrOK;
end;

procedure TFormSelectCopy.ButtonCancelClick(Sender: TObject);
begin
  FormMain.IntCopyModeIndex := COPY_MOVE_MODE_NONE;
  ModalResult := mrCancel;
end;

end.
