unit SelectMove;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 700;
  FORM_HEIGHT_SET      = 300;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TRadioGroup = class(Vcl.ExtCtrls.TRadioGroup)
  published
    property OnKeyDown;
  end;

type
  TFormSelectMove = class(TForm)
    Panel1: TPanel;
    ButtonCancel: TButton;
    ButtonSameDate: TButton;
    ButtonOverWrite: TButton;
    ButtonNew: TButton;
    ButtonExplorer: TButton;
    CheckBox6: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonSameDateClick(Sender: TObject);
    procedure ButtonOverWriteClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure ButtonExplorerClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormSelectMove: TFormSelectMove;

implementation

{$R *.dfm}

uses
  Main, MoveEx;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormSelectMove.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormSelectMove.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSelectMove.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormSelectMove.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormSelectMove.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormSelectMove', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSelectMove', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSelectMove', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSelectMove', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSelectMove', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  CheckBox6.Checked := IniFile.ReadBool('FormFtpSelectMove', 'TimeStampWithin',  FALSE);
  //j
  IniFile.Free;
end;

procedure TFormSelectMove.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSelectMove', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSelectMove', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSelectMove', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSelectMove', 'Left',   FormSelectMove.Left);
    IniFile.WriteInteger('FormSelectMove', 'Top',    FormSelectMove.Top);
    IniFile.WriteInteger('FormSelectMove', 'Width',  FormSelectMove.Width);
    IniFile.WriteInteger('FormSelectMove', 'Height', FormSelectMove.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool('FormSelectMove', 'TimeStampWithin',  CheckBox6.Checked);
  //j
  IniFile.Free;
end;

procedure TFormSelectMove.FormResize(Sender: TObject);
begin
;
end;

procedure TFormSelectMove.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSelectMove.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSelectMove.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSelectMove.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSelectMove.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSelectMove.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormSelectMove.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'SelectMove.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormSelectMove, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormSelectMove, StrLanguageFileName, Sender);
  end;
end;

procedure TFormSelectMove.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormSelectMove, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormSelectMove, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormSelectMove.ButtonSameDateClick(Sender: TObject);
begin
  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  FormMain.IntMoveModeIndex := COPY_MOVE_MODE_DATE;
  ModalResult := mrOK;
end;

procedure TFormSelectMove.ButtonOverWriteClick(Sender: TObject);
begin
  FormMain.IntMoveModeIndex := COPY_MOVE_MODE_OVERWRITE;
  ModalResult := mrOK;
end;

procedure TFormSelectMove.ButtonNewClick(Sender: TObject);
begin
  FormMain.IntMoveModeIndex := COPY_MOVE_MODE_NEW;
  ModalResult := mrOK;
end;

procedure TFormSelectMove.ButtonExplorerClick(Sender: TObject);
begin
  FormMain.IntMoveModeIndex := COPY_MOVE_MODE_EXPLORER;
  ModalResult := mrOK;
end;

procedure TFormSelectMove.ButtonCancelClick(Sender: TObject);
begin
  FormMain.IntMOVEModeIndex := COPY_MOVE_MODE_NONE;
  ModalResult := mrCancel;
end;

end.
