unit Sort;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 510;
  FORM_HEIGHT_SET      = 395;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormSort = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ButtonName: TButton;
    ButtonExt: TButton;
    ButtonDate: TButton;
    ButtonSize: TButton;
    ButtonNone: TButton;
    ButtonUp: TButton;
    ButtonDown: TButton;
    ButtonCancel: TButton;
    CheckBox8: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox21: TCheckBox;
    ButtonDateMake: TButton;
    ButtonDateLast: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonNameClick(Sender: TObject);
    procedure ButtonExtClick(Sender: TObject);
    procedure ButtonDateClick(Sender: TObject);
    procedure ButtonSizeClick(Sender: TObject);
    procedure ButtonNoneClick(Sender: TObject);
    procedure ButtonUpClick(Sender: TObject);
    procedure ButtonDownClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox14Click(Sender: TObject);
    procedure CheckBox21Click(Sender: TObject);
    procedure ButtonDateMakeClick(Sender: TObject);
    procedure ButtonDateLastClick(Sender: TObject);

  private
    { Private 錾 }
    iSortMode1: Integer;

    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormSort: TFormSort;

implementation

uses
  Main, Browse;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormSort.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormSort.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormSort.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormSort.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormSort', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSort', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSort', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSort', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSort', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  ButtonUp.Enabled := FALSE;
  ButtonDown.Enabled := FALSE;
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';

  if FormMain.IntSortMode1 = 1 then
  begin
    Label2.Caption := '';
  end;
  if FormMain.IntSortMode1 = 2 then
  begin
    Label3.Caption := '';
  end;
  if FormMain.IntSortMode1 = 3 then
  begin
    Label4.Caption := '';
  end;
  if FormMain.IntSortMode1 = 4 then
  begin
    Label5.Caption := '';
  end;
  if FormMain.IntSortMode1 = 0 then
  begin
    Label6.Caption := '';
  end;
  if FormMain.IntSortMode1 = 5 then
  begin
    Label7.Caption := '';
  end;
  if FormMain.IntSortMode1 = 6 then
  begin
    Label8.Caption := '';
  end;

  //explorar
  CheckBox8.Checked    := FormMain.BoolSortExplorer;
  //SJIS
  CheckBox14.Checked   := FormMain.BoolSortSJIS;
  //UNICODE
  CheckBox21.Checked   := FormMain.BoolSortUnicode;
end;

procedure TFormSort.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSort', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSort', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSort', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSort', 'Left',   FormSort.Left);
    IniFile.WriteInteger('FormSort', 'Top',    FormSort.Top);
    IniFile.WriteInteger('FormSort', 'Width',  FormSort.Width);
    IniFile.WriteInteger('FormSort', 'Height', FormSort.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormSort.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSort.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSort.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSort.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSort.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSort.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormSort.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Sort.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormSort, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormSort, StrLanguageFileName, Sender);
  end;
end;

procedure TFormSort.FormResize(Sender: TObject);
begin
;
end;

procedure TFormSort.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSort.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormSort, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormSort, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormSort.ButtonNameClick(Sender: TObject);
begin
  //0:None 1:Name 2:Ext 3:Date 4:Size 5:Date(Make) 6:Date(Last)
  //\[g
  iSortMode1 := 1;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonExtClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 2;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonDateClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 3;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonDateMakeClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 5;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonDateLastClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 6;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonSizeClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 4;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonNoneClick(Sender: TObject);
begin
  //\[g
  iSortMode1 := 0;
  //
  ButtonName.Enabled := FALSE;
  ButtonExt.Enabled  := FALSE;
  ButtonDate.Enabled := FALSE;
  ButtonSize.Enabled := FALSE;
  ButtonNone.Enabled := FALSE;
  ButtonDateMake.Enabled := FALSE;
  ButtonDateLast.Enabled := FALSE;
  //ݒ
  Label2.Caption := '';
  Label3.Caption := '';
  Label4.Caption := '';
  Label5.Caption := '';
  Label6.Caption := '';
  Label7.Caption := '';
  Label8.Caption := '';
  //L
  ButtonUp.Enabled   := TRUE;
  ButtonDown.Enabled := TRUE;
  //tH[JXړ
  ButtonUp.SetFocus;
end;

procedure TFormSort.ButtonUpClick(Sender: TObject);
begin
  //0:annsFM  1:exploler
  //0:unicode 1:SJIS
  //0: 1:~
  //0:O...
  if CheckBox8.Checked = FALSE then
  begin
    FormMain.StrRetFormSortExplorer := '0';
  end
  else
  begin
    FormMain.StrRetFormSortExplorer := '1';
  end;

  if CheckBox14.Checked = FALSE then
  begin
    FormMain.StrRetFormSortAnnsFM := '0';
  end
  else
  begin
    FormMain.StrRetFormSortAnnsFM := '1';
  end;

  if CheckBox21.Checked = FALSE then
  begin
    FormMain.StrRetFormSortUnicode := '0';
  end
  else
  begin
    FormMain.StrRetFormSortUnicode := '1';
  end;

  FormMain.StrRetFormSortOrder    := '0';
  FormMain.StrRetFormSortMode     := IntToStr(iSortMode1);
  //I
  ModalResult := mrOK;
end;

procedure TFormSort.ButtonDownClick(Sender: TObject);
begin
  //0:annsFM 1:exploler
  //0:unicode 1:SJIS
  //0: 1:~
  //0:O...
  if CheckBox8.Checked = FALSE then
  begin
    FormMain.StrRetFormSortExplorer := '0';
  end
  else
  begin
    FormMain.StrRetFormSortExplorer := '1';
  end;

  if CheckBox14.Checked = FALSE then
  begin
    FormMain.StrRetFormSortAnnsFM := '0';
  end
  else
  begin
    FormMain.StrRetFormSortAnnsFM := '1';
  end;

  if CheckBox21.Checked = FALSE then
  begin
    FormMain.StrRetFormSortUnicode := '0';
  end
  else
  begin
    FormMain.StrRetFormSortUnicode := '1';
  end;

  FormMain.StrRetFormSortOrder := '1';
  FormMain.StrRetFormSortMode  := IntToStr(iSortMode1);
  //I
  ModalResult := mrOK;
end;

procedure TFormSort.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormSort.CheckBox8Click(Sender: TObject);
begin
  if CheckBox8.Checked = TRUE then
  begin
    CheckBox14.Checked := FALSE;
    CheckBox21.Checked := FALSE;
  end
  else
  begin
    if (CheckBox14.Checked = FALSE) and (CheckBox21.Checked = FALSE) then
    begin
      CheckBox8.Checked := TRUE;
    end;
  end;
end;

procedure TFormSort.CheckBox14Click(Sender: TObject);
begin
  if CheckBox14.Checked = TRUE then
  begin
    CheckBox8.Checked  := FALSE;
    CheckBox21.Checked := FALSE;
  end
  else
  begin
    if (CheckBox8.Checked = FALSE) and (CheckBox21.Checked = FALSE) then
    begin
      CheckBox14.Checked := TRUE;
    end;
  end;
end;

procedure TFormSort.CheckBox21Click(Sender: TObject);
begin
  if CheckBox21.Checked = TRUE then
  begin
    CheckBox8.Checked  := FALSE;
    CheckBox14.Checked := FALSE;
  end
  else
  begin
    if (CheckBox8.Checked = FALSE) and (CheckBox14.Checked = FALSE) then
    begin
      CheckBox21.Checked := TRUE;
    end;
  end;
end;

end.

