unit TenKeyBoard;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility, CommCtrl, System.UITypes;

const
  FORM_WIDTH_SET       = 900;
  FORM_HEIGHT_SET      = 460;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  LIST_COLUM_WIDH_20    = 210;
  LIST_COLUM_WIDH_21    = 470;
  LIST_COLUM_WIDH_22    = 110;
  LIST_COLUM_WIDH_23    =  90;
  LIST_COLUM_WIDH_24    =  10;

  LIST_COLUM_WIDH_10    = 610;
  LIST_COLUM_WIDH_11    = 200;
  LIST_COLUM_WIDH_12    = 110;
  LIST_COLUM_WIDH_13    =  10;

type
  TFormTenKeyBoard = class(TForm)
    Panel1: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Label3: TLabel;
    ComboBox2: TComboBox;
    ButtonInit: TButton;
    ButtonClear: TButton;
    Label1: TLabel;
    ComboBox1: TComboBox;
    ListView2: TListView;
    ListView1: TListView;
    ButtonSet: TButton;
    Label7: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ReadKeyMapFromFile(Sender: TObject);
    procedure SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
    procedure SetThisCategory(Sender: TObject);
    procedure SetCommand(Sender: TObject);
    procedure SetCategory(Number: String; ComboBox: TcomboBox; Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);

    procedure ReadTenKeyMapFromFile(Sender: TObject);
    procedure SetTenThisCategory(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure SetTenCommand(Sender: TObject);
    procedure ListView2AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonSetClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonInitClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListKeyMap: TStringList;
    StrListTenKeyMap: TStringList;
    BoolSaveToFile: Boolean;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormTenKeyBoard: TFormTenKeyBoard;

implementation

{$R *.dfm}

uses Main, Browse;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormTenKeyBoard.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormTenKeyBoard.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormTenKeyBoard.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormTenKeyBoard.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormTenKeyBoard.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormTenKeyBoard', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormTenKeyBoard', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormTenKeyBoard', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormTenKeyBoard', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormTenKeyBoard', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListKeyMap := TStringList.Create;
  StrListTenKeyMap := TStringList.Create;

  //FormShow̑Oɂǂݍ
  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //ݒ
  if BoolJapanese = TRUE  then
  begin
    ListView2.Columns.Add.Caption  := 'eL[';
    ListView2.Columns.Add.Caption  := 'R}h';
    ListView2.Columns.Add.Caption  := '@\';
    ListView2.Columns.Add.Caption  := '^O';
    ListView2.Columns.Add.Caption  := '';

    ListView1.Columns.Add.Caption  := 'R}h';
    ListView1.Columns.Add.Caption  := '݂̃L[';
    ListView1.Columns.Add.Caption  := '@\';
    ListView1.Columns.Add.Caption  := '';
  end
  else
  begin
    ListView2.Columns.Add.Caption  := 'TenKey';
    ListView2.Columns.Add.Caption  := 'Command';
    ListView2.Columns.Add.Caption  := 'Function';
    ListView2.Columns.Add.Caption  := 'Tag';
    ListView2.Columns.Add.Caption  := '';

    ListView1.Columns.Add.Caption  := 'Command';
    ListView1.Columns.Add.Caption  := 'Current Key';
    ListView1.Columns.Add.Caption  := 'Function';
    ListView1.Columns.Add.Caption  := '';
  end;
  ListView2.ViewStyle := vsReport;
  ListView2.RowSelect := TRUE;
  ListView2.MultiSelect := FALSE;
  ListView2.ReadOnly := TRUE;

  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.ReadOnly := TRUE;

  //ݒ
  BoolSaveToFile := FALSE;
end;

procedure TFormTenKeyBoard.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormTenKeyBoard', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormTenKeyBoard', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormTenKeyBoard', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormTenKeyBoard', 'Left',   FormTenKeyBoard.Left);
    IniFile.WriteInteger('FormTenKeyBoard', 'Top',    FormTenKeyBoard.Top);
    IniFile.WriteInteger('FormTenKeyBoard', 'Width',  FormTenKeyBoard.Width);
    IniFile.WriteInteger('FormTenKeyBoard', 'Height', FormTenKeyBoard.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
  StrListTenKeyMap.Free;
end;

procedure TFormTenKeyBoard.FormResize(Sender: TObject);
begin
  Panel3.Height := (FormTenKeyBoard.ClientHeight - Panel1.Height) div 2;

  ListView2.Height            := Panel3.ClientHeight - 65;
  ListView2.Width             := Panel3.ClientWidth  - 45;
  ListView2.Columns[0].Width := LIST_COLUM_WIDH_20;
  ListView2.Columns[2].Width := LIST_COLUM_WIDH_22;
  ListView2.Columns[3].Width := LIST_COLUM_WIDH_23;
  ListView2.Columns[4].Width := LIST_COLUM_WIDH_24;
  ListView2.Columns[1].Width := ListView2.ClientWidth      -
                                ListView2.Columns[0].Width -
                                ListView2.Columns[2].Width -
                                ListView2.Columns[3].Width -
                                ListView2.Columns[4].Width - 20;

  ListView1.Height            := Panel2.ClientHeight - 65;
  ListView1.Width             := Panel2.ClientWidth  - 45;
  ListView1.Columns[1].Width := LIST_COLUM_WIDH_11;
  ListView1.Columns[2].Width := LIST_COLUM_WIDH_12;
  ListView1.Columns[3].Width := LIST_COLUM_WIDH_13;
  ListView1.Columns[0].Width := ListView1.ClientWidth      -
                                ListView1.Columns[1].Width -
                                ListView1.Columns[2].Width -
                                ListView1.Columns[3].Width - 20;
end;

procedure TFormTenKeyBoard.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormTenKeyBoard.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormTenKeyBoard.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormTenKeyBoard.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormTenKeyBoard.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormTenKeyBoard.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'TenKeyBoard.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormTenKeyBoard, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormTenKeyBoard, StrLanguageFileName, Sender);
  end;

  if BoolJapanese = TRUE  then
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);

    //Ǎ
    ReadTenKeyMapFromFile(Sender);
    //JeSݒ
    SetTenThisCategory(Sender);
    //Xgɐݒ
    SetTenCommand(Sender);
  end
  else
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);

    //Ǎ
    ReadTenKeyMapFromFile(Sender);
    //JeSݒ
    SetTenThisCategory(Sender);
    //Xgɐݒ
    SetTenCommand(Sender);
  end;
end;

procedure TFormTenKeyBoard.ListView1DblClick(Sender: TObject);
begin
  ButtonSetClick(Sender);
end;

procedure TFormTenKeyBoard.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormTenKeyBoard, StrLanguageFileName, Sender);
    //{
    ListView2.Columns[0].Caption  := 'eL[';
    ListView2.Columns[1].Caption  := 'R}h';
    ListView2.Columns[2].Caption  := '@\';
    ListView2.Columns[3].Caption  := '^O';
    ListView2.Columns[4].Caption  := '';

    ListView1.Columns[0].Caption  := 'R}h';
    ListView1.Columns[1].Caption  := '݂̃L[';
    ListView1.Columns[2].Caption  := '@\';
    ListView1.Columns[3].Caption  := '';

    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);

    //Ǎ
    ReadTenKeyMapFromFile(Sender);
    //JeSݒ
    SetTenThisCategory(Sender);
    //Xgɐݒ
    SetTenCommand(Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormTenKeyBoard, StrLanguageFileName, Sender);
    ListView2.Columns[0].Caption  := 'TenKey';
    ListView2.Columns[1].Caption  := 'Command';
    ListView2.Columns[2].Caption  := 'Function';
    ListView2.Columns[3].Caption  := 'Tag';
    ListView2.Columns[4].Caption  := '';

    ListView1.Columns[0].Caption  := 'Command';
    ListView1.Columns[1].Caption  := 'Current Key';
    ListView1.Columns[2].Caption  := 'Function';
    ListView1.Columns[3].Caption  := '';

    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);

    //Ǎ
    ReadTenKeyMapFromFile(Sender);
    //JeSݒ
    SetTenThisCategory(Sender);
    //Xgɐݒ
    SetTenCommand(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormTenKeyBoard.ListView1AdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView1.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView1.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView1.Canvas.Brush.Color := clAqua;
      ListView1.Canvas.FillRect(ARect);
      ListView1.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView1.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView1.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView1.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView1.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormTenKeyBoard.ListView2AdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView2.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView2.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView2.Canvas.Brush.Color := clAqua;
      ListView2.Canvas.FillRect(ARect);
      ListView2.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView2.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView2.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView2.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView2.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView2.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView2.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormTenKeyboard.ReadKeyMapFromFile(Sender: TObject);
var
  sStr3: String;
begin
  //Ǎ
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
      Label7.Caption := 'annsFM';
    end;
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_BROWSE_LIST;
    Label7.Caption := 'Browse';
  end;

  //t@Cǂݍ
  if FileExists(sStr3) = TRUE then
  begin
    //t@Cǂݍ
    StrListKeyMap.LoadFromFile(sStr3, TEncoding.Unicode);
  end;
end;

procedure TFormTenKeyboard.SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
var
  sStr3: String;
  sStr4: String;
  iRow1: Integer;
  iRow2: Integer;
  CsvList1: TStringList;
  CsvList2: TStringList;
  StrList1: TStringList;
begin
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;
  StrList1 := TStringList.Create;

  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Main.txt';
    end;
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Browse.txt';
  end;

  //t@Cǂݍ
  if FileExists(sStr3) = TRUE then
  begin
    //t@Cǂݍ
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    //
    for iRow1 := 0 to StrListMap.Count-1 do
    begin
      //WJ
      CsvList1.Clear;
      StringToCsvList(StrListMap.Strings[iRow1], CsvList1);
      //
      for iRow2 := 0 to StrList1.Count-1 do
      begin
        //WJ
        CsvList2.Clear;
        StringToCsvList(StrList1.Strings[iRow2], CsvList2);
        //v
        if CsvList1[3]  = CsvList2[0] then
        begin
          if      (CsvList1[0] = SHORTCUT_ITEM_KEY) or (CsvList1[0] = SHORTCUT_ITEM_KEY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_KEY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_KEY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SHIFT) or (CsvList1[0] = SHORTCUT_ITEM_SHIFT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_CTRL) or (CsvList1[0] = SHORTCUT_ITEM_CTRL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_CTRL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_CTRL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OTHERS) or (CsvList1[0] = SHORTCUT_ITEM_OTHERS_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_DRIVE) or (CsvList1[0] = SHORTCUT_ITEM_DRIVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_DRIVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_DRIVE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_LAUNCHER) or (CsvList1[0] = SHORTCUT_ITEM_LAUNCHER_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_LAUNCHER;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_LAUNCHER_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_HELP) or (CsvList1[0] = SHORTCUT_ITEM_HELP_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_HELP;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_HELP_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_FILE) or (CsvList1[0] = SHORTCUT_ITEM_FILE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_FILE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_FILE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OPERATION) or (CsvList1[0] = SHORTCUT_ITEM_OPERATION_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OPERATION;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OPERATION_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_WINDOW) or (CsvList1[0] = SHORTCUT_ITEM_WINDOW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_WINDOW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_WINDOW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_DIRECTORY) or (CsvList1[0] = SHORTCUT_ITEM_DIRECTORY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_DIRECTORY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_DIRECTORY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SETTING) or (CsvList1[0] = SHORTCUT_ITEM_SETTING_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SETTING;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SETTING_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG) or (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_EDIT) or (CsvList1[0] = SHORTCUT_ITEM_EDIT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_EDIT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_EDIT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_VIEW) or (CsvList1[0] = SHORTCUT_ITEM_VIEW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_VIEW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_VIEW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_MOVE) or (CsvList1[0] = SHORTCUT_ITEM_MOVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_MOVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_MOVE_ENg;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_TOOL) or (CsvList1[0] = SHORTCUT_ITEM_TOOL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_TOOL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_TOOL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OPTION) or (CsvList1[0] = SHORTCUT_ITEM_OPTION_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OPTION;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OPTION_ENG;
            end;
          end
          else
          begin
            sStr4 := CsvList1[0];
          end;

          //Đݒ
          if LanguageJpn = TRUE then
          begin
            StrListMap.Strings[iRow1] := sStr4 + #09 + CsvList2[4] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end
          else
          begin
            StrListMap.Strings[iRow1] := sStr4 + #09 + CsvList2[5] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end;
          //
          Break;
        end;
      end;
    end;
  end;

  CsvList1.Free;
  CsvList2.Free;
  StrList1.Free;
end;

procedure TFormTenKeyboard.SetThisCategory(Sender: TObject);
begin
  //R}h̍ڂݒ
  if StrListKeyMap.Count > 0 then
  begin
    //NA
    Combobox1.Items.Clear;
    //main
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
    begin
      //annsfm
      if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
      begin
        //
        SetCategory('1001', ComboBox1, Sender);
        SetCategory('1101', ComboBox1, Sender);
        SetCategory('1202', ComboBox1, Sender);
        SetCategory('1301', ComboBox1, Sender);
        SetCategory('1401', ComboBox1, Sender);
        SetCategory('1501', ComboBox1, Sender);
        SetCategory('1601', ComboBox1, Sender);
        SetCategory('1701', ComboBox1, Sender);
        SetCategory('1801', ComboBox1, Sender);
        SetCategory('1901', ComboBox1, Sender);
      end;
    end;
    //browse
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
    begin
      //
      SetCategory('1001', ComboBox1, Sender);
      SetCategory('1101', ComboBox1, Sender);
      SetCategory('1201', ComboBox1, Sender);
    end;

    //ݒ
    ComboBox1.ItemIndex := 0;
  end;
end;

procedure TFormTenKeyBoard.SetCommand(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //XV
  ListView1.Items.BeginUpdate;
  //NA
  ListView1.Items.Clear;
  //ԍ
  iRow2 := 0;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //R}h
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //L[
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr12 = ComboBox1.Text then
    begin
      nItem := ListView1.Items.Add;
      nItem.Caption := sStr14;
      ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
      ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
      iRow2 := iRow2+1;
    end;
  end;
  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;
  //XV
  ListView1.Items.EndUpdate;
end;

procedure TFormTenKeyBoard.SetCategory(Number: String; ComboBox: TcomboBox; Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
begin
  //ԍ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //R}h
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //L[
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      ComboBox.Items.Add(sStr12);
      Break;
    end;
  end;
end;


procedure TFormTenKeyboard.ReadTenKeyMapFromFile(Sender: TObject);
var
  sStr3: String;
begin
  //Ǎ
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      sStr3 := ExtractFilePath(ParamStr(0)) + KEYTEN_ANNSFM_LIST;
      Label7.Caption := 'annsFM';
    end;
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYTEN_BROWSE_LIST;
    Label7.Caption := 'Browse';
  end;

  //t@Cǂݍ
  if FileExists(sStr3) = TRUE then
  begin
    //t@Cǂݍ
    StrListTenKeyMap.LoadFromFile(sStr3, TEncoding.Unicode);
  end;
end;

procedure TFormTenKeyboard.SetTenThisCategory(Sender: TObject);
begin
  //R}h̍ڂݒ
  if StrListTenKeyMap.Count > 0 then
  begin
    //NA
    Combobox2.Items.Clear;
    //main
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
    begin
      //annsfm
      if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
      begin
        //
        ComboBox2.Items.Add('TenKey');
        ComboBox2.Items.Add('Ctrl+TenKey');
      end;
    end;
    //browse
    if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
    begin
        //
        ComboBox2.Items.Add('TenKey');
        ComboBox2.Items.Add('Ctrl+TenKey');
    end;

    //ݒ
    ComboBox2.ItemIndex := 0;
  end;
end;

procedure TFormTenKeyBoard.SetTenCommand(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr19: String;
  sStr20: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  iRow1: Integer;
  iRow2: Integer;
  iRow3: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  iPos24: Integer;
  nItem: TListItem;
begin
  //XV
  ListView2.Items.BeginUpdate;
  //NA
  ListView2.Items.Clear;
  //ԍ
  iRow2 := 0;
  for iRow1 := 0 to StrListTenKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListTenKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //R}h
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //@\
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//ȍ~̕
    iPos14 := Pos(#9, sStr17);
    sStr18 := Copy(sStr17, 1,        iPos14-1);      //(&0)
    sStr19 := Copy(sStr17, iPos14+1, Length(sStr17));//ȍ~̕

    for iRow3 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr21 := StrListKeyMap.Strings[iRow3];
      iPos21 := Pos(#9, sStr21);
      sStr22 := Copy(sStr21, 1,        iPos21-1);      //
      sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
      iPos22 := Pos(#9, sStr23);
      sStr24 := Copy(sStr23, 1,        iPos22-1);      //R}h
      sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
      iPos23 := Pos(#9, sStr25);
      sStr26 := Copy(sStr25, 1,        iPos23-1);      //L[
      sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//@\

      //@\v
      if sStr27 = sStr16 then
      begin
        sStr14 := sStr24;
        Break;
      end;
    end;


//    V[gJbg폜ꍇ
//    if Length(sStr14) >= 0 then
//    begin
//      iPos15 := Pos('(&', sStr14);
//      if iPos15 > 0 then
//      begin
//        sStr20 := Copy(sStr14, 1, iPos15-1) + Copy(sStr14, iPos15+4, Length(sStr14));
//      end
//      else
//      begin
//        sStr20 := sStr14;
//      end;
//    end
//    else
//    begin
//      sStr20 := sStr14;
//    end;
    //̂܂ܕ\ꍇ
    sStr20 := sStr14;

    //
    if ComboBox2.ItemIndex = 0 then
    begin
      if (iRow1 >= 15*0) and (iRow1 < 15*1) then
      begin
        nItem := ListView2.Items.Add;
        nItem.Caption := sStr12;
        ListView2.Items.Item[iRow2].SubItems.Add(sStr20);
        ListView2.Items.Item[iRow2].SubItems.Add(sStr16);
        ListView2.Items.Item[iRow2].SubItems.Add(sStr19);
        iRow2 := iRow2+1;
      end;
    end;
    if ComboBox2.ItemIndex = 1 then
    begin
      if (iRow1 >= 15*1) and (iRow1 < 15*2) then
      begin
        nItem := ListView2.Items.Add;
        nItem.Caption := sStr12;
        ListView2.Items.Item[iRow2].SubItems.Add(sStr20);
        ListView2.Items.Item[iRow2].SubItems.Add(sStr16);
        ListView2.Items.Item[iRow2].SubItems.Add(sStr19);
        iRow2 := iRow2+1;
      end;
    end;
  end;
  //ݒ
  if ListView2.Items.Count > 0 then
  begin
    ListView2.ItemIndex := 0;
    ListView2.Selected := ListView2.Items[0];
    ListView2.ItemFocused := ListView2.Items[0];
  end;
  //XV
  ListView2.Items.EndUpdate;
end;

procedure TFormTenKeyBoard.ButtonClearClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  CsvList1: TStringList;
begin
  if ListView2.Items.Count > 0 then
  begin
    //ւ
    ListView2.Items[ListView2.ItemIndex].SubItems[0] := '';
    ListView2.Items[ListView2.ItemIndex].SubItems[1] := '';

    //m
    CsvList1 := TStringList.Create;

    //ݒ
    if ComboBox2.ItemIndex = 0 then
    begin
      //WJ
      sStr1 := StrListTenKeyMap.Strings[15*0 + ListView2.ItemIndex];
      StringToCsvList(sstr1, CsvList1);
      //ւ
      sStr2 := CsvList1[0] + #09 + '' + #09 + '' + #09 +CsvList1[3] + #09 +CsvList1[4];
      StrListTenKeyMap.Strings[15*0 + ListView2.ItemIndex] := sStr2;
    end;

    //ݒ
    if ComboBox2.ItemIndex = 1 then
    begin
      //WJ
      sStr1 := StrListTenKeyMap.Strings[15*1 + ListView2.ItemIndex];
      StringToCsvList(sstr1, CsvList1);
      //ւ
      sStr2 := CsvList1[0] + #09 + '' + #09 + '' + #09 +CsvList1[3] + #09 +CsvList1[4];
      StrListTenKeyMap.Strings[15*1 + ListView2.ItemIndex] := sStr2;
    end;

    //j
    Csvlist1.Free;
  end;
end;

procedure TFormTenKeyBoard.ButtonInitClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  wRet1: Word;
begin
  //mF
  if BoolJapanese = TRUE then
  begin
    sStr2 := 'Information : ݒĕۑ܂H';
  end
  else
  begin
    sStr2 := 'Information : Initialize and save to file ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet1 := MessageDlg(sStr2, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet1 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //ݒ
  BoolSaveToFile := TRUE;

  //Ǎ
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYTEN_ANNSFM_LIST;
      FormMain.InitTenKeyMap(KEYBORD_MENU_ANNSFM, Sender);
      FormMain.StrListTenKeyMapAnnsFM.SaveToFile(sStr1, TEncoding.Unicode);
     end;
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
  begin
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYTEN_BROWSE_LIST;
    FormBrowse.InitTenKeyMap(0, Sender);
    FormMain.StrListTenKeyMapBrowse.SaveToFile(sStr1, TEncoding.Unicode);
  end;

  if BoolJapanese = TRUE  then
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);

    //Ǎ
    ReadTenKeyMapFromFile(Sender);
    //JeSݒ
    SetTenThisCategory(Sender);
    //Xgɐݒ
    SetTenCommand(Sender);
  end
  else
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);

    //Ǎ
    ReadTenKeyMapFromFile(Sender);
    //JeSݒ
    SetTenThisCategory(Sender);
    //Xgɐݒ
    SetTenCommand(Sender);
  end;
end;

procedure TFormTenKeyBoard.ButtonSetClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  CsvList1: TStringList;
begin
  if ListView2.Items.Count > 0 then
  begin
    //擾
    sStr3 := ListView1.Items[ListView1.ItemIndex].Caption;
    sStr4 := ListView1.Items[ListView1.ItemIndex].SubItems[1];
    //ւ
    ListView2.Items[ListView2.ItemIndex].SubItems[0] := sStr3;
    ListView2.Items[ListView2.ItemIndex].SubItems[1] := sStr4;

    //m
    CsvList1 := TStringList.Create;

    //ݒ
    if ComboBox2.ItemIndex = 0 then
    begin
      //WJ
      sStr1 := StrListTenKeyMap.Strings[15*0 + ListView2.ItemIndex];
      StringToCsvList(sstr1, CsvList1);
      //ւ
      sStr2 := CsvList1[0] + #09 + sStr3 + #09 + sStr4 + #09 +CsvList1[3] + #09 +CsvList1[4];
      StrListTenKeyMap.Strings[15*0 + ListView2.ItemIndex] := sStr2;
    end;

    //ݒ
    if ComboBox2.ItemIndex = 1 then
    begin
      //WJ
      sStr1 := StrListTenKeyMap.Strings[15*1 + ListView2.ItemIndex];
      StringToCsvList(sstr1, CsvList1);
      //ւ
      sStr2 := CsvList1[0] + #09 + sStr3 + #09 + sStr4 + #09 +CsvList1[3] + #09 +CsvList1[4];
      StrListTenKeyMap.Strings[15*1 + ListView2.ItemIndex] := sStr2;
    end;

    //j
    Csvlist1.Free;
  end;
end;

procedure TFormTenKeyBoard.ComboBox1Change(Sender: TObject);
begin
  //R}hݒ
  SetCommand(Sender);
end;

procedure TFormTenKeyBoard.ComboBox2Change(Sender: TObject);
begin
  //R}hݒ
  SetTenCommand(Sender);
end;

procedure TFormTenKeyBoard.ButtonOKClick(Sender: TObject);
var
  sStr3: String;
  StrList2: TStringList;
begin
  //Ǎ
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      sStr3 := ExtractFilePath(ParamStr(0)) + KEYTEN_ANNSFM_LIST;
    end;
  end;
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_BROWSE then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYTEN_BROWSE_LIST;
  end;

  //m
  StrList2 := TStringList.Create;
  //ݒ
  StrList2.Assign(StrListTenKeyMap);
  //
  SetKeyMapJpnEng(TRUE, StrList2, Sender);
  //ۑ
  StrList2.SaveToFile(sStr3, TEncoding.Unicode);
  //j
  StrList2.Free;

  //
  ModalResult := mrOK;
end;


procedure TFormTenKeyBoard.ButtonCancelClick(Sender: TObject);
begin
  if BoolSaveToFile = TRUE then
  begin
    //I
    ModalResult := mrOk;
  end
  else
  begin
    //I
    ModalResult := mrCancel;
  end;
end;

end.
