unit ToolPanel;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls,
  IniFiles, CommCtrl, MyUtility;

const
  FORM_WIDTH_SET       = 960;
  FORM_HEIGHT_SET      = 640;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  LIST_COLUM_WIDH_10    =  40;
  LIST_COLUM_WIDH_11    = 150;
  LIST_COLUM_WIDH_12    = 150;
  LIST_COLUM_WIDH_13    = 315;
  LIST_COLUM_WIDH_14    = 200;
  LIST_COLUM_WIDH_15    = 110;
  LIST_COLUM_WIDH_16    =  10;

  LIST_COLUM_WIDH_20    = 150;
  LIST_COLUM_WIDH_21    = 315;
  LIST_COLUM_WIDH_22    = 200;
  LIST_COLUM_WIDH_23    = 110;
  LIST_COLUM_WIDH_24    =  10;


type
  TFormToolPanel = class(TForm)
    Panel1: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Label7: TLabel;
    Label2: TLabel;
    ButtonClear: TButton;
    ButtonUp: TButton;
    ButtonDown: TButton;
    ListView2: TListView;
    ListView1: TListView;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure SetKeyMap(Sender: TObject);
    procedure SetToolMap(Sender: TObject);
    procedure ListView2Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ButtonSetClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonUpClick(Sender: TObject);
    procedure ButtonDownClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
    procedure ListView2AdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

    procedure ReadKeyMapFromFile(Sender: TObject);
    procedure SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;
    StrListKeyMap: TStringList;

  public
    { Public 錾 }

  end;

var
  FormToolPanel: TFormToolPanel;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormToolPanel.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormToolPanel.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormToolPanel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormToolPanel.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormToolPanel.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormToolPanel', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormToolPanel', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormToolPanel', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormToolPanel', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormToolPanel', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListKeyMap := TStringList.Create;

  //ݒ
  Edit1.Text := '';

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    //ݒ
    ListView1.Columns.Add.Caption  := 'No';
    ListView1.Columns.Add.Caption  := 'O';
    ListView1.Columns.Add.Caption  := 'JeS';
    ListView1.Columns.Add.Caption  := 'R}h';
    ListView1.Columns.Add.Caption  := '݂̃L[';
    ListView1.Columns.Add.Caption  := '@\';
    ListView1.Columns.Add.Caption  := '';

    //ݒ
    ListView2.Columns.Add.Caption  := 'JeS';
    ListView2.Columns.Add.Caption  := 'R}h';
    ListView2.Columns.Add.Caption  := '݂̃L[';
    ListView2.Columns.Add.Caption  := '@\';
    ListView2.Columns.Add.Caption  := '';
  end
  else
  begin
    //ݒ
    ListView1.Columns.Add.Caption  := 'No';
    ListView1.Columns.Add.Caption  := 'Name';
    ListView1.Columns.Add.Caption  := 'Category';
    ListView1.Columns.Add.Caption  := 'Command';
    ListView1.Columns.Add.Caption  := 'Current Key';
    ListView1.Columns.Add.Caption  := 'Function';
    ListView1.Columns.Add.Caption  := '';

    //ݒ
    ListView2.Columns.Add.Caption  := 'Category';
    ListView2.Columns.Add.Caption  := 'Command';
    ListView2.Columns.Add.Caption  := 'Current Key';
    ListView2.Columns.Add.Caption  := 'Function';
    ListView2.Columns.Add.Caption  := '';
  end;

  //ݒ
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.ReadOnly := TRUE;

  //ݒ
  ListView2.ViewStyle := vsReport;
  ListView2.RowSelect := TRUE;
  ListView2.MultiSelect := FALSE;
  ListView2.Align := alClient;
  ListView2.ReadOnly := TRUE;

end;

procedure TFormToolPanel.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormToolPanel', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormToolPanel', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormToolPanel', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormToolPanel', 'Left',   FormToolPanel.Left);
    IniFile.WriteInteger('FormToolPanel', 'Top',    FormToolPanel.Top);
    IniFile.WriteInteger('FormToolPanel', 'Width',  FormToolPanel.Width);
    IniFile.WriteInteger('FormToolPanel', 'Height', FormToolPanel.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
end;

procedure TFormToolPanel.FormResize(Sender: TObject);
begin
  ListView1.Columns[0].Width := LIST_COLUM_WIDH_10;
  ListView1.Columns[1].Width := LIST_COLUM_WIDH_11;
  ListView1.Columns[2].Width := LIST_COLUM_WIDH_12;
  ListView1.Columns[4].Width := LIST_COLUM_WIDH_14;
  ListView1.Columns[5].Width := LIST_COLUM_WIDH_15;
  ListView1.Columns[6].Width := LIST_COLUM_WIDH_16;
  ListView1.Columns[3].Width := FormToolPanel.ClientWidth  -
                                ListView1.Columns[0].Width -
                                ListView1.Columns[1].Width -
                                ListView1.Columns[2].Width -
                                ListView1.Columns[4].Width -
                                ListView1.Columns[5].Width -
                                ListView1.Columns[6].Width - 30;

  ListView2.Columns[0].Width := LIST_COLUM_WIDH_20;
  ListView2.Columns[2].Width := LIST_COLUM_WIDH_22;
  ListView2.Columns[3].Width := LIST_COLUM_WIDH_23;
  ListView2.Columns[4].Width := LIST_COLUM_WIDH_24;
  ListView2.Columns[1].Width := FormToolPanel.ClientWidth  -
                                ListView2.Columns[0].Width -
                                ListView2.Columns[2].Width -
                                ListView2.Columns[3].Width -
                                ListView2.Columns[4].Width - 30;
end;

procedure TFormToolPanel.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormToolPanel.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormToolPanel.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormToolPanel.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormToolPanel.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormToolPanel.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'ToolPanel.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormToolPanel, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormToolPanel, StrLanguageFileName, Sender);
  end;

  //t@CĐݒ
  if BoolJapanese = TRUE then
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
  end
  else
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
  end;

  //\
  SetKeyMap(Sender);
  SetToolMap(Sender);
  ListView1Click(Sender);
  ListView1.SetFocus;
end;

procedure TFormToolPanel.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormToolPanel, StrLanguageFileName, Sender);
    //ݒ
    ListView1.Columns[0].Caption  := 'No';
    ListView1.Columns[1].Caption  := 'O';
    ListView1.Columns[2].Caption  := 'JeS';
    ListView1.Columns[3].Caption  := 'R}h';
    ListView1.Columns[4].Caption  := '݂̃L[';
    ListView1.Columns[5].Caption  := '@\';
    ListView1.Columns[6].Caption  := '';
    //ݒ
    ListView2.Columns[0].Caption  := 'JeS';
    ListView2.Columns[1].Caption  := 'R}h';
    ListView2.Columns[2].Caption  := '݂̃L[';
    ListView2.Columns[3].Caption  := '@\';
    ListView2.Columns[4].Caption  := '';

    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //\
    SetKeyMap(Sender);
    SetToolMap(Sender);
    ListView1Click(Sender);
    ListView1.SetFocus;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormToolPanel, StrLanguageFileName, Sender);
    //ݒ
    ListView1.Columns[0].Caption  := 'No';
    ListView1.Columns[1].Caption  := 'Name';
    ListView1.Columns[2].Caption  := 'Category';
    ListView1.Columns[3].Caption  := 'Command';
    ListView1.Columns[4].Caption  := 'Current Key';
    ListView1.Columns[5].Caption  := 'Function';
    ListView1.Columns[6].Caption  := '';
    //ݒ
    ListView2.Columns[0].Caption  := 'Category';
    ListView2.Columns[1].Caption  := 'Command';
    ListView2.Columns[2].Caption  := 'Current Key';
    ListView2.Columns[3].Caption  := 'Function';
    ListView2.Columns[4].Caption  := '';

    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //\
    SetKeyMap(Sender);
    SetToolMap(Sender);
    ListView1Click(Sender);
    ListView1.SetFocus;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormToolPanel.SetKeyMap(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView2.Items.BeginUpdate;
  ListView2.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView2.Items.Add;
    nItem.Caption := sStr12;
    ListView2.Items.Item[iRow1].SubItems.Add(sStr14);
    ListView2.Items.Item[iRow1].SubItems.Add(sStr16);
    ListView2.Items.Item[iRow1].SubItems.Add(sStr17);
  end;
  //XV
  ListView2.Items.EndUpdate;

  //ݒ
  if ListView2.Items.Count > 0 then
  begin
    ListView2.ItemIndex := 0;
    ListView2.Selected := ListView2.Items[0];
    ListView2.ItemFocused := ListView2.Items[0];
  end;

end;

procedure TFormToolPanel.SetToolMap(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iFind1: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
  IniFile: TIniFile;
  saNumber: array[0..19] of String;
  saText: array[0..19] of String;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //Ǎ
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
  begin
    saNumber[ 0] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number00',  '');
    saNumber[ 1] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number01',  '');
    saNumber[ 2] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number02',  '');
    saNumber[ 3] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number03',  '');
    saNumber[ 4] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number04',  '');
    saNumber[ 5] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number05',  '');
    saNumber[ 6] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number06',  '');
    saNumber[ 7] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number07',  '');
    saNumber[ 8] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number08',  '');
    saNumber[ 9] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number09',  '');
    saNumber[10] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number10',  '');
    saNumber[11] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number11',  '');
    saNumber[12] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number12',  '');
    saNumber[13] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number13',  '');
    saNumber[14] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number14',  '');
    saNumber[15] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number15',  '');
    saNumber[16] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number16',  '');
    saNumber[17] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number17',  '');
    saNumber[18] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number18',  '');
    saNumber[19] := IniFile.ReadString ('ToolPanelAnnsFM', 'Number19',  '');

    saText  [ 0] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text00',  '');
    saText  [ 1] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text01',  '');
    saText  [ 2] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text02',  '');
    saText  [ 3] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text03',  '');
    saText  [ 4] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text04',  '');
    saText  [ 5] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text05',  '');
    saText  [ 6] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text06',  '');
    saText  [ 7] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text07',  '');
    saText  [ 8] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text08',  '');
    saText  [ 9] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text09',  '');
    saText  [10] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text10',  '');
    saText  [11] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text11',  '');
    saText  [12] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text12',  '');
    saText  [13] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text13',  '');
    saText  [14] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text14',  '');
    saText  [15] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text15',  '');
    saText  [16] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text16',  '');
    saText  [17] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text17',  '');
    saText  [18] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text18',  '');
    saText  [19] := IniFile.ReadString ('ToolPanelAnnsFM', 'Text19',  '');
  end;

  //j
  IniFile.Free;

  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;

  //ݒ
  for iRow2 := Low(saNumber) to High(saNumber) do
  begin
    iFind1 := -1;
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
      //v
      if (sStr17 <> '') and (sStr17 = saNumber[iRow2]) then
      begin
        iFind1 := iRow1;
        Break;
      end;
    end;
    nItem := ListView1.Items.Add;
    nItem.Caption := Format('%.2d', [iRow2]);
    ListView1.Items.Item[iRow2].SubItems.Add(saText[iRow2]);
    if iFind1 = -1 then
    begin
      ListView1.Items.Item[iRow2].SubItems.Add('');
      ListView1.Items.Item[iRow2].SubItems.Add('');
      ListView1.Items.Item[iRow2].SubItems.Add('');
      ListView1.Items.Item[iRow2].SubItems.Add('');
    end
    else
    begin
      ListView1.Items.Item[iRow2].SubItems.Add(sStr12);
      ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
      ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
      ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    end;
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

end;


procedure TFormToolPanel.ListView1AdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView1.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView1.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView1.Canvas.Brush.Color := clAqua;
      ListView1.Canvas.FillRect(ARect);
      ListView1.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView1.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView1.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView1.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView1.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormToolPanel.ListView1Click(Sender: TObject);
var
  sStr1: String;
begin
  if (ListView1.Items.Count > 0) and (ListView1.ItemIndex <> -1) then
  begin
    sStr1 := ListView1.Items[ListView1.ItemIndex].SubItems[0];
    Edit1.Text := sStr1;
  end;
end;

procedure TFormToolPanel.ListView1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  ListView1Click(Sender);
end;

procedure TFormToolPanel.ListView2AdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView2.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView2.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView2.Canvas.Brush.Color := clAqua;
      ListView2.Canvas.FillRect(ARect);
      ListView2.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView2.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView2.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView2.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView2.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView2.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView2.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormToolPanel.ListView2Click(Sender: TObject);
begin
  if (ListView2.Items.Count > 0) and (ListView2.ItemIndex <> -1) then
  begin
    Edit1.Text := '';
    ListView1.Items[ListView1.ItemIndex].SubItems[0] := '';
    ListView1.Items[ListView1.ItemIndex].SubItems[1] := ListView2.Items[ListView2.ItemIndex].Caption;
    ListView1.Items[ListView1.ItemIndex].SubItems[2] := ListView2.Items[ListView2.ItemIndex].SubItems[0];
    ListView1.Items[ListView1.ItemIndex].SubItems[3] := ListView2.Items[ListView2.ItemIndex].SubItems[1];
    ListView1.Items[ListView1.ItemIndex].SubItems[4] := ListView2.Items[ListView2.ItemIndex].SubItems[2];
  end;
end;

procedure TFormToolPanel.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormToolPanel.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  for iRow1 := 0 to ListView1.Items.Count-1 do
  begin
    if ListView1.Items[iRow1].SubItems[4] <> '' then
    begin
      if ListView1.Items[iRow1].SubItems[0] = '' then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : ' + Format('%.2d', [iRow1]) + ' ̖Oݒ肳Ă܂';
        end
        else
        begin
          FormMain.StrMsg := 'Information : ' + Format('%.2d', [iRow1]) + ' name is empty.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
      if ListView1.Items[iRow1].SubItems[3] = '' then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : ' + Format('%.2d', [iRow1]) + ' ̃V[gJbgL[ݒ肳Ă܂';
        end
        else
        begin
          FormMain.StrMsg := 'Information : ' + Format('%.2d', [iRow1]) + ' shortcut key is empty.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
    end;
  end;


  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //Ǎ
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
  begin
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number00',  ListView1.Items[ 0].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number01',  ListView1.Items[ 1].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number02',  ListView1.Items[ 2].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number03',  ListView1.Items[ 3].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number04',  ListView1.Items[ 4].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number05',  ListView1.Items[ 5].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number06',  ListView1.Items[ 6].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number07',  ListView1.Items[ 7].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number08',  ListView1.Items[ 8].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number09',  ListView1.Items[ 9].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number10',  ListView1.Items[10].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number11',  ListView1.Items[11].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number12',  ListView1.Items[12].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number13',  ListView1.Items[13].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number14',  ListView1.Items[14].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number15',  ListView1.Items[15].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number16',  ListView1.Items[16].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number17',  ListView1.Items[17].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number18',  ListView1.Items[18].SubItems[4]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Number19',  ListView1.Items[19].SubItems[4]);

    IniFile.WriteString ('ToolPanelAnnsFM', 'Text00',    ListView1.Items[ 0].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text01',    ListView1.Items[ 1].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text02',    ListView1.Items[ 2].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text03',    ListView1.Items[ 3].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text04',    ListView1.Items[ 4].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text05',    ListView1.Items[ 5].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text06',    ListView1.Items[ 6].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text07',    ListView1.Items[ 7].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text08',    ListView1.Items[ 8].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text09',    ListView1.Items[ 9].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text10',    ListView1.Items[10].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text11',    ListView1.Items[11].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text12',    ListView1.Items[12].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text13',    ListView1.Items[13].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text14',    ListView1.Items[14].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text15',    ListView1.Items[15].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text16',    ListView1.Items[16].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text17',    ListView1.Items[17].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text18',    ListView1.Items[18].SubItems[0]);
    IniFile.WriteString ('ToolPanelAnnsFM', 'Text19',    ListView1.Items[19].SubItems[0]);
  end;

  //I
  ModalResult := mrOK;
end;

procedure TFormToolPanel.ButtonSetClick(Sender: TObject);
begin
  //f
  ListView1.Items[ListView1.ItemIndex].SubItems[0] := Edit1.Text;
end;

procedure TFormToolPanel.ButtonClearClick(Sender: TObject);
begin
  //f
  Edit1.Text := '';
  ListView1.Items[ListView1.ItemIndex].SubItems[0] := '';
  ListView1.Items[ListView1.ItemIndex].SubItems[1] := '';
  ListView1.Items[ListView1.ItemIndex].SubItems[2] := '';
  ListView1.Items[ListView1.ItemIndex].SubItems[3] := '';
  ListView1.Items[ListView1.ItemIndex].SubItems[4] := '';
end;

procedure TFormToolPanel.ButtonUpClick(Sender: TObject);
var
  sStr01: String;
  sStr02: String;
  sStr03: String;
  sStr04: String;
  sStr05: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  iIndex1: Integer;
  iIndex2: Integer;
  Rect1: TRect;
begin
  //
  if ListView1.ItemIndex = 0 then
  begin
    Exit;
  end;

  //擾
  sStr01 := ListView1.Items[ListView1.ItemIndex+0].SubItems[0];
  sStr02 := ListView1.Items[ListView1.ItemIndex+0].SubItems[1];
  sStr03 := ListView1.Items[ListView1.ItemIndex+0].SubItems[2];
  sStr04 := ListView1.Items[ListView1.ItemIndex+0].SubItems[3];
  sStr05 := ListView1.Items[ListView1.ItemIndex+0].SubItems[4];
  sStr11 := ListView1.Items[ListView1.ItemIndex-1].SubItems[0];
  sStr12 := ListView1.Items[ListView1.ItemIndex-1].SubItems[1];
  sStr13 := ListView1.Items[ListView1.ItemIndex-1].SubItems[2];
  sStr14 := ListView1.Items[ListView1.ItemIndex-1].SubItems[3];
  sStr15 := ListView1.Items[ListView1.ItemIndex-1].SubItems[4];

  //
  ListView1.Items[ListView1.ItemIndex-1].SubItems[0] := sStr01;
  ListView1.Items[ListView1.ItemIndex-1].SubItems[1] := sStr02;
  ListView1.Items[ListView1.ItemIndex-1].SubItems[2] := sStr03;
  ListView1.Items[ListView1.ItemIndex-1].SubItems[3] := sStr04;
  ListView1.Items[ListView1.ItemIndex-1].SubItems[4] := sStr05;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[0] := sStr11;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[1] := sStr12;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[2] := sStr13;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[3] := sStr14;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[4] := sStr15;

  //ړ
  ListView1.ItemIndex := ListView1.ItemIndex-1;

  //1s̍擾ăXN[
  iIndex1 := ListView1.TopItem.Index;
  iIndex2 := ListView1.ItemIndex;
  Rect1 := ListView1.Items[0].DisplayRect(drBounds);
  ListView1.Scroll(0, (iIndex2-iIndex1+1) * (Rect1.Bottom - Rect1.Top) - (ListView1.ClientHeight div 2));
end;

procedure TFormToolPanel.ButtonDownClick(Sender: TObject);
var
  sStr01: String;
  sStr02: String;
  sStr03: String;
  sStr04: String;
  sStr05: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  iIndex1: Integer;
  iIndex2: Integer;
  Rect1: TRect;
begin
  //
  if ListView1.ItemIndex = ListView1.Items.Count-1 then
  begin
    Exit;
  end;

  //擾
  sStr01 := ListView1.Items[ListView1.ItemIndex+0].SubItems[0];
  sStr02 := ListView1.Items[ListView1.ItemIndex+0].SubItems[1];
  sStr03 := ListView1.Items[ListView1.ItemIndex+0].SubItems[2];
  sStr04 := ListView1.Items[ListView1.ItemIndex+0].SubItems[3];
  sStr05 := ListView1.Items[ListView1.ItemIndex+0].SubItems[4];
  sStr11 := ListView1.Items[ListView1.ItemIndex+1].SubItems[0];
  sStr12 := ListView1.Items[ListView1.ItemIndex+1].SubItems[1];
  sStr13 := ListView1.Items[ListView1.ItemIndex+1].SubItems[2];
  sStr14 := ListView1.Items[ListView1.ItemIndex+1].SubItems[3];
  sStr15 := ListView1.Items[ListView1.ItemIndex+1].SubItems[4];

  //
  ListView1.Items[ListView1.ItemIndex+0].SubItems[0] := sStr11;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[1] := sStr12;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[2] := sStr13;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[3] := sStr14;
  ListView1.Items[ListView1.ItemIndex+0].SubItems[4] := sStr15;
  ListView1.Items[ListView1.ItemIndex+1].SubItems[0] := sStr01;
  ListView1.Items[ListView1.ItemIndex+1].SubItems[1] := sStr02;
  ListView1.Items[ListView1.ItemIndex+1].SubItems[2] := sStr03;
  ListView1.Items[ListView1.ItemIndex+1].SubItems[3] := sStr04;
  ListView1.Items[ListView1.ItemIndex+1].SubItems[4] := sStr05;

  //ړ
  ListView1.ItemIndex := ListView1.ItemIndex+1;

  //1s̍擾ăXN[
  iIndex1 := ListView1.TopItem.Index;
  iIndex2 := ListView1.ItemIndex;
  Rect1 := ListView1.Items[0].DisplayRect(drBounds);
  ListView1.Scroll(0, (iIndex2-iIndex1+1) * (Rect1.Bottom - Rect1.Top) - (ListView1.ClientHeight div 2));
end;

procedure TFormToolPanel.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormToolPanel.Edit1Change(Sender: TObject);
begin
  if ListView1.Items.Count > 0 then
  begin
    //f
    ListView1.Items[ListView1.ItemIndex].SubItems[0] := Edit1.Text;
  end;
end;

procedure TFormToolPanel.SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
var
  sStr3: String;
  sStr4: String;
  iRow1: Integer;
  iRow2: Integer;
  CsvList1: TStringList;
  CsvList2: TStringList;
  StrList1: TStringList;
begin
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;
  StrList1 := TStringList.Create;

  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Main.txt';
    end;
  end;

  //t@Cǂݍ
  if FileExists(sStr3) = TRUE then
  begin
    //t@Cǂݍ
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    //
    for iRow1 := 0 to StrListMap.Count-1 do
    begin
      //WJ
      CsvList1.Clear;
      StringToCsvList(StrListMap.Strings[iRow1], CsvList1);
      //
      for iRow2 := 0 to StrList1.Count-1 do
      begin
        //WJ
        CsvList2.Clear;
        StringToCsvList(StrList1.Strings[iRow2], CsvList2);
        //v
        if CsvList1[3]  = CsvList2[0] then
        begin
          if      (CsvList1[0] = SHORTCUT_ITEM_KEY) or (CsvList1[0] = SHORTCUT_ITEM_KEY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_KEY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_KEY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SHIFT) or (CsvList1[0] = SHORTCUT_ITEM_SHIFT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_CTRL) or (CsvList1[0] = SHORTCUT_ITEM_CTRL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_CTRL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_CTRL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OTHERS) or (CsvList1[0] = SHORTCUT_ITEM_OTHERS_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_DRIVE) or (CsvList1[0] = SHORTCUT_ITEM_DRIVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_DRIVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_DRIVE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_LAUNCHER) or (CsvList1[0] = SHORTCUT_ITEM_LAUNCHER_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_LAUNCHER;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_LAUNCHER_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_HELP) or (CsvList1[0] = SHORTCUT_ITEM_HELP_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_HELP;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_HELP_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_FILE) or (CsvList1[0] = SHORTCUT_ITEM_FILE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_FILE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_FILE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OPERATION) or (CsvList1[0] = SHORTCUT_ITEM_OPERATION_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OPERATION;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OPERATION_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_WINDOW) or (CsvList1[0] = SHORTCUT_ITEM_WINDOW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_WINDOW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_WINDOW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_DIRECTORY) or (CsvList1[0] = SHORTCUT_ITEM_DIRECTORY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_DIRECTORY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_DIRECTORY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SETTING) or (CsvList1[0] = SHORTCUT_ITEM_SETTING_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SETTING;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SETTING_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG) or (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_EDIT) or (CsvList1[0] = SHORTCUT_ITEM_EDIT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_EDIT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_EDIT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_VIEW) or (CsvList1[0] = SHORTCUT_ITEM_VIEW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_VIEW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_VIEW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_MOVE) or (CsvList1[0] = SHORTCUT_ITEM_MOVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_MOVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_MOVE_ENg;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_TOOL) or (CsvList1[0] = SHORTCUT_ITEM_TOOL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_TOOL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_TOOL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OPTION) or (CsvList1[0] = SHORTCUT_ITEM_OPTION_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OPTION;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OPTION_ENG;
            end;
          end
          else
          begin
            sStr4 := CsvList1[0];
          end;

          if LanguageJpn = TRUE then
          begin
            //Đݒ
            StrListMap.Strings[iRow1] := sStr4 + #09 + CsvList2[4] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end
          else
          begin
            //Đݒ
            StrListMap.Strings[iRow1] := sStr4 + #09  + CsvList2[5] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end;
          //
          Break;
        end;
      end;
    end;
  end;

  CsvList1.Free;
  CsvList2.Free;
  StrList1.Free;
end;

procedure TFormToolPanel.ReadKeyMapFromFile(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  if FormMain.IntKeyMapTypeIndex = KEYBORD_MAP_MAIN then
  begin
    if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
    begin
      sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
      Label7.Caption := 'annsFM';
    end;
  end;

  //t@Cǂݍ
  if FileExists(sStr1) = TRUE then
  begin
    //t@Cǂݍ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end;
end;

end.
