unit Url;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET  = 770;
  FORM_HEIGHT_SET = 260;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

type
  TFormUrl = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormUrl: TFormUrl;

implementation

uses  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormUrl.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormUrl.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormUrl.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormUrl.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormUrl.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormUrl', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormUrl', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormUrl', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormUrl', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormUrl', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //\
  Edit1.Text := FormMain.StrSetFormUrlName;
  Edit2.Text := FormMain.StrSetFormUrlUrl;

  //ҏW
  if Edit1.Text <> '' then
  begin
    Edit1.ReadOnly := TRUE;
    Edit1.Font.Color := clBlue;
  end;

end;

procedure TFormUrl.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormUrl', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormUrl', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormUrl', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormUrl', 'Left',   FormUrl.Left);
    IniFile.WriteInteger('FormUrl', 'Top',    FormUrl.Top);
    IniFile.WriteInteger('FormUrl', 'Width',  FormUrl.Width);
    IniFile.WriteInteger('FormUrl', 'Height', FormUrl.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormUrl.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormUrl, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormUrl, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormUrl.FormResize(Sender: TObject);
begin
  Edit1.Width := Panel1.Width - 40;
  Edit2.Width := Panel1.Width - 40;
end;

procedure TFormUrl.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormUrl.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormUrl.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormUrl.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormUrl.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormUrl.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  Edit1.SetFocus;

  //IMEIt
  SetImeMode(FormUrl.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Url.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormUrl, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormUrl, StrLanguageFileName, Sender);
  end;
end;

procedure TFormUrl.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormUrl.ButtonOKClick(Sender: TObject);
var
  sStr1: String;
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
begin
  if Length(Edit1.Text) < 5 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@C̕sł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Filename length is short.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  sStr1 := Copy(Edit1.Text, Length(Edit1.Text)-3, Length(Edit1.Text));
  if  UpperCase(sStr1)<> '.URL' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : gq .url ł͂܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Extention is not .url.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

//  AX^XN (*)
//  c_ (|)
//  ~L (\)
//  R (:)
//  dp (")
//  s (菬) (<)
//  s () (>)
//  ^╄ (?)
//  XbV (/)

  //
  iPos1 := Pos('*', Edit1.Text);
  iPos2 := Pos('|', Edit1.Text);
  iPos3 := Pos('\', Edit1.Text);
  iPos4 := Pos(':', Edit1.Text);
  iPos5 := Pos('"', Edit1.Text);
  iPos6 := Pos('<', Edit1.Text);
  iPos7 := Pos('>', Edit1.Text);
  iPos8 := Pos('?', Edit1.Text);
  iPos9 := Pos('/', Edit1.Text);
  if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
     (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
     (iPos9 > 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if Edit2.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : URL ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : URL is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ݒ
  FormMain.StrRetFormUrlName := Edit1.Text;
  FormMain.StrRetFormUrlUrl  := Edit2.Text;
  //I
  ModalResult := mrOK;
end;

procedure TFormUrl.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormUrl.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormUrl.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormUrl.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.
