unit Version;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Imaging.jpeg, Vcl.ExtCtrls,
  IniFiles, ClipBrd, MyUtility;

const
  FORM_WIDTH_SET       = 750;
  FORM_HEIGHT_SET      = 350;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormVersion = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    ButtonBlog: TButton;
    ButtonOK: TButton;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonBlogClick(Sender: TObject);

    procedure ImageClick(Sender: TObject);
    procedure ImageShow(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    IntImageIndex1: Integer;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormVersion: TFormVersion;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormVersion.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormVersion.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormVersion.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormVersion.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  File2: TWin32FindData;
  hFindData1: THandle;
  sStr1: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormVersion', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormVersion', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormVersion', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormVersion', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormVersion', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IntImageIndex1 := IniFile.ReadInteger ('VersionImage', 'Index', 0);
  ImageShow(Sender);
  //j
  IniFile.Free;

  //ݒ
  Image1.Top  := 100 + 32;
  Image1.Left :=  60 + 32;
  Image2.Top  := 100;
  Image2.Left :=  60;
  Image3.Top  := 100;
  Image3.Left :=  60;
  Image4.Top  := 100;
  Image4.Left :=  60;
  Image5.Top  := 100;
  Image5.Left :=  60;
  Image6.Top  := 100;
  Image6.Left :=  60;
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(ParamStr(0)), File2);
  sStr1 := '--.--';
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    sStr1 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE); //time
    sStr1 := Copy(sStr1, 1, 2) + '.' + Copy(sStr1, 4, 2);
    if Copy(sStr1, 1, 1) = '0' then
    begin
      sStr1 := Copy(sStr1, 2, Length(sStr1));
    end;
  end;
  WinApi.Windows.FindClose(hFindData1);
  Label2.Caption := sStr1;
end;

procedure TFormVersion.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormVersion', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormVersion', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormVersion', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormVersion', 'Left',   FormVersion.Left);
    IniFile.WriteInteger('FormVersion', 'Top',    FormVersion.Top);
    IniFile.WriteInteger('FormVersion', 'Width',  FormVersion.Width);
    IniFile.WriteInteger('FormVersion', 'Height', FormVersion.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteInteger ('VersionImage', 'Index',  IntImageIndex1);
  //j
  IniFile.Free;
end;

procedure TFormVersion.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormVersion.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormVersion.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormVersion.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormVersion.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormVersion.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormVersion.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Version.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormVersion, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormVersion, StrLanguageFileName, Sender);
  end;
end;

procedure TFormVersion.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormVersion.FormResize(Sender: TObject);
begin
;
end;

procedure TFormVersion.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //s
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormVersion, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormVersion, StrLanguageFileName, Sender);
    //\
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormVersion.ButtonOKClick(Sender: TObject);
begin
  //I
  ModalResult := mrOK;
end;

procedure TFormVersion.ImageShow(Sender: TObject);
begin
  if      IntImageIndex1 = 0 then
  begin
    Image1.Visible := TRUE;
    Image2.Visible := FALSE;
    Image3.Visible := FALSE;
    Image4.Visible := FALSE;
    Image5.Visible := FALSE;
    Image6.Visible := FALSE;
    if BoolJapanese = TRUE then
    begin
      Label6.Caption := 'BonsFMmini';
      Label7.Caption := 'Bons File Manager';
    end
    else
    begin
      Label6.Caption := 'BonsFMmini';
      Label7.Caption := 'Bons File Manager';
    end;
  end
  else if IntImageIndex1 = 1 then
  begin
    Image1.Visible := FALSE;
    Image2.Visible := TRUE;
    Image3.Visible := FALSE;
    Image4.Visible := FALSE;
    Image5.Visible := FALSE;
    Image6.Visible := FALSE;
    if BoolJapanese = TRUE then
    begin
      Label6.Caption := '{';
      Label7.Caption := 'bonworld ̗RƂȂ Bon ';
    end
    else
    begin
      Label6.Caption := 'Bon Chan';
      Label7.Caption := 'Bonworld comes from Bon.';
    end;
  end
  else if IntImageIndex1 = 2 then
  begin
    Image1.Visible := FALSE;
    Image2.Visible := FALSE;
    Image3.Visible := TRUE;
    Image4.Visible := FALSE;
    Image5.Visible := FALSE;
    Image6.Visible := FALSE;
    if BoolJapanese = TRUE then
    begin
      Label6.Caption := 'G[^';
      Label7.Caption := 'Ƃ̔L';
    end
    else
    begin
      Label6.Caption := 'Eitan';
      Label7.Caption := 'Eitan belonged my friend.';
    end;
  end
  else if IntImageIndex1 = 3 then
  begin
    Image1.Visible := FALSE;
    Image2.Visible := FALSE;
    Image3.Visible := FALSE;
    Image4.Visible := TRUE;
    Image5.Visible := FALSE;
    Image6.Visible := FALSE;
    if BoolJapanese = TRUE then
    begin
      Label6.Caption := '݂';
      Label7.Caption := 'ߏ̔LŁAۂł';
    end
    else
    begin
      Label6.Caption := 'Mike Chan';
      Label7.Caption := 'Mike lived in the neighborhood. Round head is prity.';
    end;
  end
  else if IntImageIndex1 = 4 then
  begin
    Image1.Visible := FALSE;
    Image2.Visible := FALSE;
    Image3.Visible := FALSE;
    Image4.Visible := FALSE;
    Image5.Visible := TRUE;
    Image6.Visible := FALSE;
    if BoolJapanese = TRUE then
    begin
      Label6.Caption := 'Ku[KuG]';
      Label7.Caption := 'ߏ̔LŁAȂĂ܂';
    end
    else
    begin
      Label6.Caption := 'Gabu chan [Gabriel]';
      Label7.Caption := 'Gabu living in the neighborhood. Gabu get used to me.';
    end;
  end
  else if IntImageIndex1 = 5 then
  begin
    Image1.Visible := FALSE;
    Image2.Visible := FALSE;
    Image3.Visible := FALSE;
    Image4.Visible := FALSE;
    Image5.Visible := FALSE;
    Image6.Visible := TRUE;
    if BoolJapanese = TRUE then
    begin
      Label6.Caption := '';
      Label7.Caption := 'uEgEg[kC]';
    end
    else
    begin
      Label6.Caption := 'Programer / Fly Fisherman';
      Label7.Caption := 'Brown traut in Hokkaido.';
    end;
  end
  else
  begin
    //
  end;
end;

procedure TFormVersion.ImageClick(Sender: TObject);
begin
  IntImageIndex1 := IntImageIndex1+1;
  if IntImageIndex1 > 5 then
  begin
    IntImageIndex1 := 0;
  end;
  ImageShow(Sender);
end;

procedure TFormVersion.ButtonBlogClick(Sender: TObject);
begin
  Clipboard.AsText := Label5.Caption;
end;

end.

